#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 285
#define LARGE_STATE_COUNT 121
#define SYMBOL_COUNT 281
#define ALIAS_COUNT 0
#define TOKEN_COUNT 216
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 20
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 35

enum {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_precision = 3,
  anon_sym_LBRACE = 4,
  anon_sym_RBRACE = 5,
  anon_sym_COMMA = 6,
  anon_sym_EQ = 7,
  anon_sym_if = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_else = 11,
  anon_sym_switch = 12,
  anon_sym_while = 13,
  anon_sym_do = 14,
  anon_sym_for = 15,
  anon_sym_continue = 16,
  anon_sym_break = 17,
  anon_sym_return = 18,
  anon_sym_discard = 19,
  anon_sym_case = 20,
  anon_sym_default = 21,
  anon_sym_LBRACK_RBRACK = 22,
  anon_sym_LBRACK = 23,
  anon_sym_RBRACK = 24,
  anon_sym_struct = 25,
  anon_sym_void = 26,
  anon_sym_float = 27,
  anon_sym_double = 28,
  anon_sym_int = 29,
  anon_sym_uint = 30,
  anon_sym_bool = 31,
  anon_sym_vec2 = 32,
  anon_sym_vec3 = 33,
  anon_sym_vec4 = 34,
  anon_sym_dvec2 = 35,
  anon_sym_dvec3 = 36,
  anon_sym_dvec4 = 37,
  anon_sym_bvec2 = 38,
  anon_sym_bvec3 = 39,
  anon_sym_bvec4 = 40,
  anon_sym_ivec2 = 41,
  anon_sym_ivec3 = 42,
  anon_sym_ivec4 = 43,
  anon_sym_uvec2 = 44,
  anon_sym_uvec3 = 45,
  anon_sym_uvec4 = 46,
  anon_sym_mat2 = 47,
  anon_sym_mat3 = 48,
  anon_sym_mat4 = 49,
  anon_sym_mat2x2 = 50,
  anon_sym_mat2x3 = 51,
  anon_sym_mat2x4 = 52,
  anon_sym_mat3x2 = 53,
  anon_sym_mat3x3 = 54,
  anon_sym_mat3x4 = 55,
  anon_sym_mat4x2 = 56,
  anon_sym_mat4x3 = 57,
  anon_sym_mat4x4 = 58,
  anon_sym_dmat2 = 59,
  anon_sym_dmat3 = 60,
  anon_sym_dmat4 = 61,
  anon_sym_dmat2x2 = 62,
  anon_sym_dmat2x3 = 63,
  anon_sym_dmat2x4 = 64,
  anon_sym_dmat3x2 = 65,
  anon_sym_dmat3x3 = 66,
  anon_sym_dmat3x4 = 67,
  anon_sym_dmat4x2 = 68,
  anon_sym_dmat4x3 = 69,
  anon_sym_dmat4x4 = 70,
  anon_sym_atomic_uint = 71,
  anon_sym_sampler1d = 72,
  anon_sym_sampler2d = 73,
  anon_sym_sampler3d = 74,
  anon_sym_samplercube = 75,
  anon_sym_sampler1DShadow = 76,
  anon_sym_sampler2DShadow = 77,
  anon_sym_samplerCubeShadow = 78,
  anon_sym_sampler1DArray = 79,
  anon_sym_sampler2DArray = 80,
  anon_sym_sampler1DArrayShadow = 81,
  anon_sym_sampler2DArrayShadow = 82,
  anon_sym_samplerCubeArray = 83,
  anon_sym_samplerCubeArrayShadow = 84,
  anon_sym_isampler1D = 85,
  anon_sym_isampler2D = 86,
  anon_sym_isampler3D = 87,
  anon_sym_isamplerCube = 88,
  anon_sym_isampler1DArray = 89,
  anon_sym_isampler2DArray = 90,
  anon_sym_isamplerCubeArray = 91,
  anon_sym_usampler1D = 92,
  anon_sym_usampler2D = 93,
  anon_sym_usampler3D = 94,
  anon_sym_usamplerCube = 95,
  anon_sym_usampler1DArray = 96,
  anon_sym_usampler2DArray = 97,
  anon_sym_usamplerCubeArray = 98,
  anon_sym_sampler2DRect = 99,
  anon_sym_sampler2DRectshadow = 100,
  anon_sym_isampler2DRect = 101,
  anon_sym_usampler2DRect = 102,
  anon_sym_samplerBuffer = 103,
  anon_sym_isamplerBuffer = 104,
  anon_sym_usamplerBuffer = 105,
  anon_sym_sampler2DMS = 106,
  anon_sym_isampler2DMS = 107,
  anon_sym_usampler2DMS = 108,
  anon_sym_sampler2DMSArray = 109,
  anon_sym_isampler2DMSArray = 110,
  anon_sym_usampler2DMSArray = 111,
  anon_sym_image1D = 112,
  anon_sym_iimage1D = 113,
  anon_sym_uimage1D = 114,
  anon_sym_image2D = 115,
  anon_sym_iimage2D = 116,
  anon_sym_uimage2D = 117,
  anon_sym_image3D = 118,
  anon_sym_iimage3D = 119,
  anon_sym_uimage3D = 120,
  anon_sym_image2DRect = 121,
  anon_sym_iimage2DRect = 122,
  anon_sym_uimage2DRect = 123,
  anon_sym_imageCube = 124,
  anon_sym_iimageCube = 125,
  anon_sym_uimageCube = 126,
  anon_sym_imageBuffer = 127,
  anon_sym_iimageBuffer = 128,
  anon_sym_uimageBuffer = 129,
  anon_sym_image1DArray = 130,
  anon_sym_iimage1DArray = 131,
  anon_sym_uimage1DArray = 132,
  anon_sym_image2DArray = 133,
  anon_sym_iimage2DArray = 134,
  anon_sym_uimage2DArray = 135,
  anon_sym_imageCubeArray = 136,
  anon_sym_iimageCubeArray = 137,
  anon_sym_uimageCubeArray = 138,
  anon_sym_image2DMS = 139,
  anon_sym_iimage2DMS = 140,
  anon_sym_uimage2DMS = 141,
  anon_sym_image2DMSArray = 142,
  anon_sym_iimage2DMSArray = 143,
  anon_sym_uimage2DMSArray = 144,
  anon_sym_const = 145,
  anon_sym_inout = 146,
  anon_sym_in = 147,
  anon_sym_out = 148,
  anon_sym_centroid = 149,
  anon_sym_patch = 150,
  anon_sym_sample = 151,
  anon_sym_uniform = 152,
  anon_sym_buffer = 153,
  anon_sym_shared = 154,
  anon_sym_coherent = 155,
  anon_sym_volatile = 156,
  anon_sym_restrict = 157,
  anon_sym_readonly = 158,
  anon_sym_writeonly = 159,
  anon_sym_subroutine = 160,
  anon_sym_varying = 161,
  anon_sym_attribute = 162,
  anon_sym_layout = 163,
  anon_sym_highp = 164,
  anon_sym_mediump = 165,
  anon_sym_lowp = 166,
  anon_sym_smooth = 167,
  anon_sym_flat = 168,
  anon_sym_noperspective = 169,
  sym_invariant_qualifier = 170,
  sym_precise_qualifier = 171,
  anon_sym_GT = 172,
  anon_sym_LT = 173,
  anon_sym_GT_EQ = 174,
  anon_sym_LT_EQ = 175,
  anon_sym_EQ_EQ = 176,
  anon_sym_BANG_EQ = 177,
  anon_sym_AMP_AMP = 178,
  anon_sym_PIPE_PIPE = 179,
  anon_sym_PLUS = 180,
  anon_sym_DASH = 181,
  anon_sym_STAR = 182,
  anon_sym_SLASH = 183,
  anon_sym_AMP = 184,
  anon_sym_PIPE = 185,
  anon_sym_CARET = 186,
  anon_sym_PERCENT = 187,
  anon_sym_LT_LT = 188,
  anon_sym_GT_GT = 189,
  anon_sym_BANG = 190,
  anon_sym_TILDE = 191,
  anon_sym_PLUS_PLUS = 192,
  anon_sym_DASH_DASH = 193,
  anon_sym_DOT = 194,
  anon_sym_PLUS_EQ = 195,
  anon_sym_DASH_EQ = 196,
  anon_sym_STAR_EQ = 197,
  anon_sym_SLASH_EQ = 198,
  anon_sym_PERCENT_EQ = 199,
  anon_sym_LT_LT_EQ = 200,
  anon_sym_GT_GT_EQ = 201,
  anon_sym_AMP_EQ = 202,
  anon_sym_CARET_EQ = 203,
  anon_sym_PIPE_EQ = 204,
  anon_sym_QMARK = 205,
  anon_sym_COLON = 206,
  anon_sym_true = 207,
  anon_sym_false = 208,
  aux_sym_number_literal_token1 = 209,
  aux_sym_number_literal_token2 = 210,
  aux_sym_number_literal_token3 = 211,
  aux_sym_number_literal_token4 = 212,
  aux_sym_number_literal_token5 = 213,
  aux_sym_number_literal_token6 = 214,
  sym_comment = 215,
  sym_translation_unit = 216,
  sym__external_declaration = 217,
  sym_declaration = 218,
  sym__init_declarator_list = 219,
  sym__initializer = 220,
  sym_function_definition = 221,
  sym_compound_statement = 222,
  sym_statement_list = 223,
  sym__statement = 224,
  sym_expression_statement = 225,
  sym_if_statement = 226,
  sym_switch_statement = 227,
  sym_iteration_statement = 228,
  sym_condition = 229,
  sym_jump_statement = 230,
  sym_function_prototype = 231,
  sym_case_label = 232,
  sym_function_declaration = 233,
  sym_fully_specified_type = 234,
  sym_function_parameter_list = 235,
  sym_parameter_declaration = 236,
  sym_parameter_declarator = 237,
  aux_sym__array_specifier_list = 238,
  sym__field_declarator = 239,
  sym_array_declarator = 240,
  sym_type_specifier = 241,
  sym_primitive_type = 242,
  sym_struct_declaration_list = 243,
  sym_struct_declaration = 244,
  sym_struct_declarator_list = 245,
  sym_struct_declarator = 246,
  sym_type_qualifier_list = 247,
  sym_type_qualifier = 248,
  sym_storage_qualifier = 249,
  sym_type_name_list = 250,
  sym_layout_qualifier = 251,
  sym_layout_qualifier_id = 252,
  sym_precision_qualifier = 253,
  sym_interpolation_qualifier = 254,
  sym_binary_expression = 255,
  sym_unary_expression = 256,
  sym_update_expression = 257,
  sym_parenthesized_expression = 258,
  sym_subscript_expression = 259,
  sym_field_expression = 260,
  sym_call_expression = 261,
  sym_comma_expression = 262,
  sym_function_call_parameter_list = 263,
  sym_assignment_expression = 264,
  sym_conditional_expression = 265,
  sym__expression = 266,
  sym__constant_expression = 267,
  sym__assignment_left_expression = 268,
  sym_number_literal = 269,
  aux_sym_translation_unit_repeat1 = 270,
  aux_sym_declaration_repeat1 = 271,
  aux_sym__initializer_repeat1 = 272,
  aux_sym_statement_list_repeat1 = 273,
  aux_sym_function_parameter_list_repeat1 = 274,
  aux_sym_struct_declaration_list_repeat1 = 275,
  aux_sym_struct_declarator_list_repeat1 = 276,
  aux_sym_type_qualifier_list_repeat1 = 277,
  aux_sym_type_name_list_repeat1 = 278,
  aux_sym_layout_qualifier_repeat1 = 279,
  aux_sym_comma_expression_repeat1 = 280,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_precision] = "precision",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_if] = "if",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_continue] = "continue",
  [anon_sym_break] = "break",
  [anon_sym_return] = "return",
  [anon_sym_discard] = "discard",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_struct] = "struct",
  [anon_sym_void] = "void",
  [anon_sym_float] = "float",
  [anon_sym_double] = "double",
  [anon_sym_int] = "int",
  [anon_sym_uint] = "uint",
  [anon_sym_bool] = "bool",
  [anon_sym_vec2] = "vec2",
  [anon_sym_vec3] = "vec3",
  [anon_sym_vec4] = "vec4",
  [anon_sym_dvec2] = "dvec2",
  [anon_sym_dvec3] = "dvec3",
  [anon_sym_dvec4] = "dvec4",
  [anon_sym_bvec2] = "bvec2",
  [anon_sym_bvec3] = "bvec3",
  [anon_sym_bvec4] = "bvec4",
  [anon_sym_ivec2] = "ivec2",
  [anon_sym_ivec3] = "ivec3",
  [anon_sym_ivec4] = "ivec4",
  [anon_sym_uvec2] = "uvec2",
  [anon_sym_uvec3] = "uvec3",
  [anon_sym_uvec4] = "uvec4",
  [anon_sym_mat2] = "mat2",
  [anon_sym_mat3] = "mat3",
  [anon_sym_mat4] = "mat4",
  [anon_sym_mat2x2] = "mat2x2",
  [anon_sym_mat2x3] = "mat2x3",
  [anon_sym_mat2x4] = "mat2x4",
  [anon_sym_mat3x2] = "mat3x2",
  [anon_sym_mat3x3] = "mat3x3",
  [anon_sym_mat3x4] = "mat3x4",
  [anon_sym_mat4x2] = "mat4x2",
  [anon_sym_mat4x3] = "mat4x3",
  [anon_sym_mat4x4] = "mat4x4",
  [anon_sym_dmat2] = "dmat2",
  [anon_sym_dmat3] = "dmat3",
  [anon_sym_dmat4] = "dmat4",
  [anon_sym_dmat2x2] = "dmat2x2",
  [anon_sym_dmat2x3] = "dmat2x3",
  [anon_sym_dmat2x4] = "dmat2x4",
  [anon_sym_dmat3x2] = "dmat3x2",
  [anon_sym_dmat3x3] = "dmat3x3",
  [anon_sym_dmat3x4] = "dmat3x4",
  [anon_sym_dmat4x2] = "dmat4x2",
  [anon_sym_dmat4x3] = "dmat4x3",
  [anon_sym_dmat4x4] = "dmat4x4",
  [anon_sym_atomic_uint] = "atomic_uint",
  [anon_sym_sampler1d] = "sampler1d",
  [anon_sym_sampler2d] = "sampler2d",
  [anon_sym_sampler3d] = "sampler3d",
  [anon_sym_samplercube] = "samplercube",
  [anon_sym_sampler1DShadow] = "sampler1DShadow",
  [anon_sym_sampler2DShadow] = "sampler2DShadow",
  [anon_sym_samplerCubeShadow] = "samplerCubeShadow",
  [anon_sym_sampler1DArray] = "sampler1DArray",
  [anon_sym_sampler2DArray] = "sampler2DArray",
  [anon_sym_sampler1DArrayShadow] = "sampler1DArrayShadow",
  [anon_sym_sampler2DArrayShadow] = "sampler2DArrayShadow",
  [anon_sym_samplerCubeArray] = "samplerCubeArray",
  [anon_sym_samplerCubeArrayShadow] = "samplerCubeArrayShadow",
  [anon_sym_isampler1D] = "isampler1D",
  [anon_sym_isampler2D] = "isampler2D",
  [anon_sym_isampler3D] = "isampler3D",
  [anon_sym_isamplerCube] = "isamplerCube",
  [anon_sym_isampler1DArray] = "isampler1DArray",
  [anon_sym_isampler2DArray] = "isampler2DArray",
  [anon_sym_isamplerCubeArray] = "isamplerCubeArray",
  [anon_sym_usampler1D] = "usampler1D",
  [anon_sym_usampler2D] = "usampler2D",
  [anon_sym_usampler3D] = "usampler3D",
  [anon_sym_usamplerCube] = "usamplerCube",
  [anon_sym_usampler1DArray] = "usampler1DArray",
  [anon_sym_usampler2DArray] = "usampler2DArray",
  [anon_sym_usamplerCubeArray] = "usamplerCubeArray",
  [anon_sym_sampler2DRect] = "sampler2DRect",
  [anon_sym_sampler2DRectshadow] = "sampler2DRectshadow",
  [anon_sym_isampler2DRect] = "isampler2DRect",
  [anon_sym_usampler2DRect] = "usampler2DRect",
  [anon_sym_samplerBuffer] = "samplerBuffer",
  [anon_sym_isamplerBuffer] = "isamplerBuffer",
  [anon_sym_usamplerBuffer] = "usamplerBuffer",
  [anon_sym_sampler2DMS] = "sampler2DMS",
  [anon_sym_isampler2DMS] = "isampler2DMS",
  [anon_sym_usampler2DMS] = "usampler2DMS",
  [anon_sym_sampler2DMSArray] = "sampler2DMSArray",
  [anon_sym_isampler2DMSArray] = "isampler2DMSArray",
  [anon_sym_usampler2DMSArray] = "usampler2DMSArray",
  [anon_sym_image1D] = "image1D",
  [anon_sym_iimage1D] = "iimage1D",
  [anon_sym_uimage1D] = "uimage1D",
  [anon_sym_image2D] = "image2D",
  [anon_sym_iimage2D] = "iimage2D",
  [anon_sym_uimage2D] = "uimage2D",
  [anon_sym_image3D] = "image3D",
  [anon_sym_iimage3D] = "iimage3D",
  [anon_sym_uimage3D] = "uimage3D",
  [anon_sym_image2DRect] = "image2DRect",
  [anon_sym_iimage2DRect] = "iimage2DRect",
  [anon_sym_uimage2DRect] = "uimage2DRect",
  [anon_sym_imageCube] = "imageCube",
  [anon_sym_iimageCube] = "iimageCube",
  [anon_sym_uimageCube] = "uimageCube",
  [anon_sym_imageBuffer] = "imageBuffer",
  [anon_sym_iimageBuffer] = "iimageBuffer",
  [anon_sym_uimageBuffer] = "uimageBuffer",
  [anon_sym_image1DArray] = "image1DArray",
  [anon_sym_iimage1DArray] = "iimage1DArray",
  [anon_sym_uimage1DArray] = "uimage1DArray",
  [anon_sym_image2DArray] = "image2DArray",
  [anon_sym_iimage2DArray] = "iimage2DArray",
  [anon_sym_uimage2DArray] = "uimage2DArray",
  [anon_sym_imageCubeArray] = "imageCubeArray",
  [anon_sym_iimageCubeArray] = "iimageCubeArray",
  [anon_sym_uimageCubeArray] = "uimageCubeArray",
  [anon_sym_image2DMS] = "image2DMS",
  [anon_sym_iimage2DMS] = "iimage2DMS",
  [anon_sym_uimage2DMS] = "uimage2DMS",
  [anon_sym_image2DMSArray] = "image2DMSArray",
  [anon_sym_iimage2DMSArray] = "iimage2DMSArray",
  [anon_sym_uimage2DMSArray] = "uimage2DMSArray",
  [anon_sym_const] = "const",
  [anon_sym_inout] = "inout",
  [anon_sym_in] = "in",
  [anon_sym_out] = "out",
  [anon_sym_centroid] = "centroid",
  [anon_sym_patch] = "patch",
  [anon_sym_sample] = "sample",
  [anon_sym_uniform] = "uniform",
  [anon_sym_buffer] = "buffer",
  [anon_sym_shared] = "shared",
  [anon_sym_coherent] = "coherent",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym_readonly] = "readonly",
  [anon_sym_writeonly] = "writeonly",
  [anon_sym_subroutine] = "subroutine",
  [anon_sym_varying] = "varying",
  [anon_sym_attribute] = "attribute",
  [anon_sym_layout] = "layout",
  [anon_sym_highp] = "highp",
  [anon_sym_mediump] = "mediump",
  [anon_sym_lowp] = "lowp",
  [anon_sym_smooth] = "smooth",
  [anon_sym_flat] = "flat",
  [anon_sym_noperspective] = "noperspective",
  [sym_invariant_qualifier] = "invariant_qualifier",
  [sym_precise_qualifier] = "precise_qualifier",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DOT] = ".",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON] = ":",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [aux_sym_number_literal_token1] = "number_literal_token1",
  [aux_sym_number_literal_token2] = "number_literal_token2",
  [aux_sym_number_literal_token3] = "number_literal_token3",
  [aux_sym_number_literal_token4] = "number_literal_token4",
  [aux_sym_number_literal_token5] = "number_literal_token5",
  [aux_sym_number_literal_token6] = "number_literal_token6",
  [sym_comment] = "comment",
  [sym_translation_unit] = "translation_unit",
  [sym__external_declaration] = "_external_declaration",
  [sym_declaration] = "declaration",
  [sym__init_declarator_list] = "_init_declarator_list",
  [sym__initializer] = "_initializer",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_statement_list] = "statement_list",
  [sym__statement] = "_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_iteration_statement] = "iteration_statement",
  [sym_condition] = "condition",
  [sym_jump_statement] = "jump_statement",
  [sym_function_prototype] = "function_prototype",
  [sym_case_label] = "case_label",
  [sym_function_declaration] = "function_declaration",
  [sym_fully_specified_type] = "fully_specified_type",
  [sym_function_parameter_list] = "function_parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_parameter_declarator] = "parameter_declarator",
  [aux_sym__array_specifier_list] = "_array_specifier_list",
  [sym__field_declarator] = "_field_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_type_specifier] = "type_specifier",
  [sym_primitive_type] = "primitive_type",
  [sym_struct_declaration_list] = "struct_declaration_list",
  [sym_struct_declaration] = "struct_declaration",
  [sym_struct_declarator_list] = "struct_declarator_list",
  [sym_struct_declarator] = "struct_declarator",
  [sym_type_qualifier_list] = "type_qualifier_list",
  [sym_type_qualifier] = "type_qualifier",
  [sym_storage_qualifier] = "storage_qualifier",
  [sym_type_name_list] = "type_name_list",
  [sym_layout_qualifier] = "layout_qualifier",
  [sym_layout_qualifier_id] = "layout_qualifier_id",
  [sym_precision_qualifier] = "precision_qualifier",
  [sym_interpolation_qualifier] = "interpolation_qualifier",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_field_expression] = "field_expression",
  [sym_call_expression] = "call_expression",
  [sym_comma_expression] = "comma_expression",
  [sym_function_call_parameter_list] = "function_call_parameter_list",
  [sym_assignment_expression] = "assignment_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym__expression] = "_expression",
  [sym__constant_expression] = "_constant_expression",
  [sym__assignment_left_expression] = "_assignment_left_expression",
  [sym_number_literal] = "number_literal",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym__initializer_repeat1] = "_initializer_repeat1",
  [aux_sym_statement_list_repeat1] = "statement_list_repeat1",
  [aux_sym_function_parameter_list_repeat1] = "function_parameter_list_repeat1",
  [aux_sym_struct_declaration_list_repeat1] = "struct_declaration_list_repeat1",
  [aux_sym_struct_declarator_list_repeat1] = "struct_declarator_list_repeat1",
  [aux_sym_type_qualifier_list_repeat1] = "type_qualifier_list_repeat1",
  [aux_sym_type_name_list_repeat1] = "type_name_list_repeat1",
  [aux_sym_layout_qualifier_repeat1] = "layout_qualifier_repeat1",
  [aux_sym_comma_expression_repeat1] = "comma_expression_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_precision] = anon_sym_precision,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_discard] = anon_sym_discard,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_uint] = anon_sym_uint,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_vec2] = anon_sym_vec2,
  [anon_sym_vec3] = anon_sym_vec3,
  [anon_sym_vec4] = anon_sym_vec4,
  [anon_sym_dvec2] = anon_sym_dvec2,
  [anon_sym_dvec3] = anon_sym_dvec3,
  [anon_sym_dvec4] = anon_sym_dvec4,
  [anon_sym_bvec2] = anon_sym_bvec2,
  [anon_sym_bvec3] = anon_sym_bvec3,
  [anon_sym_bvec4] = anon_sym_bvec4,
  [anon_sym_ivec2] = anon_sym_ivec2,
  [anon_sym_ivec3] = anon_sym_ivec3,
  [anon_sym_ivec4] = anon_sym_ivec4,
  [anon_sym_uvec2] = anon_sym_uvec2,
  [anon_sym_uvec3] = anon_sym_uvec3,
  [anon_sym_uvec4] = anon_sym_uvec4,
  [anon_sym_mat2] = anon_sym_mat2,
  [anon_sym_mat3] = anon_sym_mat3,
  [anon_sym_mat4] = anon_sym_mat4,
  [anon_sym_mat2x2] = anon_sym_mat2x2,
  [anon_sym_mat2x3] = anon_sym_mat2x3,
  [anon_sym_mat2x4] = anon_sym_mat2x4,
  [anon_sym_mat3x2] = anon_sym_mat3x2,
  [anon_sym_mat3x3] = anon_sym_mat3x3,
  [anon_sym_mat3x4] = anon_sym_mat3x4,
  [anon_sym_mat4x2] = anon_sym_mat4x2,
  [anon_sym_mat4x3] = anon_sym_mat4x3,
  [anon_sym_mat4x4] = anon_sym_mat4x4,
  [anon_sym_dmat2] = anon_sym_dmat2,
  [anon_sym_dmat3] = anon_sym_dmat3,
  [anon_sym_dmat4] = anon_sym_dmat4,
  [anon_sym_dmat2x2] = anon_sym_dmat2x2,
  [anon_sym_dmat2x3] = anon_sym_dmat2x3,
  [anon_sym_dmat2x4] = anon_sym_dmat2x4,
  [anon_sym_dmat3x2] = anon_sym_dmat3x2,
  [anon_sym_dmat3x3] = anon_sym_dmat3x3,
  [anon_sym_dmat3x4] = anon_sym_dmat3x4,
  [anon_sym_dmat4x2] = anon_sym_dmat4x2,
  [anon_sym_dmat4x3] = anon_sym_dmat4x3,
  [anon_sym_dmat4x4] = anon_sym_dmat4x4,
  [anon_sym_atomic_uint] = anon_sym_atomic_uint,
  [anon_sym_sampler1d] = anon_sym_sampler1d,
  [anon_sym_sampler2d] = anon_sym_sampler2d,
  [anon_sym_sampler3d] = anon_sym_sampler3d,
  [anon_sym_samplercube] = anon_sym_samplercube,
  [anon_sym_sampler1DShadow] = anon_sym_sampler1DShadow,
  [anon_sym_sampler2DShadow] = anon_sym_sampler2DShadow,
  [anon_sym_samplerCubeShadow] = anon_sym_samplerCubeShadow,
  [anon_sym_sampler1DArray] = anon_sym_sampler1DArray,
  [anon_sym_sampler2DArray] = anon_sym_sampler2DArray,
  [anon_sym_sampler1DArrayShadow] = anon_sym_sampler1DArrayShadow,
  [anon_sym_sampler2DArrayShadow] = anon_sym_sampler2DArrayShadow,
  [anon_sym_samplerCubeArray] = anon_sym_samplerCubeArray,
  [anon_sym_samplerCubeArrayShadow] = anon_sym_samplerCubeArrayShadow,
  [anon_sym_isampler1D] = anon_sym_isampler1D,
  [anon_sym_isampler2D] = anon_sym_isampler2D,
  [anon_sym_isampler3D] = anon_sym_isampler3D,
  [anon_sym_isamplerCube] = anon_sym_isamplerCube,
  [anon_sym_isampler1DArray] = anon_sym_isampler1DArray,
  [anon_sym_isampler2DArray] = anon_sym_isampler2DArray,
  [anon_sym_isamplerCubeArray] = anon_sym_isamplerCubeArray,
  [anon_sym_usampler1D] = anon_sym_usampler1D,
  [anon_sym_usampler2D] = anon_sym_usampler2D,
  [anon_sym_usampler3D] = anon_sym_usampler3D,
  [anon_sym_usamplerCube] = anon_sym_usamplerCube,
  [anon_sym_usampler1DArray] = anon_sym_usampler1DArray,
  [anon_sym_usampler2DArray] = anon_sym_usampler2DArray,
  [anon_sym_usamplerCubeArray] = anon_sym_usamplerCubeArray,
  [anon_sym_sampler2DRect] = anon_sym_sampler2DRect,
  [anon_sym_sampler2DRectshadow] = anon_sym_sampler2DRectshadow,
  [anon_sym_isampler2DRect] = anon_sym_isampler2DRect,
  [anon_sym_usampler2DRect] = anon_sym_usampler2DRect,
  [anon_sym_samplerBuffer] = anon_sym_samplerBuffer,
  [anon_sym_isamplerBuffer] = anon_sym_isamplerBuffer,
  [anon_sym_usamplerBuffer] = anon_sym_usamplerBuffer,
  [anon_sym_sampler2DMS] = anon_sym_sampler2DMS,
  [anon_sym_isampler2DMS] = anon_sym_isampler2DMS,
  [anon_sym_usampler2DMS] = anon_sym_usampler2DMS,
  [anon_sym_sampler2DMSArray] = anon_sym_sampler2DMSArray,
  [anon_sym_isampler2DMSArray] = anon_sym_isampler2DMSArray,
  [anon_sym_usampler2DMSArray] = anon_sym_usampler2DMSArray,
  [anon_sym_image1D] = anon_sym_image1D,
  [anon_sym_iimage1D] = anon_sym_iimage1D,
  [anon_sym_uimage1D] = anon_sym_uimage1D,
  [anon_sym_image2D] = anon_sym_image2D,
  [anon_sym_iimage2D] = anon_sym_iimage2D,
  [anon_sym_uimage2D] = anon_sym_uimage2D,
  [anon_sym_image3D] = anon_sym_image3D,
  [anon_sym_iimage3D] = anon_sym_iimage3D,
  [anon_sym_uimage3D] = anon_sym_uimage3D,
  [anon_sym_image2DRect] = anon_sym_image2DRect,
  [anon_sym_iimage2DRect] = anon_sym_iimage2DRect,
  [anon_sym_uimage2DRect] = anon_sym_uimage2DRect,
  [anon_sym_imageCube] = anon_sym_imageCube,
  [anon_sym_iimageCube] = anon_sym_iimageCube,
  [anon_sym_uimageCube] = anon_sym_uimageCube,
  [anon_sym_imageBuffer] = anon_sym_imageBuffer,
  [anon_sym_iimageBuffer] = anon_sym_iimageBuffer,
  [anon_sym_uimageBuffer] = anon_sym_uimageBuffer,
  [anon_sym_image1DArray] = anon_sym_image1DArray,
  [anon_sym_iimage1DArray] = anon_sym_iimage1DArray,
  [anon_sym_uimage1DArray] = anon_sym_uimage1DArray,
  [anon_sym_image2DArray] = anon_sym_image2DArray,
  [anon_sym_iimage2DArray] = anon_sym_iimage2DArray,
  [anon_sym_uimage2DArray] = anon_sym_uimage2DArray,
  [anon_sym_imageCubeArray] = anon_sym_imageCubeArray,
  [anon_sym_iimageCubeArray] = anon_sym_iimageCubeArray,
  [anon_sym_uimageCubeArray] = anon_sym_uimageCubeArray,
  [anon_sym_image2DMS] = anon_sym_image2DMS,
  [anon_sym_iimage2DMS] = anon_sym_iimage2DMS,
  [anon_sym_uimage2DMS] = anon_sym_uimage2DMS,
  [anon_sym_image2DMSArray] = anon_sym_image2DMSArray,
  [anon_sym_iimage2DMSArray] = anon_sym_iimage2DMSArray,
  [anon_sym_uimage2DMSArray] = anon_sym_uimage2DMSArray,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_inout] = anon_sym_inout,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_centroid] = anon_sym_centroid,
  [anon_sym_patch] = anon_sym_patch,
  [anon_sym_sample] = anon_sym_sample,
  [anon_sym_uniform] = anon_sym_uniform,
  [anon_sym_buffer] = anon_sym_buffer,
  [anon_sym_shared] = anon_sym_shared,
  [anon_sym_coherent] = anon_sym_coherent,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_writeonly] = anon_sym_writeonly,
  [anon_sym_subroutine] = anon_sym_subroutine,
  [anon_sym_varying] = anon_sym_varying,
  [anon_sym_attribute] = anon_sym_attribute,
  [anon_sym_layout] = anon_sym_layout,
  [anon_sym_highp] = anon_sym_highp,
  [anon_sym_mediump] = anon_sym_mediump,
  [anon_sym_lowp] = anon_sym_lowp,
  [anon_sym_smooth] = anon_sym_smooth,
  [anon_sym_flat] = anon_sym_flat,
  [anon_sym_noperspective] = anon_sym_noperspective,
  [sym_invariant_qualifier] = sym_invariant_qualifier,
  [sym_precise_qualifier] = sym_precise_qualifier,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [aux_sym_number_literal_token1] = aux_sym_number_literal_token1,
  [aux_sym_number_literal_token2] = aux_sym_number_literal_token2,
  [aux_sym_number_literal_token3] = aux_sym_number_literal_token3,
  [aux_sym_number_literal_token4] = aux_sym_number_literal_token4,
  [aux_sym_number_literal_token5] = aux_sym_number_literal_token5,
  [aux_sym_number_literal_token6] = aux_sym_number_literal_token6,
  [sym_comment] = sym_comment,
  [sym_translation_unit] = sym_translation_unit,
  [sym__external_declaration] = sym__external_declaration,
  [sym_declaration] = sym_declaration,
  [sym__init_declarator_list] = sym__init_declarator_list,
  [sym__initializer] = sym__initializer,
  [sym_function_definition] = sym_function_definition,
  [sym_compound_statement] = sym_compound_statement,
  [sym_statement_list] = sym_statement_list,
  [sym__statement] = sym__statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_iteration_statement] = sym_iteration_statement,
  [sym_condition] = sym_condition,
  [sym_jump_statement] = sym_jump_statement,
  [sym_function_prototype] = sym_function_prototype,
  [sym_case_label] = sym_case_label,
  [sym_function_declaration] = sym_function_declaration,
  [sym_fully_specified_type] = sym_fully_specified_type,
  [sym_function_parameter_list] = sym_function_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_parameter_declarator] = sym_parameter_declarator,
  [aux_sym__array_specifier_list] = aux_sym__array_specifier_list,
  [sym__field_declarator] = sym__field_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_type_specifier] = sym_type_specifier,
  [sym_primitive_type] = sym_primitive_type,
  [sym_struct_declaration_list] = sym_struct_declaration_list,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_struct_declarator_list] = sym_struct_declarator_list,
  [sym_struct_declarator] = sym_struct_declarator,
  [sym_type_qualifier_list] = sym_type_qualifier_list,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_storage_qualifier] = sym_storage_qualifier,
  [sym_type_name_list] = sym_type_name_list,
  [sym_layout_qualifier] = sym_layout_qualifier,
  [sym_layout_qualifier_id] = sym_layout_qualifier_id,
  [sym_precision_qualifier] = sym_precision_qualifier,
  [sym_interpolation_qualifier] = sym_interpolation_qualifier,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_comma_expression] = sym_comma_expression,
  [sym_function_call_parameter_list] = sym_function_call_parameter_list,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym__expression] = sym__expression,
  [sym__constant_expression] = sym__constant_expression,
  [sym__assignment_left_expression] = sym__assignment_left_expression,
  [sym_number_literal] = sym_number_literal,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym__initializer_repeat1] = aux_sym__initializer_repeat1,
  [aux_sym_statement_list_repeat1] = aux_sym_statement_list_repeat1,
  [aux_sym_function_parameter_list_repeat1] = aux_sym_function_parameter_list_repeat1,
  [aux_sym_struct_declaration_list_repeat1] = aux_sym_struct_declaration_list_repeat1,
  [aux_sym_struct_declarator_list_repeat1] = aux_sym_struct_declarator_list_repeat1,
  [aux_sym_type_qualifier_list_repeat1] = aux_sym_type_qualifier_list_repeat1,
  [aux_sym_type_name_list_repeat1] = aux_sym_type_name_list_repeat1,
  [aux_sym_layout_qualifier_repeat1] = aux_sym_layout_qualifier_repeat1,
  [aux_sym_comma_expression_repeat1] = aux_sym_comma_expression_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_precision] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_discard] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vec2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vec3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vec4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dvec2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dvec3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dvec4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bvec2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bvec3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bvec4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ivec2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ivec3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ivec4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uvec2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uvec3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uvec4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat2x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat2x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat2x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat3x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat3x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat3x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat4x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat4x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat4x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat2x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat2x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat2x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat3x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat3x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat3x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat4x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat4x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dmat4x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_atomic_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler1d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler2d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler3d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_samplercube] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler1DShadow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler2DShadow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_samplerCubeShadow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler1DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler2DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler1DArrayShadow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler2DArrayShadow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_samplerCubeArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_samplerCubeArrayShadow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isampler1D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isampler2D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isampler3D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isamplerCube] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isampler1DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isampler2DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isamplerCubeArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usampler1D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usampler2D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usampler3D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usamplerCube] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usampler1DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usampler2DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usamplerCubeArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler2DRect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler2DRectshadow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isampler2DRect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usampler2DRect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_samplerBuffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isamplerBuffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usamplerBuffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler2DMS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isampler2DMS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usampler2DMS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler2DMSArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isampler2DMSArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usampler2DMSArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image1D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimage1D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimage1D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image2D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimage2D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimage2D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image3D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimage3D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimage3D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image2DRect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimage2DRect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimage2DRect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_imageCube] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimageCube] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimageCube] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_imageBuffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimageBuffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimageBuffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image1DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimage1DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimage1DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image2DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimage2DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimage2DArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_imageCubeArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimageCubeArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimageCubeArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image2DMS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimage2DMS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimage2DMS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image2DMSArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iimage2DMSArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uimage2DMSArray] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inout] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_centroid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_patch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sample] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uniform] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_buffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shared] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_coherent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_writeonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_subroutine] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varying] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_attribute] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_layout] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_highp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mediump] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lowp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_smooth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_flat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noperspective] = {
    .visible = true,
    .named = false,
  },
  [sym_invariant_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_precise_qualifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_number_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token6] = {
    .visible = false,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__external_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__init_declarator_list] = {
    .visible = false,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_list] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_iteration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_jump_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_function_prototype] = {
    .visible = true,
    .named = true,
  },
  [sym_case_label] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_fully_specified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declarator] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__array_specifier_list] = {
    .visible = false,
    .named = false,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declarator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name_list] = {
    .visible = true,
    .named = true,
  },
  [sym_layout_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_layout_qualifier_id] = {
    .visible = true,
    .named = true,
  },
  [sym_precision_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__assignment_left_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_declarator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_qualifier_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_layout_qualifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comma_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alternative = 1,
  field_argument = 2,
  field_array = 3,
  field_body = 4,
  field_condition = 5,
  field_consequence = 6,
  field_declarator = 7,
  field_field = 8,
  field_function = 9,
  field_index = 10,
  field_initializer = 11,
  field_left = 12,
  field_name = 13,
  field_operand = 14,
  field_operator = 15,
  field_parameters = 16,
  field_right = 17,
  field_type = 18,
  field_update = 19,
  field_value = 20,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_array] = "array",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_declarator] = "declarator",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_left] = "left",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 2},
  [6] = {.index = 8, .length = 1},
  [7] = {.index = 9, .length = 4},
  [8] = {.index = 13, .length = 3},
  [9] = {.index = 16, .length = 2},
  [10] = {.index = 18, .length = 1},
  [11] = {.index = 19, .length = 2},
  [12] = {.index = 21, .length = 3},
  [13] = {.index = 24, .length = 2},
  [14] = {.index = 26, .length = 2},
  [15] = {.index = 28, .length = 2},
  [16] = {.index = 30, .length = 2},
  [17] = {.index = 32, .length = 2},
  [18] = {.index = 34, .length = 1},
  [19] = {.index = 35, .length = 3},
  [20] = {.index = 38, .length = 2},
  [21] = {.index = 40, .length = 4},
  [22] = {.index = 44, .length = 1},
  [23] = {.index = 45, .length = 2},
  [24] = {.index = 47, .length = 4},
  [25] = {.index = 51, .length = 3},
  [26] = {.index = 54, .length = 2},
  [27] = {.index = 56, .length = 5},
  [28] = {.index = 61, .length = 1},
  [29] = {.index = 62, .length = 4},
  [30] = {.index = 66, .length = 1},
  [31] = {.index = 67, .length = 3},
  [32] = {.index = 70, .length = 2},
  [33] = {.index = 72, .length = 2},
  [34] = {.index = 74, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 0, .inherited = true},
    {field_declarator, 0, .inherited = true},
  [2] =
    {field_body, 0},
  [3] =
    {field_declarator, 0},
  [4] =
    {field_declarator, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [6] =
    {field_body, 1},
    {field_declarator, 0},
  [8] =
    {field_declarator, 1},
  [9] =
    {field_body, 0, .inherited = true},
    {field_body, 1, .inherited = true},
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [13] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 2},
    {field_value, 0, .inherited = true},
  [16] =
    {field_name, 1},
    {field_type, 0},
  [18] =
    {field_body, 2},
  [19] =
    {field_operand, 1},
    {field_operator, 0},
  [21] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 0},
  [24] =
    {field_declarator, 1},
    {field_value, 3},
  [26] =
    {field_declarator, 2},
    {field_type, 1},
  [28] =
    {field_declarator, 1},
    {field_type, 0},
  [30] =
    {field_body, 3},
    {field_declarator, 1},
  [32] =
    {field_declarator, 0},
    {field_value, 2},
  [34] =
    {field_function, 0},
  [35] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [38] =
    {field_argument, 0},
    {field_field, 2},
  [40] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 2},
    {field_value, 0, .inherited = true},
    {field_value, 4},
  [44] =
    {field_condition, 0},
  [45] =
    {field_array, 0},
    {field_index, 2},
  [47] =
    {field_body, 2},
    {field_body, 3},
    {field_body, 4},
    {field_declarator, 1},
  [51] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [54] =
    {field_condition, 2},
    {field_consequence, 4},
  [56] =
    {field_body, 2},
    {field_body, 3},
    {field_body, 4},
    {field_declarator, 1},
    {field_declarator, 5},
  [61] =
    {field_condition, 2},
  [62] =
    {field_condition, 0},
    {field_condition, 2},
    {field_condition, 3},
    {field_declarator, 1},
  [66] =
    {field_initializer, 2},
  [67] =
    {field_alternative, 6},
    {field_condition, 2},
    {field_consequence, 4},
  [70] =
    {field_body, 5},
    {field_condition, 2},
  [72] =
    {field_initializer, 2},
    {field_update, 4},
  [74] =
    {field_initializer, 2},
    {field_update, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(18);
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '#') ADVANCE(90);
      if (lookahead == '%') ADVANCE(47);
      if (lookahead == '&') ADVANCE(44);
      if (lookahead == '(') ADVANCE(25);
      if (lookahead == ')') ADVANCE(26);
      if (lookahead == '*') ADVANCE(42);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == ',') ADVANCE(22);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(56);
      if (lookahead == '/') ADVANCE(43);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead == '<') ADVANCE(31);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(30);
      if (lookahead == '?') ADVANCE(67);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '^') ADVANCE(46);
      if (lookahead == '{') ADVANCE(20);
      if (lookahead == '|') ADVANCE(45);
      if (lookahead == '}') ADVANCE(21);
      if (lookahead == '~') ADVANCE(52);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(71);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(70);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(91);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(5);
      if (lookahead == '#') ADVANCE(90);
      if (lookahead == '%') ADVANCE(47);
      if (lookahead == '&') ADVANCE(44);
      if (lookahead == '(') ADVANCE(25);
      if (lookahead == ')') ADVANCE(26);
      if (lookahead == '*') ADVANCE(42);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == ',') ADVANCE(22);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(55);
      if (lookahead == '/') ADVANCE(43);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead == '<') ADVANCE(31);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(30);
      if (lookahead == '?') ADVANCE(67);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '^') ADVANCE(46);
      if (lookahead == '|') ADVANCE(45);
      if (lookahead == '}') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(91);
      END_STATE();
    case 2:
      if (lookahead == '*') ADVANCE(4);
      if (lookahead == '/') ADVANCE(89);
      END_STATE();
    case 3:
      if (lookahead == '*') ADVANCE(3);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == '*') ADVANCE(3);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == '=') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      END_STATE();
    case 7:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(83);
      END_STATE();
    case 8:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 9:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(84);
      END_STATE();
    case 10:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(81);
      END_STATE();
    case 11:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(78);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(85);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(83);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 17:
      if (eof) ADVANCE(18);
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(90);
      if (lookahead == '(') ADVANCE(25);
      if (lookahead == ')') ADVANCE(26);
      if (lookahead == '+') ADVANCE(38);
      if (lookahead == ',') ADVANCE(22);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '.') ADVANCE(12);
      if (lookahead == '/') ADVANCE(2);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead == '=') ADVANCE(23);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '{') ADVANCE(20);
      if (lookahead == '}') ADVANCE(21);
      if (lookahead == '~') ADVANCE(52);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(71);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(70);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(91);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(34);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(27);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(49);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(48);
      if (lookahead == '=') ADVANCE(33);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(53);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(53);
      if (lookahead == '=') ADVANCE(57);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(54);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '=') ADVANCE(58);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(59);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(60);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == '=') ADVANCE(64);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(66);
      if (lookahead == '|') ADVANCE(37);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(65);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(61);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(62);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(63);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(35);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(85);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(69);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(72);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(69);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(74);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_number_literal_token4);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(aux_sym_number_literal_token4);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(8);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(78);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(11);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_number_literal_token4);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(78);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(aux_sym_number_literal_token5);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(aux_sym_number_literal_token5);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(7);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(81);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(10);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym_number_literal_token5);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(81);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(10);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_number_literal_token6);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_number_literal_token6);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(6);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(84);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(9);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_number_literal_token6);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(84);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(89);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead != 0) ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(90);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(91);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'h') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'l') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'p') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(14);
      if (lookahead == 's') ADVANCE(15);
      if (lookahead == 't') ADVANCE(16);
      if (lookahead == 'u') ADVANCE(17);
      if (lookahead == 'v') ADVANCE(18);
      if (lookahead == 'w') ADVANCE(19);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 't') ADVANCE(20);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(21);
      if (lookahead == 'r') ADVANCE(22);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'v') ADVANCE(24);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'e') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'i') ADVANCE(29);
      if (lookahead == 'm') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'v') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 7:
      if (lookahead == 'i') ADVANCE(37);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(39);
      if (lookahead == 'm') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(41);
      if (lookahead == 's') ADVANCE(42);
      if (lookahead == 'v') ADVANCE(43);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 12:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(52);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'h') ADVANCE(54);
      if (lookahead == 'm') ADVANCE(55);
      if (lookahead == 't') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      if (lookahead == 'w') ADVANCE(58);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 17:
      if (lookahead == 'i') ADVANCE(60);
      if (lookahead == 'n') ADVANCE(61);
      if (lookahead == 's') ADVANCE(62);
      if (lookahead == 'v') ADVANCE(63);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'e') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'o') ADVANCE(69);
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'f') ADVANCE(73);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'n') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'h') ADVANCE(77);
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 32:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(84);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 35:
      if (lookahead == 'a') ADVANCE(86);
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 37:
      if (lookahead == 'g') ADVANCE(89);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 39:
      if (lookahead == 'm') ADVANCE(90);
      END_STATE();
    case 40:
      if (lookahead == 'a') ADVANCE(91);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'o') ADVANCE(92);
      if (lookahead == 't') ADVANCE(93);
      if (lookahead == 'v') ADVANCE(94);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(95);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 44:
      if (lookahead == 'y') ADVANCE(97);
      END_STATE();
    case 45:
      if (lookahead == 'w') ADVANCE(98);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 47:
      if (lookahead == 'd') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(105);
      if (lookahead == 's') ADVANCE(106);
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 53:
      if (lookahead == 'm') ADVANCE(108);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(109);
      END_STATE();
    case 55:
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 56:
      if (lookahead == 'r') ADVANCE(111);
      END_STATE();
    case 57:
      if (lookahead == 'b') ADVANCE(112);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 59:
      if (lookahead == 'u') ADVANCE(114);
      END_STATE();
    case 60:
      if (lookahead == 'm') ADVANCE(115);
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 62:
      if (lookahead == 'a') ADVANCE(118);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 64:
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(121);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(122);
      if (lookahead == 'l') ADVANCE(123);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 69:
      if (lookahead == 'm') ADVANCE(126);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(127);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(128);
      END_STATE();
    case 72:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 73:
      if (lookahead == 'f') ADVANCE(130);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(131);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(135);
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'a') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 'c') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 82:
      if (lookahead == 'b') ADVANCE(140);
      END_STATE();
    case 83:
      if (lookahead == 'c') ADVANCE(141);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 86:
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(145);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 89:
      if (lookahead == 'h') ADVANCE(146);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 91:
      if (lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 92:
      if (lookahead == 'u') ADVANCE(149);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 95:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 96:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 97:
      if (lookahead == 'o') ADVANCE(153);
      END_STATE();
    case 98:
      if (lookahead == 'p') ADVANCE(154);
      END_STATE();
    case 99:
      if (lookahead == '2') ADVANCE(155);
      if (lookahead == '3') ADVANCE(156);
      if (lookahead == '4') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(158);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 103:
      if (lookahead == 'c') ADVANCE(160);
      END_STATE();
    case 104:
      if (lookahead == 'c') ADVANCE(161);
      END_STATE();
    case 105:
      if (lookahead == 'd') ADVANCE(162);
      END_STATE();
    case 106:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(164);
      END_STATE();
    case 108:
      if (lookahead == 'p') ADVANCE(165);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(166);
      END_STATE();
    case 110:
      if (lookahead == 'o') ADVANCE(167);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 112:
      if (lookahead == 'r') ADVANCE(169);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 115:
      if (lookahead == 'a') ADVANCE(172);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 117:
      if (lookahead == 'f') ADVANCE(174);
      END_STATE();
    case 118:
      if (lookahead == 'm') ADVANCE(175);
      END_STATE();
    case 119:
      if (lookahead == 'c') ADVANCE(176);
      END_STATE();
    case 120:
      if (lookahead == 'y') ADVANCE(177);
      END_STATE();
    case 121:
      if (lookahead == '2') ADVANCE(178);
      if (lookahead == '3') ADVANCE(179);
      if (lookahead == '4') ADVANCE(180);
      END_STATE();
    case 122:
      if (lookahead == 'd') ADVANCE(181);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(182);
      END_STATE();
    case 124:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(184);
      END_STATE();
    case 126:
      if (lookahead == 'i') ADVANCE(185);
      END_STATE();
    case 127:
      if (lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 129:
      if (lookahead == 'k') ADVANCE(187);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 131:
      if (lookahead == '2') ADVANCE(189);
      if (lookahead == '3') ADVANCE(190);
      if (lookahead == '4') ADVANCE(191);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 136:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 137:
      if (lookahead == 'u') ADVANCE(196);
      END_STATE();
    case 138:
      if (lookahead == 'a') ADVANCE(197);
      END_STATE();
    case 139:
      if (lookahead == '2') ADVANCE(198);
      if (lookahead == '3') ADVANCE(199);
      if (lookahead == '4') ADVANCE(200);
      END_STATE();
    case 140:
      if (lookahead == 'l') ADVANCE(201);
      END_STATE();
    case 141:
      if (lookahead == '2') ADVANCE(202);
      if (lookahead == '3') ADVANCE(203);
      if (lookahead == '4') ADVANCE(204);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_flat);
      END_STATE();
    case 145:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 146:
      if (lookahead == 'p') ADVANCE(207);
      END_STATE();
    case 147:
      if (lookahead == 'g') ADVANCE(208);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 149:
      if (lookahead == 't') ADVANCE(210);
      END_STATE();
    case 150:
      if (lookahead == 'r') ADVANCE(211);
      END_STATE();
    case 151:
      if (lookahead == 'p') ADVANCE(212);
      END_STATE();
    case 152:
      if (lookahead == '2') ADVANCE(213);
      if (lookahead == '3') ADVANCE(214);
      if (lookahead == '4') ADVANCE(215);
      END_STATE();
    case 153:
      if (lookahead == 'u') ADVANCE(216);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_lowp);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_mat2);
      if (lookahead == 'x') ADVANCE(217);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_mat3);
      if (lookahead == 'x') ADVANCE(218);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_mat4);
      if (lookahead == 'x') ADVANCE(219);
      END_STATE();
    case 158:
      if (lookahead == 'u') ADVANCE(220);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 160:
      if (lookahead == 'h') ADVANCE(222);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(223);
      END_STATE();
    case 162:
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 163:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 165:
      if (lookahead == 'l') ADVANCE(227);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 167:
      if (lookahead == 't') ADVANCE(229);
      END_STATE();
    case 168:
      if (lookahead == 'c') ADVANCE(230);
      END_STATE();
    case 169:
      if (lookahead == 'o') ADVANCE(231);
      END_STATE();
    case 170:
      if (lookahead == 'c') ADVANCE(232);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 172:
      if (lookahead == 'g') ADVANCE(233);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_uint);
      END_STATE();
    case 174:
      if (lookahead == 'o') ADVANCE(234);
      END_STATE();
    case 175:
      if (lookahead == 'p') ADVANCE(235);
      END_STATE();
    case 176:
      if (lookahead == '2') ADVANCE(236);
      if (lookahead == '3') ADVANCE(237);
      if (lookahead == '4') ADVANCE(238);
      END_STATE();
    case 177:
      if (lookahead == 'i') ADVANCE(239);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_vec2);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_vec3);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_vec4);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 182:
      if (lookahead == 't') ADVANCE(240);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 185:
      if (lookahead == 'c') ADVANCE(243);
      END_STATE();
    case 186:
      if (lookahead == 'b') ADVANCE(244);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 188:
      if (lookahead == 'r') ADVANCE(245);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_bvec2);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_bvec3);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_bvec4);
      END_STATE();
    case 192:
      if (lookahead == 'o') ADVANCE(246);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(247);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 195:
      if (lookahead == 'n') ADVANCE(248);
      END_STATE();
    case 196:
      if (lookahead == 'l') ADVANCE(249);
      END_STATE();
    case 197:
      if (lookahead == 'r') ADVANCE(250);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_dmat2);
      if (lookahead == 'x') ADVANCE(251);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_dmat3);
      if (lookahead == 'x') ADVANCE(252);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_dmat4);
      if (lookahead == 'x') ADVANCE(253);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(254);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_dvec2);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_dvec3);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_dvec4);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_highp);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 209:
      if (lookahead == '1') ADVANCE(256);
      if (lookahead == '2') ADVANCE(257);
      if (lookahead == '3') ADVANCE(258);
      if (lookahead == 'B') ADVANCE(259);
      if (lookahead == 'C') ADVANCE(260);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_inout);
      END_STATE();
    case 211:
      if (lookahead == 'i') ADVANCE(261);
      END_STATE();
    case 212:
      if (lookahead == 'l') ADVANCE(262);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_ivec2);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_ivec3);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_ivec4);
      END_STATE();
    case 216:
      if (lookahead == 't') ADVANCE(263);
      END_STATE();
    case 217:
      if (lookahead == '2') ADVANCE(264);
      if (lookahead == '3') ADVANCE(265);
      if (lookahead == '4') ADVANCE(266);
      END_STATE();
    case 218:
      if (lookahead == '2') ADVANCE(267);
      if (lookahead == '3') ADVANCE(268);
      if (lookahead == '4') ADVANCE(269);
      END_STATE();
    case 219:
      if (lookahead == '2') ADVANCE(270);
      if (lookahead == '3') ADVANCE(271);
      if (lookahead == '4') ADVANCE(272);
      END_STATE();
    case 220:
      if (lookahead == 'm') ADVANCE(273);
      END_STATE();
    case 221:
      if (lookahead == 's') ADVANCE(274);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_patch);
      END_STATE();
    case 223:
      if (lookahead == 's') ADVANCE(275);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(276);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(277);
      END_STATE();
    case 226:
      if (lookahead == 'n') ADVANCE(278);
      END_STATE();
    case 227:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 228:
      if (lookahead == 'd') ADVANCE(280);
      END_STATE();
    case 229:
      if (lookahead == 'h') ADVANCE(281);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 231:
      if (lookahead == 'u') ADVANCE(283);
      END_STATE();
    case 232:
      if (lookahead == 'h') ADVANCE(284);
      END_STATE();
    case 233:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 234:
      if (lookahead == 'r') ADVANCE(286);
      END_STATE();
    case 235:
      if (lookahead == 'l') ADVANCE(287);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_uvec2);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_uvec3);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_uvec4);
      END_STATE();
    case 239:
      if (lookahead == 'n') ADVANCE(288);
      END_STATE();
    case 240:
      if (lookahead == 'i') ADVANCE(289);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 242:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 243:
      if (lookahead == '_') ADVANCE(291);
      END_STATE();
    case 244:
      if (lookahead == 'u') ADVANCE(292);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_buffer);
      END_STATE();
    case 246:
      if (lookahead == 'i') ADVANCE(293);
      END_STATE();
    case 247:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 248:
      if (lookahead == 'u') ADVANCE(295);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(296);
      END_STATE();
    case 250:
      if (lookahead == 'd') ADVANCE(297);
      END_STATE();
    case 251:
      if (lookahead == '2') ADVANCE(298);
      if (lookahead == '3') ADVANCE(299);
      if (lookahead == '4') ADVANCE(300);
      END_STATE();
    case 252:
      if (lookahead == '2') ADVANCE(301);
      if (lookahead == '3') ADVANCE(302);
      if (lookahead == '4') ADVANCE(303);
      END_STATE();
    case 253:
      if (lookahead == '2') ADVANCE(304);
      if (lookahead == '3') ADVANCE(305);
      if (lookahead == '4') ADVANCE(306);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 255:
      if (lookahead == '1') ADVANCE(307);
      if (lookahead == '2') ADVANCE(308);
      if (lookahead == '3') ADVANCE(309);
      if (lookahead == 'B') ADVANCE(310);
      if (lookahead == 'C') ADVANCE(311);
      END_STATE();
    case 256:
      if (lookahead == 'D') ADVANCE(312);
      END_STATE();
    case 257:
      if (lookahead == 'D') ADVANCE(313);
      END_STATE();
    case 258:
      if (lookahead == 'D') ADVANCE(314);
      END_STATE();
    case 259:
      if (lookahead == 'u') ADVANCE(315);
      END_STATE();
    case 260:
      if (lookahead == 'u') ADVANCE(316);
      END_STATE();
    case 261:
      if (lookahead == 'a') ADVANCE(317);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_layout);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_mat2x2);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_mat2x3);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_mat2x4);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_mat3x2);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_mat3x3);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_mat3x4);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_mat4x2);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_mat4x3);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_mat4x4);
      END_STATE();
    case 273:
      if (lookahead == 'p') ADVANCE(319);
      END_STATE();
    case 274:
      if (lookahead == 'p') ADVANCE(320);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(321);
      if (lookahead == 'i') ADVANCE(322);
      END_STATE();
    case 276:
      if (lookahead == 'l') ADVANCE(323);
      END_STATE();
    case 277:
      if (lookahead == 'c') ADVANCE(324);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_sample);
      if (lookahead == 'r') ADVANCE(325);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_shared);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_smooth);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 283:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 285:
      if (lookahead == '1') ADVANCE(327);
      if (lookahead == '2') ADVANCE(328);
      if (lookahead == '3') ADVANCE(329);
      if (lookahead == 'B') ADVANCE(330);
      if (lookahead == 'C') ADVANCE(331);
      END_STATE();
    case 286:
      if (lookahead == 'm') ADVANCE(332);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 288:
      if (lookahead == 'g') ADVANCE(334);
      END_STATE();
    case 289:
      if (lookahead == 'l') ADVANCE(335);
      END_STATE();
    case 290:
      if (lookahead == 'n') ADVANCE(336);
      END_STATE();
    case 291:
      if (lookahead == 'u') ADVANCE(337);
      END_STATE();
    case 292:
      if (lookahead == 't') ADVANCE(338);
      END_STATE();
    case 293:
      if (lookahead == 'd') ADVANCE(339);
      END_STATE();
    case 294:
      if (lookahead == 't') ADVANCE(340);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_discard);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_dmat2x2);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_dmat2x3);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_dmat2x4);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_dmat3x2);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_dmat3x3);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_dmat3x4);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_dmat4x2);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_dmat4x3);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_dmat4x4);
      END_STATE();
    case 307:
      if (lookahead == 'D') ADVANCE(342);
      END_STATE();
    case 308:
      if (lookahead == 'D') ADVANCE(343);
      END_STATE();
    case 309:
      if (lookahead == 'D') ADVANCE(344);
      END_STATE();
    case 310:
      if (lookahead == 'u') ADVANCE(345);
      END_STATE();
    case 311:
      if (lookahead == 'u') ADVANCE(346);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_image1D);
      if (lookahead == 'A') ADVANCE(347);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_image2D);
      if (lookahead == 'A') ADVANCE(348);
      if (lookahead == 'M') ADVANCE(349);
      if (lookahead == 'R') ADVANCE(350);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_image3D);
      END_STATE();
    case 315:
      if (lookahead == 'f') ADVANCE(351);
      END_STATE();
    case 316:
      if (lookahead == 'b') ADVANCE(352);
      END_STATE();
    case 317:
      if (lookahead == 'n') ADVANCE(353);
      END_STATE();
    case 318:
      if (lookahead == 'r') ADVANCE(354);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_mediump);
      END_STATE();
    case 320:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_precise_qualifier);
      END_STATE();
    case 322:
      if (lookahead == 'o') ADVANCE(356);
      END_STATE();
    case 323:
      if (lookahead == 'y') ADVANCE(357);
      END_STATE();
    case 324:
      if (lookahead == 't') ADVANCE(358);
      END_STATE();
    case 325:
      if (lookahead == '1') ADVANCE(359);
      if (lookahead == '2') ADVANCE(360);
      if (lookahead == '3') ADVANCE(361);
      if (lookahead == 'B') ADVANCE(362);
      if (lookahead == 'C') ADVANCE(363);
      if (lookahead == 'c') ADVANCE(364);
      END_STATE();
    case 326:
      if (lookahead == 'i') ADVANCE(365);
      END_STATE();
    case 327:
      if (lookahead == 'D') ADVANCE(366);
      END_STATE();
    case 328:
      if (lookahead == 'D') ADVANCE(367);
      END_STATE();
    case 329:
      if (lookahead == 'D') ADVANCE(368);
      END_STATE();
    case 330:
      if (lookahead == 'u') ADVANCE(369);
      END_STATE();
    case 331:
      if (lookahead == 'u') ADVANCE(370);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_uniform);
      END_STATE();
    case 333:
      if (lookahead == 'r') ADVANCE(371);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_varying);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(372);
      END_STATE();
    case 336:
      if (lookahead == 'l') ADVANCE(373);
      END_STATE();
    case 337:
      if (lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 338:
      if (lookahead == 'e') ADVANCE(375);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_centroid);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_coherent);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_iimage1D);
      if (lookahead == 'A') ADVANCE(376);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_iimage2D);
      if (lookahead == 'A') ADVANCE(377);
      if (lookahead == 'M') ADVANCE(378);
      if (lookahead == 'R') ADVANCE(379);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_iimage3D);
      END_STATE();
    case 345:
      if (lookahead == 'f') ADVANCE(380);
      END_STATE();
    case 346:
      if (lookahead == 'b') ADVANCE(381);
      END_STATE();
    case 347:
      if (lookahead == 'r') ADVANCE(382);
      END_STATE();
    case 348:
      if (lookahead == 'r') ADVANCE(383);
      END_STATE();
    case 349:
      if (lookahead == 'S') ADVANCE(384);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(385);
      END_STATE();
    case 351:
      if (lookahead == 'f') ADVANCE(386);
      END_STATE();
    case 352:
      if (lookahead == 'e') ADVANCE(387);
      END_STATE();
    case 353:
      if (lookahead == 't') ADVANCE(388);
      END_STATE();
    case 354:
      if (lookahead == '1') ADVANCE(389);
      if (lookahead == '2') ADVANCE(390);
      if (lookahead == '3') ADVANCE(391);
      if (lookahead == 'B') ADVANCE(392);
      if (lookahead == 'C') ADVANCE(393);
      END_STATE();
    case 355:
      if (lookahead == 'c') ADVANCE(394);
      END_STATE();
    case 356:
      if (lookahead == 'n') ADVANCE(395);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 359:
      if (lookahead == 'D') ADVANCE(396);
      if (lookahead == 'd') ADVANCE(397);
      END_STATE();
    case 360:
      if (lookahead == 'D') ADVANCE(398);
      if (lookahead == 'd') ADVANCE(399);
      END_STATE();
    case 361:
      if (lookahead == 'd') ADVANCE(400);
      END_STATE();
    case 362:
      if (lookahead == 'u') ADVANCE(401);
      END_STATE();
    case 363:
      if (lookahead == 'u') ADVANCE(402);
      END_STATE();
    case 364:
      if (lookahead == 'u') ADVANCE(403);
      END_STATE();
    case 365:
      if (lookahead == 'n') ADVANCE(404);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_uimage1D);
      if (lookahead == 'A') ADVANCE(405);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_uimage2D);
      if (lookahead == 'A') ADVANCE(406);
      if (lookahead == 'M') ADVANCE(407);
      if (lookahead == 'R') ADVANCE(408);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_uimage3D);
      END_STATE();
    case 369:
      if (lookahead == 'f') ADVANCE(409);
      END_STATE();
    case 370:
      if (lookahead == 'b') ADVANCE(410);
      END_STATE();
    case 371:
      if (lookahead == '1') ADVANCE(411);
      if (lookahead == '2') ADVANCE(412);
      if (lookahead == '3') ADVANCE(413);
      if (lookahead == 'B') ADVANCE(414);
      if (lookahead == 'C') ADVANCE(415);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 373:
      if (lookahead == 'y') ADVANCE(416);
      END_STATE();
    case 374:
      if (lookahead == 'n') ADVANCE(417);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_attribute);
      END_STATE();
    case 376:
      if (lookahead == 'r') ADVANCE(418);
      END_STATE();
    case 377:
      if (lookahead == 'r') ADVANCE(419);
      END_STATE();
    case 378:
      if (lookahead == 'S') ADVANCE(420);
      END_STATE();
    case 379:
      if (lookahead == 'e') ADVANCE(421);
      END_STATE();
    case 380:
      if (lookahead == 'f') ADVANCE(422);
      END_STATE();
    case 381:
      if (lookahead == 'e') ADVANCE(423);
      END_STATE();
    case 382:
      if (lookahead == 'r') ADVANCE(424);
      END_STATE();
    case 383:
      if (lookahead == 'r') ADVANCE(425);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_image2DMS);
      if (lookahead == 'A') ADVANCE(426);
      END_STATE();
    case 385:
      if (lookahead == 'c') ADVANCE(427);
      END_STATE();
    case 386:
      if (lookahead == 'e') ADVANCE(428);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_imageCube);
      if (lookahead == 'A') ADVANCE(429);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_invariant_qualifier);
      END_STATE();
    case 389:
      if (lookahead == 'D') ADVANCE(430);
      END_STATE();
    case 390:
      if (lookahead == 'D') ADVANCE(431);
      END_STATE();
    case 391:
      if (lookahead == 'D') ADVANCE(432);
      END_STATE();
    case 392:
      if (lookahead == 'u') ADVANCE(433);
      END_STATE();
    case 393:
      if (lookahead == 'u') ADVANCE(434);
      END_STATE();
    case 394:
      if (lookahead == 't') ADVANCE(435);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_precision);
      END_STATE();
    case 396:
      if (lookahead == 'A') ADVANCE(436);
      if (lookahead == 'S') ADVANCE(437);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_sampler1d);
      END_STATE();
    case 398:
      if (lookahead == 'A') ADVANCE(438);
      if (lookahead == 'M') ADVANCE(439);
      if (lookahead == 'R') ADVANCE(440);
      if (lookahead == 'S') ADVANCE(441);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_sampler2d);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_sampler3d);
      END_STATE();
    case 401:
      if (lookahead == 'f') ADVANCE(442);
      END_STATE();
    case 402:
      if (lookahead == 'b') ADVANCE(443);
      END_STATE();
    case 403:
      if (lookahead == 'b') ADVANCE(444);
      END_STATE();
    case 404:
      if (lookahead == 'e') ADVANCE(445);
      END_STATE();
    case 405:
      if (lookahead == 'r') ADVANCE(446);
      END_STATE();
    case 406:
      if (lookahead == 'r') ADVANCE(447);
      END_STATE();
    case 407:
      if (lookahead == 'S') ADVANCE(448);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(449);
      END_STATE();
    case 409:
      if (lookahead == 'f') ADVANCE(450);
      END_STATE();
    case 410:
      if (lookahead == 'e') ADVANCE(451);
      END_STATE();
    case 411:
      if (lookahead == 'D') ADVANCE(452);
      END_STATE();
    case 412:
      if (lookahead == 'D') ADVANCE(453);
      END_STATE();
    case 413:
      if (lookahead == 'D') ADVANCE(454);
      END_STATE();
    case 414:
      if (lookahead == 'u') ADVANCE(455);
      END_STATE();
    case 415:
      if (lookahead == 'u') ADVANCE(456);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_writeonly);
      END_STATE();
    case 417:
      if (lookahead == 't') ADVANCE(457);
      END_STATE();
    case 418:
      if (lookahead == 'r') ADVANCE(458);
      END_STATE();
    case 419:
      if (lookahead == 'r') ADVANCE(459);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_iimage2DMS);
      if (lookahead == 'A') ADVANCE(460);
      END_STATE();
    case 421:
      if (lookahead == 'c') ADVANCE(461);
      END_STATE();
    case 422:
      if (lookahead == 'e') ADVANCE(462);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_iimageCube);
      if (lookahead == 'A') ADVANCE(463);
      END_STATE();
    case 424:
      if (lookahead == 'a') ADVANCE(464);
      END_STATE();
    case 425:
      if (lookahead == 'a') ADVANCE(465);
      END_STATE();
    case 426:
      if (lookahead == 'r') ADVANCE(466);
      END_STATE();
    case 427:
      if (lookahead == 't') ADVANCE(467);
      END_STATE();
    case 428:
      if (lookahead == 'r') ADVANCE(468);
      END_STATE();
    case 429:
      if (lookahead == 'r') ADVANCE(469);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_isampler1D);
      if (lookahead == 'A') ADVANCE(470);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_isampler2D);
      if (lookahead == 'A') ADVANCE(471);
      if (lookahead == 'M') ADVANCE(472);
      if (lookahead == 'R') ADVANCE(473);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_isampler3D);
      END_STATE();
    case 433:
      if (lookahead == 'f') ADVANCE(474);
      END_STATE();
    case 434:
      if (lookahead == 'b') ADVANCE(475);
      END_STATE();
    case 435:
      if (lookahead == 'i') ADVANCE(476);
      END_STATE();
    case 436:
      if (lookahead == 'r') ADVANCE(477);
      END_STATE();
    case 437:
      if (lookahead == 'h') ADVANCE(478);
      END_STATE();
    case 438:
      if (lookahead == 'r') ADVANCE(479);
      END_STATE();
    case 439:
      if (lookahead == 'S') ADVANCE(480);
      END_STATE();
    case 440:
      if (lookahead == 'e') ADVANCE(481);
      END_STATE();
    case 441:
      if (lookahead == 'h') ADVANCE(482);
      END_STATE();
    case 442:
      if (lookahead == 'f') ADVANCE(483);
      END_STATE();
    case 443:
      if (lookahead == 'e') ADVANCE(484);
      END_STATE();
    case 444:
      if (lookahead == 'e') ADVANCE(485);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_subroutine);
      END_STATE();
    case 446:
      if (lookahead == 'r') ADVANCE(486);
      END_STATE();
    case 447:
      if (lookahead == 'r') ADVANCE(487);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_uimage2DMS);
      if (lookahead == 'A') ADVANCE(488);
      END_STATE();
    case 449:
      if (lookahead == 'c') ADVANCE(489);
      END_STATE();
    case 450:
      if (lookahead == 'e') ADVANCE(490);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_uimageCube);
      if (lookahead == 'A') ADVANCE(491);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_usampler1D);
      if (lookahead == 'A') ADVANCE(492);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_usampler2D);
      if (lookahead == 'A') ADVANCE(493);
      if (lookahead == 'M') ADVANCE(494);
      if (lookahead == 'R') ADVANCE(495);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_usampler3D);
      END_STATE();
    case 455:
      if (lookahead == 'f') ADVANCE(496);
      END_STATE();
    case 456:
      if (lookahead == 'b') ADVANCE(497);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_atomic_uint);
      END_STATE();
    case 458:
      if (lookahead == 'a') ADVANCE(498);
      END_STATE();
    case 459:
      if (lookahead == 'a') ADVANCE(499);
      END_STATE();
    case 460:
      if (lookahead == 'r') ADVANCE(500);
      END_STATE();
    case 461:
      if (lookahead == 't') ADVANCE(501);
      END_STATE();
    case 462:
      if (lookahead == 'r') ADVANCE(502);
      END_STATE();
    case 463:
      if (lookahead == 'r') ADVANCE(503);
      END_STATE();
    case 464:
      if (lookahead == 'y') ADVANCE(504);
      END_STATE();
    case 465:
      if (lookahead == 'y') ADVANCE(505);
      END_STATE();
    case 466:
      if (lookahead == 'r') ADVANCE(506);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_image2DRect);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_imageBuffer);
      END_STATE();
    case 469:
      if (lookahead == 'r') ADVANCE(507);
      END_STATE();
    case 470:
      if (lookahead == 'r') ADVANCE(508);
      END_STATE();
    case 471:
      if (lookahead == 'r') ADVANCE(509);
      END_STATE();
    case 472:
      if (lookahead == 'S') ADVANCE(510);
      END_STATE();
    case 473:
      if (lookahead == 'e') ADVANCE(511);
      END_STATE();
    case 474:
      if (lookahead == 'f') ADVANCE(512);
      END_STATE();
    case 475:
      if (lookahead == 'e') ADVANCE(513);
      END_STATE();
    case 476:
      if (lookahead == 'v') ADVANCE(514);
      END_STATE();
    case 477:
      if (lookahead == 'r') ADVANCE(515);
      END_STATE();
    case 478:
      if (lookahead == 'a') ADVANCE(516);
      END_STATE();
    case 479:
      if (lookahead == 'r') ADVANCE(517);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_sampler2DMS);
      if (lookahead == 'A') ADVANCE(518);
      END_STATE();
    case 481:
      if (lookahead == 'c') ADVANCE(519);
      END_STATE();
    case 482:
      if (lookahead == 'a') ADVANCE(520);
      END_STATE();
    case 483:
      if (lookahead == 'e') ADVANCE(521);
      END_STATE();
    case 484:
      if (lookahead == 'A') ADVANCE(522);
      if (lookahead == 'S') ADVANCE(523);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_samplercube);
      END_STATE();
    case 486:
      if (lookahead == 'a') ADVANCE(524);
      END_STATE();
    case 487:
      if (lookahead == 'a') ADVANCE(525);
      END_STATE();
    case 488:
      if (lookahead == 'r') ADVANCE(526);
      END_STATE();
    case 489:
      if (lookahead == 't') ADVANCE(527);
      END_STATE();
    case 490:
      if (lookahead == 'r') ADVANCE(528);
      END_STATE();
    case 491:
      if (lookahead == 'r') ADVANCE(529);
      END_STATE();
    case 492:
      if (lookahead == 'r') ADVANCE(530);
      END_STATE();
    case 493:
      if (lookahead == 'r') ADVANCE(531);
      END_STATE();
    case 494:
      if (lookahead == 'S') ADVANCE(532);
      END_STATE();
    case 495:
      if (lookahead == 'e') ADVANCE(533);
      END_STATE();
    case 496:
      if (lookahead == 'f') ADVANCE(534);
      END_STATE();
    case 497:
      if (lookahead == 'e') ADVANCE(535);
      END_STATE();
    case 498:
      if (lookahead == 'y') ADVANCE(536);
      END_STATE();
    case 499:
      if (lookahead == 'y') ADVANCE(537);
      END_STATE();
    case 500:
      if (lookahead == 'r') ADVANCE(538);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_iimage2DRect);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_iimageBuffer);
      END_STATE();
    case 503:
      if (lookahead == 'r') ADVANCE(539);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_image1DArray);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_image2DArray);
      END_STATE();
    case 506:
      if (lookahead == 'a') ADVANCE(540);
      END_STATE();
    case 507:
      if (lookahead == 'a') ADVANCE(541);
      END_STATE();
    case 508:
      if (lookahead == 'r') ADVANCE(542);
      END_STATE();
    case 509:
      if (lookahead == 'r') ADVANCE(543);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_isampler2DMS);
      if (lookahead == 'A') ADVANCE(544);
      END_STATE();
    case 511:
      if (lookahead == 'c') ADVANCE(545);
      END_STATE();
    case 512:
      if (lookahead == 'e') ADVANCE(546);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_isamplerCube);
      if (lookahead == 'A') ADVANCE(547);
      END_STATE();
    case 514:
      if (lookahead == 'e') ADVANCE(548);
      END_STATE();
    case 515:
      if (lookahead == 'a') ADVANCE(549);
      END_STATE();
    case 516:
      if (lookahead == 'd') ADVANCE(550);
      END_STATE();
    case 517:
      if (lookahead == 'a') ADVANCE(551);
      END_STATE();
    case 518:
      if (lookahead == 'r') ADVANCE(552);
      END_STATE();
    case 519:
      if (lookahead == 't') ADVANCE(553);
      END_STATE();
    case 520:
      if (lookahead == 'd') ADVANCE(554);
      END_STATE();
    case 521:
      if (lookahead == 'r') ADVANCE(555);
      END_STATE();
    case 522:
      if (lookahead == 'r') ADVANCE(556);
      END_STATE();
    case 523:
      if (lookahead == 'h') ADVANCE(557);
      END_STATE();
    case 524:
      if (lookahead == 'y') ADVANCE(558);
      END_STATE();
    case 525:
      if (lookahead == 'y') ADVANCE(559);
      END_STATE();
    case 526:
      if (lookahead == 'r') ADVANCE(560);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_uimage2DRect);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_uimageBuffer);
      END_STATE();
    case 529:
      if (lookahead == 'r') ADVANCE(561);
      END_STATE();
    case 530:
      if (lookahead == 'r') ADVANCE(562);
      END_STATE();
    case 531:
      if (lookahead == 'r') ADVANCE(563);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_usampler2DMS);
      if (lookahead == 'A') ADVANCE(564);
      END_STATE();
    case 533:
      if (lookahead == 'c') ADVANCE(565);
      END_STATE();
    case 534:
      if (lookahead == 'e') ADVANCE(566);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_usamplerCube);
      if (lookahead == 'A') ADVANCE(567);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_iimage1DArray);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_iimage2DArray);
      END_STATE();
    case 538:
      if (lookahead == 'a') ADVANCE(568);
      END_STATE();
    case 539:
      if (lookahead == 'a') ADVANCE(569);
      END_STATE();
    case 540:
      if (lookahead == 'y') ADVANCE(570);
      END_STATE();
    case 541:
      if (lookahead == 'y') ADVANCE(571);
      END_STATE();
    case 542:
      if (lookahead == 'a') ADVANCE(572);
      END_STATE();
    case 543:
      if (lookahead == 'a') ADVANCE(573);
      END_STATE();
    case 544:
      if (lookahead == 'r') ADVANCE(574);
      END_STATE();
    case 545:
      if (lookahead == 't') ADVANCE(575);
      END_STATE();
    case 546:
      if (lookahead == 'r') ADVANCE(576);
      END_STATE();
    case 547:
      if (lookahead == 'r') ADVANCE(577);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_noperspective);
      END_STATE();
    case 549:
      if (lookahead == 'y') ADVANCE(578);
      END_STATE();
    case 550:
      if (lookahead == 'o') ADVANCE(579);
      END_STATE();
    case 551:
      if (lookahead == 'y') ADVANCE(580);
      END_STATE();
    case 552:
      if (lookahead == 'r') ADVANCE(581);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_sampler2DRect);
      if (lookahead == 's') ADVANCE(582);
      END_STATE();
    case 554:
      if (lookahead == 'o') ADVANCE(583);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_samplerBuffer);
      END_STATE();
    case 556:
      if (lookahead == 'r') ADVANCE(584);
      END_STATE();
    case 557:
      if (lookahead == 'a') ADVANCE(585);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_uimage1DArray);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_uimage2DArray);
      END_STATE();
    case 560:
      if (lookahead == 'a') ADVANCE(586);
      END_STATE();
    case 561:
      if (lookahead == 'a') ADVANCE(587);
      END_STATE();
    case 562:
      if (lookahead == 'a') ADVANCE(588);
      END_STATE();
    case 563:
      if (lookahead == 'a') ADVANCE(589);
      END_STATE();
    case 564:
      if (lookahead == 'r') ADVANCE(590);
      END_STATE();
    case 565:
      if (lookahead == 't') ADVANCE(591);
      END_STATE();
    case 566:
      if (lookahead == 'r') ADVANCE(592);
      END_STATE();
    case 567:
      if (lookahead == 'r') ADVANCE(593);
      END_STATE();
    case 568:
      if (lookahead == 'y') ADVANCE(594);
      END_STATE();
    case 569:
      if (lookahead == 'y') ADVANCE(595);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_image2DMSArray);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_imageCubeArray);
      END_STATE();
    case 572:
      if (lookahead == 'y') ADVANCE(596);
      END_STATE();
    case 573:
      if (lookahead == 'y') ADVANCE(597);
      END_STATE();
    case 574:
      if (lookahead == 'r') ADVANCE(598);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_isampler2DRect);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_isamplerBuffer);
      END_STATE();
    case 577:
      if (lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_sampler1DArray);
      if (lookahead == 'S') ADVANCE(600);
      END_STATE();
    case 579:
      if (lookahead == 'w') ADVANCE(601);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_sampler2DArray);
      if (lookahead == 'S') ADVANCE(602);
      END_STATE();
    case 581:
      if (lookahead == 'a') ADVANCE(603);
      END_STATE();
    case 582:
      if (lookahead == 'h') ADVANCE(604);
      END_STATE();
    case 583:
      if (lookahead == 'w') ADVANCE(605);
      END_STATE();
    case 584:
      if (lookahead == 'a') ADVANCE(606);
      END_STATE();
    case 585:
      if (lookahead == 'd') ADVANCE(607);
      END_STATE();
    case 586:
      if (lookahead == 'y') ADVANCE(608);
      END_STATE();
    case 587:
      if (lookahead == 'y') ADVANCE(609);
      END_STATE();
    case 588:
      if (lookahead == 'y') ADVANCE(610);
      END_STATE();
    case 589:
      if (lookahead == 'y') ADVANCE(611);
      END_STATE();
    case 590:
      if (lookahead == 'r') ADVANCE(612);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_usampler2DRect);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_usamplerBuffer);
      END_STATE();
    case 593:
      if (lookahead == 'r') ADVANCE(613);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_iimage2DMSArray);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_iimageCubeArray);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_isampler1DArray);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_isampler2DArray);
      END_STATE();
    case 598:
      if (lookahead == 'a') ADVANCE(614);
      END_STATE();
    case 599:
      if (lookahead == 'a') ADVANCE(615);
      END_STATE();
    case 600:
      if (lookahead == 'h') ADVANCE(616);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym_sampler1DShadow);
      END_STATE();
    case 602:
      if (lookahead == 'h') ADVANCE(617);
      END_STATE();
    case 603:
      if (lookahead == 'y') ADVANCE(618);
      END_STATE();
    case 604:
      if (lookahead == 'a') ADVANCE(619);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_sampler2DShadow);
      END_STATE();
    case 606:
      if (lookahead == 'y') ADVANCE(620);
      END_STATE();
    case 607:
      if (lookahead == 'o') ADVANCE(621);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_uimage2DMSArray);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(anon_sym_uimageCubeArray);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(anon_sym_usampler1DArray);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym_usampler2DArray);
      END_STATE();
    case 612:
      if (lookahead == 'a') ADVANCE(622);
      END_STATE();
    case 613:
      if (lookahead == 'a') ADVANCE(623);
      END_STATE();
    case 614:
      if (lookahead == 'y') ADVANCE(624);
      END_STATE();
    case 615:
      if (lookahead == 'y') ADVANCE(625);
      END_STATE();
    case 616:
      if (lookahead == 'a') ADVANCE(626);
      END_STATE();
    case 617:
      if (lookahead == 'a') ADVANCE(627);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(anon_sym_sampler2DMSArray);
      END_STATE();
    case 619:
      if (lookahead == 'd') ADVANCE(628);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym_samplerCubeArray);
      if (lookahead == 'S') ADVANCE(629);
      END_STATE();
    case 621:
      if (lookahead == 'w') ADVANCE(630);
      END_STATE();
    case 622:
      if (lookahead == 'y') ADVANCE(631);
      END_STATE();
    case 623:
      if (lookahead == 'y') ADVANCE(632);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(anon_sym_isampler2DMSArray);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(anon_sym_isamplerCubeArray);
      END_STATE();
    case 626:
      if (lookahead == 'd') ADVANCE(633);
      END_STATE();
    case 627:
      if (lookahead == 'd') ADVANCE(634);
      END_STATE();
    case 628:
      if (lookahead == 'o') ADVANCE(635);
      END_STATE();
    case 629:
      if (lookahead == 'h') ADVANCE(636);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(anon_sym_samplerCubeShadow);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(anon_sym_usampler2DMSArray);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(anon_sym_usamplerCubeArray);
      END_STATE();
    case 633:
      if (lookahead == 'o') ADVANCE(637);
      END_STATE();
    case 634:
      if (lookahead == 'o') ADVANCE(638);
      END_STATE();
    case 635:
      if (lookahead == 'w') ADVANCE(639);
      END_STATE();
    case 636:
      if (lookahead == 'a') ADVANCE(640);
      END_STATE();
    case 637:
      if (lookahead == 'w') ADVANCE(641);
      END_STATE();
    case 638:
      if (lookahead == 'w') ADVANCE(642);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(anon_sym_sampler2DRectshadow);
      END_STATE();
    case 640:
      if (lookahead == 'd') ADVANCE(643);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(anon_sym_sampler1DArrayShadow);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(anon_sym_sampler2DArrayShadow);
      END_STATE();
    case 643:
      if (lookahead == 'o') ADVANCE(644);
      END_STATE();
    case 644:
      if (lookahead == 'w') ADVANCE(645);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(anon_sym_samplerCubeArrayShadow);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 17},
  [2] = {.lex_state = 17},
  [3] = {.lex_state = 17},
  [4] = {.lex_state = 17},
  [5] = {.lex_state = 17},
  [6] = {.lex_state = 17},
  [7] = {.lex_state = 17},
  [8] = {.lex_state = 17},
  [9] = {.lex_state = 17},
  [10] = {.lex_state = 17},
  [11] = {.lex_state = 17},
  [12] = {.lex_state = 17},
  [13] = {.lex_state = 17},
  [14] = {.lex_state = 17},
  [15] = {.lex_state = 17},
  [16] = {.lex_state = 17},
  [17] = {.lex_state = 17},
  [18] = {.lex_state = 17},
  [19] = {.lex_state = 17},
  [20] = {.lex_state = 17},
  [21] = {.lex_state = 17},
  [22] = {.lex_state = 17},
  [23] = {.lex_state = 17},
  [24] = {.lex_state = 17},
  [25] = {.lex_state = 17},
  [26] = {.lex_state = 17},
  [27] = {.lex_state = 17},
  [28] = {.lex_state = 17},
  [29] = {.lex_state = 17},
  [30] = {.lex_state = 17},
  [31] = {.lex_state = 17},
  [32] = {.lex_state = 17},
  [33] = {.lex_state = 17},
  [34] = {.lex_state = 17},
  [35] = {.lex_state = 17},
  [36] = {.lex_state = 17},
  [37] = {.lex_state = 17},
  [38] = {.lex_state = 17},
  [39] = {.lex_state = 17},
  [40] = {.lex_state = 17},
  [41] = {.lex_state = 17},
  [42] = {.lex_state = 17},
  [43] = {.lex_state = 17},
  [44] = {.lex_state = 17},
  [45] = {.lex_state = 17},
  [46] = {.lex_state = 17},
  [47] = {.lex_state = 17},
  [48] = {.lex_state = 17},
  [49] = {.lex_state = 17},
  [50] = {.lex_state = 17},
  [51] = {.lex_state = 17},
  [52] = {.lex_state = 17},
  [53] = {.lex_state = 17},
  [54] = {.lex_state = 17},
  [55] = {.lex_state = 17},
  [56] = {.lex_state = 17},
  [57] = {.lex_state = 17},
  [58] = {.lex_state = 17},
  [59] = {.lex_state = 17},
  [60] = {.lex_state = 17},
  [61] = {.lex_state = 17},
  [62] = {.lex_state = 17},
  [63] = {.lex_state = 17},
  [64] = {.lex_state = 17},
  [65] = {.lex_state = 17},
  [66] = {.lex_state = 17},
  [67] = {.lex_state = 17},
  [68] = {.lex_state = 17},
  [69] = {.lex_state = 17},
  [70] = {.lex_state = 17},
  [71] = {.lex_state = 17},
  [72] = {.lex_state = 17},
  [73] = {.lex_state = 17},
  [74] = {.lex_state = 17},
  [75] = {.lex_state = 17},
  [76] = {.lex_state = 17},
  [77] = {.lex_state = 17},
  [78] = {.lex_state = 17},
  [79] = {.lex_state = 17},
  [80] = {.lex_state = 17},
  [81] = {.lex_state = 17},
  [82] = {.lex_state = 17},
  [83] = {.lex_state = 17},
  [84] = {.lex_state = 17},
  [85] = {.lex_state = 17},
  [86] = {.lex_state = 17},
  [87] = {.lex_state = 17},
  [88] = {.lex_state = 17},
  [89] = {.lex_state = 17},
  [90] = {.lex_state = 17},
  [91] = {.lex_state = 17},
  [92] = {.lex_state = 17},
  [93] = {.lex_state = 17},
  [94] = {.lex_state = 17},
  [95] = {.lex_state = 17},
  [96] = {.lex_state = 17},
  [97] = {.lex_state = 17},
  [98] = {.lex_state = 17},
  [99] = {.lex_state = 17},
  [100] = {.lex_state = 17},
  [101] = {.lex_state = 17},
  [102] = {.lex_state = 17},
  [103] = {.lex_state = 17},
  [104] = {.lex_state = 17},
  [105] = {.lex_state = 17},
  [106] = {.lex_state = 17},
  [107] = {.lex_state = 17},
  [108] = {.lex_state = 17},
  [109] = {.lex_state = 17},
  [110] = {.lex_state = 17},
  [111] = {.lex_state = 17},
  [112] = {.lex_state = 17},
  [113] = {.lex_state = 17},
  [114] = {.lex_state = 17},
  [115] = {.lex_state = 17},
  [116] = {.lex_state = 17},
  [117] = {.lex_state = 17},
  [118] = {.lex_state = 17},
  [119] = {.lex_state = 17},
  [120] = {.lex_state = 17},
  [121] = {.lex_state = 1},
  [122] = {.lex_state = 1},
  [123] = {.lex_state = 1},
  [124] = {.lex_state = 1},
  [125] = {.lex_state = 1},
  [126] = {.lex_state = 1},
  [127] = {.lex_state = 1},
  [128] = {.lex_state = 1},
  [129] = {.lex_state = 1},
  [130] = {.lex_state = 1},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 1},
  [133] = {.lex_state = 1},
  [134] = {.lex_state = 1},
  [135] = {.lex_state = 1},
  [136] = {.lex_state = 1},
  [137] = {.lex_state = 1},
  [138] = {.lex_state = 1},
  [139] = {.lex_state = 1},
  [140] = {.lex_state = 1},
  [141] = {.lex_state = 1},
  [142] = {.lex_state = 1},
  [143] = {.lex_state = 1},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 1},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 1},
  [155] = {.lex_state = 1},
  [156] = {.lex_state = 1},
  [157] = {.lex_state = 1},
  [158] = {.lex_state = 1},
  [159] = {.lex_state = 1},
  [160] = {.lex_state = 1},
  [161] = {.lex_state = 1},
  [162] = {.lex_state = 1},
  [163] = {.lex_state = 1},
  [164] = {.lex_state = 1},
  [165] = {.lex_state = 1},
  [166] = {.lex_state = 1},
  [167] = {.lex_state = 1},
  [168] = {.lex_state = 1},
  [169] = {.lex_state = 1},
  [170] = {.lex_state = 1},
  [171] = {.lex_state = 1},
  [172] = {.lex_state = 1},
  [173] = {.lex_state = 1},
  [174] = {.lex_state = 1},
  [175] = {.lex_state = 1},
  [176] = {.lex_state = 1},
  [177] = {.lex_state = 1},
  [178] = {.lex_state = 1},
  [179] = {.lex_state = 1},
  [180] = {.lex_state = 1},
  [181] = {.lex_state = 1},
  [182] = {.lex_state = 17},
  [183] = {.lex_state = 17},
  [184] = {.lex_state = 17},
  [185] = {.lex_state = 17},
  [186] = {.lex_state = 17},
  [187] = {.lex_state = 17},
  [188] = {.lex_state = 17},
  [189] = {.lex_state = 17},
  [190] = {.lex_state = 17},
  [191] = {.lex_state = 17},
  [192] = {.lex_state = 17},
  [193] = {.lex_state = 17},
  [194] = {.lex_state = 17},
  [195] = {.lex_state = 17},
  [196] = {.lex_state = 17},
  [197] = {.lex_state = 17},
  [198] = {.lex_state = 17},
  [199] = {.lex_state = 17},
  [200] = {.lex_state = 17},
  [201] = {.lex_state = 17},
  [202] = {.lex_state = 17},
  [203] = {.lex_state = 17},
  [204] = {.lex_state = 17},
  [205] = {.lex_state = 17},
  [206] = {.lex_state = 17},
  [207] = {.lex_state = 17},
  [208] = {.lex_state = 17},
  [209] = {.lex_state = 17},
  [210] = {.lex_state = 17},
  [211] = {.lex_state = 17},
  [212] = {.lex_state = 17},
  [213] = {.lex_state = 17},
  [214] = {.lex_state = 17},
  [215] = {.lex_state = 17},
  [216] = {.lex_state = 17},
  [217] = {.lex_state = 17},
  [218] = {.lex_state = 17},
  [219] = {.lex_state = 17},
  [220] = {.lex_state = 17},
  [221] = {.lex_state = 17},
  [222] = {.lex_state = 17},
  [223] = {.lex_state = 17},
  [224] = {.lex_state = 17},
  [225] = {.lex_state = 17},
  [226] = {.lex_state = 17},
  [227] = {.lex_state = 17},
  [228] = {.lex_state = 17},
  [229] = {.lex_state = 17},
  [230] = {.lex_state = 17},
  [231] = {.lex_state = 17},
  [232] = {.lex_state = 17},
  [233] = {.lex_state = 17},
  [234] = {.lex_state = 17},
  [235] = {.lex_state = 17},
  [236] = {.lex_state = 17},
  [237] = {.lex_state = 17},
  [238] = {.lex_state = 17},
  [239] = {.lex_state = 17},
  [240] = {.lex_state = 17},
  [241] = {.lex_state = 17},
  [242] = {.lex_state = 17},
  [243] = {.lex_state = 17},
  [244] = {.lex_state = 17},
  [245] = {.lex_state = 17},
  [246] = {.lex_state = 17},
  [247] = {.lex_state = 17},
  [248] = {.lex_state = 17},
  [249] = {.lex_state = 17},
  [250] = {.lex_state = 17},
  [251] = {.lex_state = 17},
  [252] = {.lex_state = 17},
  [253] = {.lex_state = 17},
  [254] = {.lex_state = 17},
  [255] = {.lex_state = 17},
  [256] = {.lex_state = 17},
  [257] = {.lex_state = 17},
  [258] = {.lex_state = 17},
  [259] = {.lex_state = 17},
  [260] = {.lex_state = 17},
  [261] = {.lex_state = 17},
  [262] = {.lex_state = 17},
  [263] = {.lex_state = 17},
  [264] = {.lex_state = 17},
  [265] = {.lex_state = 17},
  [266] = {.lex_state = 17},
  [267] = {.lex_state = 17},
  [268] = {.lex_state = 17},
  [269] = {.lex_state = 17},
  [270] = {.lex_state = 17},
  [271] = {.lex_state = 17},
  [272] = {.lex_state = 17},
  [273] = {.lex_state = 17},
  [274] = {.lex_state = 17},
  [275] = {.lex_state = 17},
  [276] = {.lex_state = 17},
  [277] = {.lex_state = 17},
  [278] = {.lex_state = 17},
  [279] = {.lex_state = 17},
  [280] = {.lex_state = 17},
  [281] = {.lex_state = 17},
  [282] = {.lex_state = 17},
  [283] = {.lex_state = 17},
  [284] = {.lex_state = 17},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_precision] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_discard] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_uint] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_vec2] = ACTIONS(1),
    [anon_sym_vec3] = ACTIONS(1),
    [anon_sym_vec4] = ACTIONS(1),
    [anon_sym_dvec2] = ACTIONS(1),
    [anon_sym_dvec3] = ACTIONS(1),
    [anon_sym_dvec4] = ACTIONS(1),
    [anon_sym_bvec2] = ACTIONS(1),
    [anon_sym_bvec3] = ACTIONS(1),
    [anon_sym_bvec4] = ACTIONS(1),
    [anon_sym_ivec2] = ACTIONS(1),
    [anon_sym_ivec3] = ACTIONS(1),
    [anon_sym_ivec4] = ACTIONS(1),
    [anon_sym_uvec2] = ACTIONS(1),
    [anon_sym_uvec3] = ACTIONS(1),
    [anon_sym_uvec4] = ACTIONS(1),
    [anon_sym_mat2] = ACTIONS(1),
    [anon_sym_mat3] = ACTIONS(1),
    [anon_sym_mat4] = ACTIONS(1),
    [anon_sym_mat2x2] = ACTIONS(1),
    [anon_sym_mat2x3] = ACTIONS(1),
    [anon_sym_mat2x4] = ACTIONS(1),
    [anon_sym_mat3x2] = ACTIONS(1),
    [anon_sym_mat3x3] = ACTIONS(1),
    [anon_sym_mat3x4] = ACTIONS(1),
    [anon_sym_mat4x2] = ACTIONS(1),
    [anon_sym_mat4x3] = ACTIONS(1),
    [anon_sym_mat4x4] = ACTIONS(1),
    [anon_sym_dmat2] = ACTIONS(1),
    [anon_sym_dmat3] = ACTIONS(1),
    [anon_sym_dmat4] = ACTIONS(1),
    [anon_sym_dmat2x2] = ACTIONS(1),
    [anon_sym_dmat2x3] = ACTIONS(1),
    [anon_sym_dmat2x4] = ACTIONS(1),
    [anon_sym_dmat3x2] = ACTIONS(1),
    [anon_sym_dmat3x3] = ACTIONS(1),
    [anon_sym_dmat3x4] = ACTIONS(1),
    [anon_sym_dmat4x2] = ACTIONS(1),
    [anon_sym_dmat4x3] = ACTIONS(1),
    [anon_sym_dmat4x4] = ACTIONS(1),
    [anon_sym_atomic_uint] = ACTIONS(1),
    [anon_sym_sampler1d] = ACTIONS(1),
    [anon_sym_sampler2d] = ACTIONS(1),
    [anon_sym_sampler3d] = ACTIONS(1),
    [anon_sym_samplercube] = ACTIONS(1),
    [anon_sym_sampler1DShadow] = ACTIONS(1),
    [anon_sym_sampler2DShadow] = ACTIONS(1),
    [anon_sym_samplerCubeShadow] = ACTIONS(1),
    [anon_sym_sampler1DArray] = ACTIONS(1),
    [anon_sym_sampler2DArray] = ACTIONS(1),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(1),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(1),
    [anon_sym_samplerCubeArray] = ACTIONS(1),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(1),
    [anon_sym_isampler1D] = ACTIONS(1),
    [anon_sym_isampler2D] = ACTIONS(1),
    [anon_sym_isampler3D] = ACTIONS(1),
    [anon_sym_isamplerCube] = ACTIONS(1),
    [anon_sym_isampler1DArray] = ACTIONS(1),
    [anon_sym_isampler2DArray] = ACTIONS(1),
    [anon_sym_isamplerCubeArray] = ACTIONS(1),
    [anon_sym_usampler1D] = ACTIONS(1),
    [anon_sym_usampler2D] = ACTIONS(1),
    [anon_sym_usampler3D] = ACTIONS(1),
    [anon_sym_usamplerCube] = ACTIONS(1),
    [anon_sym_usampler1DArray] = ACTIONS(1),
    [anon_sym_usampler2DArray] = ACTIONS(1),
    [anon_sym_usamplerCubeArray] = ACTIONS(1),
    [anon_sym_sampler2DRect] = ACTIONS(1),
    [anon_sym_sampler2DRectshadow] = ACTIONS(1),
    [anon_sym_isampler2DRect] = ACTIONS(1),
    [anon_sym_usampler2DRect] = ACTIONS(1),
    [anon_sym_samplerBuffer] = ACTIONS(1),
    [anon_sym_isamplerBuffer] = ACTIONS(1),
    [anon_sym_usamplerBuffer] = ACTIONS(1),
    [anon_sym_sampler2DMS] = ACTIONS(1),
    [anon_sym_isampler2DMS] = ACTIONS(1),
    [anon_sym_usampler2DMS] = ACTIONS(1),
    [anon_sym_sampler2DMSArray] = ACTIONS(1),
    [anon_sym_isampler2DMSArray] = ACTIONS(1),
    [anon_sym_usampler2DMSArray] = ACTIONS(1),
    [anon_sym_image1D] = ACTIONS(1),
    [anon_sym_iimage1D] = ACTIONS(1),
    [anon_sym_uimage1D] = ACTIONS(1),
    [anon_sym_image2D] = ACTIONS(1),
    [anon_sym_iimage2D] = ACTIONS(1),
    [anon_sym_uimage2D] = ACTIONS(1),
    [anon_sym_image3D] = ACTIONS(1),
    [anon_sym_iimage3D] = ACTIONS(1),
    [anon_sym_uimage3D] = ACTIONS(1),
    [anon_sym_image2DRect] = ACTIONS(1),
    [anon_sym_iimage2DRect] = ACTIONS(1),
    [anon_sym_uimage2DRect] = ACTIONS(1),
    [anon_sym_imageCube] = ACTIONS(1),
    [anon_sym_iimageCube] = ACTIONS(1),
    [anon_sym_uimageCube] = ACTIONS(1),
    [anon_sym_imageBuffer] = ACTIONS(1),
    [anon_sym_iimageBuffer] = ACTIONS(1),
    [anon_sym_uimageBuffer] = ACTIONS(1),
    [anon_sym_image1DArray] = ACTIONS(1),
    [anon_sym_iimage1DArray] = ACTIONS(1),
    [anon_sym_uimage1DArray] = ACTIONS(1),
    [anon_sym_image2DArray] = ACTIONS(1),
    [anon_sym_iimage2DArray] = ACTIONS(1),
    [anon_sym_uimage2DArray] = ACTIONS(1),
    [anon_sym_imageCubeArray] = ACTIONS(1),
    [anon_sym_iimageCubeArray] = ACTIONS(1),
    [anon_sym_uimageCubeArray] = ACTIONS(1),
    [anon_sym_image2DMS] = ACTIONS(1),
    [anon_sym_iimage2DMS] = ACTIONS(1),
    [anon_sym_uimage2DMS] = ACTIONS(1),
    [anon_sym_image2DMSArray] = ACTIONS(1),
    [anon_sym_iimage2DMSArray] = ACTIONS(1),
    [anon_sym_uimage2DMSArray] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_inout] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_centroid] = ACTIONS(1),
    [anon_sym_patch] = ACTIONS(1),
    [anon_sym_sample] = ACTIONS(1),
    [anon_sym_uniform] = ACTIONS(1),
    [anon_sym_buffer] = ACTIONS(1),
    [anon_sym_shared] = ACTIONS(1),
    [anon_sym_coherent] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_writeonly] = ACTIONS(1),
    [anon_sym_subroutine] = ACTIONS(1),
    [anon_sym_varying] = ACTIONS(1),
    [anon_sym_attribute] = ACTIONS(1),
    [anon_sym_layout] = ACTIONS(1),
    [anon_sym_highp] = ACTIONS(1),
    [anon_sym_mediump] = ACTIONS(1),
    [anon_sym_lowp] = ACTIONS(1),
    [anon_sym_smooth] = ACTIONS(1),
    [anon_sym_flat] = ACTIONS(1),
    [anon_sym_noperspective] = ACTIONS(1),
    [sym_invariant_qualifier] = ACTIONS(1),
    [sym_precise_qualifier] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [aux_sym_number_literal_token1] = ACTIONS(1),
    [aux_sym_number_literal_token2] = ACTIONS(1),
    [aux_sym_number_literal_token3] = ACTIONS(1),
    [aux_sym_number_literal_token4] = ACTIONS(1),
    [aux_sym_number_literal_token5] = ACTIONS(1),
    [aux_sym_number_literal_token6] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_translation_unit] = STATE(264),
    [sym__external_declaration] = STATE(104),
    [sym_declaration] = STATE(105),
    [sym__init_declarator_list] = STATE(237),
    [sym_function_definition] = STATE(106),
    [sym_function_prototype] = STATE(62),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(209),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_translation_unit_repeat1] = STATE(42),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [2] = {
    [sym_declaration] = STATE(5),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(5),
    [sym_statement_list] = STATE(271),
    [sym__statement] = STATE(5),
    [sym_expression_statement] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_switch_statement] = STATE(5),
    [sym_iteration_statement] = STATE(5),
    [sym_jump_statement] = STATE(5),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(5),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_statement_list_repeat1] = STATE(5),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [3] = {
    [sym_declaration] = STATE(5),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(5),
    [sym_statement_list] = STATE(259),
    [sym__statement] = STATE(5),
    [sym_expression_statement] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_switch_statement] = STATE(5),
    [sym_iteration_statement] = STATE(5),
    [sym_jump_statement] = STATE(5),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(5),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_statement_list_repeat1] = STATE(5),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [4] = {
    [sym_declaration] = STATE(4),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(4),
    [sym__statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_iteration_statement] = STATE(4),
    [sym_jump_statement] = STATE(4),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(4),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_statement_list_repeat1] = STATE(4),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(69),
    [anon_sym_SEMI] = ACTIONS(72),
    [anon_sym_precision] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(78),
    [anon_sym_RBRACE] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN] = ACTIONS(86),
    [anon_sym_switch] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(92),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(98),
    [anon_sym_continue] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(104),
    [anon_sym_discard] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(110),
    [anon_sym_struct] = ACTIONS(113),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_float] = ACTIONS(116),
    [anon_sym_double] = ACTIONS(116),
    [anon_sym_int] = ACTIONS(116),
    [anon_sym_uint] = ACTIONS(116),
    [anon_sym_bool] = ACTIONS(116),
    [anon_sym_vec2] = ACTIONS(116),
    [anon_sym_vec3] = ACTIONS(116),
    [anon_sym_vec4] = ACTIONS(116),
    [anon_sym_dvec2] = ACTIONS(116),
    [anon_sym_dvec3] = ACTIONS(116),
    [anon_sym_dvec4] = ACTIONS(116),
    [anon_sym_bvec2] = ACTIONS(116),
    [anon_sym_bvec3] = ACTIONS(116),
    [anon_sym_bvec4] = ACTIONS(116),
    [anon_sym_ivec2] = ACTIONS(116),
    [anon_sym_ivec3] = ACTIONS(116),
    [anon_sym_ivec4] = ACTIONS(116),
    [anon_sym_uvec2] = ACTIONS(116),
    [anon_sym_uvec3] = ACTIONS(116),
    [anon_sym_uvec4] = ACTIONS(116),
    [anon_sym_mat2] = ACTIONS(116),
    [anon_sym_mat3] = ACTIONS(116),
    [anon_sym_mat4] = ACTIONS(116),
    [anon_sym_mat2x2] = ACTIONS(116),
    [anon_sym_mat2x3] = ACTIONS(116),
    [anon_sym_mat2x4] = ACTIONS(116),
    [anon_sym_mat3x2] = ACTIONS(116),
    [anon_sym_mat3x3] = ACTIONS(116),
    [anon_sym_mat3x4] = ACTIONS(116),
    [anon_sym_mat4x2] = ACTIONS(116),
    [anon_sym_mat4x3] = ACTIONS(116),
    [anon_sym_mat4x4] = ACTIONS(116),
    [anon_sym_dmat2] = ACTIONS(116),
    [anon_sym_dmat3] = ACTIONS(116),
    [anon_sym_dmat4] = ACTIONS(116),
    [anon_sym_dmat2x2] = ACTIONS(116),
    [anon_sym_dmat2x3] = ACTIONS(116),
    [anon_sym_dmat2x4] = ACTIONS(116),
    [anon_sym_dmat3x2] = ACTIONS(116),
    [anon_sym_dmat3x3] = ACTIONS(116),
    [anon_sym_dmat3x4] = ACTIONS(116),
    [anon_sym_dmat4x2] = ACTIONS(116),
    [anon_sym_dmat4x3] = ACTIONS(116),
    [anon_sym_dmat4x4] = ACTIONS(116),
    [anon_sym_atomic_uint] = ACTIONS(116),
    [anon_sym_sampler1d] = ACTIONS(116),
    [anon_sym_sampler2d] = ACTIONS(116),
    [anon_sym_sampler3d] = ACTIONS(116),
    [anon_sym_samplercube] = ACTIONS(116),
    [anon_sym_sampler1DShadow] = ACTIONS(116),
    [anon_sym_sampler2DShadow] = ACTIONS(116),
    [anon_sym_samplerCubeShadow] = ACTIONS(116),
    [anon_sym_sampler1DArray] = ACTIONS(116),
    [anon_sym_sampler2DArray] = ACTIONS(116),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(116),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(116),
    [anon_sym_samplerCubeArray] = ACTIONS(116),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(116),
    [anon_sym_isampler1D] = ACTIONS(116),
    [anon_sym_isampler2D] = ACTIONS(116),
    [anon_sym_isampler3D] = ACTIONS(116),
    [anon_sym_isamplerCube] = ACTIONS(116),
    [anon_sym_isampler1DArray] = ACTIONS(116),
    [anon_sym_isampler2DArray] = ACTIONS(116),
    [anon_sym_isamplerCubeArray] = ACTIONS(116),
    [anon_sym_usampler1D] = ACTIONS(116),
    [anon_sym_usampler2D] = ACTIONS(116),
    [anon_sym_usampler3D] = ACTIONS(116),
    [anon_sym_usamplerCube] = ACTIONS(116),
    [anon_sym_usampler1DArray] = ACTIONS(116),
    [anon_sym_usampler2DArray] = ACTIONS(116),
    [anon_sym_usamplerCubeArray] = ACTIONS(116),
    [anon_sym_sampler2DRect] = ACTIONS(116),
    [anon_sym_sampler2DRectshadow] = ACTIONS(116),
    [anon_sym_isampler2DRect] = ACTIONS(116),
    [anon_sym_usampler2DRect] = ACTIONS(116),
    [anon_sym_samplerBuffer] = ACTIONS(116),
    [anon_sym_isamplerBuffer] = ACTIONS(116),
    [anon_sym_usamplerBuffer] = ACTIONS(116),
    [anon_sym_sampler2DMS] = ACTIONS(116),
    [anon_sym_isampler2DMS] = ACTIONS(116),
    [anon_sym_usampler2DMS] = ACTIONS(116),
    [anon_sym_sampler2DMSArray] = ACTIONS(116),
    [anon_sym_isampler2DMSArray] = ACTIONS(116),
    [anon_sym_usampler2DMSArray] = ACTIONS(116),
    [anon_sym_image1D] = ACTIONS(116),
    [anon_sym_iimage1D] = ACTIONS(116),
    [anon_sym_uimage1D] = ACTIONS(116),
    [anon_sym_image2D] = ACTIONS(116),
    [anon_sym_iimage2D] = ACTIONS(116),
    [anon_sym_uimage2D] = ACTIONS(116),
    [anon_sym_image3D] = ACTIONS(116),
    [anon_sym_iimage3D] = ACTIONS(116),
    [anon_sym_uimage3D] = ACTIONS(116),
    [anon_sym_image2DRect] = ACTIONS(116),
    [anon_sym_iimage2DRect] = ACTIONS(116),
    [anon_sym_uimage2DRect] = ACTIONS(116),
    [anon_sym_imageCube] = ACTIONS(116),
    [anon_sym_iimageCube] = ACTIONS(116),
    [anon_sym_uimageCube] = ACTIONS(116),
    [anon_sym_imageBuffer] = ACTIONS(116),
    [anon_sym_iimageBuffer] = ACTIONS(116),
    [anon_sym_uimageBuffer] = ACTIONS(116),
    [anon_sym_image1DArray] = ACTIONS(116),
    [anon_sym_iimage1DArray] = ACTIONS(116),
    [anon_sym_uimage1DArray] = ACTIONS(116),
    [anon_sym_image2DArray] = ACTIONS(116),
    [anon_sym_iimage2DArray] = ACTIONS(116),
    [anon_sym_uimage2DArray] = ACTIONS(116),
    [anon_sym_imageCubeArray] = ACTIONS(116),
    [anon_sym_iimageCubeArray] = ACTIONS(116),
    [anon_sym_uimageCubeArray] = ACTIONS(116),
    [anon_sym_image2DMS] = ACTIONS(116),
    [anon_sym_iimage2DMS] = ACTIONS(116),
    [anon_sym_uimage2DMS] = ACTIONS(116),
    [anon_sym_image2DMSArray] = ACTIONS(116),
    [anon_sym_iimage2DMSArray] = ACTIONS(116),
    [anon_sym_uimage2DMSArray] = ACTIONS(116),
    [anon_sym_const] = ACTIONS(119),
    [anon_sym_inout] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_out] = ACTIONS(119),
    [anon_sym_centroid] = ACTIONS(119),
    [anon_sym_patch] = ACTIONS(119),
    [anon_sym_sample] = ACTIONS(119),
    [anon_sym_uniform] = ACTIONS(119),
    [anon_sym_buffer] = ACTIONS(119),
    [anon_sym_shared] = ACTIONS(119),
    [anon_sym_coherent] = ACTIONS(119),
    [anon_sym_volatile] = ACTIONS(119),
    [anon_sym_restrict] = ACTIONS(119),
    [anon_sym_readonly] = ACTIONS(119),
    [anon_sym_writeonly] = ACTIONS(119),
    [anon_sym_subroutine] = ACTIONS(122),
    [anon_sym_varying] = ACTIONS(119),
    [anon_sym_attribute] = ACTIONS(119),
    [anon_sym_layout] = ACTIONS(125),
    [anon_sym_highp] = ACTIONS(128),
    [anon_sym_mediump] = ACTIONS(128),
    [anon_sym_lowp] = ACTIONS(128),
    [anon_sym_smooth] = ACTIONS(131),
    [anon_sym_flat] = ACTIONS(131),
    [anon_sym_noperspective] = ACTIONS(131),
    [sym_invariant_qualifier] = ACTIONS(134),
    [sym_precise_qualifier] = ACTIONS(134),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG] = ACTIONS(140),
    [anon_sym_TILDE] = ACTIONS(140),
    [anon_sym_PLUS_PLUS] = ACTIONS(143),
    [anon_sym_DASH_DASH] = ACTIONS(143),
    [anon_sym_true] = ACTIONS(146),
    [anon_sym_false] = ACTIONS(146),
    [aux_sym_number_literal_token1] = ACTIONS(149),
    [aux_sym_number_literal_token2] = ACTIONS(149),
    [aux_sym_number_literal_token3] = ACTIONS(152),
    [aux_sym_number_literal_token4] = ACTIONS(152),
    [aux_sym_number_literal_token5] = ACTIONS(149),
    [aux_sym_number_literal_token6] = ACTIONS(152),
    [sym_comment] = ACTIONS(25),
  },
  [5] = {
    [sym_declaration] = STATE(4),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(4),
    [sym__statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_iteration_statement] = STATE(4),
    [sym_jump_statement] = STATE(4),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(4),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_statement_list_repeat1] = STATE(4),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [6] = {
    [sym_declaration] = STATE(279),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(279),
    [sym__statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_iteration_statement] = STATE(279),
    [sym_jump_statement] = STATE(279),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(279),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [7] = {
    [sym_declaration] = STATE(32),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(32),
    [sym__statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_iteration_statement] = STATE(32),
    [sym_jump_statement] = STATE(32),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(32),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [8] = {
    [sym_declaration] = STATE(33),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(33),
    [sym__statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_iteration_statement] = STATE(33),
    [sym_jump_statement] = STATE(33),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(33),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [9] = {
    [sym_declaration] = STATE(36),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(36),
    [sym__statement] = STATE(36),
    [sym_expression_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_switch_statement] = STATE(36),
    [sym_iteration_statement] = STATE(36),
    [sym_jump_statement] = STATE(36),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(36),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [10] = {
    [sym_declaration] = STATE(25),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(25),
    [sym__statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_iteration_statement] = STATE(25),
    [sym_jump_statement] = STATE(25),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(25),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [11] = {
    [sym_declaration] = STATE(35),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(35),
    [sym__statement] = STATE(35),
    [sym_expression_statement] = STATE(35),
    [sym_if_statement] = STATE(35),
    [sym_switch_statement] = STATE(35),
    [sym_iteration_statement] = STATE(35),
    [sym_jump_statement] = STATE(35),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(35),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [12] = {
    [sym_declaration] = STATE(38),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(38),
    [sym__statement] = STATE(38),
    [sym_expression_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_switch_statement] = STATE(38),
    [sym_iteration_statement] = STATE(38),
    [sym_jump_statement] = STATE(38),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(38),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [13] = {
    [sym_declaration] = STATE(37),
    [sym__init_declarator_list] = STATE(237),
    [sym_compound_statement] = STATE(37),
    [sym__statement] = STATE(37),
    [sym_expression_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_switch_statement] = STATE(37),
    [sym_iteration_statement] = STATE(37),
    [sym_jump_statement] = STATE(37),
    [sym_function_prototype] = STATE(269),
    [sym_case_label] = STATE(37),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_switch] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_for] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_discard] = ACTIONS(47),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [14] = {
    [sym_declaration] = STATE(15),
    [sym__init_declarator_list] = STATE(237),
    [sym_expression_statement] = STATE(15),
    [sym_function_prototype] = STATE(269),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(173),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(173),
    [sym_assignment_expression] = STATE(173),
    [sym_conditional_expression] = STATE(173),
    [sym__expression] = STATE(173),
    [sym__constant_expression] = STATE(173),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [15] = {
    [sym_condition] = STATE(275),
    [sym_fully_specified_type] = STATE(263),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(120),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(162),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(162),
    [sym_assignment_expression] = STATE(162),
    [sym_conditional_expression] = STATE(162),
    [sym__expression] = STATE(162),
    [sym__constant_expression] = STATE(162),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [16] = {
    [sym_condition] = STATE(261),
    [sym_fully_specified_type] = STATE(263),
    [sym_type_specifier] = STATE(201),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(120),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [sym_binary_expression] = STATE(162),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(162),
    [sym_assignment_expression] = STATE(162),
    [sym_conditional_expression] = STATE(162),
    [sym__expression] = STATE(162),
    [sym__constant_expression] = STATE(162),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [17] = {
    [ts_builtin_sym_end] = ACTIONS(159),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_precision] = ACTIONS(161),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(159),
    [anon_sym_else] = ACTIONS(161),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(161),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_break] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(161),
    [anon_sym_discard] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(161),
    [anon_sym_default] = ACTIONS(161),
    [anon_sym_struct] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(161),
    [anon_sym_float] = ACTIONS(161),
    [anon_sym_double] = ACTIONS(161),
    [anon_sym_int] = ACTIONS(161),
    [anon_sym_uint] = ACTIONS(161),
    [anon_sym_bool] = ACTIONS(161),
    [anon_sym_vec2] = ACTIONS(161),
    [anon_sym_vec3] = ACTIONS(161),
    [anon_sym_vec4] = ACTIONS(161),
    [anon_sym_dvec2] = ACTIONS(161),
    [anon_sym_dvec3] = ACTIONS(161),
    [anon_sym_dvec4] = ACTIONS(161),
    [anon_sym_bvec2] = ACTIONS(161),
    [anon_sym_bvec3] = ACTIONS(161),
    [anon_sym_bvec4] = ACTIONS(161),
    [anon_sym_ivec2] = ACTIONS(161),
    [anon_sym_ivec3] = ACTIONS(161),
    [anon_sym_ivec4] = ACTIONS(161),
    [anon_sym_uvec2] = ACTIONS(161),
    [anon_sym_uvec3] = ACTIONS(161),
    [anon_sym_uvec4] = ACTIONS(161),
    [anon_sym_mat2] = ACTIONS(161),
    [anon_sym_mat3] = ACTIONS(161),
    [anon_sym_mat4] = ACTIONS(161),
    [anon_sym_mat2x2] = ACTIONS(161),
    [anon_sym_mat2x3] = ACTIONS(161),
    [anon_sym_mat2x4] = ACTIONS(161),
    [anon_sym_mat3x2] = ACTIONS(161),
    [anon_sym_mat3x3] = ACTIONS(161),
    [anon_sym_mat3x4] = ACTIONS(161),
    [anon_sym_mat4x2] = ACTIONS(161),
    [anon_sym_mat4x3] = ACTIONS(161),
    [anon_sym_mat4x4] = ACTIONS(161),
    [anon_sym_dmat2] = ACTIONS(161),
    [anon_sym_dmat3] = ACTIONS(161),
    [anon_sym_dmat4] = ACTIONS(161),
    [anon_sym_dmat2x2] = ACTIONS(161),
    [anon_sym_dmat2x3] = ACTIONS(161),
    [anon_sym_dmat2x4] = ACTIONS(161),
    [anon_sym_dmat3x2] = ACTIONS(161),
    [anon_sym_dmat3x3] = ACTIONS(161),
    [anon_sym_dmat3x4] = ACTIONS(161),
    [anon_sym_dmat4x2] = ACTIONS(161),
    [anon_sym_dmat4x3] = ACTIONS(161),
    [anon_sym_dmat4x4] = ACTIONS(161),
    [anon_sym_atomic_uint] = ACTIONS(161),
    [anon_sym_sampler1d] = ACTIONS(161),
    [anon_sym_sampler2d] = ACTIONS(161),
    [anon_sym_sampler3d] = ACTIONS(161),
    [anon_sym_samplercube] = ACTIONS(161),
    [anon_sym_sampler1DShadow] = ACTIONS(161),
    [anon_sym_sampler2DShadow] = ACTIONS(161),
    [anon_sym_samplerCubeShadow] = ACTIONS(161),
    [anon_sym_sampler1DArray] = ACTIONS(161),
    [anon_sym_sampler2DArray] = ACTIONS(161),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(161),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(161),
    [anon_sym_samplerCubeArray] = ACTIONS(161),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(161),
    [anon_sym_isampler1D] = ACTIONS(161),
    [anon_sym_isampler2D] = ACTIONS(161),
    [anon_sym_isampler3D] = ACTIONS(161),
    [anon_sym_isamplerCube] = ACTIONS(161),
    [anon_sym_isampler1DArray] = ACTIONS(161),
    [anon_sym_isampler2DArray] = ACTIONS(161),
    [anon_sym_isamplerCubeArray] = ACTIONS(161),
    [anon_sym_usampler1D] = ACTIONS(161),
    [anon_sym_usampler2D] = ACTIONS(161),
    [anon_sym_usampler3D] = ACTIONS(161),
    [anon_sym_usamplerCube] = ACTIONS(161),
    [anon_sym_usampler1DArray] = ACTIONS(161),
    [anon_sym_usampler2DArray] = ACTIONS(161),
    [anon_sym_usamplerCubeArray] = ACTIONS(161),
    [anon_sym_sampler2DRect] = ACTIONS(161),
    [anon_sym_sampler2DRectshadow] = ACTIONS(161),
    [anon_sym_isampler2DRect] = ACTIONS(161),
    [anon_sym_usampler2DRect] = ACTIONS(161),
    [anon_sym_samplerBuffer] = ACTIONS(161),
    [anon_sym_isamplerBuffer] = ACTIONS(161),
    [anon_sym_usamplerBuffer] = ACTIONS(161),
    [anon_sym_sampler2DMS] = ACTIONS(161),
    [anon_sym_isampler2DMS] = ACTIONS(161),
    [anon_sym_usampler2DMS] = ACTIONS(161),
    [anon_sym_sampler2DMSArray] = ACTIONS(161),
    [anon_sym_isampler2DMSArray] = ACTIONS(161),
    [anon_sym_usampler2DMSArray] = ACTIONS(161),
    [anon_sym_image1D] = ACTIONS(161),
    [anon_sym_iimage1D] = ACTIONS(161),
    [anon_sym_uimage1D] = ACTIONS(161),
    [anon_sym_image2D] = ACTIONS(161),
    [anon_sym_iimage2D] = ACTIONS(161),
    [anon_sym_uimage2D] = ACTIONS(161),
    [anon_sym_image3D] = ACTIONS(161),
    [anon_sym_iimage3D] = ACTIONS(161),
    [anon_sym_uimage3D] = ACTIONS(161),
    [anon_sym_image2DRect] = ACTIONS(161),
    [anon_sym_iimage2DRect] = ACTIONS(161),
    [anon_sym_uimage2DRect] = ACTIONS(161),
    [anon_sym_imageCube] = ACTIONS(161),
    [anon_sym_iimageCube] = ACTIONS(161),
    [anon_sym_uimageCube] = ACTIONS(161),
    [anon_sym_imageBuffer] = ACTIONS(161),
    [anon_sym_iimageBuffer] = ACTIONS(161),
    [anon_sym_uimageBuffer] = ACTIONS(161),
    [anon_sym_image1DArray] = ACTIONS(161),
    [anon_sym_iimage1DArray] = ACTIONS(161),
    [anon_sym_uimage1DArray] = ACTIONS(161),
    [anon_sym_image2DArray] = ACTIONS(161),
    [anon_sym_iimage2DArray] = ACTIONS(161),
    [anon_sym_uimage2DArray] = ACTIONS(161),
    [anon_sym_imageCubeArray] = ACTIONS(161),
    [anon_sym_iimageCubeArray] = ACTIONS(161),
    [anon_sym_uimageCubeArray] = ACTIONS(161),
    [anon_sym_image2DMS] = ACTIONS(161),
    [anon_sym_iimage2DMS] = ACTIONS(161),
    [anon_sym_uimage2DMS] = ACTIONS(161),
    [anon_sym_image2DMSArray] = ACTIONS(161),
    [anon_sym_iimage2DMSArray] = ACTIONS(161),
    [anon_sym_uimage2DMSArray] = ACTIONS(161),
    [anon_sym_const] = ACTIONS(161),
    [anon_sym_inout] = ACTIONS(161),
    [anon_sym_in] = ACTIONS(161),
    [anon_sym_out] = ACTIONS(161),
    [anon_sym_centroid] = ACTIONS(161),
    [anon_sym_patch] = ACTIONS(161),
    [anon_sym_sample] = ACTIONS(161),
    [anon_sym_uniform] = ACTIONS(161),
    [anon_sym_buffer] = ACTIONS(161),
    [anon_sym_shared] = ACTIONS(161),
    [anon_sym_coherent] = ACTIONS(161),
    [anon_sym_volatile] = ACTIONS(161),
    [anon_sym_restrict] = ACTIONS(161),
    [anon_sym_readonly] = ACTIONS(161),
    [anon_sym_writeonly] = ACTIONS(161),
    [anon_sym_subroutine] = ACTIONS(161),
    [anon_sym_varying] = ACTIONS(161),
    [anon_sym_attribute] = ACTIONS(161),
    [anon_sym_layout] = ACTIONS(161),
    [anon_sym_highp] = ACTIONS(161),
    [anon_sym_mediump] = ACTIONS(161),
    [anon_sym_lowp] = ACTIONS(161),
    [anon_sym_smooth] = ACTIONS(161),
    [anon_sym_flat] = ACTIONS(161),
    [anon_sym_noperspective] = ACTIONS(161),
    [sym_invariant_qualifier] = ACTIONS(161),
    [sym_precise_qualifier] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_PLUS_PLUS] = ACTIONS(159),
    [anon_sym_DASH_DASH] = ACTIONS(159),
    [anon_sym_true] = ACTIONS(161),
    [anon_sym_false] = ACTIONS(161),
    [aux_sym_number_literal_token1] = ACTIONS(161),
    [aux_sym_number_literal_token2] = ACTIONS(161),
    [aux_sym_number_literal_token3] = ACTIONS(159),
    [aux_sym_number_literal_token4] = ACTIONS(159),
    [aux_sym_number_literal_token5] = ACTIONS(161),
    [aux_sym_number_literal_token6] = ACTIONS(159),
    [sym_comment] = ACTIONS(25),
  },
  [18] = {
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_precision] = ACTIONS(165),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_switch] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_discard] = ACTIONS(165),
    [anon_sym_case] = ACTIONS(165),
    [anon_sym_default] = ACTIONS(165),
    [anon_sym_struct] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(165),
    [anon_sym_float] = ACTIONS(165),
    [anon_sym_double] = ACTIONS(165),
    [anon_sym_int] = ACTIONS(165),
    [anon_sym_uint] = ACTIONS(165),
    [anon_sym_bool] = ACTIONS(165),
    [anon_sym_vec2] = ACTIONS(165),
    [anon_sym_vec3] = ACTIONS(165),
    [anon_sym_vec4] = ACTIONS(165),
    [anon_sym_dvec2] = ACTIONS(165),
    [anon_sym_dvec3] = ACTIONS(165),
    [anon_sym_dvec4] = ACTIONS(165),
    [anon_sym_bvec2] = ACTIONS(165),
    [anon_sym_bvec3] = ACTIONS(165),
    [anon_sym_bvec4] = ACTIONS(165),
    [anon_sym_ivec2] = ACTIONS(165),
    [anon_sym_ivec3] = ACTIONS(165),
    [anon_sym_ivec4] = ACTIONS(165),
    [anon_sym_uvec2] = ACTIONS(165),
    [anon_sym_uvec3] = ACTIONS(165),
    [anon_sym_uvec4] = ACTIONS(165),
    [anon_sym_mat2] = ACTIONS(165),
    [anon_sym_mat3] = ACTIONS(165),
    [anon_sym_mat4] = ACTIONS(165),
    [anon_sym_mat2x2] = ACTIONS(165),
    [anon_sym_mat2x3] = ACTIONS(165),
    [anon_sym_mat2x4] = ACTIONS(165),
    [anon_sym_mat3x2] = ACTIONS(165),
    [anon_sym_mat3x3] = ACTIONS(165),
    [anon_sym_mat3x4] = ACTIONS(165),
    [anon_sym_mat4x2] = ACTIONS(165),
    [anon_sym_mat4x3] = ACTIONS(165),
    [anon_sym_mat4x4] = ACTIONS(165),
    [anon_sym_dmat2] = ACTIONS(165),
    [anon_sym_dmat3] = ACTIONS(165),
    [anon_sym_dmat4] = ACTIONS(165),
    [anon_sym_dmat2x2] = ACTIONS(165),
    [anon_sym_dmat2x3] = ACTIONS(165),
    [anon_sym_dmat2x4] = ACTIONS(165),
    [anon_sym_dmat3x2] = ACTIONS(165),
    [anon_sym_dmat3x3] = ACTIONS(165),
    [anon_sym_dmat3x4] = ACTIONS(165),
    [anon_sym_dmat4x2] = ACTIONS(165),
    [anon_sym_dmat4x3] = ACTIONS(165),
    [anon_sym_dmat4x4] = ACTIONS(165),
    [anon_sym_atomic_uint] = ACTIONS(165),
    [anon_sym_sampler1d] = ACTIONS(165),
    [anon_sym_sampler2d] = ACTIONS(165),
    [anon_sym_sampler3d] = ACTIONS(165),
    [anon_sym_samplercube] = ACTIONS(165),
    [anon_sym_sampler1DShadow] = ACTIONS(165),
    [anon_sym_sampler2DShadow] = ACTIONS(165),
    [anon_sym_samplerCubeShadow] = ACTIONS(165),
    [anon_sym_sampler1DArray] = ACTIONS(165),
    [anon_sym_sampler2DArray] = ACTIONS(165),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(165),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(165),
    [anon_sym_samplerCubeArray] = ACTIONS(165),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(165),
    [anon_sym_isampler1D] = ACTIONS(165),
    [anon_sym_isampler2D] = ACTIONS(165),
    [anon_sym_isampler3D] = ACTIONS(165),
    [anon_sym_isamplerCube] = ACTIONS(165),
    [anon_sym_isampler1DArray] = ACTIONS(165),
    [anon_sym_isampler2DArray] = ACTIONS(165),
    [anon_sym_isamplerCubeArray] = ACTIONS(165),
    [anon_sym_usampler1D] = ACTIONS(165),
    [anon_sym_usampler2D] = ACTIONS(165),
    [anon_sym_usampler3D] = ACTIONS(165),
    [anon_sym_usamplerCube] = ACTIONS(165),
    [anon_sym_usampler1DArray] = ACTIONS(165),
    [anon_sym_usampler2DArray] = ACTIONS(165),
    [anon_sym_usamplerCubeArray] = ACTIONS(165),
    [anon_sym_sampler2DRect] = ACTIONS(165),
    [anon_sym_sampler2DRectshadow] = ACTIONS(165),
    [anon_sym_isampler2DRect] = ACTIONS(165),
    [anon_sym_usampler2DRect] = ACTIONS(165),
    [anon_sym_samplerBuffer] = ACTIONS(165),
    [anon_sym_isamplerBuffer] = ACTIONS(165),
    [anon_sym_usamplerBuffer] = ACTIONS(165),
    [anon_sym_sampler2DMS] = ACTIONS(165),
    [anon_sym_isampler2DMS] = ACTIONS(165),
    [anon_sym_usampler2DMS] = ACTIONS(165),
    [anon_sym_sampler2DMSArray] = ACTIONS(165),
    [anon_sym_isampler2DMSArray] = ACTIONS(165),
    [anon_sym_usampler2DMSArray] = ACTIONS(165),
    [anon_sym_image1D] = ACTIONS(165),
    [anon_sym_iimage1D] = ACTIONS(165),
    [anon_sym_uimage1D] = ACTIONS(165),
    [anon_sym_image2D] = ACTIONS(165),
    [anon_sym_iimage2D] = ACTIONS(165),
    [anon_sym_uimage2D] = ACTIONS(165),
    [anon_sym_image3D] = ACTIONS(165),
    [anon_sym_iimage3D] = ACTIONS(165),
    [anon_sym_uimage3D] = ACTIONS(165),
    [anon_sym_image2DRect] = ACTIONS(165),
    [anon_sym_iimage2DRect] = ACTIONS(165),
    [anon_sym_uimage2DRect] = ACTIONS(165),
    [anon_sym_imageCube] = ACTIONS(165),
    [anon_sym_iimageCube] = ACTIONS(165),
    [anon_sym_uimageCube] = ACTIONS(165),
    [anon_sym_imageBuffer] = ACTIONS(165),
    [anon_sym_iimageBuffer] = ACTIONS(165),
    [anon_sym_uimageBuffer] = ACTIONS(165),
    [anon_sym_image1DArray] = ACTIONS(165),
    [anon_sym_iimage1DArray] = ACTIONS(165),
    [anon_sym_uimage1DArray] = ACTIONS(165),
    [anon_sym_image2DArray] = ACTIONS(165),
    [anon_sym_iimage2DArray] = ACTIONS(165),
    [anon_sym_uimage2DArray] = ACTIONS(165),
    [anon_sym_imageCubeArray] = ACTIONS(165),
    [anon_sym_iimageCubeArray] = ACTIONS(165),
    [anon_sym_uimageCubeArray] = ACTIONS(165),
    [anon_sym_image2DMS] = ACTIONS(165),
    [anon_sym_iimage2DMS] = ACTIONS(165),
    [anon_sym_uimage2DMS] = ACTIONS(165),
    [anon_sym_image2DMSArray] = ACTIONS(165),
    [anon_sym_iimage2DMSArray] = ACTIONS(165),
    [anon_sym_uimage2DMSArray] = ACTIONS(165),
    [anon_sym_const] = ACTIONS(165),
    [anon_sym_inout] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(165),
    [anon_sym_out] = ACTIONS(165),
    [anon_sym_centroid] = ACTIONS(165),
    [anon_sym_patch] = ACTIONS(165),
    [anon_sym_sample] = ACTIONS(165),
    [anon_sym_uniform] = ACTIONS(165),
    [anon_sym_buffer] = ACTIONS(165),
    [anon_sym_shared] = ACTIONS(165),
    [anon_sym_coherent] = ACTIONS(165),
    [anon_sym_volatile] = ACTIONS(165),
    [anon_sym_restrict] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_writeonly] = ACTIONS(165),
    [anon_sym_subroutine] = ACTIONS(165),
    [anon_sym_varying] = ACTIONS(165),
    [anon_sym_attribute] = ACTIONS(165),
    [anon_sym_layout] = ACTIONS(165),
    [anon_sym_highp] = ACTIONS(165),
    [anon_sym_mediump] = ACTIONS(165),
    [anon_sym_lowp] = ACTIONS(165),
    [anon_sym_smooth] = ACTIONS(165),
    [anon_sym_flat] = ACTIONS(165),
    [anon_sym_noperspective] = ACTIONS(165),
    [sym_invariant_qualifier] = ACTIONS(165),
    [sym_precise_qualifier] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_PLUS_PLUS] = ACTIONS(163),
    [anon_sym_DASH_DASH] = ACTIONS(163),
    [anon_sym_true] = ACTIONS(165),
    [anon_sym_false] = ACTIONS(165),
    [aux_sym_number_literal_token1] = ACTIONS(165),
    [aux_sym_number_literal_token2] = ACTIONS(165),
    [aux_sym_number_literal_token3] = ACTIONS(163),
    [aux_sym_number_literal_token4] = ACTIONS(163),
    [aux_sym_number_literal_token5] = ACTIONS(165),
    [aux_sym_number_literal_token6] = ACTIONS(163),
    [sym_comment] = ACTIONS(25),
  },
  [19] = {
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(167),
    [anon_sym_precision] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_if] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_else] = ACTIONS(169),
    [anon_sym_switch] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(169),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_continue] = ACTIONS(169),
    [anon_sym_break] = ACTIONS(169),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_discard] = ACTIONS(169),
    [anon_sym_case] = ACTIONS(169),
    [anon_sym_default] = ACTIONS(169),
    [anon_sym_struct] = ACTIONS(169),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_float] = ACTIONS(169),
    [anon_sym_double] = ACTIONS(169),
    [anon_sym_int] = ACTIONS(169),
    [anon_sym_uint] = ACTIONS(169),
    [anon_sym_bool] = ACTIONS(169),
    [anon_sym_vec2] = ACTIONS(169),
    [anon_sym_vec3] = ACTIONS(169),
    [anon_sym_vec4] = ACTIONS(169),
    [anon_sym_dvec2] = ACTIONS(169),
    [anon_sym_dvec3] = ACTIONS(169),
    [anon_sym_dvec4] = ACTIONS(169),
    [anon_sym_bvec2] = ACTIONS(169),
    [anon_sym_bvec3] = ACTIONS(169),
    [anon_sym_bvec4] = ACTIONS(169),
    [anon_sym_ivec2] = ACTIONS(169),
    [anon_sym_ivec3] = ACTIONS(169),
    [anon_sym_ivec4] = ACTIONS(169),
    [anon_sym_uvec2] = ACTIONS(169),
    [anon_sym_uvec3] = ACTIONS(169),
    [anon_sym_uvec4] = ACTIONS(169),
    [anon_sym_mat2] = ACTIONS(169),
    [anon_sym_mat3] = ACTIONS(169),
    [anon_sym_mat4] = ACTIONS(169),
    [anon_sym_mat2x2] = ACTIONS(169),
    [anon_sym_mat2x3] = ACTIONS(169),
    [anon_sym_mat2x4] = ACTIONS(169),
    [anon_sym_mat3x2] = ACTIONS(169),
    [anon_sym_mat3x3] = ACTIONS(169),
    [anon_sym_mat3x4] = ACTIONS(169),
    [anon_sym_mat4x2] = ACTIONS(169),
    [anon_sym_mat4x3] = ACTIONS(169),
    [anon_sym_mat4x4] = ACTIONS(169),
    [anon_sym_dmat2] = ACTIONS(169),
    [anon_sym_dmat3] = ACTIONS(169),
    [anon_sym_dmat4] = ACTIONS(169),
    [anon_sym_dmat2x2] = ACTIONS(169),
    [anon_sym_dmat2x3] = ACTIONS(169),
    [anon_sym_dmat2x4] = ACTIONS(169),
    [anon_sym_dmat3x2] = ACTIONS(169),
    [anon_sym_dmat3x3] = ACTIONS(169),
    [anon_sym_dmat3x4] = ACTIONS(169),
    [anon_sym_dmat4x2] = ACTIONS(169),
    [anon_sym_dmat4x3] = ACTIONS(169),
    [anon_sym_dmat4x4] = ACTIONS(169),
    [anon_sym_atomic_uint] = ACTIONS(169),
    [anon_sym_sampler1d] = ACTIONS(169),
    [anon_sym_sampler2d] = ACTIONS(169),
    [anon_sym_sampler3d] = ACTIONS(169),
    [anon_sym_samplercube] = ACTIONS(169),
    [anon_sym_sampler1DShadow] = ACTIONS(169),
    [anon_sym_sampler2DShadow] = ACTIONS(169),
    [anon_sym_samplerCubeShadow] = ACTIONS(169),
    [anon_sym_sampler1DArray] = ACTIONS(169),
    [anon_sym_sampler2DArray] = ACTIONS(169),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(169),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(169),
    [anon_sym_samplerCubeArray] = ACTIONS(169),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(169),
    [anon_sym_isampler1D] = ACTIONS(169),
    [anon_sym_isampler2D] = ACTIONS(169),
    [anon_sym_isampler3D] = ACTIONS(169),
    [anon_sym_isamplerCube] = ACTIONS(169),
    [anon_sym_isampler1DArray] = ACTIONS(169),
    [anon_sym_isampler2DArray] = ACTIONS(169),
    [anon_sym_isamplerCubeArray] = ACTIONS(169),
    [anon_sym_usampler1D] = ACTIONS(169),
    [anon_sym_usampler2D] = ACTIONS(169),
    [anon_sym_usampler3D] = ACTIONS(169),
    [anon_sym_usamplerCube] = ACTIONS(169),
    [anon_sym_usampler1DArray] = ACTIONS(169),
    [anon_sym_usampler2DArray] = ACTIONS(169),
    [anon_sym_usamplerCubeArray] = ACTIONS(169),
    [anon_sym_sampler2DRect] = ACTIONS(169),
    [anon_sym_sampler2DRectshadow] = ACTIONS(169),
    [anon_sym_isampler2DRect] = ACTIONS(169),
    [anon_sym_usampler2DRect] = ACTIONS(169),
    [anon_sym_samplerBuffer] = ACTIONS(169),
    [anon_sym_isamplerBuffer] = ACTIONS(169),
    [anon_sym_usamplerBuffer] = ACTIONS(169),
    [anon_sym_sampler2DMS] = ACTIONS(169),
    [anon_sym_isampler2DMS] = ACTIONS(169),
    [anon_sym_usampler2DMS] = ACTIONS(169),
    [anon_sym_sampler2DMSArray] = ACTIONS(169),
    [anon_sym_isampler2DMSArray] = ACTIONS(169),
    [anon_sym_usampler2DMSArray] = ACTIONS(169),
    [anon_sym_image1D] = ACTIONS(169),
    [anon_sym_iimage1D] = ACTIONS(169),
    [anon_sym_uimage1D] = ACTIONS(169),
    [anon_sym_image2D] = ACTIONS(169),
    [anon_sym_iimage2D] = ACTIONS(169),
    [anon_sym_uimage2D] = ACTIONS(169),
    [anon_sym_image3D] = ACTIONS(169),
    [anon_sym_iimage3D] = ACTIONS(169),
    [anon_sym_uimage3D] = ACTIONS(169),
    [anon_sym_image2DRect] = ACTIONS(169),
    [anon_sym_iimage2DRect] = ACTIONS(169),
    [anon_sym_uimage2DRect] = ACTIONS(169),
    [anon_sym_imageCube] = ACTIONS(169),
    [anon_sym_iimageCube] = ACTIONS(169),
    [anon_sym_uimageCube] = ACTIONS(169),
    [anon_sym_imageBuffer] = ACTIONS(169),
    [anon_sym_iimageBuffer] = ACTIONS(169),
    [anon_sym_uimageBuffer] = ACTIONS(169),
    [anon_sym_image1DArray] = ACTIONS(169),
    [anon_sym_iimage1DArray] = ACTIONS(169),
    [anon_sym_uimage1DArray] = ACTIONS(169),
    [anon_sym_image2DArray] = ACTIONS(169),
    [anon_sym_iimage2DArray] = ACTIONS(169),
    [anon_sym_uimage2DArray] = ACTIONS(169),
    [anon_sym_imageCubeArray] = ACTIONS(169),
    [anon_sym_iimageCubeArray] = ACTIONS(169),
    [anon_sym_uimageCubeArray] = ACTIONS(169),
    [anon_sym_image2DMS] = ACTIONS(169),
    [anon_sym_iimage2DMS] = ACTIONS(169),
    [anon_sym_uimage2DMS] = ACTIONS(169),
    [anon_sym_image2DMSArray] = ACTIONS(169),
    [anon_sym_iimage2DMSArray] = ACTIONS(169),
    [anon_sym_uimage2DMSArray] = ACTIONS(169),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_inout] = ACTIONS(169),
    [anon_sym_in] = ACTIONS(169),
    [anon_sym_out] = ACTIONS(169),
    [anon_sym_centroid] = ACTIONS(169),
    [anon_sym_patch] = ACTIONS(169),
    [anon_sym_sample] = ACTIONS(169),
    [anon_sym_uniform] = ACTIONS(169),
    [anon_sym_buffer] = ACTIONS(169),
    [anon_sym_shared] = ACTIONS(169),
    [anon_sym_coherent] = ACTIONS(169),
    [anon_sym_volatile] = ACTIONS(169),
    [anon_sym_restrict] = ACTIONS(169),
    [anon_sym_readonly] = ACTIONS(169),
    [anon_sym_writeonly] = ACTIONS(169),
    [anon_sym_subroutine] = ACTIONS(169),
    [anon_sym_varying] = ACTIONS(169),
    [anon_sym_attribute] = ACTIONS(169),
    [anon_sym_layout] = ACTIONS(169),
    [anon_sym_highp] = ACTIONS(169),
    [anon_sym_mediump] = ACTIONS(169),
    [anon_sym_lowp] = ACTIONS(169),
    [anon_sym_smooth] = ACTIONS(169),
    [anon_sym_flat] = ACTIONS(169),
    [anon_sym_noperspective] = ACTIONS(169),
    [sym_invariant_qualifier] = ACTIONS(169),
    [sym_precise_qualifier] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(167),
    [anon_sym_TILDE] = ACTIONS(167),
    [anon_sym_PLUS_PLUS] = ACTIONS(167),
    [anon_sym_DASH_DASH] = ACTIONS(167),
    [anon_sym_true] = ACTIONS(169),
    [anon_sym_false] = ACTIONS(169),
    [aux_sym_number_literal_token1] = ACTIONS(169),
    [aux_sym_number_literal_token2] = ACTIONS(169),
    [aux_sym_number_literal_token3] = ACTIONS(167),
    [aux_sym_number_literal_token4] = ACTIONS(167),
    [aux_sym_number_literal_token5] = ACTIONS(169),
    [aux_sym_number_literal_token6] = ACTIONS(167),
    [sym_comment] = ACTIONS(25),
  },
  [20] = {
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_SEMI] = ACTIONS(171),
    [anon_sym_precision] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_else] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(173),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_do] = ACTIONS(173),
    [anon_sym_for] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(173),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_return] = ACTIONS(173),
    [anon_sym_discard] = ACTIONS(173),
    [anon_sym_case] = ACTIONS(173),
    [anon_sym_default] = ACTIONS(173),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_float] = ACTIONS(173),
    [anon_sym_double] = ACTIONS(173),
    [anon_sym_int] = ACTIONS(173),
    [anon_sym_uint] = ACTIONS(173),
    [anon_sym_bool] = ACTIONS(173),
    [anon_sym_vec2] = ACTIONS(173),
    [anon_sym_vec3] = ACTIONS(173),
    [anon_sym_vec4] = ACTIONS(173),
    [anon_sym_dvec2] = ACTIONS(173),
    [anon_sym_dvec3] = ACTIONS(173),
    [anon_sym_dvec4] = ACTIONS(173),
    [anon_sym_bvec2] = ACTIONS(173),
    [anon_sym_bvec3] = ACTIONS(173),
    [anon_sym_bvec4] = ACTIONS(173),
    [anon_sym_ivec2] = ACTIONS(173),
    [anon_sym_ivec3] = ACTIONS(173),
    [anon_sym_ivec4] = ACTIONS(173),
    [anon_sym_uvec2] = ACTIONS(173),
    [anon_sym_uvec3] = ACTIONS(173),
    [anon_sym_uvec4] = ACTIONS(173),
    [anon_sym_mat2] = ACTIONS(173),
    [anon_sym_mat3] = ACTIONS(173),
    [anon_sym_mat4] = ACTIONS(173),
    [anon_sym_mat2x2] = ACTIONS(173),
    [anon_sym_mat2x3] = ACTIONS(173),
    [anon_sym_mat2x4] = ACTIONS(173),
    [anon_sym_mat3x2] = ACTIONS(173),
    [anon_sym_mat3x3] = ACTIONS(173),
    [anon_sym_mat3x4] = ACTIONS(173),
    [anon_sym_mat4x2] = ACTIONS(173),
    [anon_sym_mat4x3] = ACTIONS(173),
    [anon_sym_mat4x4] = ACTIONS(173),
    [anon_sym_dmat2] = ACTIONS(173),
    [anon_sym_dmat3] = ACTIONS(173),
    [anon_sym_dmat4] = ACTIONS(173),
    [anon_sym_dmat2x2] = ACTIONS(173),
    [anon_sym_dmat2x3] = ACTIONS(173),
    [anon_sym_dmat2x4] = ACTIONS(173),
    [anon_sym_dmat3x2] = ACTIONS(173),
    [anon_sym_dmat3x3] = ACTIONS(173),
    [anon_sym_dmat3x4] = ACTIONS(173),
    [anon_sym_dmat4x2] = ACTIONS(173),
    [anon_sym_dmat4x3] = ACTIONS(173),
    [anon_sym_dmat4x4] = ACTIONS(173),
    [anon_sym_atomic_uint] = ACTIONS(173),
    [anon_sym_sampler1d] = ACTIONS(173),
    [anon_sym_sampler2d] = ACTIONS(173),
    [anon_sym_sampler3d] = ACTIONS(173),
    [anon_sym_samplercube] = ACTIONS(173),
    [anon_sym_sampler1DShadow] = ACTIONS(173),
    [anon_sym_sampler2DShadow] = ACTIONS(173),
    [anon_sym_samplerCubeShadow] = ACTIONS(173),
    [anon_sym_sampler1DArray] = ACTIONS(173),
    [anon_sym_sampler2DArray] = ACTIONS(173),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(173),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(173),
    [anon_sym_samplerCubeArray] = ACTIONS(173),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(173),
    [anon_sym_isampler1D] = ACTIONS(173),
    [anon_sym_isampler2D] = ACTIONS(173),
    [anon_sym_isampler3D] = ACTIONS(173),
    [anon_sym_isamplerCube] = ACTIONS(173),
    [anon_sym_isampler1DArray] = ACTIONS(173),
    [anon_sym_isampler2DArray] = ACTIONS(173),
    [anon_sym_isamplerCubeArray] = ACTIONS(173),
    [anon_sym_usampler1D] = ACTIONS(173),
    [anon_sym_usampler2D] = ACTIONS(173),
    [anon_sym_usampler3D] = ACTIONS(173),
    [anon_sym_usamplerCube] = ACTIONS(173),
    [anon_sym_usampler1DArray] = ACTIONS(173),
    [anon_sym_usampler2DArray] = ACTIONS(173),
    [anon_sym_usamplerCubeArray] = ACTIONS(173),
    [anon_sym_sampler2DRect] = ACTIONS(173),
    [anon_sym_sampler2DRectshadow] = ACTIONS(173),
    [anon_sym_isampler2DRect] = ACTIONS(173),
    [anon_sym_usampler2DRect] = ACTIONS(173),
    [anon_sym_samplerBuffer] = ACTIONS(173),
    [anon_sym_isamplerBuffer] = ACTIONS(173),
    [anon_sym_usamplerBuffer] = ACTIONS(173),
    [anon_sym_sampler2DMS] = ACTIONS(173),
    [anon_sym_isampler2DMS] = ACTIONS(173),
    [anon_sym_usampler2DMS] = ACTIONS(173),
    [anon_sym_sampler2DMSArray] = ACTIONS(173),
    [anon_sym_isampler2DMSArray] = ACTIONS(173),
    [anon_sym_usampler2DMSArray] = ACTIONS(173),
    [anon_sym_image1D] = ACTIONS(173),
    [anon_sym_iimage1D] = ACTIONS(173),
    [anon_sym_uimage1D] = ACTIONS(173),
    [anon_sym_image2D] = ACTIONS(173),
    [anon_sym_iimage2D] = ACTIONS(173),
    [anon_sym_uimage2D] = ACTIONS(173),
    [anon_sym_image3D] = ACTIONS(173),
    [anon_sym_iimage3D] = ACTIONS(173),
    [anon_sym_uimage3D] = ACTIONS(173),
    [anon_sym_image2DRect] = ACTIONS(173),
    [anon_sym_iimage2DRect] = ACTIONS(173),
    [anon_sym_uimage2DRect] = ACTIONS(173),
    [anon_sym_imageCube] = ACTIONS(173),
    [anon_sym_iimageCube] = ACTIONS(173),
    [anon_sym_uimageCube] = ACTIONS(173),
    [anon_sym_imageBuffer] = ACTIONS(173),
    [anon_sym_iimageBuffer] = ACTIONS(173),
    [anon_sym_uimageBuffer] = ACTIONS(173),
    [anon_sym_image1DArray] = ACTIONS(173),
    [anon_sym_iimage1DArray] = ACTIONS(173),
    [anon_sym_uimage1DArray] = ACTIONS(173),
    [anon_sym_image2DArray] = ACTIONS(173),
    [anon_sym_iimage2DArray] = ACTIONS(173),
    [anon_sym_uimage2DArray] = ACTIONS(173),
    [anon_sym_imageCubeArray] = ACTIONS(173),
    [anon_sym_iimageCubeArray] = ACTIONS(173),
    [anon_sym_uimageCubeArray] = ACTIONS(173),
    [anon_sym_image2DMS] = ACTIONS(173),
    [anon_sym_iimage2DMS] = ACTIONS(173),
    [anon_sym_uimage2DMS] = ACTIONS(173),
    [anon_sym_image2DMSArray] = ACTIONS(173),
    [anon_sym_iimage2DMSArray] = ACTIONS(173),
    [anon_sym_uimage2DMSArray] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(173),
    [anon_sym_inout] = ACTIONS(173),
    [anon_sym_in] = ACTIONS(173),
    [anon_sym_out] = ACTIONS(173),
    [anon_sym_centroid] = ACTIONS(173),
    [anon_sym_patch] = ACTIONS(173),
    [anon_sym_sample] = ACTIONS(173),
    [anon_sym_uniform] = ACTIONS(173),
    [anon_sym_buffer] = ACTIONS(173),
    [anon_sym_shared] = ACTIONS(173),
    [anon_sym_coherent] = ACTIONS(173),
    [anon_sym_volatile] = ACTIONS(173),
    [anon_sym_restrict] = ACTIONS(173),
    [anon_sym_readonly] = ACTIONS(173),
    [anon_sym_writeonly] = ACTIONS(173),
    [anon_sym_subroutine] = ACTIONS(173),
    [anon_sym_varying] = ACTIONS(173),
    [anon_sym_attribute] = ACTIONS(173),
    [anon_sym_layout] = ACTIONS(173),
    [anon_sym_highp] = ACTIONS(173),
    [anon_sym_mediump] = ACTIONS(173),
    [anon_sym_lowp] = ACTIONS(173),
    [anon_sym_smooth] = ACTIONS(173),
    [anon_sym_flat] = ACTIONS(173),
    [anon_sym_noperspective] = ACTIONS(173),
    [sym_invariant_qualifier] = ACTIONS(173),
    [sym_precise_qualifier] = ACTIONS(173),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_true] = ACTIONS(173),
    [anon_sym_false] = ACTIONS(173),
    [aux_sym_number_literal_token1] = ACTIONS(173),
    [aux_sym_number_literal_token2] = ACTIONS(173),
    [aux_sym_number_literal_token3] = ACTIONS(171),
    [aux_sym_number_literal_token4] = ACTIONS(171),
    [aux_sym_number_literal_token5] = ACTIONS(173),
    [aux_sym_number_literal_token6] = ACTIONS(171),
    [sym_comment] = ACTIONS(25),
  },
  [21] = {
    [ts_builtin_sym_end] = ACTIONS(175),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_precision] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(175),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_else] = ACTIONS(177),
    [anon_sym_switch] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_do] = ACTIONS(177),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(177),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_discard] = ACTIONS(177),
    [anon_sym_case] = ACTIONS(177),
    [anon_sym_default] = ACTIONS(177),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_void] = ACTIONS(177),
    [anon_sym_float] = ACTIONS(177),
    [anon_sym_double] = ACTIONS(177),
    [anon_sym_int] = ACTIONS(177),
    [anon_sym_uint] = ACTIONS(177),
    [anon_sym_bool] = ACTIONS(177),
    [anon_sym_vec2] = ACTIONS(177),
    [anon_sym_vec3] = ACTIONS(177),
    [anon_sym_vec4] = ACTIONS(177),
    [anon_sym_dvec2] = ACTIONS(177),
    [anon_sym_dvec3] = ACTIONS(177),
    [anon_sym_dvec4] = ACTIONS(177),
    [anon_sym_bvec2] = ACTIONS(177),
    [anon_sym_bvec3] = ACTIONS(177),
    [anon_sym_bvec4] = ACTIONS(177),
    [anon_sym_ivec2] = ACTIONS(177),
    [anon_sym_ivec3] = ACTIONS(177),
    [anon_sym_ivec4] = ACTIONS(177),
    [anon_sym_uvec2] = ACTIONS(177),
    [anon_sym_uvec3] = ACTIONS(177),
    [anon_sym_uvec4] = ACTIONS(177),
    [anon_sym_mat2] = ACTIONS(177),
    [anon_sym_mat3] = ACTIONS(177),
    [anon_sym_mat4] = ACTIONS(177),
    [anon_sym_mat2x2] = ACTIONS(177),
    [anon_sym_mat2x3] = ACTIONS(177),
    [anon_sym_mat2x4] = ACTIONS(177),
    [anon_sym_mat3x2] = ACTIONS(177),
    [anon_sym_mat3x3] = ACTIONS(177),
    [anon_sym_mat3x4] = ACTIONS(177),
    [anon_sym_mat4x2] = ACTIONS(177),
    [anon_sym_mat4x3] = ACTIONS(177),
    [anon_sym_mat4x4] = ACTIONS(177),
    [anon_sym_dmat2] = ACTIONS(177),
    [anon_sym_dmat3] = ACTIONS(177),
    [anon_sym_dmat4] = ACTIONS(177),
    [anon_sym_dmat2x2] = ACTIONS(177),
    [anon_sym_dmat2x3] = ACTIONS(177),
    [anon_sym_dmat2x4] = ACTIONS(177),
    [anon_sym_dmat3x2] = ACTIONS(177),
    [anon_sym_dmat3x3] = ACTIONS(177),
    [anon_sym_dmat3x4] = ACTIONS(177),
    [anon_sym_dmat4x2] = ACTIONS(177),
    [anon_sym_dmat4x3] = ACTIONS(177),
    [anon_sym_dmat4x4] = ACTIONS(177),
    [anon_sym_atomic_uint] = ACTIONS(177),
    [anon_sym_sampler1d] = ACTIONS(177),
    [anon_sym_sampler2d] = ACTIONS(177),
    [anon_sym_sampler3d] = ACTIONS(177),
    [anon_sym_samplercube] = ACTIONS(177),
    [anon_sym_sampler1DShadow] = ACTIONS(177),
    [anon_sym_sampler2DShadow] = ACTIONS(177),
    [anon_sym_samplerCubeShadow] = ACTIONS(177),
    [anon_sym_sampler1DArray] = ACTIONS(177),
    [anon_sym_sampler2DArray] = ACTIONS(177),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(177),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(177),
    [anon_sym_samplerCubeArray] = ACTIONS(177),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(177),
    [anon_sym_isampler1D] = ACTIONS(177),
    [anon_sym_isampler2D] = ACTIONS(177),
    [anon_sym_isampler3D] = ACTIONS(177),
    [anon_sym_isamplerCube] = ACTIONS(177),
    [anon_sym_isampler1DArray] = ACTIONS(177),
    [anon_sym_isampler2DArray] = ACTIONS(177),
    [anon_sym_isamplerCubeArray] = ACTIONS(177),
    [anon_sym_usampler1D] = ACTIONS(177),
    [anon_sym_usampler2D] = ACTIONS(177),
    [anon_sym_usampler3D] = ACTIONS(177),
    [anon_sym_usamplerCube] = ACTIONS(177),
    [anon_sym_usampler1DArray] = ACTIONS(177),
    [anon_sym_usampler2DArray] = ACTIONS(177),
    [anon_sym_usamplerCubeArray] = ACTIONS(177),
    [anon_sym_sampler2DRect] = ACTIONS(177),
    [anon_sym_sampler2DRectshadow] = ACTIONS(177),
    [anon_sym_isampler2DRect] = ACTIONS(177),
    [anon_sym_usampler2DRect] = ACTIONS(177),
    [anon_sym_samplerBuffer] = ACTIONS(177),
    [anon_sym_isamplerBuffer] = ACTIONS(177),
    [anon_sym_usamplerBuffer] = ACTIONS(177),
    [anon_sym_sampler2DMS] = ACTIONS(177),
    [anon_sym_isampler2DMS] = ACTIONS(177),
    [anon_sym_usampler2DMS] = ACTIONS(177),
    [anon_sym_sampler2DMSArray] = ACTIONS(177),
    [anon_sym_isampler2DMSArray] = ACTIONS(177),
    [anon_sym_usampler2DMSArray] = ACTIONS(177),
    [anon_sym_image1D] = ACTIONS(177),
    [anon_sym_iimage1D] = ACTIONS(177),
    [anon_sym_uimage1D] = ACTIONS(177),
    [anon_sym_image2D] = ACTIONS(177),
    [anon_sym_iimage2D] = ACTIONS(177),
    [anon_sym_uimage2D] = ACTIONS(177),
    [anon_sym_image3D] = ACTIONS(177),
    [anon_sym_iimage3D] = ACTIONS(177),
    [anon_sym_uimage3D] = ACTIONS(177),
    [anon_sym_image2DRect] = ACTIONS(177),
    [anon_sym_iimage2DRect] = ACTIONS(177),
    [anon_sym_uimage2DRect] = ACTIONS(177),
    [anon_sym_imageCube] = ACTIONS(177),
    [anon_sym_iimageCube] = ACTIONS(177),
    [anon_sym_uimageCube] = ACTIONS(177),
    [anon_sym_imageBuffer] = ACTIONS(177),
    [anon_sym_iimageBuffer] = ACTIONS(177),
    [anon_sym_uimageBuffer] = ACTIONS(177),
    [anon_sym_image1DArray] = ACTIONS(177),
    [anon_sym_iimage1DArray] = ACTIONS(177),
    [anon_sym_uimage1DArray] = ACTIONS(177),
    [anon_sym_image2DArray] = ACTIONS(177),
    [anon_sym_iimage2DArray] = ACTIONS(177),
    [anon_sym_uimage2DArray] = ACTIONS(177),
    [anon_sym_imageCubeArray] = ACTIONS(177),
    [anon_sym_iimageCubeArray] = ACTIONS(177),
    [anon_sym_uimageCubeArray] = ACTIONS(177),
    [anon_sym_image2DMS] = ACTIONS(177),
    [anon_sym_iimage2DMS] = ACTIONS(177),
    [anon_sym_uimage2DMS] = ACTIONS(177),
    [anon_sym_image2DMSArray] = ACTIONS(177),
    [anon_sym_iimage2DMSArray] = ACTIONS(177),
    [anon_sym_uimage2DMSArray] = ACTIONS(177),
    [anon_sym_const] = ACTIONS(177),
    [anon_sym_inout] = ACTIONS(177),
    [anon_sym_in] = ACTIONS(177),
    [anon_sym_out] = ACTIONS(177),
    [anon_sym_centroid] = ACTIONS(177),
    [anon_sym_patch] = ACTIONS(177),
    [anon_sym_sample] = ACTIONS(177),
    [anon_sym_uniform] = ACTIONS(177),
    [anon_sym_buffer] = ACTIONS(177),
    [anon_sym_shared] = ACTIONS(177),
    [anon_sym_coherent] = ACTIONS(177),
    [anon_sym_volatile] = ACTIONS(177),
    [anon_sym_restrict] = ACTIONS(177),
    [anon_sym_readonly] = ACTIONS(177),
    [anon_sym_writeonly] = ACTIONS(177),
    [anon_sym_subroutine] = ACTIONS(177),
    [anon_sym_varying] = ACTIONS(177),
    [anon_sym_attribute] = ACTIONS(177),
    [anon_sym_layout] = ACTIONS(177),
    [anon_sym_highp] = ACTIONS(177),
    [anon_sym_mediump] = ACTIONS(177),
    [anon_sym_lowp] = ACTIONS(177),
    [anon_sym_smooth] = ACTIONS(177),
    [anon_sym_flat] = ACTIONS(177),
    [anon_sym_noperspective] = ACTIONS(177),
    [sym_invariant_qualifier] = ACTIONS(177),
    [sym_precise_qualifier] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(177),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(175),
    [anon_sym_PLUS_PLUS] = ACTIONS(175),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(177),
    [anon_sym_false] = ACTIONS(177),
    [aux_sym_number_literal_token1] = ACTIONS(177),
    [aux_sym_number_literal_token2] = ACTIONS(177),
    [aux_sym_number_literal_token3] = ACTIONS(175),
    [aux_sym_number_literal_token4] = ACTIONS(175),
    [aux_sym_number_literal_token5] = ACTIONS(177),
    [aux_sym_number_literal_token6] = ACTIONS(175),
    [sym_comment] = ACTIONS(25),
  },
  [22] = {
    [ts_builtin_sym_end] = ACTIONS(179),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_precision] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(179),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_continue] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_discard] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(181),
    [anon_sym_default] = ACTIONS(181),
    [anon_sym_struct] = ACTIONS(181),
    [anon_sym_void] = ACTIONS(181),
    [anon_sym_float] = ACTIONS(181),
    [anon_sym_double] = ACTIONS(181),
    [anon_sym_int] = ACTIONS(181),
    [anon_sym_uint] = ACTIONS(181),
    [anon_sym_bool] = ACTIONS(181),
    [anon_sym_vec2] = ACTIONS(181),
    [anon_sym_vec3] = ACTIONS(181),
    [anon_sym_vec4] = ACTIONS(181),
    [anon_sym_dvec2] = ACTIONS(181),
    [anon_sym_dvec3] = ACTIONS(181),
    [anon_sym_dvec4] = ACTIONS(181),
    [anon_sym_bvec2] = ACTIONS(181),
    [anon_sym_bvec3] = ACTIONS(181),
    [anon_sym_bvec4] = ACTIONS(181),
    [anon_sym_ivec2] = ACTIONS(181),
    [anon_sym_ivec3] = ACTIONS(181),
    [anon_sym_ivec4] = ACTIONS(181),
    [anon_sym_uvec2] = ACTIONS(181),
    [anon_sym_uvec3] = ACTIONS(181),
    [anon_sym_uvec4] = ACTIONS(181),
    [anon_sym_mat2] = ACTIONS(181),
    [anon_sym_mat3] = ACTIONS(181),
    [anon_sym_mat4] = ACTIONS(181),
    [anon_sym_mat2x2] = ACTIONS(181),
    [anon_sym_mat2x3] = ACTIONS(181),
    [anon_sym_mat2x4] = ACTIONS(181),
    [anon_sym_mat3x2] = ACTIONS(181),
    [anon_sym_mat3x3] = ACTIONS(181),
    [anon_sym_mat3x4] = ACTIONS(181),
    [anon_sym_mat4x2] = ACTIONS(181),
    [anon_sym_mat4x3] = ACTIONS(181),
    [anon_sym_mat4x4] = ACTIONS(181),
    [anon_sym_dmat2] = ACTIONS(181),
    [anon_sym_dmat3] = ACTIONS(181),
    [anon_sym_dmat4] = ACTIONS(181),
    [anon_sym_dmat2x2] = ACTIONS(181),
    [anon_sym_dmat2x3] = ACTIONS(181),
    [anon_sym_dmat2x4] = ACTIONS(181),
    [anon_sym_dmat3x2] = ACTIONS(181),
    [anon_sym_dmat3x3] = ACTIONS(181),
    [anon_sym_dmat3x4] = ACTIONS(181),
    [anon_sym_dmat4x2] = ACTIONS(181),
    [anon_sym_dmat4x3] = ACTIONS(181),
    [anon_sym_dmat4x4] = ACTIONS(181),
    [anon_sym_atomic_uint] = ACTIONS(181),
    [anon_sym_sampler1d] = ACTIONS(181),
    [anon_sym_sampler2d] = ACTIONS(181),
    [anon_sym_sampler3d] = ACTIONS(181),
    [anon_sym_samplercube] = ACTIONS(181),
    [anon_sym_sampler1DShadow] = ACTIONS(181),
    [anon_sym_sampler2DShadow] = ACTIONS(181),
    [anon_sym_samplerCubeShadow] = ACTIONS(181),
    [anon_sym_sampler1DArray] = ACTIONS(181),
    [anon_sym_sampler2DArray] = ACTIONS(181),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(181),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(181),
    [anon_sym_samplerCubeArray] = ACTIONS(181),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(181),
    [anon_sym_isampler1D] = ACTIONS(181),
    [anon_sym_isampler2D] = ACTIONS(181),
    [anon_sym_isampler3D] = ACTIONS(181),
    [anon_sym_isamplerCube] = ACTIONS(181),
    [anon_sym_isampler1DArray] = ACTIONS(181),
    [anon_sym_isampler2DArray] = ACTIONS(181),
    [anon_sym_isamplerCubeArray] = ACTIONS(181),
    [anon_sym_usampler1D] = ACTIONS(181),
    [anon_sym_usampler2D] = ACTIONS(181),
    [anon_sym_usampler3D] = ACTIONS(181),
    [anon_sym_usamplerCube] = ACTIONS(181),
    [anon_sym_usampler1DArray] = ACTIONS(181),
    [anon_sym_usampler2DArray] = ACTIONS(181),
    [anon_sym_usamplerCubeArray] = ACTIONS(181),
    [anon_sym_sampler2DRect] = ACTIONS(181),
    [anon_sym_sampler2DRectshadow] = ACTIONS(181),
    [anon_sym_isampler2DRect] = ACTIONS(181),
    [anon_sym_usampler2DRect] = ACTIONS(181),
    [anon_sym_samplerBuffer] = ACTIONS(181),
    [anon_sym_isamplerBuffer] = ACTIONS(181),
    [anon_sym_usamplerBuffer] = ACTIONS(181),
    [anon_sym_sampler2DMS] = ACTIONS(181),
    [anon_sym_isampler2DMS] = ACTIONS(181),
    [anon_sym_usampler2DMS] = ACTIONS(181),
    [anon_sym_sampler2DMSArray] = ACTIONS(181),
    [anon_sym_isampler2DMSArray] = ACTIONS(181),
    [anon_sym_usampler2DMSArray] = ACTIONS(181),
    [anon_sym_image1D] = ACTIONS(181),
    [anon_sym_iimage1D] = ACTIONS(181),
    [anon_sym_uimage1D] = ACTIONS(181),
    [anon_sym_image2D] = ACTIONS(181),
    [anon_sym_iimage2D] = ACTIONS(181),
    [anon_sym_uimage2D] = ACTIONS(181),
    [anon_sym_image3D] = ACTIONS(181),
    [anon_sym_iimage3D] = ACTIONS(181),
    [anon_sym_uimage3D] = ACTIONS(181),
    [anon_sym_image2DRect] = ACTIONS(181),
    [anon_sym_iimage2DRect] = ACTIONS(181),
    [anon_sym_uimage2DRect] = ACTIONS(181),
    [anon_sym_imageCube] = ACTIONS(181),
    [anon_sym_iimageCube] = ACTIONS(181),
    [anon_sym_uimageCube] = ACTIONS(181),
    [anon_sym_imageBuffer] = ACTIONS(181),
    [anon_sym_iimageBuffer] = ACTIONS(181),
    [anon_sym_uimageBuffer] = ACTIONS(181),
    [anon_sym_image1DArray] = ACTIONS(181),
    [anon_sym_iimage1DArray] = ACTIONS(181),
    [anon_sym_uimage1DArray] = ACTIONS(181),
    [anon_sym_image2DArray] = ACTIONS(181),
    [anon_sym_iimage2DArray] = ACTIONS(181),
    [anon_sym_uimage2DArray] = ACTIONS(181),
    [anon_sym_imageCubeArray] = ACTIONS(181),
    [anon_sym_iimageCubeArray] = ACTIONS(181),
    [anon_sym_uimageCubeArray] = ACTIONS(181),
    [anon_sym_image2DMS] = ACTIONS(181),
    [anon_sym_iimage2DMS] = ACTIONS(181),
    [anon_sym_uimage2DMS] = ACTIONS(181),
    [anon_sym_image2DMSArray] = ACTIONS(181),
    [anon_sym_iimage2DMSArray] = ACTIONS(181),
    [anon_sym_uimage2DMSArray] = ACTIONS(181),
    [anon_sym_const] = ACTIONS(181),
    [anon_sym_inout] = ACTIONS(181),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_out] = ACTIONS(181),
    [anon_sym_centroid] = ACTIONS(181),
    [anon_sym_patch] = ACTIONS(181),
    [anon_sym_sample] = ACTIONS(181),
    [anon_sym_uniform] = ACTIONS(181),
    [anon_sym_buffer] = ACTIONS(181),
    [anon_sym_shared] = ACTIONS(181),
    [anon_sym_coherent] = ACTIONS(181),
    [anon_sym_volatile] = ACTIONS(181),
    [anon_sym_restrict] = ACTIONS(181),
    [anon_sym_readonly] = ACTIONS(181),
    [anon_sym_writeonly] = ACTIONS(181),
    [anon_sym_subroutine] = ACTIONS(181),
    [anon_sym_varying] = ACTIONS(181),
    [anon_sym_attribute] = ACTIONS(181),
    [anon_sym_layout] = ACTIONS(181),
    [anon_sym_highp] = ACTIONS(181),
    [anon_sym_mediump] = ACTIONS(181),
    [anon_sym_lowp] = ACTIONS(181),
    [anon_sym_smooth] = ACTIONS(181),
    [anon_sym_flat] = ACTIONS(181),
    [anon_sym_noperspective] = ACTIONS(181),
    [sym_invariant_qualifier] = ACTIONS(181),
    [sym_precise_qualifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_TILDE] = ACTIONS(179),
    [anon_sym_PLUS_PLUS] = ACTIONS(179),
    [anon_sym_DASH_DASH] = ACTIONS(179),
    [anon_sym_true] = ACTIONS(181),
    [anon_sym_false] = ACTIONS(181),
    [aux_sym_number_literal_token1] = ACTIONS(181),
    [aux_sym_number_literal_token2] = ACTIONS(181),
    [aux_sym_number_literal_token3] = ACTIONS(179),
    [aux_sym_number_literal_token4] = ACTIONS(179),
    [aux_sym_number_literal_token5] = ACTIONS(181),
    [aux_sym_number_literal_token6] = ACTIONS(179),
    [sym_comment] = ACTIONS(25),
  },
  [23] = {
    [ts_builtin_sym_end] = ACTIONS(183),
    [sym_identifier] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_precision] = ACTIONS(185),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_else] = ACTIONS(185),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(185),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(185),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_break] = ACTIONS(185),
    [anon_sym_return] = ACTIONS(185),
    [anon_sym_discard] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_default] = ACTIONS(185),
    [anon_sym_struct] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(185),
    [anon_sym_float] = ACTIONS(185),
    [anon_sym_double] = ACTIONS(185),
    [anon_sym_int] = ACTIONS(185),
    [anon_sym_uint] = ACTIONS(185),
    [anon_sym_bool] = ACTIONS(185),
    [anon_sym_vec2] = ACTIONS(185),
    [anon_sym_vec3] = ACTIONS(185),
    [anon_sym_vec4] = ACTIONS(185),
    [anon_sym_dvec2] = ACTIONS(185),
    [anon_sym_dvec3] = ACTIONS(185),
    [anon_sym_dvec4] = ACTIONS(185),
    [anon_sym_bvec2] = ACTIONS(185),
    [anon_sym_bvec3] = ACTIONS(185),
    [anon_sym_bvec4] = ACTIONS(185),
    [anon_sym_ivec2] = ACTIONS(185),
    [anon_sym_ivec3] = ACTIONS(185),
    [anon_sym_ivec4] = ACTIONS(185),
    [anon_sym_uvec2] = ACTIONS(185),
    [anon_sym_uvec3] = ACTIONS(185),
    [anon_sym_uvec4] = ACTIONS(185),
    [anon_sym_mat2] = ACTIONS(185),
    [anon_sym_mat3] = ACTIONS(185),
    [anon_sym_mat4] = ACTIONS(185),
    [anon_sym_mat2x2] = ACTIONS(185),
    [anon_sym_mat2x3] = ACTIONS(185),
    [anon_sym_mat2x4] = ACTIONS(185),
    [anon_sym_mat3x2] = ACTIONS(185),
    [anon_sym_mat3x3] = ACTIONS(185),
    [anon_sym_mat3x4] = ACTIONS(185),
    [anon_sym_mat4x2] = ACTIONS(185),
    [anon_sym_mat4x3] = ACTIONS(185),
    [anon_sym_mat4x4] = ACTIONS(185),
    [anon_sym_dmat2] = ACTIONS(185),
    [anon_sym_dmat3] = ACTIONS(185),
    [anon_sym_dmat4] = ACTIONS(185),
    [anon_sym_dmat2x2] = ACTIONS(185),
    [anon_sym_dmat2x3] = ACTIONS(185),
    [anon_sym_dmat2x4] = ACTIONS(185),
    [anon_sym_dmat3x2] = ACTIONS(185),
    [anon_sym_dmat3x3] = ACTIONS(185),
    [anon_sym_dmat3x4] = ACTIONS(185),
    [anon_sym_dmat4x2] = ACTIONS(185),
    [anon_sym_dmat4x3] = ACTIONS(185),
    [anon_sym_dmat4x4] = ACTIONS(185),
    [anon_sym_atomic_uint] = ACTIONS(185),
    [anon_sym_sampler1d] = ACTIONS(185),
    [anon_sym_sampler2d] = ACTIONS(185),
    [anon_sym_sampler3d] = ACTIONS(185),
    [anon_sym_samplercube] = ACTIONS(185),
    [anon_sym_sampler1DShadow] = ACTIONS(185),
    [anon_sym_sampler2DShadow] = ACTIONS(185),
    [anon_sym_samplerCubeShadow] = ACTIONS(185),
    [anon_sym_sampler1DArray] = ACTIONS(185),
    [anon_sym_sampler2DArray] = ACTIONS(185),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(185),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(185),
    [anon_sym_samplerCubeArray] = ACTIONS(185),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(185),
    [anon_sym_isampler1D] = ACTIONS(185),
    [anon_sym_isampler2D] = ACTIONS(185),
    [anon_sym_isampler3D] = ACTIONS(185),
    [anon_sym_isamplerCube] = ACTIONS(185),
    [anon_sym_isampler1DArray] = ACTIONS(185),
    [anon_sym_isampler2DArray] = ACTIONS(185),
    [anon_sym_isamplerCubeArray] = ACTIONS(185),
    [anon_sym_usampler1D] = ACTIONS(185),
    [anon_sym_usampler2D] = ACTIONS(185),
    [anon_sym_usampler3D] = ACTIONS(185),
    [anon_sym_usamplerCube] = ACTIONS(185),
    [anon_sym_usampler1DArray] = ACTIONS(185),
    [anon_sym_usampler2DArray] = ACTIONS(185),
    [anon_sym_usamplerCubeArray] = ACTIONS(185),
    [anon_sym_sampler2DRect] = ACTIONS(185),
    [anon_sym_sampler2DRectshadow] = ACTIONS(185),
    [anon_sym_isampler2DRect] = ACTIONS(185),
    [anon_sym_usampler2DRect] = ACTIONS(185),
    [anon_sym_samplerBuffer] = ACTIONS(185),
    [anon_sym_isamplerBuffer] = ACTIONS(185),
    [anon_sym_usamplerBuffer] = ACTIONS(185),
    [anon_sym_sampler2DMS] = ACTIONS(185),
    [anon_sym_isampler2DMS] = ACTIONS(185),
    [anon_sym_usampler2DMS] = ACTIONS(185),
    [anon_sym_sampler2DMSArray] = ACTIONS(185),
    [anon_sym_isampler2DMSArray] = ACTIONS(185),
    [anon_sym_usampler2DMSArray] = ACTIONS(185),
    [anon_sym_image1D] = ACTIONS(185),
    [anon_sym_iimage1D] = ACTIONS(185),
    [anon_sym_uimage1D] = ACTIONS(185),
    [anon_sym_image2D] = ACTIONS(185),
    [anon_sym_iimage2D] = ACTIONS(185),
    [anon_sym_uimage2D] = ACTIONS(185),
    [anon_sym_image3D] = ACTIONS(185),
    [anon_sym_iimage3D] = ACTIONS(185),
    [anon_sym_uimage3D] = ACTIONS(185),
    [anon_sym_image2DRect] = ACTIONS(185),
    [anon_sym_iimage2DRect] = ACTIONS(185),
    [anon_sym_uimage2DRect] = ACTIONS(185),
    [anon_sym_imageCube] = ACTIONS(185),
    [anon_sym_iimageCube] = ACTIONS(185),
    [anon_sym_uimageCube] = ACTIONS(185),
    [anon_sym_imageBuffer] = ACTIONS(185),
    [anon_sym_iimageBuffer] = ACTIONS(185),
    [anon_sym_uimageBuffer] = ACTIONS(185),
    [anon_sym_image1DArray] = ACTIONS(185),
    [anon_sym_iimage1DArray] = ACTIONS(185),
    [anon_sym_uimage1DArray] = ACTIONS(185),
    [anon_sym_image2DArray] = ACTIONS(185),
    [anon_sym_iimage2DArray] = ACTIONS(185),
    [anon_sym_uimage2DArray] = ACTIONS(185),
    [anon_sym_imageCubeArray] = ACTIONS(185),
    [anon_sym_iimageCubeArray] = ACTIONS(185),
    [anon_sym_uimageCubeArray] = ACTIONS(185),
    [anon_sym_image2DMS] = ACTIONS(185),
    [anon_sym_iimage2DMS] = ACTIONS(185),
    [anon_sym_uimage2DMS] = ACTIONS(185),
    [anon_sym_image2DMSArray] = ACTIONS(185),
    [anon_sym_iimage2DMSArray] = ACTIONS(185),
    [anon_sym_uimage2DMSArray] = ACTIONS(185),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_inout] = ACTIONS(185),
    [anon_sym_in] = ACTIONS(185),
    [anon_sym_out] = ACTIONS(185),
    [anon_sym_centroid] = ACTIONS(185),
    [anon_sym_patch] = ACTIONS(185),
    [anon_sym_sample] = ACTIONS(185),
    [anon_sym_uniform] = ACTIONS(185),
    [anon_sym_buffer] = ACTIONS(185),
    [anon_sym_shared] = ACTIONS(185),
    [anon_sym_coherent] = ACTIONS(185),
    [anon_sym_volatile] = ACTIONS(185),
    [anon_sym_restrict] = ACTIONS(185),
    [anon_sym_readonly] = ACTIONS(185),
    [anon_sym_writeonly] = ACTIONS(185),
    [anon_sym_subroutine] = ACTIONS(185),
    [anon_sym_varying] = ACTIONS(185),
    [anon_sym_attribute] = ACTIONS(185),
    [anon_sym_layout] = ACTIONS(185),
    [anon_sym_highp] = ACTIONS(185),
    [anon_sym_mediump] = ACTIONS(185),
    [anon_sym_lowp] = ACTIONS(185),
    [anon_sym_smooth] = ACTIONS(185),
    [anon_sym_flat] = ACTIONS(185),
    [anon_sym_noperspective] = ACTIONS(185),
    [sym_invariant_qualifier] = ACTIONS(185),
    [sym_precise_qualifier] = ACTIONS(185),
    [anon_sym_PLUS] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(185),
    [anon_sym_BANG] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(183),
    [anon_sym_PLUS_PLUS] = ACTIONS(183),
    [anon_sym_DASH_DASH] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(185),
    [anon_sym_false] = ACTIONS(185),
    [aux_sym_number_literal_token1] = ACTIONS(185),
    [aux_sym_number_literal_token2] = ACTIONS(185),
    [aux_sym_number_literal_token3] = ACTIONS(183),
    [aux_sym_number_literal_token4] = ACTIONS(183),
    [aux_sym_number_literal_token5] = ACTIONS(185),
    [aux_sym_number_literal_token6] = ACTIONS(183),
    [sym_comment] = ACTIONS(25),
  },
  [24] = {
    [ts_builtin_sym_end] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_precision] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(187),
    [anon_sym_RBRACE] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(187),
    [anon_sym_else] = ACTIONS(189),
    [anon_sym_switch] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(189),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(189),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_discard] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(189),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_struct] = ACTIONS(189),
    [anon_sym_void] = ACTIONS(189),
    [anon_sym_float] = ACTIONS(189),
    [anon_sym_double] = ACTIONS(189),
    [anon_sym_int] = ACTIONS(189),
    [anon_sym_uint] = ACTIONS(189),
    [anon_sym_bool] = ACTIONS(189),
    [anon_sym_vec2] = ACTIONS(189),
    [anon_sym_vec3] = ACTIONS(189),
    [anon_sym_vec4] = ACTIONS(189),
    [anon_sym_dvec2] = ACTIONS(189),
    [anon_sym_dvec3] = ACTIONS(189),
    [anon_sym_dvec4] = ACTIONS(189),
    [anon_sym_bvec2] = ACTIONS(189),
    [anon_sym_bvec3] = ACTIONS(189),
    [anon_sym_bvec4] = ACTIONS(189),
    [anon_sym_ivec2] = ACTIONS(189),
    [anon_sym_ivec3] = ACTIONS(189),
    [anon_sym_ivec4] = ACTIONS(189),
    [anon_sym_uvec2] = ACTIONS(189),
    [anon_sym_uvec3] = ACTIONS(189),
    [anon_sym_uvec4] = ACTIONS(189),
    [anon_sym_mat2] = ACTIONS(189),
    [anon_sym_mat3] = ACTIONS(189),
    [anon_sym_mat4] = ACTIONS(189),
    [anon_sym_mat2x2] = ACTIONS(189),
    [anon_sym_mat2x3] = ACTIONS(189),
    [anon_sym_mat2x4] = ACTIONS(189),
    [anon_sym_mat3x2] = ACTIONS(189),
    [anon_sym_mat3x3] = ACTIONS(189),
    [anon_sym_mat3x4] = ACTIONS(189),
    [anon_sym_mat4x2] = ACTIONS(189),
    [anon_sym_mat4x3] = ACTIONS(189),
    [anon_sym_mat4x4] = ACTIONS(189),
    [anon_sym_dmat2] = ACTIONS(189),
    [anon_sym_dmat3] = ACTIONS(189),
    [anon_sym_dmat4] = ACTIONS(189),
    [anon_sym_dmat2x2] = ACTIONS(189),
    [anon_sym_dmat2x3] = ACTIONS(189),
    [anon_sym_dmat2x4] = ACTIONS(189),
    [anon_sym_dmat3x2] = ACTIONS(189),
    [anon_sym_dmat3x3] = ACTIONS(189),
    [anon_sym_dmat3x4] = ACTIONS(189),
    [anon_sym_dmat4x2] = ACTIONS(189),
    [anon_sym_dmat4x3] = ACTIONS(189),
    [anon_sym_dmat4x4] = ACTIONS(189),
    [anon_sym_atomic_uint] = ACTIONS(189),
    [anon_sym_sampler1d] = ACTIONS(189),
    [anon_sym_sampler2d] = ACTIONS(189),
    [anon_sym_sampler3d] = ACTIONS(189),
    [anon_sym_samplercube] = ACTIONS(189),
    [anon_sym_sampler1DShadow] = ACTIONS(189),
    [anon_sym_sampler2DShadow] = ACTIONS(189),
    [anon_sym_samplerCubeShadow] = ACTIONS(189),
    [anon_sym_sampler1DArray] = ACTIONS(189),
    [anon_sym_sampler2DArray] = ACTIONS(189),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(189),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(189),
    [anon_sym_samplerCubeArray] = ACTIONS(189),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(189),
    [anon_sym_isampler1D] = ACTIONS(189),
    [anon_sym_isampler2D] = ACTIONS(189),
    [anon_sym_isampler3D] = ACTIONS(189),
    [anon_sym_isamplerCube] = ACTIONS(189),
    [anon_sym_isampler1DArray] = ACTIONS(189),
    [anon_sym_isampler2DArray] = ACTIONS(189),
    [anon_sym_isamplerCubeArray] = ACTIONS(189),
    [anon_sym_usampler1D] = ACTIONS(189),
    [anon_sym_usampler2D] = ACTIONS(189),
    [anon_sym_usampler3D] = ACTIONS(189),
    [anon_sym_usamplerCube] = ACTIONS(189),
    [anon_sym_usampler1DArray] = ACTIONS(189),
    [anon_sym_usampler2DArray] = ACTIONS(189),
    [anon_sym_usamplerCubeArray] = ACTIONS(189),
    [anon_sym_sampler2DRect] = ACTIONS(189),
    [anon_sym_sampler2DRectshadow] = ACTIONS(189),
    [anon_sym_isampler2DRect] = ACTIONS(189),
    [anon_sym_usampler2DRect] = ACTIONS(189),
    [anon_sym_samplerBuffer] = ACTIONS(189),
    [anon_sym_isamplerBuffer] = ACTIONS(189),
    [anon_sym_usamplerBuffer] = ACTIONS(189),
    [anon_sym_sampler2DMS] = ACTIONS(189),
    [anon_sym_isampler2DMS] = ACTIONS(189),
    [anon_sym_usampler2DMS] = ACTIONS(189),
    [anon_sym_sampler2DMSArray] = ACTIONS(189),
    [anon_sym_isampler2DMSArray] = ACTIONS(189),
    [anon_sym_usampler2DMSArray] = ACTIONS(189),
    [anon_sym_image1D] = ACTIONS(189),
    [anon_sym_iimage1D] = ACTIONS(189),
    [anon_sym_uimage1D] = ACTIONS(189),
    [anon_sym_image2D] = ACTIONS(189),
    [anon_sym_iimage2D] = ACTIONS(189),
    [anon_sym_uimage2D] = ACTIONS(189),
    [anon_sym_image3D] = ACTIONS(189),
    [anon_sym_iimage3D] = ACTIONS(189),
    [anon_sym_uimage3D] = ACTIONS(189),
    [anon_sym_image2DRect] = ACTIONS(189),
    [anon_sym_iimage2DRect] = ACTIONS(189),
    [anon_sym_uimage2DRect] = ACTIONS(189),
    [anon_sym_imageCube] = ACTIONS(189),
    [anon_sym_iimageCube] = ACTIONS(189),
    [anon_sym_uimageCube] = ACTIONS(189),
    [anon_sym_imageBuffer] = ACTIONS(189),
    [anon_sym_iimageBuffer] = ACTIONS(189),
    [anon_sym_uimageBuffer] = ACTIONS(189),
    [anon_sym_image1DArray] = ACTIONS(189),
    [anon_sym_iimage1DArray] = ACTIONS(189),
    [anon_sym_uimage1DArray] = ACTIONS(189),
    [anon_sym_image2DArray] = ACTIONS(189),
    [anon_sym_iimage2DArray] = ACTIONS(189),
    [anon_sym_uimage2DArray] = ACTIONS(189),
    [anon_sym_imageCubeArray] = ACTIONS(189),
    [anon_sym_iimageCubeArray] = ACTIONS(189),
    [anon_sym_uimageCubeArray] = ACTIONS(189),
    [anon_sym_image2DMS] = ACTIONS(189),
    [anon_sym_iimage2DMS] = ACTIONS(189),
    [anon_sym_uimage2DMS] = ACTIONS(189),
    [anon_sym_image2DMSArray] = ACTIONS(189),
    [anon_sym_iimage2DMSArray] = ACTIONS(189),
    [anon_sym_uimage2DMSArray] = ACTIONS(189),
    [anon_sym_const] = ACTIONS(189),
    [anon_sym_inout] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(189),
    [anon_sym_out] = ACTIONS(189),
    [anon_sym_centroid] = ACTIONS(189),
    [anon_sym_patch] = ACTIONS(189),
    [anon_sym_sample] = ACTIONS(189),
    [anon_sym_uniform] = ACTIONS(189),
    [anon_sym_buffer] = ACTIONS(189),
    [anon_sym_shared] = ACTIONS(189),
    [anon_sym_coherent] = ACTIONS(189),
    [anon_sym_volatile] = ACTIONS(189),
    [anon_sym_restrict] = ACTIONS(189),
    [anon_sym_readonly] = ACTIONS(189),
    [anon_sym_writeonly] = ACTIONS(189),
    [anon_sym_subroutine] = ACTIONS(189),
    [anon_sym_varying] = ACTIONS(189),
    [anon_sym_attribute] = ACTIONS(189),
    [anon_sym_layout] = ACTIONS(189),
    [anon_sym_highp] = ACTIONS(189),
    [anon_sym_mediump] = ACTIONS(189),
    [anon_sym_lowp] = ACTIONS(189),
    [anon_sym_smooth] = ACTIONS(189),
    [anon_sym_flat] = ACTIONS(189),
    [anon_sym_noperspective] = ACTIONS(189),
    [sym_invariant_qualifier] = ACTIONS(189),
    [sym_precise_qualifier] = ACTIONS(189),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_BANG] = ACTIONS(187),
    [anon_sym_TILDE] = ACTIONS(187),
    [anon_sym_PLUS_PLUS] = ACTIONS(187),
    [anon_sym_DASH_DASH] = ACTIONS(187),
    [anon_sym_true] = ACTIONS(189),
    [anon_sym_false] = ACTIONS(189),
    [aux_sym_number_literal_token1] = ACTIONS(189),
    [aux_sym_number_literal_token2] = ACTIONS(189),
    [aux_sym_number_literal_token3] = ACTIONS(187),
    [aux_sym_number_literal_token4] = ACTIONS(187),
    [aux_sym_number_literal_token5] = ACTIONS(189),
    [aux_sym_number_literal_token6] = ACTIONS(187),
    [sym_comment] = ACTIONS(25),
  },
  [25] = {
    [sym_identifier] = ACTIONS(191),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_precision] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_else] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(191),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_for] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(191),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_discard] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(191),
    [anon_sym_struct] = ACTIONS(191),
    [anon_sym_void] = ACTIONS(191),
    [anon_sym_float] = ACTIONS(191),
    [anon_sym_double] = ACTIONS(191),
    [anon_sym_int] = ACTIONS(191),
    [anon_sym_uint] = ACTIONS(191),
    [anon_sym_bool] = ACTIONS(191),
    [anon_sym_vec2] = ACTIONS(191),
    [anon_sym_vec3] = ACTIONS(191),
    [anon_sym_vec4] = ACTIONS(191),
    [anon_sym_dvec2] = ACTIONS(191),
    [anon_sym_dvec3] = ACTIONS(191),
    [anon_sym_dvec4] = ACTIONS(191),
    [anon_sym_bvec2] = ACTIONS(191),
    [anon_sym_bvec3] = ACTIONS(191),
    [anon_sym_bvec4] = ACTIONS(191),
    [anon_sym_ivec2] = ACTIONS(191),
    [anon_sym_ivec3] = ACTIONS(191),
    [anon_sym_ivec4] = ACTIONS(191),
    [anon_sym_uvec2] = ACTIONS(191),
    [anon_sym_uvec3] = ACTIONS(191),
    [anon_sym_uvec4] = ACTIONS(191),
    [anon_sym_mat2] = ACTIONS(191),
    [anon_sym_mat3] = ACTIONS(191),
    [anon_sym_mat4] = ACTIONS(191),
    [anon_sym_mat2x2] = ACTIONS(191),
    [anon_sym_mat2x3] = ACTIONS(191),
    [anon_sym_mat2x4] = ACTIONS(191),
    [anon_sym_mat3x2] = ACTIONS(191),
    [anon_sym_mat3x3] = ACTIONS(191),
    [anon_sym_mat3x4] = ACTIONS(191),
    [anon_sym_mat4x2] = ACTIONS(191),
    [anon_sym_mat4x3] = ACTIONS(191),
    [anon_sym_mat4x4] = ACTIONS(191),
    [anon_sym_dmat2] = ACTIONS(191),
    [anon_sym_dmat3] = ACTIONS(191),
    [anon_sym_dmat4] = ACTIONS(191),
    [anon_sym_dmat2x2] = ACTIONS(191),
    [anon_sym_dmat2x3] = ACTIONS(191),
    [anon_sym_dmat2x4] = ACTIONS(191),
    [anon_sym_dmat3x2] = ACTIONS(191),
    [anon_sym_dmat3x3] = ACTIONS(191),
    [anon_sym_dmat3x4] = ACTIONS(191),
    [anon_sym_dmat4x2] = ACTIONS(191),
    [anon_sym_dmat4x3] = ACTIONS(191),
    [anon_sym_dmat4x4] = ACTIONS(191),
    [anon_sym_atomic_uint] = ACTIONS(191),
    [anon_sym_sampler1d] = ACTIONS(191),
    [anon_sym_sampler2d] = ACTIONS(191),
    [anon_sym_sampler3d] = ACTIONS(191),
    [anon_sym_samplercube] = ACTIONS(191),
    [anon_sym_sampler1DShadow] = ACTIONS(191),
    [anon_sym_sampler2DShadow] = ACTIONS(191),
    [anon_sym_samplerCubeShadow] = ACTIONS(191),
    [anon_sym_sampler1DArray] = ACTIONS(191),
    [anon_sym_sampler2DArray] = ACTIONS(191),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(191),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(191),
    [anon_sym_samplerCubeArray] = ACTIONS(191),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(191),
    [anon_sym_isampler1D] = ACTIONS(191),
    [anon_sym_isampler2D] = ACTIONS(191),
    [anon_sym_isampler3D] = ACTIONS(191),
    [anon_sym_isamplerCube] = ACTIONS(191),
    [anon_sym_isampler1DArray] = ACTIONS(191),
    [anon_sym_isampler2DArray] = ACTIONS(191),
    [anon_sym_isamplerCubeArray] = ACTIONS(191),
    [anon_sym_usampler1D] = ACTIONS(191),
    [anon_sym_usampler2D] = ACTIONS(191),
    [anon_sym_usampler3D] = ACTIONS(191),
    [anon_sym_usamplerCube] = ACTIONS(191),
    [anon_sym_usampler1DArray] = ACTIONS(191),
    [anon_sym_usampler2DArray] = ACTIONS(191),
    [anon_sym_usamplerCubeArray] = ACTIONS(191),
    [anon_sym_sampler2DRect] = ACTIONS(191),
    [anon_sym_sampler2DRectshadow] = ACTIONS(191),
    [anon_sym_isampler2DRect] = ACTIONS(191),
    [anon_sym_usampler2DRect] = ACTIONS(191),
    [anon_sym_samplerBuffer] = ACTIONS(191),
    [anon_sym_isamplerBuffer] = ACTIONS(191),
    [anon_sym_usamplerBuffer] = ACTIONS(191),
    [anon_sym_sampler2DMS] = ACTIONS(191),
    [anon_sym_isampler2DMS] = ACTIONS(191),
    [anon_sym_usampler2DMS] = ACTIONS(191),
    [anon_sym_sampler2DMSArray] = ACTIONS(191),
    [anon_sym_isampler2DMSArray] = ACTIONS(191),
    [anon_sym_usampler2DMSArray] = ACTIONS(191),
    [anon_sym_image1D] = ACTIONS(191),
    [anon_sym_iimage1D] = ACTIONS(191),
    [anon_sym_uimage1D] = ACTIONS(191),
    [anon_sym_image2D] = ACTIONS(191),
    [anon_sym_iimage2D] = ACTIONS(191),
    [anon_sym_uimage2D] = ACTIONS(191),
    [anon_sym_image3D] = ACTIONS(191),
    [anon_sym_iimage3D] = ACTIONS(191),
    [anon_sym_uimage3D] = ACTIONS(191),
    [anon_sym_image2DRect] = ACTIONS(191),
    [anon_sym_iimage2DRect] = ACTIONS(191),
    [anon_sym_uimage2DRect] = ACTIONS(191),
    [anon_sym_imageCube] = ACTIONS(191),
    [anon_sym_iimageCube] = ACTIONS(191),
    [anon_sym_uimageCube] = ACTIONS(191),
    [anon_sym_imageBuffer] = ACTIONS(191),
    [anon_sym_iimageBuffer] = ACTIONS(191),
    [anon_sym_uimageBuffer] = ACTIONS(191),
    [anon_sym_image1DArray] = ACTIONS(191),
    [anon_sym_iimage1DArray] = ACTIONS(191),
    [anon_sym_uimage1DArray] = ACTIONS(191),
    [anon_sym_image2DArray] = ACTIONS(191),
    [anon_sym_iimage2DArray] = ACTIONS(191),
    [anon_sym_uimage2DArray] = ACTIONS(191),
    [anon_sym_imageCubeArray] = ACTIONS(191),
    [anon_sym_iimageCubeArray] = ACTIONS(191),
    [anon_sym_uimageCubeArray] = ACTIONS(191),
    [anon_sym_image2DMS] = ACTIONS(191),
    [anon_sym_iimage2DMS] = ACTIONS(191),
    [anon_sym_uimage2DMS] = ACTIONS(191),
    [anon_sym_image2DMSArray] = ACTIONS(191),
    [anon_sym_iimage2DMSArray] = ACTIONS(191),
    [anon_sym_uimage2DMSArray] = ACTIONS(191),
    [anon_sym_const] = ACTIONS(191),
    [anon_sym_inout] = ACTIONS(191),
    [anon_sym_in] = ACTIONS(191),
    [anon_sym_out] = ACTIONS(191),
    [anon_sym_centroid] = ACTIONS(191),
    [anon_sym_patch] = ACTIONS(191),
    [anon_sym_sample] = ACTIONS(191),
    [anon_sym_uniform] = ACTIONS(191),
    [anon_sym_buffer] = ACTIONS(191),
    [anon_sym_shared] = ACTIONS(191),
    [anon_sym_coherent] = ACTIONS(191),
    [anon_sym_volatile] = ACTIONS(191),
    [anon_sym_restrict] = ACTIONS(191),
    [anon_sym_readonly] = ACTIONS(191),
    [anon_sym_writeonly] = ACTIONS(191),
    [anon_sym_subroutine] = ACTIONS(191),
    [anon_sym_varying] = ACTIONS(191),
    [anon_sym_attribute] = ACTIONS(191),
    [anon_sym_layout] = ACTIONS(191),
    [anon_sym_highp] = ACTIONS(191),
    [anon_sym_mediump] = ACTIONS(191),
    [anon_sym_lowp] = ACTIONS(191),
    [anon_sym_smooth] = ACTIONS(191),
    [anon_sym_flat] = ACTIONS(191),
    [anon_sym_noperspective] = ACTIONS(191),
    [sym_invariant_qualifier] = ACTIONS(191),
    [sym_precise_qualifier] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(193),
    [anon_sym_TILDE] = ACTIONS(193),
    [anon_sym_PLUS_PLUS] = ACTIONS(193),
    [anon_sym_DASH_DASH] = ACTIONS(193),
    [anon_sym_true] = ACTIONS(191),
    [anon_sym_false] = ACTIONS(191),
    [aux_sym_number_literal_token1] = ACTIONS(191),
    [aux_sym_number_literal_token2] = ACTIONS(191),
    [aux_sym_number_literal_token3] = ACTIONS(193),
    [aux_sym_number_literal_token4] = ACTIONS(193),
    [aux_sym_number_literal_token5] = ACTIONS(191),
    [aux_sym_number_literal_token6] = ACTIONS(193),
    [sym_comment] = ACTIONS(25),
  },
  [26] = {
    [sym_identifier] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(197),
    [anon_sym_precision] = ACTIONS(195),
    [anon_sym_LBRACE] = ACTIONS(197),
    [anon_sym_RBRACE] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(195),
    [anon_sym_LPAREN] = ACTIONS(197),
    [anon_sym_else] = ACTIONS(195),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_discard] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(195),
    [anon_sym_struct] = ACTIONS(195),
    [anon_sym_void] = ACTIONS(195),
    [anon_sym_float] = ACTIONS(195),
    [anon_sym_double] = ACTIONS(195),
    [anon_sym_int] = ACTIONS(195),
    [anon_sym_uint] = ACTIONS(195),
    [anon_sym_bool] = ACTIONS(195),
    [anon_sym_vec2] = ACTIONS(195),
    [anon_sym_vec3] = ACTIONS(195),
    [anon_sym_vec4] = ACTIONS(195),
    [anon_sym_dvec2] = ACTIONS(195),
    [anon_sym_dvec3] = ACTIONS(195),
    [anon_sym_dvec4] = ACTIONS(195),
    [anon_sym_bvec2] = ACTIONS(195),
    [anon_sym_bvec3] = ACTIONS(195),
    [anon_sym_bvec4] = ACTIONS(195),
    [anon_sym_ivec2] = ACTIONS(195),
    [anon_sym_ivec3] = ACTIONS(195),
    [anon_sym_ivec4] = ACTIONS(195),
    [anon_sym_uvec2] = ACTIONS(195),
    [anon_sym_uvec3] = ACTIONS(195),
    [anon_sym_uvec4] = ACTIONS(195),
    [anon_sym_mat2] = ACTIONS(195),
    [anon_sym_mat3] = ACTIONS(195),
    [anon_sym_mat4] = ACTIONS(195),
    [anon_sym_mat2x2] = ACTIONS(195),
    [anon_sym_mat2x3] = ACTIONS(195),
    [anon_sym_mat2x4] = ACTIONS(195),
    [anon_sym_mat3x2] = ACTIONS(195),
    [anon_sym_mat3x3] = ACTIONS(195),
    [anon_sym_mat3x4] = ACTIONS(195),
    [anon_sym_mat4x2] = ACTIONS(195),
    [anon_sym_mat4x3] = ACTIONS(195),
    [anon_sym_mat4x4] = ACTIONS(195),
    [anon_sym_dmat2] = ACTIONS(195),
    [anon_sym_dmat3] = ACTIONS(195),
    [anon_sym_dmat4] = ACTIONS(195),
    [anon_sym_dmat2x2] = ACTIONS(195),
    [anon_sym_dmat2x3] = ACTIONS(195),
    [anon_sym_dmat2x4] = ACTIONS(195),
    [anon_sym_dmat3x2] = ACTIONS(195),
    [anon_sym_dmat3x3] = ACTIONS(195),
    [anon_sym_dmat3x4] = ACTIONS(195),
    [anon_sym_dmat4x2] = ACTIONS(195),
    [anon_sym_dmat4x3] = ACTIONS(195),
    [anon_sym_dmat4x4] = ACTIONS(195),
    [anon_sym_atomic_uint] = ACTIONS(195),
    [anon_sym_sampler1d] = ACTIONS(195),
    [anon_sym_sampler2d] = ACTIONS(195),
    [anon_sym_sampler3d] = ACTIONS(195),
    [anon_sym_samplercube] = ACTIONS(195),
    [anon_sym_sampler1DShadow] = ACTIONS(195),
    [anon_sym_sampler2DShadow] = ACTIONS(195),
    [anon_sym_samplerCubeShadow] = ACTIONS(195),
    [anon_sym_sampler1DArray] = ACTIONS(195),
    [anon_sym_sampler2DArray] = ACTIONS(195),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(195),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(195),
    [anon_sym_samplerCubeArray] = ACTIONS(195),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(195),
    [anon_sym_isampler1D] = ACTIONS(195),
    [anon_sym_isampler2D] = ACTIONS(195),
    [anon_sym_isampler3D] = ACTIONS(195),
    [anon_sym_isamplerCube] = ACTIONS(195),
    [anon_sym_isampler1DArray] = ACTIONS(195),
    [anon_sym_isampler2DArray] = ACTIONS(195),
    [anon_sym_isamplerCubeArray] = ACTIONS(195),
    [anon_sym_usampler1D] = ACTIONS(195),
    [anon_sym_usampler2D] = ACTIONS(195),
    [anon_sym_usampler3D] = ACTIONS(195),
    [anon_sym_usamplerCube] = ACTIONS(195),
    [anon_sym_usampler1DArray] = ACTIONS(195),
    [anon_sym_usampler2DArray] = ACTIONS(195),
    [anon_sym_usamplerCubeArray] = ACTIONS(195),
    [anon_sym_sampler2DRect] = ACTIONS(195),
    [anon_sym_sampler2DRectshadow] = ACTIONS(195),
    [anon_sym_isampler2DRect] = ACTIONS(195),
    [anon_sym_usampler2DRect] = ACTIONS(195),
    [anon_sym_samplerBuffer] = ACTIONS(195),
    [anon_sym_isamplerBuffer] = ACTIONS(195),
    [anon_sym_usamplerBuffer] = ACTIONS(195),
    [anon_sym_sampler2DMS] = ACTIONS(195),
    [anon_sym_isampler2DMS] = ACTIONS(195),
    [anon_sym_usampler2DMS] = ACTIONS(195),
    [anon_sym_sampler2DMSArray] = ACTIONS(195),
    [anon_sym_isampler2DMSArray] = ACTIONS(195),
    [anon_sym_usampler2DMSArray] = ACTIONS(195),
    [anon_sym_image1D] = ACTIONS(195),
    [anon_sym_iimage1D] = ACTIONS(195),
    [anon_sym_uimage1D] = ACTIONS(195),
    [anon_sym_image2D] = ACTIONS(195),
    [anon_sym_iimage2D] = ACTIONS(195),
    [anon_sym_uimage2D] = ACTIONS(195),
    [anon_sym_image3D] = ACTIONS(195),
    [anon_sym_iimage3D] = ACTIONS(195),
    [anon_sym_uimage3D] = ACTIONS(195),
    [anon_sym_image2DRect] = ACTIONS(195),
    [anon_sym_iimage2DRect] = ACTIONS(195),
    [anon_sym_uimage2DRect] = ACTIONS(195),
    [anon_sym_imageCube] = ACTIONS(195),
    [anon_sym_iimageCube] = ACTIONS(195),
    [anon_sym_uimageCube] = ACTIONS(195),
    [anon_sym_imageBuffer] = ACTIONS(195),
    [anon_sym_iimageBuffer] = ACTIONS(195),
    [anon_sym_uimageBuffer] = ACTIONS(195),
    [anon_sym_image1DArray] = ACTIONS(195),
    [anon_sym_iimage1DArray] = ACTIONS(195),
    [anon_sym_uimage1DArray] = ACTIONS(195),
    [anon_sym_image2DArray] = ACTIONS(195),
    [anon_sym_iimage2DArray] = ACTIONS(195),
    [anon_sym_uimage2DArray] = ACTIONS(195),
    [anon_sym_imageCubeArray] = ACTIONS(195),
    [anon_sym_iimageCubeArray] = ACTIONS(195),
    [anon_sym_uimageCubeArray] = ACTIONS(195),
    [anon_sym_image2DMS] = ACTIONS(195),
    [anon_sym_iimage2DMS] = ACTIONS(195),
    [anon_sym_uimage2DMS] = ACTIONS(195),
    [anon_sym_image2DMSArray] = ACTIONS(195),
    [anon_sym_iimage2DMSArray] = ACTIONS(195),
    [anon_sym_uimage2DMSArray] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(195),
    [anon_sym_inout] = ACTIONS(195),
    [anon_sym_in] = ACTIONS(195),
    [anon_sym_out] = ACTIONS(195),
    [anon_sym_centroid] = ACTIONS(195),
    [anon_sym_patch] = ACTIONS(195),
    [anon_sym_sample] = ACTIONS(195),
    [anon_sym_uniform] = ACTIONS(195),
    [anon_sym_buffer] = ACTIONS(195),
    [anon_sym_shared] = ACTIONS(195),
    [anon_sym_coherent] = ACTIONS(195),
    [anon_sym_volatile] = ACTIONS(195),
    [anon_sym_restrict] = ACTIONS(195),
    [anon_sym_readonly] = ACTIONS(195),
    [anon_sym_writeonly] = ACTIONS(195),
    [anon_sym_subroutine] = ACTIONS(195),
    [anon_sym_varying] = ACTIONS(195),
    [anon_sym_attribute] = ACTIONS(195),
    [anon_sym_layout] = ACTIONS(195),
    [anon_sym_highp] = ACTIONS(195),
    [anon_sym_mediump] = ACTIONS(195),
    [anon_sym_lowp] = ACTIONS(195),
    [anon_sym_smooth] = ACTIONS(195),
    [anon_sym_flat] = ACTIONS(195),
    [anon_sym_noperspective] = ACTIONS(195),
    [sym_invariant_qualifier] = ACTIONS(195),
    [sym_precise_qualifier] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(195),
    [anon_sym_DASH] = ACTIONS(195),
    [anon_sym_BANG] = ACTIONS(197),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_PLUS_PLUS] = ACTIONS(197),
    [anon_sym_DASH_DASH] = ACTIONS(197),
    [anon_sym_true] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(195),
    [aux_sym_number_literal_token1] = ACTIONS(195),
    [aux_sym_number_literal_token2] = ACTIONS(195),
    [aux_sym_number_literal_token3] = ACTIONS(197),
    [aux_sym_number_literal_token4] = ACTIONS(197),
    [aux_sym_number_literal_token5] = ACTIONS(195),
    [aux_sym_number_literal_token6] = ACTIONS(197),
    [sym_comment] = ACTIONS(25),
  },
  [27] = {
    [sym_identifier] = ACTIONS(199),
    [anon_sym_SEMI] = ACTIONS(201),
    [anon_sym_precision] = ACTIONS(199),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(199),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(199),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_discard] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(199),
    [anon_sym_default] = ACTIONS(199),
    [anon_sym_struct] = ACTIONS(199),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_float] = ACTIONS(199),
    [anon_sym_double] = ACTIONS(199),
    [anon_sym_int] = ACTIONS(199),
    [anon_sym_uint] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_vec2] = ACTIONS(199),
    [anon_sym_vec3] = ACTIONS(199),
    [anon_sym_vec4] = ACTIONS(199),
    [anon_sym_dvec2] = ACTIONS(199),
    [anon_sym_dvec3] = ACTIONS(199),
    [anon_sym_dvec4] = ACTIONS(199),
    [anon_sym_bvec2] = ACTIONS(199),
    [anon_sym_bvec3] = ACTIONS(199),
    [anon_sym_bvec4] = ACTIONS(199),
    [anon_sym_ivec2] = ACTIONS(199),
    [anon_sym_ivec3] = ACTIONS(199),
    [anon_sym_ivec4] = ACTIONS(199),
    [anon_sym_uvec2] = ACTIONS(199),
    [anon_sym_uvec3] = ACTIONS(199),
    [anon_sym_uvec4] = ACTIONS(199),
    [anon_sym_mat2] = ACTIONS(199),
    [anon_sym_mat3] = ACTIONS(199),
    [anon_sym_mat4] = ACTIONS(199),
    [anon_sym_mat2x2] = ACTIONS(199),
    [anon_sym_mat2x3] = ACTIONS(199),
    [anon_sym_mat2x4] = ACTIONS(199),
    [anon_sym_mat3x2] = ACTIONS(199),
    [anon_sym_mat3x3] = ACTIONS(199),
    [anon_sym_mat3x4] = ACTIONS(199),
    [anon_sym_mat4x2] = ACTIONS(199),
    [anon_sym_mat4x3] = ACTIONS(199),
    [anon_sym_mat4x4] = ACTIONS(199),
    [anon_sym_dmat2] = ACTIONS(199),
    [anon_sym_dmat3] = ACTIONS(199),
    [anon_sym_dmat4] = ACTIONS(199),
    [anon_sym_dmat2x2] = ACTIONS(199),
    [anon_sym_dmat2x3] = ACTIONS(199),
    [anon_sym_dmat2x4] = ACTIONS(199),
    [anon_sym_dmat3x2] = ACTIONS(199),
    [anon_sym_dmat3x3] = ACTIONS(199),
    [anon_sym_dmat3x4] = ACTIONS(199),
    [anon_sym_dmat4x2] = ACTIONS(199),
    [anon_sym_dmat4x3] = ACTIONS(199),
    [anon_sym_dmat4x4] = ACTIONS(199),
    [anon_sym_atomic_uint] = ACTIONS(199),
    [anon_sym_sampler1d] = ACTIONS(199),
    [anon_sym_sampler2d] = ACTIONS(199),
    [anon_sym_sampler3d] = ACTIONS(199),
    [anon_sym_samplercube] = ACTIONS(199),
    [anon_sym_sampler1DShadow] = ACTIONS(199),
    [anon_sym_sampler2DShadow] = ACTIONS(199),
    [anon_sym_samplerCubeShadow] = ACTIONS(199),
    [anon_sym_sampler1DArray] = ACTIONS(199),
    [anon_sym_sampler2DArray] = ACTIONS(199),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(199),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(199),
    [anon_sym_samplerCubeArray] = ACTIONS(199),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(199),
    [anon_sym_isampler1D] = ACTIONS(199),
    [anon_sym_isampler2D] = ACTIONS(199),
    [anon_sym_isampler3D] = ACTIONS(199),
    [anon_sym_isamplerCube] = ACTIONS(199),
    [anon_sym_isampler1DArray] = ACTIONS(199),
    [anon_sym_isampler2DArray] = ACTIONS(199),
    [anon_sym_isamplerCubeArray] = ACTIONS(199),
    [anon_sym_usampler1D] = ACTIONS(199),
    [anon_sym_usampler2D] = ACTIONS(199),
    [anon_sym_usampler3D] = ACTIONS(199),
    [anon_sym_usamplerCube] = ACTIONS(199),
    [anon_sym_usampler1DArray] = ACTIONS(199),
    [anon_sym_usampler2DArray] = ACTIONS(199),
    [anon_sym_usamplerCubeArray] = ACTIONS(199),
    [anon_sym_sampler2DRect] = ACTIONS(199),
    [anon_sym_sampler2DRectshadow] = ACTIONS(199),
    [anon_sym_isampler2DRect] = ACTIONS(199),
    [anon_sym_usampler2DRect] = ACTIONS(199),
    [anon_sym_samplerBuffer] = ACTIONS(199),
    [anon_sym_isamplerBuffer] = ACTIONS(199),
    [anon_sym_usamplerBuffer] = ACTIONS(199),
    [anon_sym_sampler2DMS] = ACTIONS(199),
    [anon_sym_isampler2DMS] = ACTIONS(199),
    [anon_sym_usampler2DMS] = ACTIONS(199),
    [anon_sym_sampler2DMSArray] = ACTIONS(199),
    [anon_sym_isampler2DMSArray] = ACTIONS(199),
    [anon_sym_usampler2DMSArray] = ACTIONS(199),
    [anon_sym_image1D] = ACTIONS(199),
    [anon_sym_iimage1D] = ACTIONS(199),
    [anon_sym_uimage1D] = ACTIONS(199),
    [anon_sym_image2D] = ACTIONS(199),
    [anon_sym_iimage2D] = ACTIONS(199),
    [anon_sym_uimage2D] = ACTIONS(199),
    [anon_sym_image3D] = ACTIONS(199),
    [anon_sym_iimage3D] = ACTIONS(199),
    [anon_sym_uimage3D] = ACTIONS(199),
    [anon_sym_image2DRect] = ACTIONS(199),
    [anon_sym_iimage2DRect] = ACTIONS(199),
    [anon_sym_uimage2DRect] = ACTIONS(199),
    [anon_sym_imageCube] = ACTIONS(199),
    [anon_sym_iimageCube] = ACTIONS(199),
    [anon_sym_uimageCube] = ACTIONS(199),
    [anon_sym_imageBuffer] = ACTIONS(199),
    [anon_sym_iimageBuffer] = ACTIONS(199),
    [anon_sym_uimageBuffer] = ACTIONS(199),
    [anon_sym_image1DArray] = ACTIONS(199),
    [anon_sym_iimage1DArray] = ACTIONS(199),
    [anon_sym_uimage1DArray] = ACTIONS(199),
    [anon_sym_image2DArray] = ACTIONS(199),
    [anon_sym_iimage2DArray] = ACTIONS(199),
    [anon_sym_uimage2DArray] = ACTIONS(199),
    [anon_sym_imageCubeArray] = ACTIONS(199),
    [anon_sym_iimageCubeArray] = ACTIONS(199),
    [anon_sym_uimageCubeArray] = ACTIONS(199),
    [anon_sym_image2DMS] = ACTIONS(199),
    [anon_sym_iimage2DMS] = ACTIONS(199),
    [anon_sym_uimage2DMS] = ACTIONS(199),
    [anon_sym_image2DMSArray] = ACTIONS(199),
    [anon_sym_iimage2DMSArray] = ACTIONS(199),
    [anon_sym_uimage2DMSArray] = ACTIONS(199),
    [anon_sym_const] = ACTIONS(199),
    [anon_sym_inout] = ACTIONS(199),
    [anon_sym_in] = ACTIONS(199),
    [anon_sym_out] = ACTIONS(199),
    [anon_sym_centroid] = ACTIONS(199),
    [anon_sym_patch] = ACTIONS(199),
    [anon_sym_sample] = ACTIONS(199),
    [anon_sym_uniform] = ACTIONS(199),
    [anon_sym_buffer] = ACTIONS(199),
    [anon_sym_shared] = ACTIONS(199),
    [anon_sym_coherent] = ACTIONS(199),
    [anon_sym_volatile] = ACTIONS(199),
    [anon_sym_restrict] = ACTIONS(199),
    [anon_sym_readonly] = ACTIONS(199),
    [anon_sym_writeonly] = ACTIONS(199),
    [anon_sym_subroutine] = ACTIONS(199),
    [anon_sym_varying] = ACTIONS(199),
    [anon_sym_attribute] = ACTIONS(199),
    [anon_sym_layout] = ACTIONS(199),
    [anon_sym_highp] = ACTIONS(199),
    [anon_sym_mediump] = ACTIONS(199),
    [anon_sym_lowp] = ACTIONS(199),
    [anon_sym_smooth] = ACTIONS(199),
    [anon_sym_flat] = ACTIONS(199),
    [anon_sym_noperspective] = ACTIONS(199),
    [sym_invariant_qualifier] = ACTIONS(199),
    [sym_precise_qualifier] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(201),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_true] = ACTIONS(199),
    [anon_sym_false] = ACTIONS(199),
    [aux_sym_number_literal_token1] = ACTIONS(199),
    [aux_sym_number_literal_token2] = ACTIONS(199),
    [aux_sym_number_literal_token3] = ACTIONS(201),
    [aux_sym_number_literal_token4] = ACTIONS(201),
    [aux_sym_number_literal_token5] = ACTIONS(199),
    [aux_sym_number_literal_token6] = ACTIONS(201),
    [sym_comment] = ACTIONS(25),
  },
  [28] = {
    [sym_identifier] = ACTIONS(203),
    [anon_sym_SEMI] = ACTIONS(205),
    [anon_sym_precision] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(205),
    [anon_sym_RBRACE] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_else] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_while] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(203),
    [anon_sym_break] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(203),
    [anon_sym_discard] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(203),
    [anon_sym_struct] = ACTIONS(203),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_float] = ACTIONS(203),
    [anon_sym_double] = ACTIONS(203),
    [anon_sym_int] = ACTIONS(203),
    [anon_sym_uint] = ACTIONS(203),
    [anon_sym_bool] = ACTIONS(203),
    [anon_sym_vec2] = ACTIONS(203),
    [anon_sym_vec3] = ACTIONS(203),
    [anon_sym_vec4] = ACTIONS(203),
    [anon_sym_dvec2] = ACTIONS(203),
    [anon_sym_dvec3] = ACTIONS(203),
    [anon_sym_dvec4] = ACTIONS(203),
    [anon_sym_bvec2] = ACTIONS(203),
    [anon_sym_bvec3] = ACTIONS(203),
    [anon_sym_bvec4] = ACTIONS(203),
    [anon_sym_ivec2] = ACTIONS(203),
    [anon_sym_ivec3] = ACTIONS(203),
    [anon_sym_ivec4] = ACTIONS(203),
    [anon_sym_uvec2] = ACTIONS(203),
    [anon_sym_uvec3] = ACTIONS(203),
    [anon_sym_uvec4] = ACTIONS(203),
    [anon_sym_mat2] = ACTIONS(203),
    [anon_sym_mat3] = ACTIONS(203),
    [anon_sym_mat4] = ACTIONS(203),
    [anon_sym_mat2x2] = ACTIONS(203),
    [anon_sym_mat2x3] = ACTIONS(203),
    [anon_sym_mat2x4] = ACTIONS(203),
    [anon_sym_mat3x2] = ACTIONS(203),
    [anon_sym_mat3x3] = ACTIONS(203),
    [anon_sym_mat3x4] = ACTIONS(203),
    [anon_sym_mat4x2] = ACTIONS(203),
    [anon_sym_mat4x3] = ACTIONS(203),
    [anon_sym_mat4x4] = ACTIONS(203),
    [anon_sym_dmat2] = ACTIONS(203),
    [anon_sym_dmat3] = ACTIONS(203),
    [anon_sym_dmat4] = ACTIONS(203),
    [anon_sym_dmat2x2] = ACTIONS(203),
    [anon_sym_dmat2x3] = ACTIONS(203),
    [anon_sym_dmat2x4] = ACTIONS(203),
    [anon_sym_dmat3x2] = ACTIONS(203),
    [anon_sym_dmat3x3] = ACTIONS(203),
    [anon_sym_dmat3x4] = ACTIONS(203),
    [anon_sym_dmat4x2] = ACTIONS(203),
    [anon_sym_dmat4x3] = ACTIONS(203),
    [anon_sym_dmat4x4] = ACTIONS(203),
    [anon_sym_atomic_uint] = ACTIONS(203),
    [anon_sym_sampler1d] = ACTIONS(203),
    [anon_sym_sampler2d] = ACTIONS(203),
    [anon_sym_sampler3d] = ACTIONS(203),
    [anon_sym_samplercube] = ACTIONS(203),
    [anon_sym_sampler1DShadow] = ACTIONS(203),
    [anon_sym_sampler2DShadow] = ACTIONS(203),
    [anon_sym_samplerCubeShadow] = ACTIONS(203),
    [anon_sym_sampler1DArray] = ACTIONS(203),
    [anon_sym_sampler2DArray] = ACTIONS(203),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(203),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(203),
    [anon_sym_samplerCubeArray] = ACTIONS(203),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(203),
    [anon_sym_isampler1D] = ACTIONS(203),
    [anon_sym_isampler2D] = ACTIONS(203),
    [anon_sym_isampler3D] = ACTIONS(203),
    [anon_sym_isamplerCube] = ACTIONS(203),
    [anon_sym_isampler1DArray] = ACTIONS(203),
    [anon_sym_isampler2DArray] = ACTIONS(203),
    [anon_sym_isamplerCubeArray] = ACTIONS(203),
    [anon_sym_usampler1D] = ACTIONS(203),
    [anon_sym_usampler2D] = ACTIONS(203),
    [anon_sym_usampler3D] = ACTIONS(203),
    [anon_sym_usamplerCube] = ACTIONS(203),
    [anon_sym_usampler1DArray] = ACTIONS(203),
    [anon_sym_usampler2DArray] = ACTIONS(203),
    [anon_sym_usamplerCubeArray] = ACTIONS(203),
    [anon_sym_sampler2DRect] = ACTIONS(203),
    [anon_sym_sampler2DRectshadow] = ACTIONS(203),
    [anon_sym_isampler2DRect] = ACTIONS(203),
    [anon_sym_usampler2DRect] = ACTIONS(203),
    [anon_sym_samplerBuffer] = ACTIONS(203),
    [anon_sym_isamplerBuffer] = ACTIONS(203),
    [anon_sym_usamplerBuffer] = ACTIONS(203),
    [anon_sym_sampler2DMS] = ACTIONS(203),
    [anon_sym_isampler2DMS] = ACTIONS(203),
    [anon_sym_usampler2DMS] = ACTIONS(203),
    [anon_sym_sampler2DMSArray] = ACTIONS(203),
    [anon_sym_isampler2DMSArray] = ACTIONS(203),
    [anon_sym_usampler2DMSArray] = ACTIONS(203),
    [anon_sym_image1D] = ACTIONS(203),
    [anon_sym_iimage1D] = ACTIONS(203),
    [anon_sym_uimage1D] = ACTIONS(203),
    [anon_sym_image2D] = ACTIONS(203),
    [anon_sym_iimage2D] = ACTIONS(203),
    [anon_sym_uimage2D] = ACTIONS(203),
    [anon_sym_image3D] = ACTIONS(203),
    [anon_sym_iimage3D] = ACTIONS(203),
    [anon_sym_uimage3D] = ACTIONS(203),
    [anon_sym_image2DRect] = ACTIONS(203),
    [anon_sym_iimage2DRect] = ACTIONS(203),
    [anon_sym_uimage2DRect] = ACTIONS(203),
    [anon_sym_imageCube] = ACTIONS(203),
    [anon_sym_iimageCube] = ACTIONS(203),
    [anon_sym_uimageCube] = ACTIONS(203),
    [anon_sym_imageBuffer] = ACTIONS(203),
    [anon_sym_iimageBuffer] = ACTIONS(203),
    [anon_sym_uimageBuffer] = ACTIONS(203),
    [anon_sym_image1DArray] = ACTIONS(203),
    [anon_sym_iimage1DArray] = ACTIONS(203),
    [anon_sym_uimage1DArray] = ACTIONS(203),
    [anon_sym_image2DArray] = ACTIONS(203),
    [anon_sym_iimage2DArray] = ACTIONS(203),
    [anon_sym_uimage2DArray] = ACTIONS(203),
    [anon_sym_imageCubeArray] = ACTIONS(203),
    [anon_sym_iimageCubeArray] = ACTIONS(203),
    [anon_sym_uimageCubeArray] = ACTIONS(203),
    [anon_sym_image2DMS] = ACTIONS(203),
    [anon_sym_iimage2DMS] = ACTIONS(203),
    [anon_sym_uimage2DMS] = ACTIONS(203),
    [anon_sym_image2DMSArray] = ACTIONS(203),
    [anon_sym_iimage2DMSArray] = ACTIONS(203),
    [anon_sym_uimage2DMSArray] = ACTIONS(203),
    [anon_sym_const] = ACTIONS(203),
    [anon_sym_inout] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_out] = ACTIONS(203),
    [anon_sym_centroid] = ACTIONS(203),
    [anon_sym_patch] = ACTIONS(203),
    [anon_sym_sample] = ACTIONS(203),
    [anon_sym_uniform] = ACTIONS(203),
    [anon_sym_buffer] = ACTIONS(203),
    [anon_sym_shared] = ACTIONS(203),
    [anon_sym_coherent] = ACTIONS(203),
    [anon_sym_volatile] = ACTIONS(203),
    [anon_sym_restrict] = ACTIONS(203),
    [anon_sym_readonly] = ACTIONS(203),
    [anon_sym_writeonly] = ACTIONS(203),
    [anon_sym_subroutine] = ACTIONS(203),
    [anon_sym_varying] = ACTIONS(203),
    [anon_sym_attribute] = ACTIONS(203),
    [anon_sym_layout] = ACTIONS(203),
    [anon_sym_highp] = ACTIONS(203),
    [anon_sym_mediump] = ACTIONS(203),
    [anon_sym_lowp] = ACTIONS(203),
    [anon_sym_smooth] = ACTIONS(203),
    [anon_sym_flat] = ACTIONS(203),
    [anon_sym_noperspective] = ACTIONS(203),
    [sym_invariant_qualifier] = ACTIONS(203),
    [sym_precise_qualifier] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_true] = ACTIONS(203),
    [anon_sym_false] = ACTIONS(203),
    [aux_sym_number_literal_token1] = ACTIONS(203),
    [aux_sym_number_literal_token2] = ACTIONS(203),
    [aux_sym_number_literal_token3] = ACTIONS(205),
    [aux_sym_number_literal_token4] = ACTIONS(205),
    [aux_sym_number_literal_token5] = ACTIONS(203),
    [aux_sym_number_literal_token6] = ACTIONS(205),
    [sym_comment] = ACTIONS(25),
  },
  [29] = {
    [sym_identifier] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_precision] = ACTIONS(207),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_RBRACE] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_else] = ACTIONS(207),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(207),
    [anon_sym_for] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(207),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(207),
    [anon_sym_discard] = ACTIONS(207),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_struct] = ACTIONS(207),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_float] = ACTIONS(207),
    [anon_sym_double] = ACTIONS(207),
    [anon_sym_int] = ACTIONS(207),
    [anon_sym_uint] = ACTIONS(207),
    [anon_sym_bool] = ACTIONS(207),
    [anon_sym_vec2] = ACTIONS(207),
    [anon_sym_vec3] = ACTIONS(207),
    [anon_sym_vec4] = ACTIONS(207),
    [anon_sym_dvec2] = ACTIONS(207),
    [anon_sym_dvec3] = ACTIONS(207),
    [anon_sym_dvec4] = ACTIONS(207),
    [anon_sym_bvec2] = ACTIONS(207),
    [anon_sym_bvec3] = ACTIONS(207),
    [anon_sym_bvec4] = ACTIONS(207),
    [anon_sym_ivec2] = ACTIONS(207),
    [anon_sym_ivec3] = ACTIONS(207),
    [anon_sym_ivec4] = ACTIONS(207),
    [anon_sym_uvec2] = ACTIONS(207),
    [anon_sym_uvec3] = ACTIONS(207),
    [anon_sym_uvec4] = ACTIONS(207),
    [anon_sym_mat2] = ACTIONS(207),
    [anon_sym_mat3] = ACTIONS(207),
    [anon_sym_mat4] = ACTIONS(207),
    [anon_sym_mat2x2] = ACTIONS(207),
    [anon_sym_mat2x3] = ACTIONS(207),
    [anon_sym_mat2x4] = ACTIONS(207),
    [anon_sym_mat3x2] = ACTIONS(207),
    [anon_sym_mat3x3] = ACTIONS(207),
    [anon_sym_mat3x4] = ACTIONS(207),
    [anon_sym_mat4x2] = ACTIONS(207),
    [anon_sym_mat4x3] = ACTIONS(207),
    [anon_sym_mat4x4] = ACTIONS(207),
    [anon_sym_dmat2] = ACTIONS(207),
    [anon_sym_dmat3] = ACTIONS(207),
    [anon_sym_dmat4] = ACTIONS(207),
    [anon_sym_dmat2x2] = ACTIONS(207),
    [anon_sym_dmat2x3] = ACTIONS(207),
    [anon_sym_dmat2x4] = ACTIONS(207),
    [anon_sym_dmat3x2] = ACTIONS(207),
    [anon_sym_dmat3x3] = ACTIONS(207),
    [anon_sym_dmat3x4] = ACTIONS(207),
    [anon_sym_dmat4x2] = ACTIONS(207),
    [anon_sym_dmat4x3] = ACTIONS(207),
    [anon_sym_dmat4x4] = ACTIONS(207),
    [anon_sym_atomic_uint] = ACTIONS(207),
    [anon_sym_sampler1d] = ACTIONS(207),
    [anon_sym_sampler2d] = ACTIONS(207),
    [anon_sym_sampler3d] = ACTIONS(207),
    [anon_sym_samplercube] = ACTIONS(207),
    [anon_sym_sampler1DShadow] = ACTIONS(207),
    [anon_sym_sampler2DShadow] = ACTIONS(207),
    [anon_sym_samplerCubeShadow] = ACTIONS(207),
    [anon_sym_sampler1DArray] = ACTIONS(207),
    [anon_sym_sampler2DArray] = ACTIONS(207),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(207),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(207),
    [anon_sym_samplerCubeArray] = ACTIONS(207),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(207),
    [anon_sym_isampler1D] = ACTIONS(207),
    [anon_sym_isampler2D] = ACTIONS(207),
    [anon_sym_isampler3D] = ACTIONS(207),
    [anon_sym_isamplerCube] = ACTIONS(207),
    [anon_sym_isampler1DArray] = ACTIONS(207),
    [anon_sym_isampler2DArray] = ACTIONS(207),
    [anon_sym_isamplerCubeArray] = ACTIONS(207),
    [anon_sym_usampler1D] = ACTIONS(207),
    [anon_sym_usampler2D] = ACTIONS(207),
    [anon_sym_usampler3D] = ACTIONS(207),
    [anon_sym_usamplerCube] = ACTIONS(207),
    [anon_sym_usampler1DArray] = ACTIONS(207),
    [anon_sym_usampler2DArray] = ACTIONS(207),
    [anon_sym_usamplerCubeArray] = ACTIONS(207),
    [anon_sym_sampler2DRect] = ACTIONS(207),
    [anon_sym_sampler2DRectshadow] = ACTIONS(207),
    [anon_sym_isampler2DRect] = ACTIONS(207),
    [anon_sym_usampler2DRect] = ACTIONS(207),
    [anon_sym_samplerBuffer] = ACTIONS(207),
    [anon_sym_isamplerBuffer] = ACTIONS(207),
    [anon_sym_usamplerBuffer] = ACTIONS(207),
    [anon_sym_sampler2DMS] = ACTIONS(207),
    [anon_sym_isampler2DMS] = ACTIONS(207),
    [anon_sym_usampler2DMS] = ACTIONS(207),
    [anon_sym_sampler2DMSArray] = ACTIONS(207),
    [anon_sym_isampler2DMSArray] = ACTIONS(207),
    [anon_sym_usampler2DMSArray] = ACTIONS(207),
    [anon_sym_image1D] = ACTIONS(207),
    [anon_sym_iimage1D] = ACTIONS(207),
    [anon_sym_uimage1D] = ACTIONS(207),
    [anon_sym_image2D] = ACTIONS(207),
    [anon_sym_iimage2D] = ACTIONS(207),
    [anon_sym_uimage2D] = ACTIONS(207),
    [anon_sym_image3D] = ACTIONS(207),
    [anon_sym_iimage3D] = ACTIONS(207),
    [anon_sym_uimage3D] = ACTIONS(207),
    [anon_sym_image2DRect] = ACTIONS(207),
    [anon_sym_iimage2DRect] = ACTIONS(207),
    [anon_sym_uimage2DRect] = ACTIONS(207),
    [anon_sym_imageCube] = ACTIONS(207),
    [anon_sym_iimageCube] = ACTIONS(207),
    [anon_sym_uimageCube] = ACTIONS(207),
    [anon_sym_imageBuffer] = ACTIONS(207),
    [anon_sym_iimageBuffer] = ACTIONS(207),
    [anon_sym_uimageBuffer] = ACTIONS(207),
    [anon_sym_image1DArray] = ACTIONS(207),
    [anon_sym_iimage1DArray] = ACTIONS(207),
    [anon_sym_uimage1DArray] = ACTIONS(207),
    [anon_sym_image2DArray] = ACTIONS(207),
    [anon_sym_iimage2DArray] = ACTIONS(207),
    [anon_sym_uimage2DArray] = ACTIONS(207),
    [anon_sym_imageCubeArray] = ACTIONS(207),
    [anon_sym_iimageCubeArray] = ACTIONS(207),
    [anon_sym_uimageCubeArray] = ACTIONS(207),
    [anon_sym_image2DMS] = ACTIONS(207),
    [anon_sym_iimage2DMS] = ACTIONS(207),
    [anon_sym_uimage2DMS] = ACTIONS(207),
    [anon_sym_image2DMSArray] = ACTIONS(207),
    [anon_sym_iimage2DMSArray] = ACTIONS(207),
    [anon_sym_uimage2DMSArray] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(207),
    [anon_sym_inout] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(207),
    [anon_sym_out] = ACTIONS(207),
    [anon_sym_centroid] = ACTIONS(207),
    [anon_sym_patch] = ACTIONS(207),
    [anon_sym_sample] = ACTIONS(207),
    [anon_sym_uniform] = ACTIONS(207),
    [anon_sym_buffer] = ACTIONS(207),
    [anon_sym_shared] = ACTIONS(207),
    [anon_sym_coherent] = ACTIONS(207),
    [anon_sym_volatile] = ACTIONS(207),
    [anon_sym_restrict] = ACTIONS(207),
    [anon_sym_readonly] = ACTIONS(207),
    [anon_sym_writeonly] = ACTIONS(207),
    [anon_sym_subroutine] = ACTIONS(207),
    [anon_sym_varying] = ACTIONS(207),
    [anon_sym_attribute] = ACTIONS(207),
    [anon_sym_layout] = ACTIONS(207),
    [anon_sym_highp] = ACTIONS(207),
    [anon_sym_mediump] = ACTIONS(207),
    [anon_sym_lowp] = ACTIONS(207),
    [anon_sym_smooth] = ACTIONS(207),
    [anon_sym_flat] = ACTIONS(207),
    [anon_sym_noperspective] = ACTIONS(207),
    [sym_invariant_qualifier] = ACTIONS(207),
    [sym_precise_qualifier] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(209),
    [anon_sym_DASH_DASH] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(207),
    [anon_sym_false] = ACTIONS(207),
    [aux_sym_number_literal_token1] = ACTIONS(207),
    [aux_sym_number_literal_token2] = ACTIONS(207),
    [aux_sym_number_literal_token3] = ACTIONS(209),
    [aux_sym_number_literal_token4] = ACTIONS(209),
    [aux_sym_number_literal_token5] = ACTIONS(207),
    [aux_sym_number_literal_token6] = ACTIONS(209),
    [sym_comment] = ACTIONS(25),
  },
  [30] = {
    [sym_identifier] = ACTIONS(211),
    [anon_sym_SEMI] = ACTIONS(213),
    [anon_sym_precision] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(213),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_else] = ACTIONS(211),
    [anon_sym_switch] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_continue] = ACTIONS(211),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(211),
    [anon_sym_discard] = ACTIONS(211),
    [anon_sym_case] = ACTIONS(211),
    [anon_sym_default] = ACTIONS(211),
    [anon_sym_struct] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(211),
    [anon_sym_float] = ACTIONS(211),
    [anon_sym_double] = ACTIONS(211),
    [anon_sym_int] = ACTIONS(211),
    [anon_sym_uint] = ACTIONS(211),
    [anon_sym_bool] = ACTIONS(211),
    [anon_sym_vec2] = ACTIONS(211),
    [anon_sym_vec3] = ACTIONS(211),
    [anon_sym_vec4] = ACTIONS(211),
    [anon_sym_dvec2] = ACTIONS(211),
    [anon_sym_dvec3] = ACTIONS(211),
    [anon_sym_dvec4] = ACTIONS(211),
    [anon_sym_bvec2] = ACTIONS(211),
    [anon_sym_bvec3] = ACTIONS(211),
    [anon_sym_bvec4] = ACTIONS(211),
    [anon_sym_ivec2] = ACTIONS(211),
    [anon_sym_ivec3] = ACTIONS(211),
    [anon_sym_ivec4] = ACTIONS(211),
    [anon_sym_uvec2] = ACTIONS(211),
    [anon_sym_uvec3] = ACTIONS(211),
    [anon_sym_uvec4] = ACTIONS(211),
    [anon_sym_mat2] = ACTIONS(211),
    [anon_sym_mat3] = ACTIONS(211),
    [anon_sym_mat4] = ACTIONS(211),
    [anon_sym_mat2x2] = ACTIONS(211),
    [anon_sym_mat2x3] = ACTIONS(211),
    [anon_sym_mat2x4] = ACTIONS(211),
    [anon_sym_mat3x2] = ACTIONS(211),
    [anon_sym_mat3x3] = ACTIONS(211),
    [anon_sym_mat3x4] = ACTIONS(211),
    [anon_sym_mat4x2] = ACTIONS(211),
    [anon_sym_mat4x3] = ACTIONS(211),
    [anon_sym_mat4x4] = ACTIONS(211),
    [anon_sym_dmat2] = ACTIONS(211),
    [anon_sym_dmat3] = ACTIONS(211),
    [anon_sym_dmat4] = ACTIONS(211),
    [anon_sym_dmat2x2] = ACTIONS(211),
    [anon_sym_dmat2x3] = ACTIONS(211),
    [anon_sym_dmat2x4] = ACTIONS(211),
    [anon_sym_dmat3x2] = ACTIONS(211),
    [anon_sym_dmat3x3] = ACTIONS(211),
    [anon_sym_dmat3x4] = ACTIONS(211),
    [anon_sym_dmat4x2] = ACTIONS(211),
    [anon_sym_dmat4x3] = ACTIONS(211),
    [anon_sym_dmat4x4] = ACTIONS(211),
    [anon_sym_atomic_uint] = ACTIONS(211),
    [anon_sym_sampler1d] = ACTIONS(211),
    [anon_sym_sampler2d] = ACTIONS(211),
    [anon_sym_sampler3d] = ACTIONS(211),
    [anon_sym_samplercube] = ACTIONS(211),
    [anon_sym_sampler1DShadow] = ACTIONS(211),
    [anon_sym_sampler2DShadow] = ACTIONS(211),
    [anon_sym_samplerCubeShadow] = ACTIONS(211),
    [anon_sym_sampler1DArray] = ACTIONS(211),
    [anon_sym_sampler2DArray] = ACTIONS(211),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(211),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(211),
    [anon_sym_samplerCubeArray] = ACTIONS(211),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(211),
    [anon_sym_isampler1D] = ACTIONS(211),
    [anon_sym_isampler2D] = ACTIONS(211),
    [anon_sym_isampler3D] = ACTIONS(211),
    [anon_sym_isamplerCube] = ACTIONS(211),
    [anon_sym_isampler1DArray] = ACTIONS(211),
    [anon_sym_isampler2DArray] = ACTIONS(211),
    [anon_sym_isamplerCubeArray] = ACTIONS(211),
    [anon_sym_usampler1D] = ACTIONS(211),
    [anon_sym_usampler2D] = ACTIONS(211),
    [anon_sym_usampler3D] = ACTIONS(211),
    [anon_sym_usamplerCube] = ACTIONS(211),
    [anon_sym_usampler1DArray] = ACTIONS(211),
    [anon_sym_usampler2DArray] = ACTIONS(211),
    [anon_sym_usamplerCubeArray] = ACTIONS(211),
    [anon_sym_sampler2DRect] = ACTIONS(211),
    [anon_sym_sampler2DRectshadow] = ACTIONS(211),
    [anon_sym_isampler2DRect] = ACTIONS(211),
    [anon_sym_usampler2DRect] = ACTIONS(211),
    [anon_sym_samplerBuffer] = ACTIONS(211),
    [anon_sym_isamplerBuffer] = ACTIONS(211),
    [anon_sym_usamplerBuffer] = ACTIONS(211),
    [anon_sym_sampler2DMS] = ACTIONS(211),
    [anon_sym_isampler2DMS] = ACTIONS(211),
    [anon_sym_usampler2DMS] = ACTIONS(211),
    [anon_sym_sampler2DMSArray] = ACTIONS(211),
    [anon_sym_isampler2DMSArray] = ACTIONS(211),
    [anon_sym_usampler2DMSArray] = ACTIONS(211),
    [anon_sym_image1D] = ACTIONS(211),
    [anon_sym_iimage1D] = ACTIONS(211),
    [anon_sym_uimage1D] = ACTIONS(211),
    [anon_sym_image2D] = ACTIONS(211),
    [anon_sym_iimage2D] = ACTIONS(211),
    [anon_sym_uimage2D] = ACTIONS(211),
    [anon_sym_image3D] = ACTIONS(211),
    [anon_sym_iimage3D] = ACTIONS(211),
    [anon_sym_uimage3D] = ACTIONS(211),
    [anon_sym_image2DRect] = ACTIONS(211),
    [anon_sym_iimage2DRect] = ACTIONS(211),
    [anon_sym_uimage2DRect] = ACTIONS(211),
    [anon_sym_imageCube] = ACTIONS(211),
    [anon_sym_iimageCube] = ACTIONS(211),
    [anon_sym_uimageCube] = ACTIONS(211),
    [anon_sym_imageBuffer] = ACTIONS(211),
    [anon_sym_iimageBuffer] = ACTIONS(211),
    [anon_sym_uimageBuffer] = ACTIONS(211),
    [anon_sym_image1DArray] = ACTIONS(211),
    [anon_sym_iimage1DArray] = ACTIONS(211),
    [anon_sym_uimage1DArray] = ACTIONS(211),
    [anon_sym_image2DArray] = ACTIONS(211),
    [anon_sym_iimage2DArray] = ACTIONS(211),
    [anon_sym_uimage2DArray] = ACTIONS(211),
    [anon_sym_imageCubeArray] = ACTIONS(211),
    [anon_sym_iimageCubeArray] = ACTIONS(211),
    [anon_sym_uimageCubeArray] = ACTIONS(211),
    [anon_sym_image2DMS] = ACTIONS(211),
    [anon_sym_iimage2DMS] = ACTIONS(211),
    [anon_sym_uimage2DMS] = ACTIONS(211),
    [anon_sym_image2DMSArray] = ACTIONS(211),
    [anon_sym_iimage2DMSArray] = ACTIONS(211),
    [anon_sym_uimage2DMSArray] = ACTIONS(211),
    [anon_sym_const] = ACTIONS(211),
    [anon_sym_inout] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(211),
    [anon_sym_out] = ACTIONS(211),
    [anon_sym_centroid] = ACTIONS(211),
    [anon_sym_patch] = ACTIONS(211),
    [anon_sym_sample] = ACTIONS(211),
    [anon_sym_uniform] = ACTIONS(211),
    [anon_sym_buffer] = ACTIONS(211),
    [anon_sym_shared] = ACTIONS(211),
    [anon_sym_coherent] = ACTIONS(211),
    [anon_sym_volatile] = ACTIONS(211),
    [anon_sym_restrict] = ACTIONS(211),
    [anon_sym_readonly] = ACTIONS(211),
    [anon_sym_writeonly] = ACTIONS(211),
    [anon_sym_subroutine] = ACTIONS(211),
    [anon_sym_varying] = ACTIONS(211),
    [anon_sym_attribute] = ACTIONS(211),
    [anon_sym_layout] = ACTIONS(211),
    [anon_sym_highp] = ACTIONS(211),
    [anon_sym_mediump] = ACTIONS(211),
    [anon_sym_lowp] = ACTIONS(211),
    [anon_sym_smooth] = ACTIONS(211),
    [anon_sym_flat] = ACTIONS(211),
    [anon_sym_noperspective] = ACTIONS(211),
    [sym_invariant_qualifier] = ACTIONS(211),
    [sym_precise_qualifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_BANG] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(213),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_true] = ACTIONS(211),
    [anon_sym_false] = ACTIONS(211),
    [aux_sym_number_literal_token1] = ACTIONS(211),
    [aux_sym_number_literal_token2] = ACTIONS(211),
    [aux_sym_number_literal_token3] = ACTIONS(213),
    [aux_sym_number_literal_token4] = ACTIONS(213),
    [aux_sym_number_literal_token5] = ACTIONS(211),
    [aux_sym_number_literal_token6] = ACTIONS(213),
    [sym_comment] = ACTIONS(25),
  },
  [31] = {
    [sym_identifier] = ACTIONS(215),
    [anon_sym_SEMI] = ACTIONS(217),
    [anon_sym_precision] = ACTIONS(215),
    [anon_sym_LBRACE] = ACTIONS(217),
    [anon_sym_RBRACE] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_LPAREN] = ACTIONS(217),
    [anon_sym_else] = ACTIONS(215),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_while] = ACTIONS(215),
    [anon_sym_do] = ACTIONS(215),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_discard] = ACTIONS(215),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_void] = ACTIONS(215),
    [anon_sym_float] = ACTIONS(215),
    [anon_sym_double] = ACTIONS(215),
    [anon_sym_int] = ACTIONS(215),
    [anon_sym_uint] = ACTIONS(215),
    [anon_sym_bool] = ACTIONS(215),
    [anon_sym_vec2] = ACTIONS(215),
    [anon_sym_vec3] = ACTIONS(215),
    [anon_sym_vec4] = ACTIONS(215),
    [anon_sym_dvec2] = ACTIONS(215),
    [anon_sym_dvec3] = ACTIONS(215),
    [anon_sym_dvec4] = ACTIONS(215),
    [anon_sym_bvec2] = ACTIONS(215),
    [anon_sym_bvec3] = ACTIONS(215),
    [anon_sym_bvec4] = ACTIONS(215),
    [anon_sym_ivec2] = ACTIONS(215),
    [anon_sym_ivec3] = ACTIONS(215),
    [anon_sym_ivec4] = ACTIONS(215),
    [anon_sym_uvec2] = ACTIONS(215),
    [anon_sym_uvec3] = ACTIONS(215),
    [anon_sym_uvec4] = ACTIONS(215),
    [anon_sym_mat2] = ACTIONS(215),
    [anon_sym_mat3] = ACTIONS(215),
    [anon_sym_mat4] = ACTIONS(215),
    [anon_sym_mat2x2] = ACTIONS(215),
    [anon_sym_mat2x3] = ACTIONS(215),
    [anon_sym_mat2x4] = ACTIONS(215),
    [anon_sym_mat3x2] = ACTIONS(215),
    [anon_sym_mat3x3] = ACTIONS(215),
    [anon_sym_mat3x4] = ACTIONS(215),
    [anon_sym_mat4x2] = ACTIONS(215),
    [anon_sym_mat4x3] = ACTIONS(215),
    [anon_sym_mat4x4] = ACTIONS(215),
    [anon_sym_dmat2] = ACTIONS(215),
    [anon_sym_dmat3] = ACTIONS(215),
    [anon_sym_dmat4] = ACTIONS(215),
    [anon_sym_dmat2x2] = ACTIONS(215),
    [anon_sym_dmat2x3] = ACTIONS(215),
    [anon_sym_dmat2x4] = ACTIONS(215),
    [anon_sym_dmat3x2] = ACTIONS(215),
    [anon_sym_dmat3x3] = ACTIONS(215),
    [anon_sym_dmat3x4] = ACTIONS(215),
    [anon_sym_dmat4x2] = ACTIONS(215),
    [anon_sym_dmat4x3] = ACTIONS(215),
    [anon_sym_dmat4x4] = ACTIONS(215),
    [anon_sym_atomic_uint] = ACTIONS(215),
    [anon_sym_sampler1d] = ACTIONS(215),
    [anon_sym_sampler2d] = ACTIONS(215),
    [anon_sym_sampler3d] = ACTIONS(215),
    [anon_sym_samplercube] = ACTIONS(215),
    [anon_sym_sampler1DShadow] = ACTIONS(215),
    [anon_sym_sampler2DShadow] = ACTIONS(215),
    [anon_sym_samplerCubeShadow] = ACTIONS(215),
    [anon_sym_sampler1DArray] = ACTIONS(215),
    [anon_sym_sampler2DArray] = ACTIONS(215),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(215),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(215),
    [anon_sym_samplerCubeArray] = ACTIONS(215),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(215),
    [anon_sym_isampler1D] = ACTIONS(215),
    [anon_sym_isampler2D] = ACTIONS(215),
    [anon_sym_isampler3D] = ACTIONS(215),
    [anon_sym_isamplerCube] = ACTIONS(215),
    [anon_sym_isampler1DArray] = ACTIONS(215),
    [anon_sym_isampler2DArray] = ACTIONS(215),
    [anon_sym_isamplerCubeArray] = ACTIONS(215),
    [anon_sym_usampler1D] = ACTIONS(215),
    [anon_sym_usampler2D] = ACTIONS(215),
    [anon_sym_usampler3D] = ACTIONS(215),
    [anon_sym_usamplerCube] = ACTIONS(215),
    [anon_sym_usampler1DArray] = ACTIONS(215),
    [anon_sym_usampler2DArray] = ACTIONS(215),
    [anon_sym_usamplerCubeArray] = ACTIONS(215),
    [anon_sym_sampler2DRect] = ACTIONS(215),
    [anon_sym_sampler2DRectshadow] = ACTIONS(215),
    [anon_sym_isampler2DRect] = ACTIONS(215),
    [anon_sym_usampler2DRect] = ACTIONS(215),
    [anon_sym_samplerBuffer] = ACTIONS(215),
    [anon_sym_isamplerBuffer] = ACTIONS(215),
    [anon_sym_usamplerBuffer] = ACTIONS(215),
    [anon_sym_sampler2DMS] = ACTIONS(215),
    [anon_sym_isampler2DMS] = ACTIONS(215),
    [anon_sym_usampler2DMS] = ACTIONS(215),
    [anon_sym_sampler2DMSArray] = ACTIONS(215),
    [anon_sym_isampler2DMSArray] = ACTIONS(215),
    [anon_sym_usampler2DMSArray] = ACTIONS(215),
    [anon_sym_image1D] = ACTIONS(215),
    [anon_sym_iimage1D] = ACTIONS(215),
    [anon_sym_uimage1D] = ACTIONS(215),
    [anon_sym_image2D] = ACTIONS(215),
    [anon_sym_iimage2D] = ACTIONS(215),
    [anon_sym_uimage2D] = ACTIONS(215),
    [anon_sym_image3D] = ACTIONS(215),
    [anon_sym_iimage3D] = ACTIONS(215),
    [anon_sym_uimage3D] = ACTIONS(215),
    [anon_sym_image2DRect] = ACTIONS(215),
    [anon_sym_iimage2DRect] = ACTIONS(215),
    [anon_sym_uimage2DRect] = ACTIONS(215),
    [anon_sym_imageCube] = ACTIONS(215),
    [anon_sym_iimageCube] = ACTIONS(215),
    [anon_sym_uimageCube] = ACTIONS(215),
    [anon_sym_imageBuffer] = ACTIONS(215),
    [anon_sym_iimageBuffer] = ACTIONS(215),
    [anon_sym_uimageBuffer] = ACTIONS(215),
    [anon_sym_image1DArray] = ACTIONS(215),
    [anon_sym_iimage1DArray] = ACTIONS(215),
    [anon_sym_uimage1DArray] = ACTIONS(215),
    [anon_sym_image2DArray] = ACTIONS(215),
    [anon_sym_iimage2DArray] = ACTIONS(215),
    [anon_sym_uimage2DArray] = ACTIONS(215),
    [anon_sym_imageCubeArray] = ACTIONS(215),
    [anon_sym_iimageCubeArray] = ACTIONS(215),
    [anon_sym_uimageCubeArray] = ACTIONS(215),
    [anon_sym_image2DMS] = ACTIONS(215),
    [anon_sym_iimage2DMS] = ACTIONS(215),
    [anon_sym_uimage2DMS] = ACTIONS(215),
    [anon_sym_image2DMSArray] = ACTIONS(215),
    [anon_sym_iimage2DMSArray] = ACTIONS(215),
    [anon_sym_uimage2DMSArray] = ACTIONS(215),
    [anon_sym_const] = ACTIONS(215),
    [anon_sym_inout] = ACTIONS(215),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_out] = ACTIONS(215),
    [anon_sym_centroid] = ACTIONS(215),
    [anon_sym_patch] = ACTIONS(215),
    [anon_sym_sample] = ACTIONS(215),
    [anon_sym_uniform] = ACTIONS(215),
    [anon_sym_buffer] = ACTIONS(215),
    [anon_sym_shared] = ACTIONS(215),
    [anon_sym_coherent] = ACTIONS(215),
    [anon_sym_volatile] = ACTIONS(215),
    [anon_sym_restrict] = ACTIONS(215),
    [anon_sym_readonly] = ACTIONS(215),
    [anon_sym_writeonly] = ACTIONS(215),
    [anon_sym_subroutine] = ACTIONS(215),
    [anon_sym_varying] = ACTIONS(215),
    [anon_sym_attribute] = ACTIONS(215),
    [anon_sym_layout] = ACTIONS(215),
    [anon_sym_highp] = ACTIONS(215),
    [anon_sym_mediump] = ACTIONS(215),
    [anon_sym_lowp] = ACTIONS(215),
    [anon_sym_smooth] = ACTIONS(215),
    [anon_sym_flat] = ACTIONS(215),
    [anon_sym_noperspective] = ACTIONS(215),
    [sym_invariant_qualifier] = ACTIONS(215),
    [sym_precise_qualifier] = ACTIONS(215),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [anon_sym_PLUS_PLUS] = ACTIONS(217),
    [anon_sym_DASH_DASH] = ACTIONS(217),
    [anon_sym_true] = ACTIONS(215),
    [anon_sym_false] = ACTIONS(215),
    [aux_sym_number_literal_token1] = ACTIONS(215),
    [aux_sym_number_literal_token2] = ACTIONS(215),
    [aux_sym_number_literal_token3] = ACTIONS(217),
    [aux_sym_number_literal_token4] = ACTIONS(217),
    [aux_sym_number_literal_token5] = ACTIONS(215),
    [aux_sym_number_literal_token6] = ACTIONS(217),
    [sym_comment] = ACTIONS(25),
  },
  [32] = {
    [sym_identifier] = ACTIONS(219),
    [anon_sym_SEMI] = ACTIONS(221),
    [anon_sym_precision] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(221),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_else] = ACTIONS(223),
    [anon_sym_switch] = ACTIONS(219),
    [anon_sym_while] = ACTIONS(219),
    [anon_sym_do] = ACTIONS(219),
    [anon_sym_for] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_return] = ACTIONS(219),
    [anon_sym_discard] = ACTIONS(219),
    [anon_sym_case] = ACTIONS(219),
    [anon_sym_default] = ACTIONS(219),
    [anon_sym_struct] = ACTIONS(219),
    [anon_sym_void] = ACTIONS(219),
    [anon_sym_float] = ACTIONS(219),
    [anon_sym_double] = ACTIONS(219),
    [anon_sym_int] = ACTIONS(219),
    [anon_sym_uint] = ACTIONS(219),
    [anon_sym_bool] = ACTIONS(219),
    [anon_sym_vec2] = ACTIONS(219),
    [anon_sym_vec3] = ACTIONS(219),
    [anon_sym_vec4] = ACTIONS(219),
    [anon_sym_dvec2] = ACTIONS(219),
    [anon_sym_dvec3] = ACTIONS(219),
    [anon_sym_dvec4] = ACTIONS(219),
    [anon_sym_bvec2] = ACTIONS(219),
    [anon_sym_bvec3] = ACTIONS(219),
    [anon_sym_bvec4] = ACTIONS(219),
    [anon_sym_ivec2] = ACTIONS(219),
    [anon_sym_ivec3] = ACTIONS(219),
    [anon_sym_ivec4] = ACTIONS(219),
    [anon_sym_uvec2] = ACTIONS(219),
    [anon_sym_uvec3] = ACTIONS(219),
    [anon_sym_uvec4] = ACTIONS(219),
    [anon_sym_mat2] = ACTIONS(219),
    [anon_sym_mat3] = ACTIONS(219),
    [anon_sym_mat4] = ACTIONS(219),
    [anon_sym_mat2x2] = ACTIONS(219),
    [anon_sym_mat2x3] = ACTIONS(219),
    [anon_sym_mat2x4] = ACTIONS(219),
    [anon_sym_mat3x2] = ACTIONS(219),
    [anon_sym_mat3x3] = ACTIONS(219),
    [anon_sym_mat3x4] = ACTIONS(219),
    [anon_sym_mat4x2] = ACTIONS(219),
    [anon_sym_mat4x3] = ACTIONS(219),
    [anon_sym_mat4x4] = ACTIONS(219),
    [anon_sym_dmat2] = ACTIONS(219),
    [anon_sym_dmat3] = ACTIONS(219),
    [anon_sym_dmat4] = ACTIONS(219),
    [anon_sym_dmat2x2] = ACTIONS(219),
    [anon_sym_dmat2x3] = ACTIONS(219),
    [anon_sym_dmat2x4] = ACTIONS(219),
    [anon_sym_dmat3x2] = ACTIONS(219),
    [anon_sym_dmat3x3] = ACTIONS(219),
    [anon_sym_dmat3x4] = ACTIONS(219),
    [anon_sym_dmat4x2] = ACTIONS(219),
    [anon_sym_dmat4x3] = ACTIONS(219),
    [anon_sym_dmat4x4] = ACTIONS(219),
    [anon_sym_atomic_uint] = ACTIONS(219),
    [anon_sym_sampler1d] = ACTIONS(219),
    [anon_sym_sampler2d] = ACTIONS(219),
    [anon_sym_sampler3d] = ACTIONS(219),
    [anon_sym_samplercube] = ACTIONS(219),
    [anon_sym_sampler1DShadow] = ACTIONS(219),
    [anon_sym_sampler2DShadow] = ACTIONS(219),
    [anon_sym_samplerCubeShadow] = ACTIONS(219),
    [anon_sym_sampler1DArray] = ACTIONS(219),
    [anon_sym_sampler2DArray] = ACTIONS(219),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(219),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(219),
    [anon_sym_samplerCubeArray] = ACTIONS(219),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(219),
    [anon_sym_isampler1D] = ACTIONS(219),
    [anon_sym_isampler2D] = ACTIONS(219),
    [anon_sym_isampler3D] = ACTIONS(219),
    [anon_sym_isamplerCube] = ACTIONS(219),
    [anon_sym_isampler1DArray] = ACTIONS(219),
    [anon_sym_isampler2DArray] = ACTIONS(219),
    [anon_sym_isamplerCubeArray] = ACTIONS(219),
    [anon_sym_usampler1D] = ACTIONS(219),
    [anon_sym_usampler2D] = ACTIONS(219),
    [anon_sym_usampler3D] = ACTIONS(219),
    [anon_sym_usamplerCube] = ACTIONS(219),
    [anon_sym_usampler1DArray] = ACTIONS(219),
    [anon_sym_usampler2DArray] = ACTIONS(219),
    [anon_sym_usamplerCubeArray] = ACTIONS(219),
    [anon_sym_sampler2DRect] = ACTIONS(219),
    [anon_sym_sampler2DRectshadow] = ACTIONS(219),
    [anon_sym_isampler2DRect] = ACTIONS(219),
    [anon_sym_usampler2DRect] = ACTIONS(219),
    [anon_sym_samplerBuffer] = ACTIONS(219),
    [anon_sym_isamplerBuffer] = ACTIONS(219),
    [anon_sym_usamplerBuffer] = ACTIONS(219),
    [anon_sym_sampler2DMS] = ACTIONS(219),
    [anon_sym_isampler2DMS] = ACTIONS(219),
    [anon_sym_usampler2DMS] = ACTIONS(219),
    [anon_sym_sampler2DMSArray] = ACTIONS(219),
    [anon_sym_isampler2DMSArray] = ACTIONS(219),
    [anon_sym_usampler2DMSArray] = ACTIONS(219),
    [anon_sym_image1D] = ACTIONS(219),
    [anon_sym_iimage1D] = ACTIONS(219),
    [anon_sym_uimage1D] = ACTIONS(219),
    [anon_sym_image2D] = ACTIONS(219),
    [anon_sym_iimage2D] = ACTIONS(219),
    [anon_sym_uimage2D] = ACTIONS(219),
    [anon_sym_image3D] = ACTIONS(219),
    [anon_sym_iimage3D] = ACTIONS(219),
    [anon_sym_uimage3D] = ACTIONS(219),
    [anon_sym_image2DRect] = ACTIONS(219),
    [anon_sym_iimage2DRect] = ACTIONS(219),
    [anon_sym_uimage2DRect] = ACTIONS(219),
    [anon_sym_imageCube] = ACTIONS(219),
    [anon_sym_iimageCube] = ACTIONS(219),
    [anon_sym_uimageCube] = ACTIONS(219),
    [anon_sym_imageBuffer] = ACTIONS(219),
    [anon_sym_iimageBuffer] = ACTIONS(219),
    [anon_sym_uimageBuffer] = ACTIONS(219),
    [anon_sym_image1DArray] = ACTIONS(219),
    [anon_sym_iimage1DArray] = ACTIONS(219),
    [anon_sym_uimage1DArray] = ACTIONS(219),
    [anon_sym_image2DArray] = ACTIONS(219),
    [anon_sym_iimage2DArray] = ACTIONS(219),
    [anon_sym_uimage2DArray] = ACTIONS(219),
    [anon_sym_imageCubeArray] = ACTIONS(219),
    [anon_sym_iimageCubeArray] = ACTIONS(219),
    [anon_sym_uimageCubeArray] = ACTIONS(219),
    [anon_sym_image2DMS] = ACTIONS(219),
    [anon_sym_iimage2DMS] = ACTIONS(219),
    [anon_sym_uimage2DMS] = ACTIONS(219),
    [anon_sym_image2DMSArray] = ACTIONS(219),
    [anon_sym_iimage2DMSArray] = ACTIONS(219),
    [anon_sym_uimage2DMSArray] = ACTIONS(219),
    [anon_sym_const] = ACTIONS(219),
    [anon_sym_inout] = ACTIONS(219),
    [anon_sym_in] = ACTIONS(219),
    [anon_sym_out] = ACTIONS(219),
    [anon_sym_centroid] = ACTIONS(219),
    [anon_sym_patch] = ACTIONS(219),
    [anon_sym_sample] = ACTIONS(219),
    [anon_sym_uniform] = ACTIONS(219),
    [anon_sym_buffer] = ACTIONS(219),
    [anon_sym_shared] = ACTIONS(219),
    [anon_sym_coherent] = ACTIONS(219),
    [anon_sym_volatile] = ACTIONS(219),
    [anon_sym_restrict] = ACTIONS(219),
    [anon_sym_readonly] = ACTIONS(219),
    [anon_sym_writeonly] = ACTIONS(219),
    [anon_sym_subroutine] = ACTIONS(219),
    [anon_sym_varying] = ACTIONS(219),
    [anon_sym_attribute] = ACTIONS(219),
    [anon_sym_layout] = ACTIONS(219),
    [anon_sym_highp] = ACTIONS(219),
    [anon_sym_mediump] = ACTIONS(219),
    [anon_sym_lowp] = ACTIONS(219),
    [anon_sym_smooth] = ACTIONS(219),
    [anon_sym_flat] = ACTIONS(219),
    [anon_sym_noperspective] = ACTIONS(219),
    [sym_invariant_qualifier] = ACTIONS(219),
    [sym_precise_qualifier] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(221),
    [anon_sym_TILDE] = ACTIONS(221),
    [anon_sym_PLUS_PLUS] = ACTIONS(221),
    [anon_sym_DASH_DASH] = ACTIONS(221),
    [anon_sym_true] = ACTIONS(219),
    [anon_sym_false] = ACTIONS(219),
    [aux_sym_number_literal_token1] = ACTIONS(219),
    [aux_sym_number_literal_token2] = ACTIONS(219),
    [aux_sym_number_literal_token3] = ACTIONS(221),
    [aux_sym_number_literal_token4] = ACTIONS(221),
    [aux_sym_number_literal_token5] = ACTIONS(219),
    [aux_sym_number_literal_token6] = ACTIONS(221),
    [sym_comment] = ACTIONS(25),
  },
  [33] = {
    [sym_identifier] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(227),
    [anon_sym_precision] = ACTIONS(225),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_else] = ACTIONS(225),
    [anon_sym_switch] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(225),
    [anon_sym_break] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_discard] = ACTIONS(225),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_struct] = ACTIONS(225),
    [anon_sym_void] = ACTIONS(225),
    [anon_sym_float] = ACTIONS(225),
    [anon_sym_double] = ACTIONS(225),
    [anon_sym_int] = ACTIONS(225),
    [anon_sym_uint] = ACTIONS(225),
    [anon_sym_bool] = ACTIONS(225),
    [anon_sym_vec2] = ACTIONS(225),
    [anon_sym_vec3] = ACTIONS(225),
    [anon_sym_vec4] = ACTIONS(225),
    [anon_sym_dvec2] = ACTIONS(225),
    [anon_sym_dvec3] = ACTIONS(225),
    [anon_sym_dvec4] = ACTIONS(225),
    [anon_sym_bvec2] = ACTIONS(225),
    [anon_sym_bvec3] = ACTIONS(225),
    [anon_sym_bvec4] = ACTIONS(225),
    [anon_sym_ivec2] = ACTIONS(225),
    [anon_sym_ivec3] = ACTIONS(225),
    [anon_sym_ivec4] = ACTIONS(225),
    [anon_sym_uvec2] = ACTIONS(225),
    [anon_sym_uvec3] = ACTIONS(225),
    [anon_sym_uvec4] = ACTIONS(225),
    [anon_sym_mat2] = ACTIONS(225),
    [anon_sym_mat3] = ACTIONS(225),
    [anon_sym_mat4] = ACTIONS(225),
    [anon_sym_mat2x2] = ACTIONS(225),
    [anon_sym_mat2x3] = ACTIONS(225),
    [anon_sym_mat2x4] = ACTIONS(225),
    [anon_sym_mat3x2] = ACTIONS(225),
    [anon_sym_mat3x3] = ACTIONS(225),
    [anon_sym_mat3x4] = ACTIONS(225),
    [anon_sym_mat4x2] = ACTIONS(225),
    [anon_sym_mat4x3] = ACTIONS(225),
    [anon_sym_mat4x4] = ACTIONS(225),
    [anon_sym_dmat2] = ACTIONS(225),
    [anon_sym_dmat3] = ACTIONS(225),
    [anon_sym_dmat4] = ACTIONS(225),
    [anon_sym_dmat2x2] = ACTIONS(225),
    [anon_sym_dmat2x3] = ACTIONS(225),
    [anon_sym_dmat2x4] = ACTIONS(225),
    [anon_sym_dmat3x2] = ACTIONS(225),
    [anon_sym_dmat3x3] = ACTIONS(225),
    [anon_sym_dmat3x4] = ACTIONS(225),
    [anon_sym_dmat4x2] = ACTIONS(225),
    [anon_sym_dmat4x3] = ACTIONS(225),
    [anon_sym_dmat4x4] = ACTIONS(225),
    [anon_sym_atomic_uint] = ACTIONS(225),
    [anon_sym_sampler1d] = ACTIONS(225),
    [anon_sym_sampler2d] = ACTIONS(225),
    [anon_sym_sampler3d] = ACTIONS(225),
    [anon_sym_samplercube] = ACTIONS(225),
    [anon_sym_sampler1DShadow] = ACTIONS(225),
    [anon_sym_sampler2DShadow] = ACTIONS(225),
    [anon_sym_samplerCubeShadow] = ACTIONS(225),
    [anon_sym_sampler1DArray] = ACTIONS(225),
    [anon_sym_sampler2DArray] = ACTIONS(225),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(225),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(225),
    [anon_sym_samplerCubeArray] = ACTIONS(225),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(225),
    [anon_sym_isampler1D] = ACTIONS(225),
    [anon_sym_isampler2D] = ACTIONS(225),
    [anon_sym_isampler3D] = ACTIONS(225),
    [anon_sym_isamplerCube] = ACTIONS(225),
    [anon_sym_isampler1DArray] = ACTIONS(225),
    [anon_sym_isampler2DArray] = ACTIONS(225),
    [anon_sym_isamplerCubeArray] = ACTIONS(225),
    [anon_sym_usampler1D] = ACTIONS(225),
    [anon_sym_usampler2D] = ACTIONS(225),
    [anon_sym_usampler3D] = ACTIONS(225),
    [anon_sym_usamplerCube] = ACTIONS(225),
    [anon_sym_usampler1DArray] = ACTIONS(225),
    [anon_sym_usampler2DArray] = ACTIONS(225),
    [anon_sym_usamplerCubeArray] = ACTIONS(225),
    [anon_sym_sampler2DRect] = ACTIONS(225),
    [anon_sym_sampler2DRectshadow] = ACTIONS(225),
    [anon_sym_isampler2DRect] = ACTIONS(225),
    [anon_sym_usampler2DRect] = ACTIONS(225),
    [anon_sym_samplerBuffer] = ACTIONS(225),
    [anon_sym_isamplerBuffer] = ACTIONS(225),
    [anon_sym_usamplerBuffer] = ACTIONS(225),
    [anon_sym_sampler2DMS] = ACTIONS(225),
    [anon_sym_isampler2DMS] = ACTIONS(225),
    [anon_sym_usampler2DMS] = ACTIONS(225),
    [anon_sym_sampler2DMSArray] = ACTIONS(225),
    [anon_sym_isampler2DMSArray] = ACTIONS(225),
    [anon_sym_usampler2DMSArray] = ACTIONS(225),
    [anon_sym_image1D] = ACTIONS(225),
    [anon_sym_iimage1D] = ACTIONS(225),
    [anon_sym_uimage1D] = ACTIONS(225),
    [anon_sym_image2D] = ACTIONS(225),
    [anon_sym_iimage2D] = ACTIONS(225),
    [anon_sym_uimage2D] = ACTIONS(225),
    [anon_sym_image3D] = ACTIONS(225),
    [anon_sym_iimage3D] = ACTIONS(225),
    [anon_sym_uimage3D] = ACTIONS(225),
    [anon_sym_image2DRect] = ACTIONS(225),
    [anon_sym_iimage2DRect] = ACTIONS(225),
    [anon_sym_uimage2DRect] = ACTIONS(225),
    [anon_sym_imageCube] = ACTIONS(225),
    [anon_sym_iimageCube] = ACTIONS(225),
    [anon_sym_uimageCube] = ACTIONS(225),
    [anon_sym_imageBuffer] = ACTIONS(225),
    [anon_sym_iimageBuffer] = ACTIONS(225),
    [anon_sym_uimageBuffer] = ACTIONS(225),
    [anon_sym_image1DArray] = ACTIONS(225),
    [anon_sym_iimage1DArray] = ACTIONS(225),
    [anon_sym_uimage1DArray] = ACTIONS(225),
    [anon_sym_image2DArray] = ACTIONS(225),
    [anon_sym_iimage2DArray] = ACTIONS(225),
    [anon_sym_uimage2DArray] = ACTIONS(225),
    [anon_sym_imageCubeArray] = ACTIONS(225),
    [anon_sym_iimageCubeArray] = ACTIONS(225),
    [anon_sym_uimageCubeArray] = ACTIONS(225),
    [anon_sym_image2DMS] = ACTIONS(225),
    [anon_sym_iimage2DMS] = ACTIONS(225),
    [anon_sym_uimage2DMS] = ACTIONS(225),
    [anon_sym_image2DMSArray] = ACTIONS(225),
    [anon_sym_iimage2DMSArray] = ACTIONS(225),
    [anon_sym_uimage2DMSArray] = ACTIONS(225),
    [anon_sym_const] = ACTIONS(225),
    [anon_sym_inout] = ACTIONS(225),
    [anon_sym_in] = ACTIONS(225),
    [anon_sym_out] = ACTIONS(225),
    [anon_sym_centroid] = ACTIONS(225),
    [anon_sym_patch] = ACTIONS(225),
    [anon_sym_sample] = ACTIONS(225),
    [anon_sym_uniform] = ACTIONS(225),
    [anon_sym_buffer] = ACTIONS(225),
    [anon_sym_shared] = ACTIONS(225),
    [anon_sym_coherent] = ACTIONS(225),
    [anon_sym_volatile] = ACTIONS(225),
    [anon_sym_restrict] = ACTIONS(225),
    [anon_sym_readonly] = ACTIONS(225),
    [anon_sym_writeonly] = ACTIONS(225),
    [anon_sym_subroutine] = ACTIONS(225),
    [anon_sym_varying] = ACTIONS(225),
    [anon_sym_attribute] = ACTIONS(225),
    [anon_sym_layout] = ACTIONS(225),
    [anon_sym_highp] = ACTIONS(225),
    [anon_sym_mediump] = ACTIONS(225),
    [anon_sym_lowp] = ACTIONS(225),
    [anon_sym_smooth] = ACTIONS(225),
    [anon_sym_flat] = ACTIONS(225),
    [anon_sym_noperspective] = ACTIONS(225),
    [sym_invariant_qualifier] = ACTIONS(225),
    [sym_precise_qualifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(227),
    [anon_sym_PLUS_PLUS] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(227),
    [anon_sym_true] = ACTIONS(225),
    [anon_sym_false] = ACTIONS(225),
    [aux_sym_number_literal_token1] = ACTIONS(225),
    [aux_sym_number_literal_token2] = ACTIONS(225),
    [aux_sym_number_literal_token3] = ACTIONS(227),
    [aux_sym_number_literal_token4] = ACTIONS(227),
    [aux_sym_number_literal_token5] = ACTIONS(225),
    [aux_sym_number_literal_token6] = ACTIONS(227),
    [sym_comment] = ACTIONS(25),
  },
  [34] = {
    [sym_identifier] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_precision] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(231),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_switch] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_continue] = ACTIONS(229),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_discard] = ACTIONS(229),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_struct] = ACTIONS(229),
    [anon_sym_void] = ACTIONS(229),
    [anon_sym_float] = ACTIONS(229),
    [anon_sym_double] = ACTIONS(229),
    [anon_sym_int] = ACTIONS(229),
    [anon_sym_uint] = ACTIONS(229),
    [anon_sym_bool] = ACTIONS(229),
    [anon_sym_vec2] = ACTIONS(229),
    [anon_sym_vec3] = ACTIONS(229),
    [anon_sym_vec4] = ACTIONS(229),
    [anon_sym_dvec2] = ACTIONS(229),
    [anon_sym_dvec3] = ACTIONS(229),
    [anon_sym_dvec4] = ACTIONS(229),
    [anon_sym_bvec2] = ACTIONS(229),
    [anon_sym_bvec3] = ACTIONS(229),
    [anon_sym_bvec4] = ACTIONS(229),
    [anon_sym_ivec2] = ACTIONS(229),
    [anon_sym_ivec3] = ACTIONS(229),
    [anon_sym_ivec4] = ACTIONS(229),
    [anon_sym_uvec2] = ACTIONS(229),
    [anon_sym_uvec3] = ACTIONS(229),
    [anon_sym_uvec4] = ACTIONS(229),
    [anon_sym_mat2] = ACTIONS(229),
    [anon_sym_mat3] = ACTIONS(229),
    [anon_sym_mat4] = ACTIONS(229),
    [anon_sym_mat2x2] = ACTIONS(229),
    [anon_sym_mat2x3] = ACTIONS(229),
    [anon_sym_mat2x4] = ACTIONS(229),
    [anon_sym_mat3x2] = ACTIONS(229),
    [anon_sym_mat3x3] = ACTIONS(229),
    [anon_sym_mat3x4] = ACTIONS(229),
    [anon_sym_mat4x2] = ACTIONS(229),
    [anon_sym_mat4x3] = ACTIONS(229),
    [anon_sym_mat4x4] = ACTIONS(229),
    [anon_sym_dmat2] = ACTIONS(229),
    [anon_sym_dmat3] = ACTIONS(229),
    [anon_sym_dmat4] = ACTIONS(229),
    [anon_sym_dmat2x2] = ACTIONS(229),
    [anon_sym_dmat2x3] = ACTIONS(229),
    [anon_sym_dmat2x4] = ACTIONS(229),
    [anon_sym_dmat3x2] = ACTIONS(229),
    [anon_sym_dmat3x3] = ACTIONS(229),
    [anon_sym_dmat3x4] = ACTIONS(229),
    [anon_sym_dmat4x2] = ACTIONS(229),
    [anon_sym_dmat4x3] = ACTIONS(229),
    [anon_sym_dmat4x4] = ACTIONS(229),
    [anon_sym_atomic_uint] = ACTIONS(229),
    [anon_sym_sampler1d] = ACTIONS(229),
    [anon_sym_sampler2d] = ACTIONS(229),
    [anon_sym_sampler3d] = ACTIONS(229),
    [anon_sym_samplercube] = ACTIONS(229),
    [anon_sym_sampler1DShadow] = ACTIONS(229),
    [anon_sym_sampler2DShadow] = ACTIONS(229),
    [anon_sym_samplerCubeShadow] = ACTIONS(229),
    [anon_sym_sampler1DArray] = ACTIONS(229),
    [anon_sym_sampler2DArray] = ACTIONS(229),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(229),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(229),
    [anon_sym_samplerCubeArray] = ACTIONS(229),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(229),
    [anon_sym_isampler1D] = ACTIONS(229),
    [anon_sym_isampler2D] = ACTIONS(229),
    [anon_sym_isampler3D] = ACTIONS(229),
    [anon_sym_isamplerCube] = ACTIONS(229),
    [anon_sym_isampler1DArray] = ACTIONS(229),
    [anon_sym_isampler2DArray] = ACTIONS(229),
    [anon_sym_isamplerCubeArray] = ACTIONS(229),
    [anon_sym_usampler1D] = ACTIONS(229),
    [anon_sym_usampler2D] = ACTIONS(229),
    [anon_sym_usampler3D] = ACTIONS(229),
    [anon_sym_usamplerCube] = ACTIONS(229),
    [anon_sym_usampler1DArray] = ACTIONS(229),
    [anon_sym_usampler2DArray] = ACTIONS(229),
    [anon_sym_usamplerCubeArray] = ACTIONS(229),
    [anon_sym_sampler2DRect] = ACTIONS(229),
    [anon_sym_sampler2DRectshadow] = ACTIONS(229),
    [anon_sym_isampler2DRect] = ACTIONS(229),
    [anon_sym_usampler2DRect] = ACTIONS(229),
    [anon_sym_samplerBuffer] = ACTIONS(229),
    [anon_sym_isamplerBuffer] = ACTIONS(229),
    [anon_sym_usamplerBuffer] = ACTIONS(229),
    [anon_sym_sampler2DMS] = ACTIONS(229),
    [anon_sym_isampler2DMS] = ACTIONS(229),
    [anon_sym_usampler2DMS] = ACTIONS(229),
    [anon_sym_sampler2DMSArray] = ACTIONS(229),
    [anon_sym_isampler2DMSArray] = ACTIONS(229),
    [anon_sym_usampler2DMSArray] = ACTIONS(229),
    [anon_sym_image1D] = ACTIONS(229),
    [anon_sym_iimage1D] = ACTIONS(229),
    [anon_sym_uimage1D] = ACTIONS(229),
    [anon_sym_image2D] = ACTIONS(229),
    [anon_sym_iimage2D] = ACTIONS(229),
    [anon_sym_uimage2D] = ACTIONS(229),
    [anon_sym_image3D] = ACTIONS(229),
    [anon_sym_iimage3D] = ACTIONS(229),
    [anon_sym_uimage3D] = ACTIONS(229),
    [anon_sym_image2DRect] = ACTIONS(229),
    [anon_sym_iimage2DRect] = ACTIONS(229),
    [anon_sym_uimage2DRect] = ACTIONS(229),
    [anon_sym_imageCube] = ACTIONS(229),
    [anon_sym_iimageCube] = ACTIONS(229),
    [anon_sym_uimageCube] = ACTIONS(229),
    [anon_sym_imageBuffer] = ACTIONS(229),
    [anon_sym_iimageBuffer] = ACTIONS(229),
    [anon_sym_uimageBuffer] = ACTIONS(229),
    [anon_sym_image1DArray] = ACTIONS(229),
    [anon_sym_iimage1DArray] = ACTIONS(229),
    [anon_sym_uimage1DArray] = ACTIONS(229),
    [anon_sym_image2DArray] = ACTIONS(229),
    [anon_sym_iimage2DArray] = ACTIONS(229),
    [anon_sym_uimage2DArray] = ACTIONS(229),
    [anon_sym_imageCubeArray] = ACTIONS(229),
    [anon_sym_iimageCubeArray] = ACTIONS(229),
    [anon_sym_uimageCubeArray] = ACTIONS(229),
    [anon_sym_image2DMS] = ACTIONS(229),
    [anon_sym_iimage2DMS] = ACTIONS(229),
    [anon_sym_uimage2DMS] = ACTIONS(229),
    [anon_sym_image2DMSArray] = ACTIONS(229),
    [anon_sym_iimage2DMSArray] = ACTIONS(229),
    [anon_sym_uimage2DMSArray] = ACTIONS(229),
    [anon_sym_const] = ACTIONS(229),
    [anon_sym_inout] = ACTIONS(229),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_out] = ACTIONS(229),
    [anon_sym_centroid] = ACTIONS(229),
    [anon_sym_patch] = ACTIONS(229),
    [anon_sym_sample] = ACTIONS(229),
    [anon_sym_uniform] = ACTIONS(229),
    [anon_sym_buffer] = ACTIONS(229),
    [anon_sym_shared] = ACTIONS(229),
    [anon_sym_coherent] = ACTIONS(229),
    [anon_sym_volatile] = ACTIONS(229),
    [anon_sym_restrict] = ACTIONS(229),
    [anon_sym_readonly] = ACTIONS(229),
    [anon_sym_writeonly] = ACTIONS(229),
    [anon_sym_subroutine] = ACTIONS(229),
    [anon_sym_varying] = ACTIONS(229),
    [anon_sym_attribute] = ACTIONS(229),
    [anon_sym_layout] = ACTIONS(229),
    [anon_sym_highp] = ACTIONS(229),
    [anon_sym_mediump] = ACTIONS(229),
    [anon_sym_lowp] = ACTIONS(229),
    [anon_sym_smooth] = ACTIONS(229),
    [anon_sym_flat] = ACTIONS(229),
    [anon_sym_noperspective] = ACTIONS(229),
    [sym_invariant_qualifier] = ACTIONS(229),
    [sym_precise_qualifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [anon_sym_PLUS_PLUS] = ACTIONS(231),
    [anon_sym_DASH_DASH] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(229),
    [aux_sym_number_literal_token1] = ACTIONS(229),
    [aux_sym_number_literal_token2] = ACTIONS(229),
    [aux_sym_number_literal_token3] = ACTIONS(231),
    [aux_sym_number_literal_token4] = ACTIONS(231),
    [aux_sym_number_literal_token5] = ACTIONS(229),
    [aux_sym_number_literal_token6] = ACTIONS(231),
    [sym_comment] = ACTIONS(25),
  },
  [35] = {
    [sym_identifier] = ACTIONS(233),
    [anon_sym_SEMI] = ACTIONS(235),
    [anon_sym_precision] = ACTIONS(233),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_RBRACE] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_else] = ACTIONS(233),
    [anon_sym_switch] = ACTIONS(233),
    [anon_sym_while] = ACTIONS(233),
    [anon_sym_do] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(233),
    [anon_sym_continue] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_discard] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(233),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_struct] = ACTIONS(233),
    [anon_sym_void] = ACTIONS(233),
    [anon_sym_float] = ACTIONS(233),
    [anon_sym_double] = ACTIONS(233),
    [anon_sym_int] = ACTIONS(233),
    [anon_sym_uint] = ACTIONS(233),
    [anon_sym_bool] = ACTIONS(233),
    [anon_sym_vec2] = ACTIONS(233),
    [anon_sym_vec3] = ACTIONS(233),
    [anon_sym_vec4] = ACTIONS(233),
    [anon_sym_dvec2] = ACTIONS(233),
    [anon_sym_dvec3] = ACTIONS(233),
    [anon_sym_dvec4] = ACTIONS(233),
    [anon_sym_bvec2] = ACTIONS(233),
    [anon_sym_bvec3] = ACTIONS(233),
    [anon_sym_bvec4] = ACTIONS(233),
    [anon_sym_ivec2] = ACTIONS(233),
    [anon_sym_ivec3] = ACTIONS(233),
    [anon_sym_ivec4] = ACTIONS(233),
    [anon_sym_uvec2] = ACTIONS(233),
    [anon_sym_uvec3] = ACTIONS(233),
    [anon_sym_uvec4] = ACTIONS(233),
    [anon_sym_mat2] = ACTIONS(233),
    [anon_sym_mat3] = ACTIONS(233),
    [anon_sym_mat4] = ACTIONS(233),
    [anon_sym_mat2x2] = ACTIONS(233),
    [anon_sym_mat2x3] = ACTIONS(233),
    [anon_sym_mat2x4] = ACTIONS(233),
    [anon_sym_mat3x2] = ACTIONS(233),
    [anon_sym_mat3x3] = ACTIONS(233),
    [anon_sym_mat3x4] = ACTIONS(233),
    [anon_sym_mat4x2] = ACTIONS(233),
    [anon_sym_mat4x3] = ACTIONS(233),
    [anon_sym_mat4x4] = ACTIONS(233),
    [anon_sym_dmat2] = ACTIONS(233),
    [anon_sym_dmat3] = ACTIONS(233),
    [anon_sym_dmat4] = ACTIONS(233),
    [anon_sym_dmat2x2] = ACTIONS(233),
    [anon_sym_dmat2x3] = ACTIONS(233),
    [anon_sym_dmat2x4] = ACTIONS(233),
    [anon_sym_dmat3x2] = ACTIONS(233),
    [anon_sym_dmat3x3] = ACTIONS(233),
    [anon_sym_dmat3x4] = ACTIONS(233),
    [anon_sym_dmat4x2] = ACTIONS(233),
    [anon_sym_dmat4x3] = ACTIONS(233),
    [anon_sym_dmat4x4] = ACTIONS(233),
    [anon_sym_atomic_uint] = ACTIONS(233),
    [anon_sym_sampler1d] = ACTIONS(233),
    [anon_sym_sampler2d] = ACTIONS(233),
    [anon_sym_sampler3d] = ACTIONS(233),
    [anon_sym_samplercube] = ACTIONS(233),
    [anon_sym_sampler1DShadow] = ACTIONS(233),
    [anon_sym_sampler2DShadow] = ACTIONS(233),
    [anon_sym_samplerCubeShadow] = ACTIONS(233),
    [anon_sym_sampler1DArray] = ACTIONS(233),
    [anon_sym_sampler2DArray] = ACTIONS(233),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(233),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(233),
    [anon_sym_samplerCubeArray] = ACTIONS(233),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(233),
    [anon_sym_isampler1D] = ACTIONS(233),
    [anon_sym_isampler2D] = ACTIONS(233),
    [anon_sym_isampler3D] = ACTIONS(233),
    [anon_sym_isamplerCube] = ACTIONS(233),
    [anon_sym_isampler1DArray] = ACTIONS(233),
    [anon_sym_isampler2DArray] = ACTIONS(233),
    [anon_sym_isamplerCubeArray] = ACTIONS(233),
    [anon_sym_usampler1D] = ACTIONS(233),
    [anon_sym_usampler2D] = ACTIONS(233),
    [anon_sym_usampler3D] = ACTIONS(233),
    [anon_sym_usamplerCube] = ACTIONS(233),
    [anon_sym_usampler1DArray] = ACTIONS(233),
    [anon_sym_usampler2DArray] = ACTIONS(233),
    [anon_sym_usamplerCubeArray] = ACTIONS(233),
    [anon_sym_sampler2DRect] = ACTIONS(233),
    [anon_sym_sampler2DRectshadow] = ACTIONS(233),
    [anon_sym_isampler2DRect] = ACTIONS(233),
    [anon_sym_usampler2DRect] = ACTIONS(233),
    [anon_sym_samplerBuffer] = ACTIONS(233),
    [anon_sym_isamplerBuffer] = ACTIONS(233),
    [anon_sym_usamplerBuffer] = ACTIONS(233),
    [anon_sym_sampler2DMS] = ACTIONS(233),
    [anon_sym_isampler2DMS] = ACTIONS(233),
    [anon_sym_usampler2DMS] = ACTIONS(233),
    [anon_sym_sampler2DMSArray] = ACTIONS(233),
    [anon_sym_isampler2DMSArray] = ACTIONS(233),
    [anon_sym_usampler2DMSArray] = ACTIONS(233),
    [anon_sym_image1D] = ACTIONS(233),
    [anon_sym_iimage1D] = ACTIONS(233),
    [anon_sym_uimage1D] = ACTIONS(233),
    [anon_sym_image2D] = ACTIONS(233),
    [anon_sym_iimage2D] = ACTIONS(233),
    [anon_sym_uimage2D] = ACTIONS(233),
    [anon_sym_image3D] = ACTIONS(233),
    [anon_sym_iimage3D] = ACTIONS(233),
    [anon_sym_uimage3D] = ACTIONS(233),
    [anon_sym_image2DRect] = ACTIONS(233),
    [anon_sym_iimage2DRect] = ACTIONS(233),
    [anon_sym_uimage2DRect] = ACTIONS(233),
    [anon_sym_imageCube] = ACTIONS(233),
    [anon_sym_iimageCube] = ACTIONS(233),
    [anon_sym_uimageCube] = ACTIONS(233),
    [anon_sym_imageBuffer] = ACTIONS(233),
    [anon_sym_iimageBuffer] = ACTIONS(233),
    [anon_sym_uimageBuffer] = ACTIONS(233),
    [anon_sym_image1DArray] = ACTIONS(233),
    [anon_sym_iimage1DArray] = ACTIONS(233),
    [anon_sym_uimage1DArray] = ACTIONS(233),
    [anon_sym_image2DArray] = ACTIONS(233),
    [anon_sym_iimage2DArray] = ACTIONS(233),
    [anon_sym_uimage2DArray] = ACTIONS(233),
    [anon_sym_imageCubeArray] = ACTIONS(233),
    [anon_sym_iimageCubeArray] = ACTIONS(233),
    [anon_sym_uimageCubeArray] = ACTIONS(233),
    [anon_sym_image2DMS] = ACTIONS(233),
    [anon_sym_iimage2DMS] = ACTIONS(233),
    [anon_sym_uimage2DMS] = ACTIONS(233),
    [anon_sym_image2DMSArray] = ACTIONS(233),
    [anon_sym_iimage2DMSArray] = ACTIONS(233),
    [anon_sym_uimage2DMSArray] = ACTIONS(233),
    [anon_sym_const] = ACTIONS(233),
    [anon_sym_inout] = ACTIONS(233),
    [anon_sym_in] = ACTIONS(233),
    [anon_sym_out] = ACTIONS(233),
    [anon_sym_centroid] = ACTIONS(233),
    [anon_sym_patch] = ACTIONS(233),
    [anon_sym_sample] = ACTIONS(233),
    [anon_sym_uniform] = ACTIONS(233),
    [anon_sym_buffer] = ACTIONS(233),
    [anon_sym_shared] = ACTIONS(233),
    [anon_sym_coherent] = ACTIONS(233),
    [anon_sym_volatile] = ACTIONS(233),
    [anon_sym_restrict] = ACTIONS(233),
    [anon_sym_readonly] = ACTIONS(233),
    [anon_sym_writeonly] = ACTIONS(233),
    [anon_sym_subroutine] = ACTIONS(233),
    [anon_sym_varying] = ACTIONS(233),
    [anon_sym_attribute] = ACTIONS(233),
    [anon_sym_layout] = ACTIONS(233),
    [anon_sym_highp] = ACTIONS(233),
    [anon_sym_mediump] = ACTIONS(233),
    [anon_sym_lowp] = ACTIONS(233),
    [anon_sym_smooth] = ACTIONS(233),
    [anon_sym_flat] = ACTIONS(233),
    [anon_sym_noperspective] = ACTIONS(233),
    [sym_invariant_qualifier] = ACTIONS(233),
    [sym_precise_qualifier] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(233),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(235),
    [anon_sym_PLUS_PLUS] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_false] = ACTIONS(233),
    [aux_sym_number_literal_token1] = ACTIONS(233),
    [aux_sym_number_literal_token2] = ACTIONS(233),
    [aux_sym_number_literal_token3] = ACTIONS(235),
    [aux_sym_number_literal_token4] = ACTIONS(235),
    [aux_sym_number_literal_token5] = ACTIONS(233),
    [aux_sym_number_literal_token6] = ACTIONS(235),
    [sym_comment] = ACTIONS(25),
  },
  [36] = {
    [sym_identifier] = ACTIONS(237),
    [anon_sym_SEMI] = ACTIONS(239),
    [anon_sym_precision] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_RBRACE] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_else] = ACTIONS(237),
    [anon_sym_switch] = ACTIONS(237),
    [anon_sym_while] = ACTIONS(237),
    [anon_sym_do] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(237),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_break] = ACTIONS(237),
    [anon_sym_return] = ACTIONS(237),
    [anon_sym_discard] = ACTIONS(237),
    [anon_sym_case] = ACTIONS(237),
    [anon_sym_default] = ACTIONS(237),
    [anon_sym_struct] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_float] = ACTIONS(237),
    [anon_sym_double] = ACTIONS(237),
    [anon_sym_int] = ACTIONS(237),
    [anon_sym_uint] = ACTIONS(237),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_vec2] = ACTIONS(237),
    [anon_sym_vec3] = ACTIONS(237),
    [anon_sym_vec4] = ACTIONS(237),
    [anon_sym_dvec2] = ACTIONS(237),
    [anon_sym_dvec3] = ACTIONS(237),
    [anon_sym_dvec4] = ACTIONS(237),
    [anon_sym_bvec2] = ACTIONS(237),
    [anon_sym_bvec3] = ACTIONS(237),
    [anon_sym_bvec4] = ACTIONS(237),
    [anon_sym_ivec2] = ACTIONS(237),
    [anon_sym_ivec3] = ACTIONS(237),
    [anon_sym_ivec4] = ACTIONS(237),
    [anon_sym_uvec2] = ACTIONS(237),
    [anon_sym_uvec3] = ACTIONS(237),
    [anon_sym_uvec4] = ACTIONS(237),
    [anon_sym_mat2] = ACTIONS(237),
    [anon_sym_mat3] = ACTIONS(237),
    [anon_sym_mat4] = ACTIONS(237),
    [anon_sym_mat2x2] = ACTIONS(237),
    [anon_sym_mat2x3] = ACTIONS(237),
    [anon_sym_mat2x4] = ACTIONS(237),
    [anon_sym_mat3x2] = ACTIONS(237),
    [anon_sym_mat3x3] = ACTIONS(237),
    [anon_sym_mat3x4] = ACTIONS(237),
    [anon_sym_mat4x2] = ACTIONS(237),
    [anon_sym_mat4x3] = ACTIONS(237),
    [anon_sym_mat4x4] = ACTIONS(237),
    [anon_sym_dmat2] = ACTIONS(237),
    [anon_sym_dmat3] = ACTIONS(237),
    [anon_sym_dmat4] = ACTIONS(237),
    [anon_sym_dmat2x2] = ACTIONS(237),
    [anon_sym_dmat2x3] = ACTIONS(237),
    [anon_sym_dmat2x4] = ACTIONS(237),
    [anon_sym_dmat3x2] = ACTIONS(237),
    [anon_sym_dmat3x3] = ACTIONS(237),
    [anon_sym_dmat3x4] = ACTIONS(237),
    [anon_sym_dmat4x2] = ACTIONS(237),
    [anon_sym_dmat4x3] = ACTIONS(237),
    [anon_sym_dmat4x4] = ACTIONS(237),
    [anon_sym_atomic_uint] = ACTIONS(237),
    [anon_sym_sampler1d] = ACTIONS(237),
    [anon_sym_sampler2d] = ACTIONS(237),
    [anon_sym_sampler3d] = ACTIONS(237),
    [anon_sym_samplercube] = ACTIONS(237),
    [anon_sym_sampler1DShadow] = ACTIONS(237),
    [anon_sym_sampler2DShadow] = ACTIONS(237),
    [anon_sym_samplerCubeShadow] = ACTIONS(237),
    [anon_sym_sampler1DArray] = ACTIONS(237),
    [anon_sym_sampler2DArray] = ACTIONS(237),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(237),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(237),
    [anon_sym_samplerCubeArray] = ACTIONS(237),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(237),
    [anon_sym_isampler1D] = ACTIONS(237),
    [anon_sym_isampler2D] = ACTIONS(237),
    [anon_sym_isampler3D] = ACTIONS(237),
    [anon_sym_isamplerCube] = ACTIONS(237),
    [anon_sym_isampler1DArray] = ACTIONS(237),
    [anon_sym_isampler2DArray] = ACTIONS(237),
    [anon_sym_isamplerCubeArray] = ACTIONS(237),
    [anon_sym_usampler1D] = ACTIONS(237),
    [anon_sym_usampler2D] = ACTIONS(237),
    [anon_sym_usampler3D] = ACTIONS(237),
    [anon_sym_usamplerCube] = ACTIONS(237),
    [anon_sym_usampler1DArray] = ACTIONS(237),
    [anon_sym_usampler2DArray] = ACTIONS(237),
    [anon_sym_usamplerCubeArray] = ACTIONS(237),
    [anon_sym_sampler2DRect] = ACTIONS(237),
    [anon_sym_sampler2DRectshadow] = ACTIONS(237),
    [anon_sym_isampler2DRect] = ACTIONS(237),
    [anon_sym_usampler2DRect] = ACTIONS(237),
    [anon_sym_samplerBuffer] = ACTIONS(237),
    [anon_sym_isamplerBuffer] = ACTIONS(237),
    [anon_sym_usamplerBuffer] = ACTIONS(237),
    [anon_sym_sampler2DMS] = ACTIONS(237),
    [anon_sym_isampler2DMS] = ACTIONS(237),
    [anon_sym_usampler2DMS] = ACTIONS(237),
    [anon_sym_sampler2DMSArray] = ACTIONS(237),
    [anon_sym_isampler2DMSArray] = ACTIONS(237),
    [anon_sym_usampler2DMSArray] = ACTIONS(237),
    [anon_sym_image1D] = ACTIONS(237),
    [anon_sym_iimage1D] = ACTIONS(237),
    [anon_sym_uimage1D] = ACTIONS(237),
    [anon_sym_image2D] = ACTIONS(237),
    [anon_sym_iimage2D] = ACTIONS(237),
    [anon_sym_uimage2D] = ACTIONS(237),
    [anon_sym_image3D] = ACTIONS(237),
    [anon_sym_iimage3D] = ACTIONS(237),
    [anon_sym_uimage3D] = ACTIONS(237),
    [anon_sym_image2DRect] = ACTIONS(237),
    [anon_sym_iimage2DRect] = ACTIONS(237),
    [anon_sym_uimage2DRect] = ACTIONS(237),
    [anon_sym_imageCube] = ACTIONS(237),
    [anon_sym_iimageCube] = ACTIONS(237),
    [anon_sym_uimageCube] = ACTIONS(237),
    [anon_sym_imageBuffer] = ACTIONS(237),
    [anon_sym_iimageBuffer] = ACTIONS(237),
    [anon_sym_uimageBuffer] = ACTIONS(237),
    [anon_sym_image1DArray] = ACTIONS(237),
    [anon_sym_iimage1DArray] = ACTIONS(237),
    [anon_sym_uimage1DArray] = ACTIONS(237),
    [anon_sym_image2DArray] = ACTIONS(237),
    [anon_sym_iimage2DArray] = ACTIONS(237),
    [anon_sym_uimage2DArray] = ACTIONS(237),
    [anon_sym_imageCubeArray] = ACTIONS(237),
    [anon_sym_iimageCubeArray] = ACTIONS(237),
    [anon_sym_uimageCubeArray] = ACTIONS(237),
    [anon_sym_image2DMS] = ACTIONS(237),
    [anon_sym_iimage2DMS] = ACTIONS(237),
    [anon_sym_uimage2DMS] = ACTIONS(237),
    [anon_sym_image2DMSArray] = ACTIONS(237),
    [anon_sym_iimage2DMSArray] = ACTIONS(237),
    [anon_sym_uimage2DMSArray] = ACTIONS(237),
    [anon_sym_const] = ACTIONS(237),
    [anon_sym_inout] = ACTIONS(237),
    [anon_sym_in] = ACTIONS(237),
    [anon_sym_out] = ACTIONS(237),
    [anon_sym_centroid] = ACTIONS(237),
    [anon_sym_patch] = ACTIONS(237),
    [anon_sym_sample] = ACTIONS(237),
    [anon_sym_uniform] = ACTIONS(237),
    [anon_sym_buffer] = ACTIONS(237),
    [anon_sym_shared] = ACTIONS(237),
    [anon_sym_coherent] = ACTIONS(237),
    [anon_sym_volatile] = ACTIONS(237),
    [anon_sym_restrict] = ACTIONS(237),
    [anon_sym_readonly] = ACTIONS(237),
    [anon_sym_writeonly] = ACTIONS(237),
    [anon_sym_subroutine] = ACTIONS(237),
    [anon_sym_varying] = ACTIONS(237),
    [anon_sym_attribute] = ACTIONS(237),
    [anon_sym_layout] = ACTIONS(237),
    [anon_sym_highp] = ACTIONS(237),
    [anon_sym_mediump] = ACTIONS(237),
    [anon_sym_lowp] = ACTIONS(237),
    [anon_sym_smooth] = ACTIONS(237),
    [anon_sym_flat] = ACTIONS(237),
    [anon_sym_noperspective] = ACTIONS(237),
    [sym_invariant_qualifier] = ACTIONS(237),
    [sym_precise_qualifier] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(239),
    [anon_sym_PLUS_PLUS] = ACTIONS(239),
    [anon_sym_DASH_DASH] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(237),
    [anon_sym_false] = ACTIONS(237),
    [aux_sym_number_literal_token1] = ACTIONS(237),
    [aux_sym_number_literal_token2] = ACTIONS(237),
    [aux_sym_number_literal_token3] = ACTIONS(239),
    [aux_sym_number_literal_token4] = ACTIONS(239),
    [aux_sym_number_literal_token5] = ACTIONS(237),
    [aux_sym_number_literal_token6] = ACTIONS(239),
    [sym_comment] = ACTIONS(25),
  },
  [37] = {
    [sym_identifier] = ACTIONS(241),
    [anon_sym_SEMI] = ACTIONS(243),
    [anon_sym_precision] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_else] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(241),
    [anon_sym_while] = ACTIONS(241),
    [anon_sym_do] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(241),
    [anon_sym_continue] = ACTIONS(241),
    [anon_sym_break] = ACTIONS(241),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_discard] = ACTIONS(241),
    [anon_sym_case] = ACTIONS(241),
    [anon_sym_default] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(241),
    [anon_sym_void] = ACTIONS(241),
    [anon_sym_float] = ACTIONS(241),
    [anon_sym_double] = ACTIONS(241),
    [anon_sym_int] = ACTIONS(241),
    [anon_sym_uint] = ACTIONS(241),
    [anon_sym_bool] = ACTIONS(241),
    [anon_sym_vec2] = ACTIONS(241),
    [anon_sym_vec3] = ACTIONS(241),
    [anon_sym_vec4] = ACTIONS(241),
    [anon_sym_dvec2] = ACTIONS(241),
    [anon_sym_dvec3] = ACTIONS(241),
    [anon_sym_dvec4] = ACTIONS(241),
    [anon_sym_bvec2] = ACTIONS(241),
    [anon_sym_bvec3] = ACTIONS(241),
    [anon_sym_bvec4] = ACTIONS(241),
    [anon_sym_ivec2] = ACTIONS(241),
    [anon_sym_ivec3] = ACTIONS(241),
    [anon_sym_ivec4] = ACTIONS(241),
    [anon_sym_uvec2] = ACTIONS(241),
    [anon_sym_uvec3] = ACTIONS(241),
    [anon_sym_uvec4] = ACTIONS(241),
    [anon_sym_mat2] = ACTIONS(241),
    [anon_sym_mat3] = ACTIONS(241),
    [anon_sym_mat4] = ACTIONS(241),
    [anon_sym_mat2x2] = ACTIONS(241),
    [anon_sym_mat2x3] = ACTIONS(241),
    [anon_sym_mat2x4] = ACTIONS(241),
    [anon_sym_mat3x2] = ACTIONS(241),
    [anon_sym_mat3x3] = ACTIONS(241),
    [anon_sym_mat3x4] = ACTIONS(241),
    [anon_sym_mat4x2] = ACTIONS(241),
    [anon_sym_mat4x3] = ACTIONS(241),
    [anon_sym_mat4x4] = ACTIONS(241),
    [anon_sym_dmat2] = ACTIONS(241),
    [anon_sym_dmat3] = ACTIONS(241),
    [anon_sym_dmat4] = ACTIONS(241),
    [anon_sym_dmat2x2] = ACTIONS(241),
    [anon_sym_dmat2x3] = ACTIONS(241),
    [anon_sym_dmat2x4] = ACTIONS(241),
    [anon_sym_dmat3x2] = ACTIONS(241),
    [anon_sym_dmat3x3] = ACTIONS(241),
    [anon_sym_dmat3x4] = ACTIONS(241),
    [anon_sym_dmat4x2] = ACTIONS(241),
    [anon_sym_dmat4x3] = ACTIONS(241),
    [anon_sym_dmat4x4] = ACTIONS(241),
    [anon_sym_atomic_uint] = ACTIONS(241),
    [anon_sym_sampler1d] = ACTIONS(241),
    [anon_sym_sampler2d] = ACTIONS(241),
    [anon_sym_sampler3d] = ACTIONS(241),
    [anon_sym_samplercube] = ACTIONS(241),
    [anon_sym_sampler1DShadow] = ACTIONS(241),
    [anon_sym_sampler2DShadow] = ACTIONS(241),
    [anon_sym_samplerCubeShadow] = ACTIONS(241),
    [anon_sym_sampler1DArray] = ACTIONS(241),
    [anon_sym_sampler2DArray] = ACTIONS(241),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(241),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(241),
    [anon_sym_samplerCubeArray] = ACTIONS(241),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(241),
    [anon_sym_isampler1D] = ACTIONS(241),
    [anon_sym_isampler2D] = ACTIONS(241),
    [anon_sym_isampler3D] = ACTIONS(241),
    [anon_sym_isamplerCube] = ACTIONS(241),
    [anon_sym_isampler1DArray] = ACTIONS(241),
    [anon_sym_isampler2DArray] = ACTIONS(241),
    [anon_sym_isamplerCubeArray] = ACTIONS(241),
    [anon_sym_usampler1D] = ACTIONS(241),
    [anon_sym_usampler2D] = ACTIONS(241),
    [anon_sym_usampler3D] = ACTIONS(241),
    [anon_sym_usamplerCube] = ACTIONS(241),
    [anon_sym_usampler1DArray] = ACTIONS(241),
    [anon_sym_usampler2DArray] = ACTIONS(241),
    [anon_sym_usamplerCubeArray] = ACTIONS(241),
    [anon_sym_sampler2DRect] = ACTIONS(241),
    [anon_sym_sampler2DRectshadow] = ACTIONS(241),
    [anon_sym_isampler2DRect] = ACTIONS(241),
    [anon_sym_usampler2DRect] = ACTIONS(241),
    [anon_sym_samplerBuffer] = ACTIONS(241),
    [anon_sym_isamplerBuffer] = ACTIONS(241),
    [anon_sym_usamplerBuffer] = ACTIONS(241),
    [anon_sym_sampler2DMS] = ACTIONS(241),
    [anon_sym_isampler2DMS] = ACTIONS(241),
    [anon_sym_usampler2DMS] = ACTIONS(241),
    [anon_sym_sampler2DMSArray] = ACTIONS(241),
    [anon_sym_isampler2DMSArray] = ACTIONS(241),
    [anon_sym_usampler2DMSArray] = ACTIONS(241),
    [anon_sym_image1D] = ACTIONS(241),
    [anon_sym_iimage1D] = ACTIONS(241),
    [anon_sym_uimage1D] = ACTIONS(241),
    [anon_sym_image2D] = ACTIONS(241),
    [anon_sym_iimage2D] = ACTIONS(241),
    [anon_sym_uimage2D] = ACTIONS(241),
    [anon_sym_image3D] = ACTIONS(241),
    [anon_sym_iimage3D] = ACTIONS(241),
    [anon_sym_uimage3D] = ACTIONS(241),
    [anon_sym_image2DRect] = ACTIONS(241),
    [anon_sym_iimage2DRect] = ACTIONS(241),
    [anon_sym_uimage2DRect] = ACTIONS(241),
    [anon_sym_imageCube] = ACTIONS(241),
    [anon_sym_iimageCube] = ACTIONS(241),
    [anon_sym_uimageCube] = ACTIONS(241),
    [anon_sym_imageBuffer] = ACTIONS(241),
    [anon_sym_iimageBuffer] = ACTIONS(241),
    [anon_sym_uimageBuffer] = ACTIONS(241),
    [anon_sym_image1DArray] = ACTIONS(241),
    [anon_sym_iimage1DArray] = ACTIONS(241),
    [anon_sym_uimage1DArray] = ACTIONS(241),
    [anon_sym_image2DArray] = ACTIONS(241),
    [anon_sym_iimage2DArray] = ACTIONS(241),
    [anon_sym_uimage2DArray] = ACTIONS(241),
    [anon_sym_imageCubeArray] = ACTIONS(241),
    [anon_sym_iimageCubeArray] = ACTIONS(241),
    [anon_sym_uimageCubeArray] = ACTIONS(241),
    [anon_sym_image2DMS] = ACTIONS(241),
    [anon_sym_iimage2DMS] = ACTIONS(241),
    [anon_sym_uimage2DMS] = ACTIONS(241),
    [anon_sym_image2DMSArray] = ACTIONS(241),
    [anon_sym_iimage2DMSArray] = ACTIONS(241),
    [anon_sym_uimage2DMSArray] = ACTIONS(241),
    [anon_sym_const] = ACTIONS(241),
    [anon_sym_inout] = ACTIONS(241),
    [anon_sym_in] = ACTIONS(241),
    [anon_sym_out] = ACTIONS(241),
    [anon_sym_centroid] = ACTIONS(241),
    [anon_sym_patch] = ACTIONS(241),
    [anon_sym_sample] = ACTIONS(241),
    [anon_sym_uniform] = ACTIONS(241),
    [anon_sym_buffer] = ACTIONS(241),
    [anon_sym_shared] = ACTIONS(241),
    [anon_sym_coherent] = ACTIONS(241),
    [anon_sym_volatile] = ACTIONS(241),
    [anon_sym_restrict] = ACTIONS(241),
    [anon_sym_readonly] = ACTIONS(241),
    [anon_sym_writeonly] = ACTIONS(241),
    [anon_sym_subroutine] = ACTIONS(241),
    [anon_sym_varying] = ACTIONS(241),
    [anon_sym_attribute] = ACTIONS(241),
    [anon_sym_layout] = ACTIONS(241),
    [anon_sym_highp] = ACTIONS(241),
    [anon_sym_mediump] = ACTIONS(241),
    [anon_sym_lowp] = ACTIONS(241),
    [anon_sym_smooth] = ACTIONS(241),
    [anon_sym_flat] = ACTIONS(241),
    [anon_sym_noperspective] = ACTIONS(241),
    [sym_invariant_qualifier] = ACTIONS(241),
    [sym_precise_qualifier] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(241),
    [anon_sym_BANG] = ACTIONS(243),
    [anon_sym_TILDE] = ACTIONS(243),
    [anon_sym_PLUS_PLUS] = ACTIONS(243),
    [anon_sym_DASH_DASH] = ACTIONS(243),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [aux_sym_number_literal_token1] = ACTIONS(241),
    [aux_sym_number_literal_token2] = ACTIONS(241),
    [aux_sym_number_literal_token3] = ACTIONS(243),
    [aux_sym_number_literal_token4] = ACTIONS(243),
    [aux_sym_number_literal_token5] = ACTIONS(241),
    [aux_sym_number_literal_token6] = ACTIONS(243),
    [sym_comment] = ACTIONS(25),
  },
  [38] = {
    [sym_identifier] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(247),
    [anon_sym_precision] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_LPAREN] = ACTIONS(247),
    [anon_sym_else] = ACTIONS(245),
    [anon_sym_switch] = ACTIONS(245),
    [anon_sym_while] = ACTIONS(245),
    [anon_sym_do] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(245),
    [anon_sym_continue] = ACTIONS(245),
    [anon_sym_break] = ACTIONS(245),
    [anon_sym_return] = ACTIONS(245),
    [anon_sym_discard] = ACTIONS(245),
    [anon_sym_case] = ACTIONS(245),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_struct] = ACTIONS(245),
    [anon_sym_void] = ACTIONS(245),
    [anon_sym_float] = ACTIONS(245),
    [anon_sym_double] = ACTIONS(245),
    [anon_sym_int] = ACTIONS(245),
    [anon_sym_uint] = ACTIONS(245),
    [anon_sym_bool] = ACTIONS(245),
    [anon_sym_vec2] = ACTIONS(245),
    [anon_sym_vec3] = ACTIONS(245),
    [anon_sym_vec4] = ACTIONS(245),
    [anon_sym_dvec2] = ACTIONS(245),
    [anon_sym_dvec3] = ACTIONS(245),
    [anon_sym_dvec4] = ACTIONS(245),
    [anon_sym_bvec2] = ACTIONS(245),
    [anon_sym_bvec3] = ACTIONS(245),
    [anon_sym_bvec4] = ACTIONS(245),
    [anon_sym_ivec2] = ACTIONS(245),
    [anon_sym_ivec3] = ACTIONS(245),
    [anon_sym_ivec4] = ACTIONS(245),
    [anon_sym_uvec2] = ACTIONS(245),
    [anon_sym_uvec3] = ACTIONS(245),
    [anon_sym_uvec4] = ACTIONS(245),
    [anon_sym_mat2] = ACTIONS(245),
    [anon_sym_mat3] = ACTIONS(245),
    [anon_sym_mat4] = ACTIONS(245),
    [anon_sym_mat2x2] = ACTIONS(245),
    [anon_sym_mat2x3] = ACTIONS(245),
    [anon_sym_mat2x4] = ACTIONS(245),
    [anon_sym_mat3x2] = ACTIONS(245),
    [anon_sym_mat3x3] = ACTIONS(245),
    [anon_sym_mat3x4] = ACTIONS(245),
    [anon_sym_mat4x2] = ACTIONS(245),
    [anon_sym_mat4x3] = ACTIONS(245),
    [anon_sym_mat4x4] = ACTIONS(245),
    [anon_sym_dmat2] = ACTIONS(245),
    [anon_sym_dmat3] = ACTIONS(245),
    [anon_sym_dmat4] = ACTIONS(245),
    [anon_sym_dmat2x2] = ACTIONS(245),
    [anon_sym_dmat2x3] = ACTIONS(245),
    [anon_sym_dmat2x4] = ACTIONS(245),
    [anon_sym_dmat3x2] = ACTIONS(245),
    [anon_sym_dmat3x3] = ACTIONS(245),
    [anon_sym_dmat3x4] = ACTIONS(245),
    [anon_sym_dmat4x2] = ACTIONS(245),
    [anon_sym_dmat4x3] = ACTIONS(245),
    [anon_sym_dmat4x4] = ACTIONS(245),
    [anon_sym_atomic_uint] = ACTIONS(245),
    [anon_sym_sampler1d] = ACTIONS(245),
    [anon_sym_sampler2d] = ACTIONS(245),
    [anon_sym_sampler3d] = ACTIONS(245),
    [anon_sym_samplercube] = ACTIONS(245),
    [anon_sym_sampler1DShadow] = ACTIONS(245),
    [anon_sym_sampler2DShadow] = ACTIONS(245),
    [anon_sym_samplerCubeShadow] = ACTIONS(245),
    [anon_sym_sampler1DArray] = ACTIONS(245),
    [anon_sym_sampler2DArray] = ACTIONS(245),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(245),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(245),
    [anon_sym_samplerCubeArray] = ACTIONS(245),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(245),
    [anon_sym_isampler1D] = ACTIONS(245),
    [anon_sym_isampler2D] = ACTIONS(245),
    [anon_sym_isampler3D] = ACTIONS(245),
    [anon_sym_isamplerCube] = ACTIONS(245),
    [anon_sym_isampler1DArray] = ACTIONS(245),
    [anon_sym_isampler2DArray] = ACTIONS(245),
    [anon_sym_isamplerCubeArray] = ACTIONS(245),
    [anon_sym_usampler1D] = ACTIONS(245),
    [anon_sym_usampler2D] = ACTIONS(245),
    [anon_sym_usampler3D] = ACTIONS(245),
    [anon_sym_usamplerCube] = ACTIONS(245),
    [anon_sym_usampler1DArray] = ACTIONS(245),
    [anon_sym_usampler2DArray] = ACTIONS(245),
    [anon_sym_usamplerCubeArray] = ACTIONS(245),
    [anon_sym_sampler2DRect] = ACTIONS(245),
    [anon_sym_sampler2DRectshadow] = ACTIONS(245),
    [anon_sym_isampler2DRect] = ACTIONS(245),
    [anon_sym_usampler2DRect] = ACTIONS(245),
    [anon_sym_samplerBuffer] = ACTIONS(245),
    [anon_sym_isamplerBuffer] = ACTIONS(245),
    [anon_sym_usamplerBuffer] = ACTIONS(245),
    [anon_sym_sampler2DMS] = ACTIONS(245),
    [anon_sym_isampler2DMS] = ACTIONS(245),
    [anon_sym_usampler2DMS] = ACTIONS(245),
    [anon_sym_sampler2DMSArray] = ACTIONS(245),
    [anon_sym_isampler2DMSArray] = ACTIONS(245),
    [anon_sym_usampler2DMSArray] = ACTIONS(245),
    [anon_sym_image1D] = ACTIONS(245),
    [anon_sym_iimage1D] = ACTIONS(245),
    [anon_sym_uimage1D] = ACTIONS(245),
    [anon_sym_image2D] = ACTIONS(245),
    [anon_sym_iimage2D] = ACTIONS(245),
    [anon_sym_uimage2D] = ACTIONS(245),
    [anon_sym_image3D] = ACTIONS(245),
    [anon_sym_iimage3D] = ACTIONS(245),
    [anon_sym_uimage3D] = ACTIONS(245),
    [anon_sym_image2DRect] = ACTIONS(245),
    [anon_sym_iimage2DRect] = ACTIONS(245),
    [anon_sym_uimage2DRect] = ACTIONS(245),
    [anon_sym_imageCube] = ACTIONS(245),
    [anon_sym_iimageCube] = ACTIONS(245),
    [anon_sym_uimageCube] = ACTIONS(245),
    [anon_sym_imageBuffer] = ACTIONS(245),
    [anon_sym_iimageBuffer] = ACTIONS(245),
    [anon_sym_uimageBuffer] = ACTIONS(245),
    [anon_sym_image1DArray] = ACTIONS(245),
    [anon_sym_iimage1DArray] = ACTIONS(245),
    [anon_sym_uimage1DArray] = ACTIONS(245),
    [anon_sym_image2DArray] = ACTIONS(245),
    [anon_sym_iimage2DArray] = ACTIONS(245),
    [anon_sym_uimage2DArray] = ACTIONS(245),
    [anon_sym_imageCubeArray] = ACTIONS(245),
    [anon_sym_iimageCubeArray] = ACTIONS(245),
    [anon_sym_uimageCubeArray] = ACTIONS(245),
    [anon_sym_image2DMS] = ACTIONS(245),
    [anon_sym_iimage2DMS] = ACTIONS(245),
    [anon_sym_uimage2DMS] = ACTIONS(245),
    [anon_sym_image2DMSArray] = ACTIONS(245),
    [anon_sym_iimage2DMSArray] = ACTIONS(245),
    [anon_sym_uimage2DMSArray] = ACTIONS(245),
    [anon_sym_const] = ACTIONS(245),
    [anon_sym_inout] = ACTIONS(245),
    [anon_sym_in] = ACTIONS(245),
    [anon_sym_out] = ACTIONS(245),
    [anon_sym_centroid] = ACTIONS(245),
    [anon_sym_patch] = ACTIONS(245),
    [anon_sym_sample] = ACTIONS(245),
    [anon_sym_uniform] = ACTIONS(245),
    [anon_sym_buffer] = ACTIONS(245),
    [anon_sym_shared] = ACTIONS(245),
    [anon_sym_coherent] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_restrict] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_writeonly] = ACTIONS(245),
    [anon_sym_subroutine] = ACTIONS(245),
    [anon_sym_varying] = ACTIONS(245),
    [anon_sym_attribute] = ACTIONS(245),
    [anon_sym_layout] = ACTIONS(245),
    [anon_sym_highp] = ACTIONS(245),
    [anon_sym_mediump] = ACTIONS(245),
    [anon_sym_lowp] = ACTIONS(245),
    [anon_sym_smooth] = ACTIONS(245),
    [anon_sym_flat] = ACTIONS(245),
    [anon_sym_noperspective] = ACTIONS(245),
    [sym_invariant_qualifier] = ACTIONS(245),
    [sym_precise_qualifier] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(245),
    [anon_sym_DASH] = ACTIONS(245),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_PLUS_PLUS] = ACTIONS(247),
    [anon_sym_DASH_DASH] = ACTIONS(247),
    [anon_sym_true] = ACTIONS(245),
    [anon_sym_false] = ACTIONS(245),
    [aux_sym_number_literal_token1] = ACTIONS(245),
    [aux_sym_number_literal_token2] = ACTIONS(245),
    [aux_sym_number_literal_token3] = ACTIONS(247),
    [aux_sym_number_literal_token4] = ACTIONS(247),
    [aux_sym_number_literal_token5] = ACTIONS(245),
    [aux_sym_number_literal_token6] = ACTIONS(247),
    [sym_comment] = ACTIONS(25),
  },
  [39] = {
    [sym_identifier] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_precision] = ACTIONS(249),
    [anon_sym_LBRACE] = ACTIONS(251),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_else] = ACTIONS(249),
    [anon_sym_switch] = ACTIONS(249),
    [anon_sym_while] = ACTIONS(249),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_for] = ACTIONS(249),
    [anon_sym_continue] = ACTIONS(249),
    [anon_sym_break] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_case] = ACTIONS(249),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_struct] = ACTIONS(249),
    [anon_sym_void] = ACTIONS(249),
    [anon_sym_float] = ACTIONS(249),
    [anon_sym_double] = ACTIONS(249),
    [anon_sym_int] = ACTIONS(249),
    [anon_sym_uint] = ACTIONS(249),
    [anon_sym_bool] = ACTIONS(249),
    [anon_sym_vec2] = ACTIONS(249),
    [anon_sym_vec3] = ACTIONS(249),
    [anon_sym_vec4] = ACTIONS(249),
    [anon_sym_dvec2] = ACTIONS(249),
    [anon_sym_dvec3] = ACTIONS(249),
    [anon_sym_dvec4] = ACTIONS(249),
    [anon_sym_bvec2] = ACTIONS(249),
    [anon_sym_bvec3] = ACTIONS(249),
    [anon_sym_bvec4] = ACTIONS(249),
    [anon_sym_ivec2] = ACTIONS(249),
    [anon_sym_ivec3] = ACTIONS(249),
    [anon_sym_ivec4] = ACTIONS(249),
    [anon_sym_uvec2] = ACTIONS(249),
    [anon_sym_uvec3] = ACTIONS(249),
    [anon_sym_uvec4] = ACTIONS(249),
    [anon_sym_mat2] = ACTIONS(249),
    [anon_sym_mat3] = ACTIONS(249),
    [anon_sym_mat4] = ACTIONS(249),
    [anon_sym_mat2x2] = ACTIONS(249),
    [anon_sym_mat2x3] = ACTIONS(249),
    [anon_sym_mat2x4] = ACTIONS(249),
    [anon_sym_mat3x2] = ACTIONS(249),
    [anon_sym_mat3x3] = ACTIONS(249),
    [anon_sym_mat3x4] = ACTIONS(249),
    [anon_sym_mat4x2] = ACTIONS(249),
    [anon_sym_mat4x3] = ACTIONS(249),
    [anon_sym_mat4x4] = ACTIONS(249),
    [anon_sym_dmat2] = ACTIONS(249),
    [anon_sym_dmat3] = ACTIONS(249),
    [anon_sym_dmat4] = ACTIONS(249),
    [anon_sym_dmat2x2] = ACTIONS(249),
    [anon_sym_dmat2x3] = ACTIONS(249),
    [anon_sym_dmat2x4] = ACTIONS(249),
    [anon_sym_dmat3x2] = ACTIONS(249),
    [anon_sym_dmat3x3] = ACTIONS(249),
    [anon_sym_dmat3x4] = ACTIONS(249),
    [anon_sym_dmat4x2] = ACTIONS(249),
    [anon_sym_dmat4x3] = ACTIONS(249),
    [anon_sym_dmat4x4] = ACTIONS(249),
    [anon_sym_atomic_uint] = ACTIONS(249),
    [anon_sym_sampler1d] = ACTIONS(249),
    [anon_sym_sampler2d] = ACTIONS(249),
    [anon_sym_sampler3d] = ACTIONS(249),
    [anon_sym_samplercube] = ACTIONS(249),
    [anon_sym_sampler1DShadow] = ACTIONS(249),
    [anon_sym_sampler2DShadow] = ACTIONS(249),
    [anon_sym_samplerCubeShadow] = ACTIONS(249),
    [anon_sym_sampler1DArray] = ACTIONS(249),
    [anon_sym_sampler2DArray] = ACTIONS(249),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(249),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(249),
    [anon_sym_samplerCubeArray] = ACTIONS(249),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(249),
    [anon_sym_isampler1D] = ACTIONS(249),
    [anon_sym_isampler2D] = ACTIONS(249),
    [anon_sym_isampler3D] = ACTIONS(249),
    [anon_sym_isamplerCube] = ACTIONS(249),
    [anon_sym_isampler1DArray] = ACTIONS(249),
    [anon_sym_isampler2DArray] = ACTIONS(249),
    [anon_sym_isamplerCubeArray] = ACTIONS(249),
    [anon_sym_usampler1D] = ACTIONS(249),
    [anon_sym_usampler2D] = ACTIONS(249),
    [anon_sym_usampler3D] = ACTIONS(249),
    [anon_sym_usamplerCube] = ACTIONS(249),
    [anon_sym_usampler1DArray] = ACTIONS(249),
    [anon_sym_usampler2DArray] = ACTIONS(249),
    [anon_sym_usamplerCubeArray] = ACTIONS(249),
    [anon_sym_sampler2DRect] = ACTIONS(249),
    [anon_sym_sampler2DRectshadow] = ACTIONS(249),
    [anon_sym_isampler2DRect] = ACTIONS(249),
    [anon_sym_usampler2DRect] = ACTIONS(249),
    [anon_sym_samplerBuffer] = ACTIONS(249),
    [anon_sym_isamplerBuffer] = ACTIONS(249),
    [anon_sym_usamplerBuffer] = ACTIONS(249),
    [anon_sym_sampler2DMS] = ACTIONS(249),
    [anon_sym_isampler2DMS] = ACTIONS(249),
    [anon_sym_usampler2DMS] = ACTIONS(249),
    [anon_sym_sampler2DMSArray] = ACTIONS(249),
    [anon_sym_isampler2DMSArray] = ACTIONS(249),
    [anon_sym_usampler2DMSArray] = ACTIONS(249),
    [anon_sym_image1D] = ACTIONS(249),
    [anon_sym_iimage1D] = ACTIONS(249),
    [anon_sym_uimage1D] = ACTIONS(249),
    [anon_sym_image2D] = ACTIONS(249),
    [anon_sym_iimage2D] = ACTIONS(249),
    [anon_sym_uimage2D] = ACTIONS(249),
    [anon_sym_image3D] = ACTIONS(249),
    [anon_sym_iimage3D] = ACTIONS(249),
    [anon_sym_uimage3D] = ACTIONS(249),
    [anon_sym_image2DRect] = ACTIONS(249),
    [anon_sym_iimage2DRect] = ACTIONS(249),
    [anon_sym_uimage2DRect] = ACTIONS(249),
    [anon_sym_imageCube] = ACTIONS(249),
    [anon_sym_iimageCube] = ACTIONS(249),
    [anon_sym_uimageCube] = ACTIONS(249),
    [anon_sym_imageBuffer] = ACTIONS(249),
    [anon_sym_iimageBuffer] = ACTIONS(249),
    [anon_sym_uimageBuffer] = ACTIONS(249),
    [anon_sym_image1DArray] = ACTIONS(249),
    [anon_sym_iimage1DArray] = ACTIONS(249),
    [anon_sym_uimage1DArray] = ACTIONS(249),
    [anon_sym_image2DArray] = ACTIONS(249),
    [anon_sym_iimage2DArray] = ACTIONS(249),
    [anon_sym_uimage2DArray] = ACTIONS(249),
    [anon_sym_imageCubeArray] = ACTIONS(249),
    [anon_sym_iimageCubeArray] = ACTIONS(249),
    [anon_sym_uimageCubeArray] = ACTIONS(249),
    [anon_sym_image2DMS] = ACTIONS(249),
    [anon_sym_iimage2DMS] = ACTIONS(249),
    [anon_sym_uimage2DMS] = ACTIONS(249),
    [anon_sym_image2DMSArray] = ACTIONS(249),
    [anon_sym_iimage2DMSArray] = ACTIONS(249),
    [anon_sym_uimage2DMSArray] = ACTIONS(249),
    [anon_sym_const] = ACTIONS(249),
    [anon_sym_inout] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(249),
    [anon_sym_out] = ACTIONS(249),
    [anon_sym_centroid] = ACTIONS(249),
    [anon_sym_patch] = ACTIONS(249),
    [anon_sym_sample] = ACTIONS(249),
    [anon_sym_uniform] = ACTIONS(249),
    [anon_sym_buffer] = ACTIONS(249),
    [anon_sym_shared] = ACTIONS(249),
    [anon_sym_coherent] = ACTIONS(249),
    [anon_sym_volatile] = ACTIONS(249),
    [anon_sym_restrict] = ACTIONS(249),
    [anon_sym_readonly] = ACTIONS(249),
    [anon_sym_writeonly] = ACTIONS(249),
    [anon_sym_subroutine] = ACTIONS(249),
    [anon_sym_varying] = ACTIONS(249),
    [anon_sym_attribute] = ACTIONS(249),
    [anon_sym_layout] = ACTIONS(249),
    [anon_sym_highp] = ACTIONS(249),
    [anon_sym_mediump] = ACTIONS(249),
    [anon_sym_lowp] = ACTIONS(249),
    [anon_sym_smooth] = ACTIONS(249),
    [anon_sym_flat] = ACTIONS(249),
    [anon_sym_noperspective] = ACTIONS(249),
    [sym_invariant_qualifier] = ACTIONS(249),
    [sym_precise_qualifier] = ACTIONS(249),
    [anon_sym_PLUS] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_BANG] = ACTIONS(251),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_PLUS_PLUS] = ACTIONS(251),
    [anon_sym_DASH_DASH] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_false] = ACTIONS(249),
    [aux_sym_number_literal_token1] = ACTIONS(249),
    [aux_sym_number_literal_token2] = ACTIONS(249),
    [aux_sym_number_literal_token3] = ACTIONS(251),
    [aux_sym_number_literal_token4] = ACTIONS(251),
    [aux_sym_number_literal_token5] = ACTIONS(249),
    [aux_sym_number_literal_token6] = ACTIONS(251),
    [sym_comment] = ACTIONS(25),
  },
  [40] = {
    [sym_identifier] = ACTIONS(253),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_precision] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_else] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(253),
    [anon_sym_while] = ACTIONS(253),
    [anon_sym_do] = ACTIONS(253),
    [anon_sym_for] = ACTIONS(253),
    [anon_sym_continue] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(253),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_discard] = ACTIONS(253),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_default] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(253),
    [anon_sym_void] = ACTIONS(253),
    [anon_sym_float] = ACTIONS(253),
    [anon_sym_double] = ACTIONS(253),
    [anon_sym_int] = ACTIONS(253),
    [anon_sym_uint] = ACTIONS(253),
    [anon_sym_bool] = ACTIONS(253),
    [anon_sym_vec2] = ACTIONS(253),
    [anon_sym_vec3] = ACTIONS(253),
    [anon_sym_vec4] = ACTIONS(253),
    [anon_sym_dvec2] = ACTIONS(253),
    [anon_sym_dvec3] = ACTIONS(253),
    [anon_sym_dvec4] = ACTIONS(253),
    [anon_sym_bvec2] = ACTIONS(253),
    [anon_sym_bvec3] = ACTIONS(253),
    [anon_sym_bvec4] = ACTIONS(253),
    [anon_sym_ivec2] = ACTIONS(253),
    [anon_sym_ivec3] = ACTIONS(253),
    [anon_sym_ivec4] = ACTIONS(253),
    [anon_sym_uvec2] = ACTIONS(253),
    [anon_sym_uvec3] = ACTIONS(253),
    [anon_sym_uvec4] = ACTIONS(253),
    [anon_sym_mat2] = ACTIONS(253),
    [anon_sym_mat3] = ACTIONS(253),
    [anon_sym_mat4] = ACTIONS(253),
    [anon_sym_mat2x2] = ACTIONS(253),
    [anon_sym_mat2x3] = ACTIONS(253),
    [anon_sym_mat2x4] = ACTIONS(253),
    [anon_sym_mat3x2] = ACTIONS(253),
    [anon_sym_mat3x3] = ACTIONS(253),
    [anon_sym_mat3x4] = ACTIONS(253),
    [anon_sym_mat4x2] = ACTIONS(253),
    [anon_sym_mat4x3] = ACTIONS(253),
    [anon_sym_mat4x4] = ACTIONS(253),
    [anon_sym_dmat2] = ACTIONS(253),
    [anon_sym_dmat3] = ACTIONS(253),
    [anon_sym_dmat4] = ACTIONS(253),
    [anon_sym_dmat2x2] = ACTIONS(253),
    [anon_sym_dmat2x3] = ACTIONS(253),
    [anon_sym_dmat2x4] = ACTIONS(253),
    [anon_sym_dmat3x2] = ACTIONS(253),
    [anon_sym_dmat3x3] = ACTIONS(253),
    [anon_sym_dmat3x4] = ACTIONS(253),
    [anon_sym_dmat4x2] = ACTIONS(253),
    [anon_sym_dmat4x3] = ACTIONS(253),
    [anon_sym_dmat4x4] = ACTIONS(253),
    [anon_sym_atomic_uint] = ACTIONS(253),
    [anon_sym_sampler1d] = ACTIONS(253),
    [anon_sym_sampler2d] = ACTIONS(253),
    [anon_sym_sampler3d] = ACTIONS(253),
    [anon_sym_samplercube] = ACTIONS(253),
    [anon_sym_sampler1DShadow] = ACTIONS(253),
    [anon_sym_sampler2DShadow] = ACTIONS(253),
    [anon_sym_samplerCubeShadow] = ACTIONS(253),
    [anon_sym_sampler1DArray] = ACTIONS(253),
    [anon_sym_sampler2DArray] = ACTIONS(253),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(253),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(253),
    [anon_sym_samplerCubeArray] = ACTIONS(253),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(253),
    [anon_sym_isampler1D] = ACTIONS(253),
    [anon_sym_isampler2D] = ACTIONS(253),
    [anon_sym_isampler3D] = ACTIONS(253),
    [anon_sym_isamplerCube] = ACTIONS(253),
    [anon_sym_isampler1DArray] = ACTIONS(253),
    [anon_sym_isampler2DArray] = ACTIONS(253),
    [anon_sym_isamplerCubeArray] = ACTIONS(253),
    [anon_sym_usampler1D] = ACTIONS(253),
    [anon_sym_usampler2D] = ACTIONS(253),
    [anon_sym_usampler3D] = ACTIONS(253),
    [anon_sym_usamplerCube] = ACTIONS(253),
    [anon_sym_usampler1DArray] = ACTIONS(253),
    [anon_sym_usampler2DArray] = ACTIONS(253),
    [anon_sym_usamplerCubeArray] = ACTIONS(253),
    [anon_sym_sampler2DRect] = ACTIONS(253),
    [anon_sym_sampler2DRectshadow] = ACTIONS(253),
    [anon_sym_isampler2DRect] = ACTIONS(253),
    [anon_sym_usampler2DRect] = ACTIONS(253),
    [anon_sym_samplerBuffer] = ACTIONS(253),
    [anon_sym_isamplerBuffer] = ACTIONS(253),
    [anon_sym_usamplerBuffer] = ACTIONS(253),
    [anon_sym_sampler2DMS] = ACTIONS(253),
    [anon_sym_isampler2DMS] = ACTIONS(253),
    [anon_sym_usampler2DMS] = ACTIONS(253),
    [anon_sym_sampler2DMSArray] = ACTIONS(253),
    [anon_sym_isampler2DMSArray] = ACTIONS(253),
    [anon_sym_usampler2DMSArray] = ACTIONS(253),
    [anon_sym_image1D] = ACTIONS(253),
    [anon_sym_iimage1D] = ACTIONS(253),
    [anon_sym_uimage1D] = ACTIONS(253),
    [anon_sym_image2D] = ACTIONS(253),
    [anon_sym_iimage2D] = ACTIONS(253),
    [anon_sym_uimage2D] = ACTIONS(253),
    [anon_sym_image3D] = ACTIONS(253),
    [anon_sym_iimage3D] = ACTIONS(253),
    [anon_sym_uimage3D] = ACTIONS(253),
    [anon_sym_image2DRect] = ACTIONS(253),
    [anon_sym_iimage2DRect] = ACTIONS(253),
    [anon_sym_uimage2DRect] = ACTIONS(253),
    [anon_sym_imageCube] = ACTIONS(253),
    [anon_sym_iimageCube] = ACTIONS(253),
    [anon_sym_uimageCube] = ACTIONS(253),
    [anon_sym_imageBuffer] = ACTIONS(253),
    [anon_sym_iimageBuffer] = ACTIONS(253),
    [anon_sym_uimageBuffer] = ACTIONS(253),
    [anon_sym_image1DArray] = ACTIONS(253),
    [anon_sym_iimage1DArray] = ACTIONS(253),
    [anon_sym_uimage1DArray] = ACTIONS(253),
    [anon_sym_image2DArray] = ACTIONS(253),
    [anon_sym_iimage2DArray] = ACTIONS(253),
    [anon_sym_uimage2DArray] = ACTIONS(253),
    [anon_sym_imageCubeArray] = ACTIONS(253),
    [anon_sym_iimageCubeArray] = ACTIONS(253),
    [anon_sym_uimageCubeArray] = ACTIONS(253),
    [anon_sym_image2DMS] = ACTIONS(253),
    [anon_sym_iimage2DMS] = ACTIONS(253),
    [anon_sym_uimage2DMS] = ACTIONS(253),
    [anon_sym_image2DMSArray] = ACTIONS(253),
    [anon_sym_iimage2DMSArray] = ACTIONS(253),
    [anon_sym_uimage2DMSArray] = ACTIONS(253),
    [anon_sym_const] = ACTIONS(253),
    [anon_sym_inout] = ACTIONS(253),
    [anon_sym_in] = ACTIONS(253),
    [anon_sym_out] = ACTIONS(253),
    [anon_sym_centroid] = ACTIONS(253),
    [anon_sym_patch] = ACTIONS(253),
    [anon_sym_sample] = ACTIONS(253),
    [anon_sym_uniform] = ACTIONS(253),
    [anon_sym_buffer] = ACTIONS(253),
    [anon_sym_shared] = ACTIONS(253),
    [anon_sym_coherent] = ACTIONS(253),
    [anon_sym_volatile] = ACTIONS(253),
    [anon_sym_restrict] = ACTIONS(253),
    [anon_sym_readonly] = ACTIONS(253),
    [anon_sym_writeonly] = ACTIONS(253),
    [anon_sym_subroutine] = ACTIONS(253),
    [anon_sym_varying] = ACTIONS(253),
    [anon_sym_attribute] = ACTIONS(253),
    [anon_sym_layout] = ACTIONS(253),
    [anon_sym_highp] = ACTIONS(253),
    [anon_sym_mediump] = ACTIONS(253),
    [anon_sym_lowp] = ACTIONS(253),
    [anon_sym_smooth] = ACTIONS(253),
    [anon_sym_flat] = ACTIONS(253),
    [anon_sym_noperspective] = ACTIONS(253),
    [sym_invariant_qualifier] = ACTIONS(253),
    [sym_precise_qualifier] = ACTIONS(253),
    [anon_sym_PLUS] = ACTIONS(253),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_PLUS_PLUS] = ACTIONS(255),
    [anon_sym_DASH_DASH] = ACTIONS(255),
    [anon_sym_true] = ACTIONS(253),
    [anon_sym_false] = ACTIONS(253),
    [aux_sym_number_literal_token1] = ACTIONS(253),
    [aux_sym_number_literal_token2] = ACTIONS(253),
    [aux_sym_number_literal_token3] = ACTIONS(255),
    [aux_sym_number_literal_token4] = ACTIONS(255),
    [aux_sym_number_literal_token5] = ACTIONS(253),
    [aux_sym_number_literal_token6] = ACTIONS(255),
    [sym_comment] = ACTIONS(25),
  },
  [41] = {
    [sym__external_declaration] = STATE(104),
    [sym_declaration] = STATE(105),
    [sym__init_declarator_list] = STATE(237),
    [sym_function_definition] = STATE(106),
    [sym_function_prototype] = STATE(62),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(209),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_translation_unit_repeat1] = STATE(41),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(257),
    [sym_identifier] = ACTIONS(259),
    [anon_sym_precision] = ACTIONS(262),
    [anon_sym_struct] = ACTIONS(265),
    [anon_sym_void] = ACTIONS(268),
    [anon_sym_float] = ACTIONS(268),
    [anon_sym_double] = ACTIONS(268),
    [anon_sym_int] = ACTIONS(268),
    [anon_sym_uint] = ACTIONS(268),
    [anon_sym_bool] = ACTIONS(268),
    [anon_sym_vec2] = ACTIONS(268),
    [anon_sym_vec3] = ACTIONS(268),
    [anon_sym_vec4] = ACTIONS(268),
    [anon_sym_dvec2] = ACTIONS(268),
    [anon_sym_dvec3] = ACTIONS(268),
    [anon_sym_dvec4] = ACTIONS(268),
    [anon_sym_bvec2] = ACTIONS(268),
    [anon_sym_bvec3] = ACTIONS(268),
    [anon_sym_bvec4] = ACTIONS(268),
    [anon_sym_ivec2] = ACTIONS(268),
    [anon_sym_ivec3] = ACTIONS(268),
    [anon_sym_ivec4] = ACTIONS(268),
    [anon_sym_uvec2] = ACTIONS(268),
    [anon_sym_uvec3] = ACTIONS(268),
    [anon_sym_uvec4] = ACTIONS(268),
    [anon_sym_mat2] = ACTIONS(268),
    [anon_sym_mat3] = ACTIONS(268),
    [anon_sym_mat4] = ACTIONS(268),
    [anon_sym_mat2x2] = ACTIONS(268),
    [anon_sym_mat2x3] = ACTIONS(268),
    [anon_sym_mat2x4] = ACTIONS(268),
    [anon_sym_mat3x2] = ACTIONS(268),
    [anon_sym_mat3x3] = ACTIONS(268),
    [anon_sym_mat3x4] = ACTIONS(268),
    [anon_sym_mat4x2] = ACTIONS(268),
    [anon_sym_mat4x3] = ACTIONS(268),
    [anon_sym_mat4x4] = ACTIONS(268),
    [anon_sym_dmat2] = ACTIONS(268),
    [anon_sym_dmat3] = ACTIONS(268),
    [anon_sym_dmat4] = ACTIONS(268),
    [anon_sym_dmat2x2] = ACTIONS(268),
    [anon_sym_dmat2x3] = ACTIONS(268),
    [anon_sym_dmat2x4] = ACTIONS(268),
    [anon_sym_dmat3x2] = ACTIONS(268),
    [anon_sym_dmat3x3] = ACTIONS(268),
    [anon_sym_dmat3x4] = ACTIONS(268),
    [anon_sym_dmat4x2] = ACTIONS(268),
    [anon_sym_dmat4x3] = ACTIONS(268),
    [anon_sym_dmat4x4] = ACTIONS(268),
    [anon_sym_atomic_uint] = ACTIONS(268),
    [anon_sym_sampler1d] = ACTIONS(268),
    [anon_sym_sampler2d] = ACTIONS(268),
    [anon_sym_sampler3d] = ACTIONS(268),
    [anon_sym_samplercube] = ACTIONS(268),
    [anon_sym_sampler1DShadow] = ACTIONS(268),
    [anon_sym_sampler2DShadow] = ACTIONS(268),
    [anon_sym_samplerCubeShadow] = ACTIONS(268),
    [anon_sym_sampler1DArray] = ACTIONS(268),
    [anon_sym_sampler2DArray] = ACTIONS(268),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(268),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(268),
    [anon_sym_samplerCubeArray] = ACTIONS(268),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(268),
    [anon_sym_isampler1D] = ACTIONS(268),
    [anon_sym_isampler2D] = ACTIONS(268),
    [anon_sym_isampler3D] = ACTIONS(268),
    [anon_sym_isamplerCube] = ACTIONS(268),
    [anon_sym_isampler1DArray] = ACTIONS(268),
    [anon_sym_isampler2DArray] = ACTIONS(268),
    [anon_sym_isamplerCubeArray] = ACTIONS(268),
    [anon_sym_usampler1D] = ACTIONS(268),
    [anon_sym_usampler2D] = ACTIONS(268),
    [anon_sym_usampler3D] = ACTIONS(268),
    [anon_sym_usamplerCube] = ACTIONS(268),
    [anon_sym_usampler1DArray] = ACTIONS(268),
    [anon_sym_usampler2DArray] = ACTIONS(268),
    [anon_sym_usamplerCubeArray] = ACTIONS(268),
    [anon_sym_sampler2DRect] = ACTIONS(268),
    [anon_sym_sampler2DRectshadow] = ACTIONS(268),
    [anon_sym_isampler2DRect] = ACTIONS(268),
    [anon_sym_usampler2DRect] = ACTIONS(268),
    [anon_sym_samplerBuffer] = ACTIONS(268),
    [anon_sym_isamplerBuffer] = ACTIONS(268),
    [anon_sym_usamplerBuffer] = ACTIONS(268),
    [anon_sym_sampler2DMS] = ACTIONS(268),
    [anon_sym_isampler2DMS] = ACTIONS(268),
    [anon_sym_usampler2DMS] = ACTIONS(268),
    [anon_sym_sampler2DMSArray] = ACTIONS(268),
    [anon_sym_isampler2DMSArray] = ACTIONS(268),
    [anon_sym_usampler2DMSArray] = ACTIONS(268),
    [anon_sym_image1D] = ACTIONS(268),
    [anon_sym_iimage1D] = ACTIONS(268),
    [anon_sym_uimage1D] = ACTIONS(268),
    [anon_sym_image2D] = ACTIONS(268),
    [anon_sym_iimage2D] = ACTIONS(268),
    [anon_sym_uimage2D] = ACTIONS(268),
    [anon_sym_image3D] = ACTIONS(268),
    [anon_sym_iimage3D] = ACTIONS(268),
    [anon_sym_uimage3D] = ACTIONS(268),
    [anon_sym_image2DRect] = ACTIONS(268),
    [anon_sym_iimage2DRect] = ACTIONS(268),
    [anon_sym_uimage2DRect] = ACTIONS(268),
    [anon_sym_imageCube] = ACTIONS(268),
    [anon_sym_iimageCube] = ACTIONS(268),
    [anon_sym_uimageCube] = ACTIONS(268),
    [anon_sym_imageBuffer] = ACTIONS(268),
    [anon_sym_iimageBuffer] = ACTIONS(268),
    [anon_sym_uimageBuffer] = ACTIONS(268),
    [anon_sym_image1DArray] = ACTIONS(268),
    [anon_sym_iimage1DArray] = ACTIONS(268),
    [anon_sym_uimage1DArray] = ACTIONS(268),
    [anon_sym_image2DArray] = ACTIONS(268),
    [anon_sym_iimage2DArray] = ACTIONS(268),
    [anon_sym_uimage2DArray] = ACTIONS(268),
    [anon_sym_imageCubeArray] = ACTIONS(268),
    [anon_sym_iimageCubeArray] = ACTIONS(268),
    [anon_sym_uimageCubeArray] = ACTIONS(268),
    [anon_sym_image2DMS] = ACTIONS(268),
    [anon_sym_iimage2DMS] = ACTIONS(268),
    [anon_sym_uimage2DMS] = ACTIONS(268),
    [anon_sym_image2DMSArray] = ACTIONS(268),
    [anon_sym_iimage2DMSArray] = ACTIONS(268),
    [anon_sym_uimage2DMSArray] = ACTIONS(268),
    [anon_sym_const] = ACTIONS(271),
    [anon_sym_inout] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(271),
    [anon_sym_out] = ACTIONS(271),
    [anon_sym_centroid] = ACTIONS(271),
    [anon_sym_patch] = ACTIONS(271),
    [anon_sym_sample] = ACTIONS(271),
    [anon_sym_uniform] = ACTIONS(271),
    [anon_sym_buffer] = ACTIONS(271),
    [anon_sym_shared] = ACTIONS(271),
    [anon_sym_coherent] = ACTIONS(271),
    [anon_sym_volatile] = ACTIONS(271),
    [anon_sym_restrict] = ACTIONS(271),
    [anon_sym_readonly] = ACTIONS(271),
    [anon_sym_writeonly] = ACTIONS(271),
    [anon_sym_subroutine] = ACTIONS(274),
    [anon_sym_varying] = ACTIONS(271),
    [anon_sym_attribute] = ACTIONS(271),
    [anon_sym_layout] = ACTIONS(277),
    [anon_sym_highp] = ACTIONS(280),
    [anon_sym_mediump] = ACTIONS(280),
    [anon_sym_lowp] = ACTIONS(280),
    [anon_sym_smooth] = ACTIONS(283),
    [anon_sym_flat] = ACTIONS(283),
    [anon_sym_noperspective] = ACTIONS(283),
    [sym_invariant_qualifier] = ACTIONS(286),
    [sym_precise_qualifier] = ACTIONS(286),
    [sym_comment] = ACTIONS(25),
  },
  [42] = {
    [sym__external_declaration] = STATE(104),
    [sym_declaration] = STATE(105),
    [sym__init_declarator_list] = STATE(237),
    [sym_function_definition] = STATE(106),
    [sym_function_prototype] = STATE(62),
    [sym_function_declaration] = STATE(262),
    [sym_fully_specified_type] = STATE(196),
    [sym_type_specifier] = STATE(209),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(117),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_translation_unit_repeat1] = STATE(41),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(289),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_precision] = ACTIONS(7),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [43] = {
    [sym_function_parameter_list] = STATE(274),
    [sym_parameter_declaration] = STATE(216),
    [sym_parameter_declarator] = STATE(244),
    [sym_type_specifier] = STATE(197),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(116),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [44] = {
    [sym_type_specifier] = STATE(198),
    [sym_primitive_type] = STATE(190),
    [sym_struct_declaration_list] = STATE(251),
    [sym_struct_declaration] = STATE(48),
    [sym_type_qualifier_list] = STATE(119),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_struct_declaration_list_repeat1] = STATE(48),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [45] = {
    [sym_type_specifier] = STATE(198),
    [sym_primitive_type] = STATE(190),
    [sym_struct_declaration_list] = STATE(254),
    [sym_struct_declaration] = STATE(48),
    [sym_type_qualifier_list] = STATE(119),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_struct_declaration_list_repeat1] = STATE(48),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [46] = {
    [sym_type_specifier] = STATE(198),
    [sym_primitive_type] = STATE(190),
    [sym_struct_declaration] = STATE(46),
    [sym_type_qualifier_list] = STATE(119),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_struct_declaration_list_repeat1] = STATE(46),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(296),
    [anon_sym_struct] = ACTIONS(298),
    [anon_sym_void] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(301),
    [anon_sym_double] = ACTIONS(301),
    [anon_sym_int] = ACTIONS(301),
    [anon_sym_uint] = ACTIONS(301),
    [anon_sym_bool] = ACTIONS(301),
    [anon_sym_vec2] = ACTIONS(301),
    [anon_sym_vec3] = ACTIONS(301),
    [anon_sym_vec4] = ACTIONS(301),
    [anon_sym_dvec2] = ACTIONS(301),
    [anon_sym_dvec3] = ACTIONS(301),
    [anon_sym_dvec4] = ACTIONS(301),
    [anon_sym_bvec2] = ACTIONS(301),
    [anon_sym_bvec3] = ACTIONS(301),
    [anon_sym_bvec4] = ACTIONS(301),
    [anon_sym_ivec2] = ACTIONS(301),
    [anon_sym_ivec3] = ACTIONS(301),
    [anon_sym_ivec4] = ACTIONS(301),
    [anon_sym_uvec2] = ACTIONS(301),
    [anon_sym_uvec3] = ACTIONS(301),
    [anon_sym_uvec4] = ACTIONS(301),
    [anon_sym_mat2] = ACTIONS(301),
    [anon_sym_mat3] = ACTIONS(301),
    [anon_sym_mat4] = ACTIONS(301),
    [anon_sym_mat2x2] = ACTIONS(301),
    [anon_sym_mat2x3] = ACTIONS(301),
    [anon_sym_mat2x4] = ACTIONS(301),
    [anon_sym_mat3x2] = ACTIONS(301),
    [anon_sym_mat3x3] = ACTIONS(301),
    [anon_sym_mat3x4] = ACTIONS(301),
    [anon_sym_mat4x2] = ACTIONS(301),
    [anon_sym_mat4x3] = ACTIONS(301),
    [anon_sym_mat4x4] = ACTIONS(301),
    [anon_sym_dmat2] = ACTIONS(301),
    [anon_sym_dmat3] = ACTIONS(301),
    [anon_sym_dmat4] = ACTIONS(301),
    [anon_sym_dmat2x2] = ACTIONS(301),
    [anon_sym_dmat2x3] = ACTIONS(301),
    [anon_sym_dmat2x4] = ACTIONS(301),
    [anon_sym_dmat3x2] = ACTIONS(301),
    [anon_sym_dmat3x3] = ACTIONS(301),
    [anon_sym_dmat3x4] = ACTIONS(301),
    [anon_sym_dmat4x2] = ACTIONS(301),
    [anon_sym_dmat4x3] = ACTIONS(301),
    [anon_sym_dmat4x4] = ACTIONS(301),
    [anon_sym_atomic_uint] = ACTIONS(301),
    [anon_sym_sampler1d] = ACTIONS(301),
    [anon_sym_sampler2d] = ACTIONS(301),
    [anon_sym_sampler3d] = ACTIONS(301),
    [anon_sym_samplercube] = ACTIONS(301),
    [anon_sym_sampler1DShadow] = ACTIONS(301),
    [anon_sym_sampler2DShadow] = ACTIONS(301),
    [anon_sym_samplerCubeShadow] = ACTIONS(301),
    [anon_sym_sampler1DArray] = ACTIONS(301),
    [anon_sym_sampler2DArray] = ACTIONS(301),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(301),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(301),
    [anon_sym_samplerCubeArray] = ACTIONS(301),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(301),
    [anon_sym_isampler1D] = ACTIONS(301),
    [anon_sym_isampler2D] = ACTIONS(301),
    [anon_sym_isampler3D] = ACTIONS(301),
    [anon_sym_isamplerCube] = ACTIONS(301),
    [anon_sym_isampler1DArray] = ACTIONS(301),
    [anon_sym_isampler2DArray] = ACTIONS(301),
    [anon_sym_isamplerCubeArray] = ACTIONS(301),
    [anon_sym_usampler1D] = ACTIONS(301),
    [anon_sym_usampler2D] = ACTIONS(301),
    [anon_sym_usampler3D] = ACTIONS(301),
    [anon_sym_usamplerCube] = ACTIONS(301),
    [anon_sym_usampler1DArray] = ACTIONS(301),
    [anon_sym_usampler2DArray] = ACTIONS(301),
    [anon_sym_usamplerCubeArray] = ACTIONS(301),
    [anon_sym_sampler2DRect] = ACTIONS(301),
    [anon_sym_sampler2DRectshadow] = ACTIONS(301),
    [anon_sym_isampler2DRect] = ACTIONS(301),
    [anon_sym_usampler2DRect] = ACTIONS(301),
    [anon_sym_samplerBuffer] = ACTIONS(301),
    [anon_sym_isamplerBuffer] = ACTIONS(301),
    [anon_sym_usamplerBuffer] = ACTIONS(301),
    [anon_sym_sampler2DMS] = ACTIONS(301),
    [anon_sym_isampler2DMS] = ACTIONS(301),
    [anon_sym_usampler2DMS] = ACTIONS(301),
    [anon_sym_sampler2DMSArray] = ACTIONS(301),
    [anon_sym_isampler2DMSArray] = ACTIONS(301),
    [anon_sym_usampler2DMSArray] = ACTIONS(301),
    [anon_sym_image1D] = ACTIONS(301),
    [anon_sym_iimage1D] = ACTIONS(301),
    [anon_sym_uimage1D] = ACTIONS(301),
    [anon_sym_image2D] = ACTIONS(301),
    [anon_sym_iimage2D] = ACTIONS(301),
    [anon_sym_uimage2D] = ACTIONS(301),
    [anon_sym_image3D] = ACTIONS(301),
    [anon_sym_iimage3D] = ACTIONS(301),
    [anon_sym_uimage3D] = ACTIONS(301),
    [anon_sym_image2DRect] = ACTIONS(301),
    [anon_sym_iimage2DRect] = ACTIONS(301),
    [anon_sym_uimage2DRect] = ACTIONS(301),
    [anon_sym_imageCube] = ACTIONS(301),
    [anon_sym_iimageCube] = ACTIONS(301),
    [anon_sym_uimageCube] = ACTIONS(301),
    [anon_sym_imageBuffer] = ACTIONS(301),
    [anon_sym_iimageBuffer] = ACTIONS(301),
    [anon_sym_uimageBuffer] = ACTIONS(301),
    [anon_sym_image1DArray] = ACTIONS(301),
    [anon_sym_iimage1DArray] = ACTIONS(301),
    [anon_sym_uimage1DArray] = ACTIONS(301),
    [anon_sym_image2DArray] = ACTIONS(301),
    [anon_sym_iimage2DArray] = ACTIONS(301),
    [anon_sym_uimage2DArray] = ACTIONS(301),
    [anon_sym_imageCubeArray] = ACTIONS(301),
    [anon_sym_iimageCubeArray] = ACTIONS(301),
    [anon_sym_uimageCubeArray] = ACTIONS(301),
    [anon_sym_image2DMS] = ACTIONS(301),
    [anon_sym_iimage2DMS] = ACTIONS(301),
    [anon_sym_uimage2DMS] = ACTIONS(301),
    [anon_sym_image2DMSArray] = ACTIONS(301),
    [anon_sym_iimage2DMSArray] = ACTIONS(301),
    [anon_sym_uimage2DMSArray] = ACTIONS(301),
    [anon_sym_const] = ACTIONS(304),
    [anon_sym_inout] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_out] = ACTIONS(304),
    [anon_sym_centroid] = ACTIONS(304),
    [anon_sym_patch] = ACTIONS(304),
    [anon_sym_sample] = ACTIONS(304),
    [anon_sym_uniform] = ACTIONS(304),
    [anon_sym_buffer] = ACTIONS(304),
    [anon_sym_shared] = ACTIONS(304),
    [anon_sym_coherent] = ACTIONS(304),
    [anon_sym_volatile] = ACTIONS(304),
    [anon_sym_restrict] = ACTIONS(304),
    [anon_sym_readonly] = ACTIONS(304),
    [anon_sym_writeonly] = ACTIONS(304),
    [anon_sym_subroutine] = ACTIONS(307),
    [anon_sym_varying] = ACTIONS(304),
    [anon_sym_attribute] = ACTIONS(304),
    [anon_sym_layout] = ACTIONS(310),
    [anon_sym_highp] = ACTIONS(313),
    [anon_sym_mediump] = ACTIONS(313),
    [anon_sym_lowp] = ACTIONS(313),
    [anon_sym_smooth] = ACTIONS(316),
    [anon_sym_flat] = ACTIONS(316),
    [anon_sym_noperspective] = ACTIONS(316),
    [sym_invariant_qualifier] = ACTIONS(319),
    [sym_precise_qualifier] = ACTIONS(319),
    [sym_comment] = ACTIONS(25),
  },
  [47] = {
    [sym_type_specifier] = STATE(198),
    [sym_primitive_type] = STATE(190),
    [sym_struct_declaration_list] = STATE(268),
    [sym_struct_declaration] = STATE(48),
    [sym_type_qualifier_list] = STATE(119),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_struct_declaration_list_repeat1] = STATE(48),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [48] = {
    [sym_type_specifier] = STATE(198),
    [sym_primitive_type] = STATE(190),
    [sym_struct_declaration] = STATE(46),
    [sym_type_qualifier_list] = STATE(119),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_struct_declaration_list_repeat1] = STATE(46),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_RBRACE] = ACTIONS(322),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [49] = {
    [sym_parameter_declaration] = STATE(245),
    [sym_parameter_declarator] = STATE(244),
    [sym_type_specifier] = STATE(197),
    [sym_primitive_type] = STATE(190),
    [sym_type_qualifier_list] = STATE(116),
    [sym_type_qualifier] = STATE(52),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_type_qualifier_list_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [50] = {
    [sym__initializer] = STATE(233),
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(164),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym__expression] = STATE(164),
    [sym__constant_expression] = STATE(164),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(324),
    [anon_sym_RBRACE] = ACTIONS(326),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [51] = {
    [sym_type_qualifier] = STATE(51),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_type_qualifier_list_repeat1] = STATE(51),
    [sym_identifier] = ACTIONS(328),
    [anon_sym_SEMI] = ACTIONS(330),
    [anon_sym_struct] = ACTIONS(328),
    [anon_sym_void] = ACTIONS(328),
    [anon_sym_float] = ACTIONS(328),
    [anon_sym_double] = ACTIONS(328),
    [anon_sym_int] = ACTIONS(328),
    [anon_sym_uint] = ACTIONS(328),
    [anon_sym_bool] = ACTIONS(328),
    [anon_sym_vec2] = ACTIONS(328),
    [anon_sym_vec3] = ACTIONS(328),
    [anon_sym_vec4] = ACTIONS(328),
    [anon_sym_dvec2] = ACTIONS(328),
    [anon_sym_dvec3] = ACTIONS(328),
    [anon_sym_dvec4] = ACTIONS(328),
    [anon_sym_bvec2] = ACTIONS(328),
    [anon_sym_bvec3] = ACTIONS(328),
    [anon_sym_bvec4] = ACTIONS(328),
    [anon_sym_ivec2] = ACTIONS(328),
    [anon_sym_ivec3] = ACTIONS(328),
    [anon_sym_ivec4] = ACTIONS(328),
    [anon_sym_uvec2] = ACTIONS(328),
    [anon_sym_uvec3] = ACTIONS(328),
    [anon_sym_uvec4] = ACTIONS(328),
    [anon_sym_mat2] = ACTIONS(328),
    [anon_sym_mat3] = ACTIONS(328),
    [anon_sym_mat4] = ACTIONS(328),
    [anon_sym_mat2x2] = ACTIONS(328),
    [anon_sym_mat2x3] = ACTIONS(328),
    [anon_sym_mat2x4] = ACTIONS(328),
    [anon_sym_mat3x2] = ACTIONS(328),
    [anon_sym_mat3x3] = ACTIONS(328),
    [anon_sym_mat3x4] = ACTIONS(328),
    [anon_sym_mat4x2] = ACTIONS(328),
    [anon_sym_mat4x3] = ACTIONS(328),
    [anon_sym_mat4x4] = ACTIONS(328),
    [anon_sym_dmat2] = ACTIONS(328),
    [anon_sym_dmat3] = ACTIONS(328),
    [anon_sym_dmat4] = ACTIONS(328),
    [anon_sym_dmat2x2] = ACTIONS(328),
    [anon_sym_dmat2x3] = ACTIONS(328),
    [anon_sym_dmat2x4] = ACTIONS(328),
    [anon_sym_dmat3x2] = ACTIONS(328),
    [anon_sym_dmat3x3] = ACTIONS(328),
    [anon_sym_dmat3x4] = ACTIONS(328),
    [anon_sym_dmat4x2] = ACTIONS(328),
    [anon_sym_dmat4x3] = ACTIONS(328),
    [anon_sym_dmat4x4] = ACTIONS(328),
    [anon_sym_atomic_uint] = ACTIONS(328),
    [anon_sym_sampler1d] = ACTIONS(328),
    [anon_sym_sampler2d] = ACTIONS(328),
    [anon_sym_sampler3d] = ACTIONS(328),
    [anon_sym_samplercube] = ACTIONS(328),
    [anon_sym_sampler1DShadow] = ACTIONS(328),
    [anon_sym_sampler2DShadow] = ACTIONS(328),
    [anon_sym_samplerCubeShadow] = ACTIONS(328),
    [anon_sym_sampler1DArray] = ACTIONS(328),
    [anon_sym_sampler2DArray] = ACTIONS(328),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(328),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(328),
    [anon_sym_samplerCubeArray] = ACTIONS(328),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(328),
    [anon_sym_isampler1D] = ACTIONS(328),
    [anon_sym_isampler2D] = ACTIONS(328),
    [anon_sym_isampler3D] = ACTIONS(328),
    [anon_sym_isamplerCube] = ACTIONS(328),
    [anon_sym_isampler1DArray] = ACTIONS(328),
    [anon_sym_isampler2DArray] = ACTIONS(328),
    [anon_sym_isamplerCubeArray] = ACTIONS(328),
    [anon_sym_usampler1D] = ACTIONS(328),
    [anon_sym_usampler2D] = ACTIONS(328),
    [anon_sym_usampler3D] = ACTIONS(328),
    [anon_sym_usamplerCube] = ACTIONS(328),
    [anon_sym_usampler1DArray] = ACTIONS(328),
    [anon_sym_usampler2DArray] = ACTIONS(328),
    [anon_sym_usamplerCubeArray] = ACTIONS(328),
    [anon_sym_sampler2DRect] = ACTIONS(328),
    [anon_sym_sampler2DRectshadow] = ACTIONS(328),
    [anon_sym_isampler2DRect] = ACTIONS(328),
    [anon_sym_usampler2DRect] = ACTIONS(328),
    [anon_sym_samplerBuffer] = ACTIONS(328),
    [anon_sym_isamplerBuffer] = ACTIONS(328),
    [anon_sym_usamplerBuffer] = ACTIONS(328),
    [anon_sym_sampler2DMS] = ACTIONS(328),
    [anon_sym_isampler2DMS] = ACTIONS(328),
    [anon_sym_usampler2DMS] = ACTIONS(328),
    [anon_sym_sampler2DMSArray] = ACTIONS(328),
    [anon_sym_isampler2DMSArray] = ACTIONS(328),
    [anon_sym_usampler2DMSArray] = ACTIONS(328),
    [anon_sym_image1D] = ACTIONS(328),
    [anon_sym_iimage1D] = ACTIONS(328),
    [anon_sym_uimage1D] = ACTIONS(328),
    [anon_sym_image2D] = ACTIONS(328),
    [anon_sym_iimage2D] = ACTIONS(328),
    [anon_sym_uimage2D] = ACTIONS(328),
    [anon_sym_image3D] = ACTIONS(328),
    [anon_sym_iimage3D] = ACTIONS(328),
    [anon_sym_uimage3D] = ACTIONS(328),
    [anon_sym_image2DRect] = ACTIONS(328),
    [anon_sym_iimage2DRect] = ACTIONS(328),
    [anon_sym_uimage2DRect] = ACTIONS(328),
    [anon_sym_imageCube] = ACTIONS(328),
    [anon_sym_iimageCube] = ACTIONS(328),
    [anon_sym_uimageCube] = ACTIONS(328),
    [anon_sym_imageBuffer] = ACTIONS(328),
    [anon_sym_iimageBuffer] = ACTIONS(328),
    [anon_sym_uimageBuffer] = ACTIONS(328),
    [anon_sym_image1DArray] = ACTIONS(328),
    [anon_sym_iimage1DArray] = ACTIONS(328),
    [anon_sym_uimage1DArray] = ACTIONS(328),
    [anon_sym_image2DArray] = ACTIONS(328),
    [anon_sym_iimage2DArray] = ACTIONS(328),
    [anon_sym_uimage2DArray] = ACTIONS(328),
    [anon_sym_imageCubeArray] = ACTIONS(328),
    [anon_sym_iimageCubeArray] = ACTIONS(328),
    [anon_sym_uimageCubeArray] = ACTIONS(328),
    [anon_sym_image2DMS] = ACTIONS(328),
    [anon_sym_iimage2DMS] = ACTIONS(328),
    [anon_sym_uimage2DMS] = ACTIONS(328),
    [anon_sym_image2DMSArray] = ACTIONS(328),
    [anon_sym_iimage2DMSArray] = ACTIONS(328),
    [anon_sym_uimage2DMSArray] = ACTIONS(328),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_inout] = ACTIONS(332),
    [anon_sym_in] = ACTIONS(332),
    [anon_sym_out] = ACTIONS(332),
    [anon_sym_centroid] = ACTIONS(332),
    [anon_sym_patch] = ACTIONS(332),
    [anon_sym_sample] = ACTIONS(332),
    [anon_sym_uniform] = ACTIONS(332),
    [anon_sym_buffer] = ACTIONS(332),
    [anon_sym_shared] = ACTIONS(332),
    [anon_sym_coherent] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym_readonly] = ACTIONS(332),
    [anon_sym_writeonly] = ACTIONS(332),
    [anon_sym_subroutine] = ACTIONS(335),
    [anon_sym_varying] = ACTIONS(332),
    [anon_sym_attribute] = ACTIONS(332),
    [anon_sym_layout] = ACTIONS(338),
    [anon_sym_highp] = ACTIONS(341),
    [anon_sym_mediump] = ACTIONS(341),
    [anon_sym_lowp] = ACTIONS(341),
    [anon_sym_smooth] = ACTIONS(344),
    [anon_sym_flat] = ACTIONS(344),
    [anon_sym_noperspective] = ACTIONS(344),
    [sym_invariant_qualifier] = ACTIONS(347),
    [sym_precise_qualifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(25),
  },
  [52] = {
    [sym_type_qualifier] = STATE(51),
    [sym_storage_qualifier] = STATE(112),
    [sym_layout_qualifier] = STATE(112),
    [sym_precision_qualifier] = STATE(112),
    [sym_interpolation_qualifier] = STATE(112),
    [aux_sym_type_qualifier_list_repeat1] = STATE(51),
    [sym_identifier] = ACTIONS(350),
    [anon_sym_SEMI] = ACTIONS(352),
    [anon_sym_struct] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_float] = ACTIONS(350),
    [anon_sym_double] = ACTIONS(350),
    [anon_sym_int] = ACTIONS(350),
    [anon_sym_uint] = ACTIONS(350),
    [anon_sym_bool] = ACTIONS(350),
    [anon_sym_vec2] = ACTIONS(350),
    [anon_sym_vec3] = ACTIONS(350),
    [anon_sym_vec4] = ACTIONS(350),
    [anon_sym_dvec2] = ACTIONS(350),
    [anon_sym_dvec3] = ACTIONS(350),
    [anon_sym_dvec4] = ACTIONS(350),
    [anon_sym_bvec2] = ACTIONS(350),
    [anon_sym_bvec3] = ACTIONS(350),
    [anon_sym_bvec4] = ACTIONS(350),
    [anon_sym_ivec2] = ACTIONS(350),
    [anon_sym_ivec3] = ACTIONS(350),
    [anon_sym_ivec4] = ACTIONS(350),
    [anon_sym_uvec2] = ACTIONS(350),
    [anon_sym_uvec3] = ACTIONS(350),
    [anon_sym_uvec4] = ACTIONS(350),
    [anon_sym_mat2] = ACTIONS(350),
    [anon_sym_mat3] = ACTIONS(350),
    [anon_sym_mat4] = ACTIONS(350),
    [anon_sym_mat2x2] = ACTIONS(350),
    [anon_sym_mat2x3] = ACTIONS(350),
    [anon_sym_mat2x4] = ACTIONS(350),
    [anon_sym_mat3x2] = ACTIONS(350),
    [anon_sym_mat3x3] = ACTIONS(350),
    [anon_sym_mat3x4] = ACTIONS(350),
    [anon_sym_mat4x2] = ACTIONS(350),
    [anon_sym_mat4x3] = ACTIONS(350),
    [anon_sym_mat4x4] = ACTIONS(350),
    [anon_sym_dmat2] = ACTIONS(350),
    [anon_sym_dmat3] = ACTIONS(350),
    [anon_sym_dmat4] = ACTIONS(350),
    [anon_sym_dmat2x2] = ACTIONS(350),
    [anon_sym_dmat2x3] = ACTIONS(350),
    [anon_sym_dmat2x4] = ACTIONS(350),
    [anon_sym_dmat3x2] = ACTIONS(350),
    [anon_sym_dmat3x3] = ACTIONS(350),
    [anon_sym_dmat3x4] = ACTIONS(350),
    [anon_sym_dmat4x2] = ACTIONS(350),
    [anon_sym_dmat4x3] = ACTIONS(350),
    [anon_sym_dmat4x4] = ACTIONS(350),
    [anon_sym_atomic_uint] = ACTIONS(350),
    [anon_sym_sampler1d] = ACTIONS(350),
    [anon_sym_sampler2d] = ACTIONS(350),
    [anon_sym_sampler3d] = ACTIONS(350),
    [anon_sym_samplercube] = ACTIONS(350),
    [anon_sym_sampler1DShadow] = ACTIONS(350),
    [anon_sym_sampler2DShadow] = ACTIONS(350),
    [anon_sym_samplerCubeShadow] = ACTIONS(350),
    [anon_sym_sampler1DArray] = ACTIONS(350),
    [anon_sym_sampler2DArray] = ACTIONS(350),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(350),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(350),
    [anon_sym_samplerCubeArray] = ACTIONS(350),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(350),
    [anon_sym_isampler1D] = ACTIONS(350),
    [anon_sym_isampler2D] = ACTIONS(350),
    [anon_sym_isampler3D] = ACTIONS(350),
    [anon_sym_isamplerCube] = ACTIONS(350),
    [anon_sym_isampler1DArray] = ACTIONS(350),
    [anon_sym_isampler2DArray] = ACTIONS(350),
    [anon_sym_isamplerCubeArray] = ACTIONS(350),
    [anon_sym_usampler1D] = ACTIONS(350),
    [anon_sym_usampler2D] = ACTIONS(350),
    [anon_sym_usampler3D] = ACTIONS(350),
    [anon_sym_usamplerCube] = ACTIONS(350),
    [anon_sym_usampler1DArray] = ACTIONS(350),
    [anon_sym_usampler2DArray] = ACTIONS(350),
    [anon_sym_usamplerCubeArray] = ACTIONS(350),
    [anon_sym_sampler2DRect] = ACTIONS(350),
    [anon_sym_sampler2DRectshadow] = ACTIONS(350),
    [anon_sym_isampler2DRect] = ACTIONS(350),
    [anon_sym_usampler2DRect] = ACTIONS(350),
    [anon_sym_samplerBuffer] = ACTIONS(350),
    [anon_sym_isamplerBuffer] = ACTIONS(350),
    [anon_sym_usamplerBuffer] = ACTIONS(350),
    [anon_sym_sampler2DMS] = ACTIONS(350),
    [anon_sym_isampler2DMS] = ACTIONS(350),
    [anon_sym_usampler2DMS] = ACTIONS(350),
    [anon_sym_sampler2DMSArray] = ACTIONS(350),
    [anon_sym_isampler2DMSArray] = ACTIONS(350),
    [anon_sym_usampler2DMSArray] = ACTIONS(350),
    [anon_sym_image1D] = ACTIONS(350),
    [anon_sym_iimage1D] = ACTIONS(350),
    [anon_sym_uimage1D] = ACTIONS(350),
    [anon_sym_image2D] = ACTIONS(350),
    [anon_sym_iimage2D] = ACTIONS(350),
    [anon_sym_uimage2D] = ACTIONS(350),
    [anon_sym_image3D] = ACTIONS(350),
    [anon_sym_iimage3D] = ACTIONS(350),
    [anon_sym_uimage3D] = ACTIONS(350),
    [anon_sym_image2DRect] = ACTIONS(350),
    [anon_sym_iimage2DRect] = ACTIONS(350),
    [anon_sym_uimage2DRect] = ACTIONS(350),
    [anon_sym_imageCube] = ACTIONS(350),
    [anon_sym_iimageCube] = ACTIONS(350),
    [anon_sym_uimageCube] = ACTIONS(350),
    [anon_sym_imageBuffer] = ACTIONS(350),
    [anon_sym_iimageBuffer] = ACTIONS(350),
    [anon_sym_uimageBuffer] = ACTIONS(350),
    [anon_sym_image1DArray] = ACTIONS(350),
    [anon_sym_iimage1DArray] = ACTIONS(350),
    [anon_sym_uimage1DArray] = ACTIONS(350),
    [anon_sym_image2DArray] = ACTIONS(350),
    [anon_sym_iimage2DArray] = ACTIONS(350),
    [anon_sym_uimage2DArray] = ACTIONS(350),
    [anon_sym_imageCubeArray] = ACTIONS(350),
    [anon_sym_iimageCubeArray] = ACTIONS(350),
    [anon_sym_uimageCubeArray] = ACTIONS(350),
    [anon_sym_image2DMS] = ACTIONS(350),
    [anon_sym_iimage2DMS] = ACTIONS(350),
    [anon_sym_uimage2DMS] = ACTIONS(350),
    [anon_sym_image2DMSArray] = ACTIONS(350),
    [anon_sym_iimage2DMSArray] = ACTIONS(350),
    [anon_sym_uimage2DMSArray] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(13),
    [anon_sym_inout] = ACTIONS(13),
    [anon_sym_in] = ACTIONS(13),
    [anon_sym_out] = ACTIONS(13),
    [anon_sym_centroid] = ACTIONS(13),
    [anon_sym_patch] = ACTIONS(13),
    [anon_sym_sample] = ACTIONS(13),
    [anon_sym_uniform] = ACTIONS(13),
    [anon_sym_buffer] = ACTIONS(13),
    [anon_sym_shared] = ACTIONS(13),
    [anon_sym_coherent] = ACTIONS(13),
    [anon_sym_volatile] = ACTIONS(13),
    [anon_sym_restrict] = ACTIONS(13),
    [anon_sym_readonly] = ACTIONS(13),
    [anon_sym_writeonly] = ACTIONS(13),
    [anon_sym_subroutine] = ACTIONS(15),
    [anon_sym_varying] = ACTIONS(13),
    [anon_sym_attribute] = ACTIONS(13),
    [anon_sym_layout] = ACTIONS(17),
    [anon_sym_highp] = ACTIONS(19),
    [anon_sym_mediump] = ACTIONS(19),
    [anon_sym_lowp] = ACTIONS(19),
    [anon_sym_smooth] = ACTIONS(21),
    [anon_sym_flat] = ACTIONS(21),
    [anon_sym_noperspective] = ACTIONS(21),
    [sym_invariant_qualifier] = ACTIONS(23),
    [sym_precise_qualifier] = ACTIONS(23),
    [sym_comment] = ACTIONS(25),
  },
  [53] = {
    [sym__initializer] = STATE(233),
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(164),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym__expression] = STATE(164),
    [sym__constant_expression] = STATE(164),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(324),
    [anon_sym_RBRACE] = ACTIONS(354),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [54] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(169),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(169),
    [sym_function_call_parameter_list] = STATE(255),
    [sym_assignment_expression] = STATE(169),
    [sym_conditional_expression] = STATE(169),
    [sym__expression] = STATE(169),
    [sym__constant_expression] = STATE(169),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(356),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(358),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [55] = {
    [sym__initializer] = STATE(242),
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(164),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym__expression] = STATE(164),
    [sym__constant_expression] = STATE(164),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [56] = {
    [sym__initializer] = STATE(232),
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(164),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym__expression] = STATE(164),
    [sym__constant_expression] = STATE(164),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [57] = {
    [sym__initializer] = STATE(240),
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(163),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(163),
    [sym_assignment_expression] = STATE(163),
    [sym_conditional_expression] = STATE(163),
    [sym__expression] = STATE(163),
    [sym__constant_expression] = STATE(163),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [58] = {
    [sym__initializer] = STATE(233),
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(164),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym__expression] = STATE(164),
    [sym__constant_expression] = STATE(164),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [59] = {
    [sym__initializer] = STATE(234),
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(164),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym__expression] = STATE(164),
    [sym__constant_expression] = STATE(164),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [60] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(172),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(172),
    [sym_assignment_expression] = STATE(172),
    [sym_conditional_expression] = STATE(172),
    [sym__expression] = STATE(172),
    [sym__constant_expression] = STATE(172),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(360),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [61] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(178),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(178),
    [sym_assignment_expression] = STATE(178),
    [sym_conditional_expression] = STATE(178),
    [sym__expression] = STATE(178),
    [sym__constant_expression] = STATE(178),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(362),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [62] = {
    [sym_compound_statement] = STATE(103),
    [ts_builtin_sym_end] = ACTIONS(364),
    [sym_identifier] = ACTIONS(366),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym_precision] = ACTIONS(366),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(366),
    [anon_sym_void] = ACTIONS(366),
    [anon_sym_float] = ACTIONS(366),
    [anon_sym_double] = ACTIONS(366),
    [anon_sym_int] = ACTIONS(366),
    [anon_sym_uint] = ACTIONS(366),
    [anon_sym_bool] = ACTIONS(366),
    [anon_sym_vec2] = ACTIONS(366),
    [anon_sym_vec3] = ACTIONS(366),
    [anon_sym_vec4] = ACTIONS(366),
    [anon_sym_dvec2] = ACTIONS(366),
    [anon_sym_dvec3] = ACTIONS(366),
    [anon_sym_dvec4] = ACTIONS(366),
    [anon_sym_bvec2] = ACTIONS(366),
    [anon_sym_bvec3] = ACTIONS(366),
    [anon_sym_bvec4] = ACTIONS(366),
    [anon_sym_ivec2] = ACTIONS(366),
    [anon_sym_ivec3] = ACTIONS(366),
    [anon_sym_ivec4] = ACTIONS(366),
    [anon_sym_uvec2] = ACTIONS(366),
    [anon_sym_uvec3] = ACTIONS(366),
    [anon_sym_uvec4] = ACTIONS(366),
    [anon_sym_mat2] = ACTIONS(366),
    [anon_sym_mat3] = ACTIONS(366),
    [anon_sym_mat4] = ACTIONS(366),
    [anon_sym_mat2x2] = ACTIONS(366),
    [anon_sym_mat2x3] = ACTIONS(366),
    [anon_sym_mat2x4] = ACTIONS(366),
    [anon_sym_mat3x2] = ACTIONS(366),
    [anon_sym_mat3x3] = ACTIONS(366),
    [anon_sym_mat3x4] = ACTIONS(366),
    [anon_sym_mat4x2] = ACTIONS(366),
    [anon_sym_mat4x3] = ACTIONS(366),
    [anon_sym_mat4x4] = ACTIONS(366),
    [anon_sym_dmat2] = ACTIONS(366),
    [anon_sym_dmat3] = ACTIONS(366),
    [anon_sym_dmat4] = ACTIONS(366),
    [anon_sym_dmat2x2] = ACTIONS(366),
    [anon_sym_dmat2x3] = ACTIONS(366),
    [anon_sym_dmat2x4] = ACTIONS(366),
    [anon_sym_dmat3x2] = ACTIONS(366),
    [anon_sym_dmat3x3] = ACTIONS(366),
    [anon_sym_dmat3x4] = ACTIONS(366),
    [anon_sym_dmat4x2] = ACTIONS(366),
    [anon_sym_dmat4x3] = ACTIONS(366),
    [anon_sym_dmat4x4] = ACTIONS(366),
    [anon_sym_atomic_uint] = ACTIONS(366),
    [anon_sym_sampler1d] = ACTIONS(366),
    [anon_sym_sampler2d] = ACTIONS(366),
    [anon_sym_sampler3d] = ACTIONS(366),
    [anon_sym_samplercube] = ACTIONS(366),
    [anon_sym_sampler1DShadow] = ACTIONS(366),
    [anon_sym_sampler2DShadow] = ACTIONS(366),
    [anon_sym_samplerCubeShadow] = ACTIONS(366),
    [anon_sym_sampler1DArray] = ACTIONS(366),
    [anon_sym_sampler2DArray] = ACTIONS(366),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(366),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(366),
    [anon_sym_samplerCubeArray] = ACTIONS(366),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(366),
    [anon_sym_isampler1D] = ACTIONS(366),
    [anon_sym_isampler2D] = ACTIONS(366),
    [anon_sym_isampler3D] = ACTIONS(366),
    [anon_sym_isamplerCube] = ACTIONS(366),
    [anon_sym_isampler1DArray] = ACTIONS(366),
    [anon_sym_isampler2DArray] = ACTIONS(366),
    [anon_sym_isamplerCubeArray] = ACTIONS(366),
    [anon_sym_usampler1D] = ACTIONS(366),
    [anon_sym_usampler2D] = ACTIONS(366),
    [anon_sym_usampler3D] = ACTIONS(366),
    [anon_sym_usamplerCube] = ACTIONS(366),
    [anon_sym_usampler1DArray] = ACTIONS(366),
    [anon_sym_usampler2DArray] = ACTIONS(366),
    [anon_sym_usamplerCubeArray] = ACTIONS(366),
    [anon_sym_sampler2DRect] = ACTIONS(366),
    [anon_sym_sampler2DRectshadow] = ACTIONS(366),
    [anon_sym_isampler2DRect] = ACTIONS(366),
    [anon_sym_usampler2DRect] = ACTIONS(366),
    [anon_sym_samplerBuffer] = ACTIONS(366),
    [anon_sym_isamplerBuffer] = ACTIONS(366),
    [anon_sym_usamplerBuffer] = ACTIONS(366),
    [anon_sym_sampler2DMS] = ACTIONS(366),
    [anon_sym_isampler2DMS] = ACTIONS(366),
    [anon_sym_usampler2DMS] = ACTIONS(366),
    [anon_sym_sampler2DMSArray] = ACTIONS(366),
    [anon_sym_isampler2DMSArray] = ACTIONS(366),
    [anon_sym_usampler2DMSArray] = ACTIONS(366),
    [anon_sym_image1D] = ACTIONS(366),
    [anon_sym_iimage1D] = ACTIONS(366),
    [anon_sym_uimage1D] = ACTIONS(366),
    [anon_sym_image2D] = ACTIONS(366),
    [anon_sym_iimage2D] = ACTIONS(366),
    [anon_sym_uimage2D] = ACTIONS(366),
    [anon_sym_image3D] = ACTIONS(366),
    [anon_sym_iimage3D] = ACTIONS(366),
    [anon_sym_uimage3D] = ACTIONS(366),
    [anon_sym_image2DRect] = ACTIONS(366),
    [anon_sym_iimage2DRect] = ACTIONS(366),
    [anon_sym_uimage2DRect] = ACTIONS(366),
    [anon_sym_imageCube] = ACTIONS(366),
    [anon_sym_iimageCube] = ACTIONS(366),
    [anon_sym_uimageCube] = ACTIONS(366),
    [anon_sym_imageBuffer] = ACTIONS(366),
    [anon_sym_iimageBuffer] = ACTIONS(366),
    [anon_sym_uimageBuffer] = ACTIONS(366),
    [anon_sym_image1DArray] = ACTIONS(366),
    [anon_sym_iimage1DArray] = ACTIONS(366),
    [anon_sym_uimage1DArray] = ACTIONS(366),
    [anon_sym_image2DArray] = ACTIONS(366),
    [anon_sym_iimage2DArray] = ACTIONS(366),
    [anon_sym_uimage2DArray] = ACTIONS(366),
    [anon_sym_imageCubeArray] = ACTIONS(366),
    [anon_sym_iimageCubeArray] = ACTIONS(366),
    [anon_sym_uimageCubeArray] = ACTIONS(366),
    [anon_sym_image2DMS] = ACTIONS(366),
    [anon_sym_iimage2DMS] = ACTIONS(366),
    [anon_sym_uimage2DMS] = ACTIONS(366),
    [anon_sym_image2DMSArray] = ACTIONS(366),
    [anon_sym_iimage2DMSArray] = ACTIONS(366),
    [anon_sym_uimage2DMSArray] = ACTIONS(366),
    [anon_sym_const] = ACTIONS(366),
    [anon_sym_inout] = ACTIONS(366),
    [anon_sym_in] = ACTIONS(366),
    [anon_sym_out] = ACTIONS(366),
    [anon_sym_centroid] = ACTIONS(366),
    [anon_sym_patch] = ACTIONS(366),
    [anon_sym_sample] = ACTIONS(366),
    [anon_sym_uniform] = ACTIONS(366),
    [anon_sym_buffer] = ACTIONS(366),
    [anon_sym_shared] = ACTIONS(366),
    [anon_sym_coherent] = ACTIONS(366),
    [anon_sym_volatile] = ACTIONS(366),
    [anon_sym_restrict] = ACTIONS(366),
    [anon_sym_readonly] = ACTIONS(366),
    [anon_sym_writeonly] = ACTIONS(366),
    [anon_sym_subroutine] = ACTIONS(366),
    [anon_sym_varying] = ACTIONS(366),
    [anon_sym_attribute] = ACTIONS(366),
    [anon_sym_layout] = ACTIONS(366),
    [anon_sym_highp] = ACTIONS(366),
    [anon_sym_mediump] = ACTIONS(366),
    [anon_sym_lowp] = ACTIONS(366),
    [anon_sym_smooth] = ACTIONS(366),
    [anon_sym_flat] = ACTIONS(366),
    [anon_sym_noperspective] = ACTIONS(366),
    [sym_invariant_qualifier] = ACTIONS(366),
    [sym_precise_qualifier] = ACTIONS(366),
    [sym_comment] = ACTIONS(25),
  },
  [63] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(168),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(168),
    [sym_assignment_expression] = STATE(168),
    [sym_conditional_expression] = STATE(168),
    [sym__expression] = STATE(168),
    [sym__constant_expression] = STATE(168),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(370),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [64] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(123),
    [sym_unary_expression] = STATE(123),
    [sym_update_expression] = STATE(123),
    [sym_parenthesized_expression] = STATE(123),
    [sym_subscript_expression] = STATE(123),
    [sym_field_expression] = STATE(123),
    [sym_call_expression] = STATE(123),
    [sym_comma_expression] = STATE(123),
    [sym_assignment_expression] = STATE(123),
    [sym_conditional_expression] = STATE(123),
    [sym__expression] = STATE(123),
    [sym__constant_expression] = STATE(123),
    [sym__assignment_left_expression] = STATE(123),
    [sym_number_literal] = STATE(123),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(372),
    [anon_sym_false] = ACTIONS(372),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [65] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(176),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(176),
    [sym_assignment_expression] = STATE(176),
    [sym_conditional_expression] = STATE(176),
    [sym__expression] = STATE(176),
    [sym__constant_expression] = STATE(176),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [66] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(155),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(155),
    [sym_assignment_expression] = STATE(155),
    [sym_conditional_expression] = STATE(155),
    [sym__expression] = STATE(155),
    [sym__constant_expression] = STATE(155),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [67] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(174),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(174),
    [sym_assignment_expression] = STATE(174),
    [sym_conditional_expression] = STATE(174),
    [sym__expression] = STATE(174),
    [sym__constant_expression] = STATE(174),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [68] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(137),
    [sym_unary_expression] = STATE(137),
    [sym_update_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_comma_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_conditional_expression] = STATE(137),
    [sym__expression] = STATE(137),
    [sym__constant_expression] = STATE(137),
    [sym__assignment_left_expression] = STATE(137),
    [sym_number_literal] = STATE(137),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(374),
    [anon_sym_false] = ACTIONS(374),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [69] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(156),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(156),
    [sym_assignment_expression] = STATE(156),
    [sym_conditional_expression] = STATE(156),
    [sym__expression] = STATE(156),
    [sym__constant_expression] = STATE(156),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [70] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(157),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(157),
    [sym_assignment_expression] = STATE(157),
    [sym_conditional_expression] = STATE(157),
    [sym__expression] = STATE(157),
    [sym__constant_expression] = STATE(157),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [71] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(150),
    [sym_assignment_expression] = STATE(150),
    [sym_conditional_expression] = STATE(150),
    [sym__expression] = STATE(150),
    [sym__constant_expression] = STATE(150),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [72] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(158),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(158),
    [sym_assignment_expression] = STATE(158),
    [sym_conditional_expression] = STATE(158),
    [sym__expression] = STATE(158),
    [sym__constant_expression] = STATE(158),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [73] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(136),
    [sym_unary_expression] = STATE(136),
    [sym_update_expression] = STATE(136),
    [sym_parenthesized_expression] = STATE(136),
    [sym_subscript_expression] = STATE(136),
    [sym_field_expression] = STATE(136),
    [sym_call_expression] = STATE(136),
    [sym_comma_expression] = STATE(136),
    [sym_assignment_expression] = STATE(136),
    [sym_conditional_expression] = STATE(136),
    [sym__expression] = STATE(136),
    [sym__constant_expression] = STATE(136),
    [sym__assignment_left_expression] = STATE(136),
    [sym_number_literal] = STATE(136),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(376),
    [anon_sym_false] = ACTIONS(376),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [74] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(159),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(159),
    [sym_assignment_expression] = STATE(159),
    [sym_conditional_expression] = STATE(159),
    [sym__expression] = STATE(159),
    [sym__constant_expression] = STATE(159),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [75] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(175),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(175),
    [sym_assignment_expression] = STATE(175),
    [sym_conditional_expression] = STATE(175),
    [sym__expression] = STATE(175),
    [sym__constant_expression] = STATE(175),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [76] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(133),
    [sym_unary_expression] = STATE(133),
    [sym_update_expression] = STATE(133),
    [sym_parenthesized_expression] = STATE(133),
    [sym_subscript_expression] = STATE(133),
    [sym_field_expression] = STATE(133),
    [sym_call_expression] = STATE(133),
    [sym_comma_expression] = STATE(133),
    [sym_assignment_expression] = STATE(133),
    [sym_conditional_expression] = STATE(133),
    [sym__expression] = STATE(133),
    [sym__constant_expression] = STATE(133),
    [sym__assignment_left_expression] = STATE(133),
    [sym_number_literal] = STATE(133),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(378),
    [anon_sym_false] = ACTIONS(378),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(380),
    [sym_identifier] = ACTIONS(382),
    [anon_sym_SEMI] = ACTIONS(380),
    [anon_sym_precision] = ACTIONS(382),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_struct] = ACTIONS(382),
    [anon_sym_void] = ACTIONS(382),
    [anon_sym_float] = ACTIONS(382),
    [anon_sym_double] = ACTIONS(382),
    [anon_sym_int] = ACTIONS(382),
    [anon_sym_uint] = ACTIONS(382),
    [anon_sym_bool] = ACTIONS(382),
    [anon_sym_vec2] = ACTIONS(382),
    [anon_sym_vec3] = ACTIONS(382),
    [anon_sym_vec4] = ACTIONS(382),
    [anon_sym_dvec2] = ACTIONS(382),
    [anon_sym_dvec3] = ACTIONS(382),
    [anon_sym_dvec4] = ACTIONS(382),
    [anon_sym_bvec2] = ACTIONS(382),
    [anon_sym_bvec3] = ACTIONS(382),
    [anon_sym_bvec4] = ACTIONS(382),
    [anon_sym_ivec2] = ACTIONS(382),
    [anon_sym_ivec3] = ACTIONS(382),
    [anon_sym_ivec4] = ACTIONS(382),
    [anon_sym_uvec2] = ACTIONS(382),
    [anon_sym_uvec3] = ACTIONS(382),
    [anon_sym_uvec4] = ACTIONS(382),
    [anon_sym_mat2] = ACTIONS(382),
    [anon_sym_mat3] = ACTIONS(382),
    [anon_sym_mat4] = ACTIONS(382),
    [anon_sym_mat2x2] = ACTIONS(382),
    [anon_sym_mat2x3] = ACTIONS(382),
    [anon_sym_mat2x4] = ACTIONS(382),
    [anon_sym_mat3x2] = ACTIONS(382),
    [anon_sym_mat3x3] = ACTIONS(382),
    [anon_sym_mat3x4] = ACTIONS(382),
    [anon_sym_mat4x2] = ACTIONS(382),
    [anon_sym_mat4x3] = ACTIONS(382),
    [anon_sym_mat4x4] = ACTIONS(382),
    [anon_sym_dmat2] = ACTIONS(382),
    [anon_sym_dmat3] = ACTIONS(382),
    [anon_sym_dmat4] = ACTIONS(382),
    [anon_sym_dmat2x2] = ACTIONS(382),
    [anon_sym_dmat2x3] = ACTIONS(382),
    [anon_sym_dmat2x4] = ACTIONS(382),
    [anon_sym_dmat3x2] = ACTIONS(382),
    [anon_sym_dmat3x3] = ACTIONS(382),
    [anon_sym_dmat3x4] = ACTIONS(382),
    [anon_sym_dmat4x2] = ACTIONS(382),
    [anon_sym_dmat4x3] = ACTIONS(382),
    [anon_sym_dmat4x4] = ACTIONS(382),
    [anon_sym_atomic_uint] = ACTIONS(382),
    [anon_sym_sampler1d] = ACTIONS(382),
    [anon_sym_sampler2d] = ACTIONS(382),
    [anon_sym_sampler3d] = ACTIONS(382),
    [anon_sym_samplercube] = ACTIONS(382),
    [anon_sym_sampler1DShadow] = ACTIONS(382),
    [anon_sym_sampler2DShadow] = ACTIONS(382),
    [anon_sym_samplerCubeShadow] = ACTIONS(382),
    [anon_sym_sampler1DArray] = ACTIONS(382),
    [anon_sym_sampler2DArray] = ACTIONS(382),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(382),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(382),
    [anon_sym_samplerCubeArray] = ACTIONS(382),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(382),
    [anon_sym_isampler1D] = ACTIONS(382),
    [anon_sym_isampler2D] = ACTIONS(382),
    [anon_sym_isampler3D] = ACTIONS(382),
    [anon_sym_isamplerCube] = ACTIONS(382),
    [anon_sym_isampler1DArray] = ACTIONS(382),
    [anon_sym_isampler2DArray] = ACTIONS(382),
    [anon_sym_isamplerCubeArray] = ACTIONS(382),
    [anon_sym_usampler1D] = ACTIONS(382),
    [anon_sym_usampler2D] = ACTIONS(382),
    [anon_sym_usampler3D] = ACTIONS(382),
    [anon_sym_usamplerCube] = ACTIONS(382),
    [anon_sym_usampler1DArray] = ACTIONS(382),
    [anon_sym_usampler2DArray] = ACTIONS(382),
    [anon_sym_usamplerCubeArray] = ACTIONS(382),
    [anon_sym_sampler2DRect] = ACTIONS(382),
    [anon_sym_sampler2DRectshadow] = ACTIONS(382),
    [anon_sym_isampler2DRect] = ACTIONS(382),
    [anon_sym_usampler2DRect] = ACTIONS(382),
    [anon_sym_samplerBuffer] = ACTIONS(382),
    [anon_sym_isamplerBuffer] = ACTIONS(382),
    [anon_sym_usamplerBuffer] = ACTIONS(382),
    [anon_sym_sampler2DMS] = ACTIONS(382),
    [anon_sym_isampler2DMS] = ACTIONS(382),
    [anon_sym_usampler2DMS] = ACTIONS(382),
    [anon_sym_sampler2DMSArray] = ACTIONS(382),
    [anon_sym_isampler2DMSArray] = ACTIONS(382),
    [anon_sym_usampler2DMSArray] = ACTIONS(382),
    [anon_sym_image1D] = ACTIONS(382),
    [anon_sym_iimage1D] = ACTIONS(382),
    [anon_sym_uimage1D] = ACTIONS(382),
    [anon_sym_image2D] = ACTIONS(382),
    [anon_sym_iimage2D] = ACTIONS(382),
    [anon_sym_uimage2D] = ACTIONS(382),
    [anon_sym_image3D] = ACTIONS(382),
    [anon_sym_iimage3D] = ACTIONS(382),
    [anon_sym_uimage3D] = ACTIONS(382),
    [anon_sym_image2DRect] = ACTIONS(382),
    [anon_sym_iimage2DRect] = ACTIONS(382),
    [anon_sym_uimage2DRect] = ACTIONS(382),
    [anon_sym_imageCube] = ACTIONS(382),
    [anon_sym_iimageCube] = ACTIONS(382),
    [anon_sym_uimageCube] = ACTIONS(382),
    [anon_sym_imageBuffer] = ACTIONS(382),
    [anon_sym_iimageBuffer] = ACTIONS(382),
    [anon_sym_uimageBuffer] = ACTIONS(382),
    [anon_sym_image1DArray] = ACTIONS(382),
    [anon_sym_iimage1DArray] = ACTIONS(382),
    [anon_sym_uimage1DArray] = ACTIONS(382),
    [anon_sym_image2DArray] = ACTIONS(382),
    [anon_sym_iimage2DArray] = ACTIONS(382),
    [anon_sym_uimage2DArray] = ACTIONS(382),
    [anon_sym_imageCubeArray] = ACTIONS(382),
    [anon_sym_iimageCubeArray] = ACTIONS(382),
    [anon_sym_uimageCubeArray] = ACTIONS(382),
    [anon_sym_image2DMS] = ACTIONS(382),
    [anon_sym_iimage2DMS] = ACTIONS(382),
    [anon_sym_uimage2DMS] = ACTIONS(382),
    [anon_sym_image2DMSArray] = ACTIONS(382),
    [anon_sym_iimage2DMSArray] = ACTIONS(382),
    [anon_sym_uimage2DMSArray] = ACTIONS(382),
    [anon_sym_const] = ACTIONS(382),
    [anon_sym_inout] = ACTIONS(382),
    [anon_sym_in] = ACTIONS(382),
    [anon_sym_out] = ACTIONS(382),
    [anon_sym_centroid] = ACTIONS(382),
    [anon_sym_patch] = ACTIONS(382),
    [anon_sym_sample] = ACTIONS(382),
    [anon_sym_uniform] = ACTIONS(382),
    [anon_sym_buffer] = ACTIONS(382),
    [anon_sym_shared] = ACTIONS(382),
    [anon_sym_coherent] = ACTIONS(382),
    [anon_sym_volatile] = ACTIONS(382),
    [anon_sym_restrict] = ACTIONS(382),
    [anon_sym_readonly] = ACTIONS(382),
    [anon_sym_writeonly] = ACTIONS(382),
    [anon_sym_subroutine] = ACTIONS(382),
    [anon_sym_varying] = ACTIONS(382),
    [anon_sym_attribute] = ACTIONS(382),
    [anon_sym_layout] = ACTIONS(382),
    [anon_sym_highp] = ACTIONS(382),
    [anon_sym_mediump] = ACTIONS(382),
    [anon_sym_lowp] = ACTIONS(382),
    [anon_sym_smooth] = ACTIONS(382),
    [anon_sym_flat] = ACTIONS(382),
    [anon_sym_noperspective] = ACTIONS(382),
    [sym_invariant_qualifier] = ACTIONS(382),
    [sym_precise_qualifier] = ACTIONS(382),
    [sym_comment] = ACTIONS(25),
  },
  [78] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(148),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(148),
    [sym_assignment_expression] = STATE(148),
    [sym_conditional_expression] = STATE(148),
    [sym__expression] = STATE(148),
    [sym__constant_expression] = STATE(148),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [79] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(160),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(160),
    [sym_assignment_expression] = STATE(160),
    [sym_conditional_expression] = STATE(160),
    [sym__expression] = STATE(160),
    [sym__constant_expression] = STATE(160),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [80] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(170),
    [sym_assignment_expression] = STATE(170),
    [sym_conditional_expression] = STATE(170),
    [sym__expression] = STATE(170),
    [sym__constant_expression] = STATE(170),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [81] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(161),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(161),
    [sym_assignment_expression] = STATE(161),
    [sym_conditional_expression] = STATE(161),
    [sym__expression] = STATE(161),
    [sym__constant_expression] = STATE(161),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [82] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(126),
    [sym_unary_expression] = STATE(126),
    [sym_update_expression] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_subscript_expression] = STATE(126),
    [sym_field_expression] = STATE(126),
    [sym_call_expression] = STATE(126),
    [sym_comma_expression] = STATE(126),
    [sym_assignment_expression] = STATE(126),
    [sym_conditional_expression] = STATE(126),
    [sym__expression] = STATE(126),
    [sym__constant_expression] = STATE(126),
    [sym__assignment_left_expression] = STATE(126),
    [sym_number_literal] = STATE(126),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(384),
    [anon_sym_false] = ACTIONS(384),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [83] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(125),
    [sym_unary_expression] = STATE(125),
    [sym_update_expression] = STATE(125),
    [sym_parenthesized_expression] = STATE(125),
    [sym_subscript_expression] = STATE(125),
    [sym_field_expression] = STATE(125),
    [sym_call_expression] = STATE(125),
    [sym_comma_expression] = STATE(125),
    [sym_assignment_expression] = STATE(125),
    [sym_conditional_expression] = STATE(125),
    [sym__expression] = STATE(125),
    [sym__constant_expression] = STATE(125),
    [sym__assignment_left_expression] = STATE(125),
    [sym_number_literal] = STATE(125),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(386),
    [anon_sym_false] = ACTIONS(386),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [84] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(171),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(171),
    [sym_assignment_expression] = STATE(171),
    [sym_conditional_expression] = STATE(171),
    [sym__expression] = STATE(171),
    [sym__constant_expression] = STATE(171),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [85] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(165),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(165),
    [sym_assignment_expression] = STATE(165),
    [sym_conditional_expression] = STATE(165),
    [sym__expression] = STATE(165),
    [sym__constant_expression] = STATE(165),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [86] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(154),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(154),
    [sym_assignment_expression] = STATE(154),
    [sym_conditional_expression] = STATE(154),
    [sym__expression] = STATE(154),
    [sym__constant_expression] = STATE(154),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [87] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(130),
    [sym_unary_expression] = STATE(130),
    [sym_update_expression] = STATE(130),
    [sym_parenthesized_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_field_expression] = STATE(130),
    [sym_call_expression] = STATE(130),
    [sym_comma_expression] = STATE(130),
    [sym_assignment_expression] = STATE(130),
    [sym_conditional_expression] = STATE(130),
    [sym__expression] = STATE(130),
    [sym__constant_expression] = STATE(130),
    [sym__assignment_left_expression] = STATE(130),
    [sym_number_literal] = STATE(130),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(388),
    [anon_sym_false] = ACTIONS(388),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [88] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(151),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(151),
    [sym_assignment_expression] = STATE(151),
    [sym_conditional_expression] = STATE(151),
    [sym__expression] = STATE(151),
    [sym__constant_expression] = STATE(151),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [89] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(134),
    [sym_unary_expression] = STATE(134),
    [sym_update_expression] = STATE(134),
    [sym_parenthesized_expression] = STATE(134),
    [sym_subscript_expression] = STATE(134),
    [sym_field_expression] = STATE(134),
    [sym_call_expression] = STATE(134),
    [sym_comma_expression] = STATE(134),
    [sym_assignment_expression] = STATE(134),
    [sym_conditional_expression] = STATE(134),
    [sym__expression] = STATE(134),
    [sym__constant_expression] = STATE(134),
    [sym__assignment_left_expression] = STATE(134),
    [sym_number_literal] = STATE(134),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(390),
    [anon_sym_false] = ACTIONS(390),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [90] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(127),
    [sym_unary_expression] = STATE(127),
    [sym_update_expression] = STATE(127),
    [sym_parenthesized_expression] = STATE(127),
    [sym_subscript_expression] = STATE(127),
    [sym_field_expression] = STATE(127),
    [sym_call_expression] = STATE(127),
    [sym_comma_expression] = STATE(127),
    [sym_assignment_expression] = STATE(127),
    [sym_conditional_expression] = STATE(127),
    [sym__expression] = STATE(127),
    [sym__constant_expression] = STATE(127),
    [sym__assignment_left_expression] = STATE(127),
    [sym_number_literal] = STATE(127),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(392),
    [anon_sym_false] = ACTIONS(392),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [91] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(138),
    [sym_unary_expression] = STATE(138),
    [sym_update_expression] = STATE(138),
    [sym_parenthesized_expression] = STATE(138),
    [sym_subscript_expression] = STATE(138),
    [sym_field_expression] = STATE(138),
    [sym_call_expression] = STATE(138),
    [sym_comma_expression] = STATE(138),
    [sym_assignment_expression] = STATE(138),
    [sym_conditional_expression] = STATE(138),
    [sym__expression] = STATE(138),
    [sym__constant_expression] = STATE(138),
    [sym__assignment_left_expression] = STATE(138),
    [sym_number_literal] = STATE(138),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(394),
    [anon_sym_false] = ACTIONS(394),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [92] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(122),
    [sym_unary_expression] = STATE(122),
    [sym_update_expression] = STATE(122),
    [sym_parenthesized_expression] = STATE(122),
    [sym_subscript_expression] = STATE(122),
    [sym_field_expression] = STATE(122),
    [sym_call_expression] = STATE(122),
    [sym_comma_expression] = STATE(122),
    [sym_assignment_expression] = STATE(122),
    [sym_conditional_expression] = STATE(122),
    [sym__expression] = STATE(122),
    [sym__constant_expression] = STATE(122),
    [sym__assignment_left_expression] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(396),
    [anon_sym_false] = ACTIONS(396),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [93] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(129),
    [sym_unary_expression] = STATE(129),
    [sym_update_expression] = STATE(129),
    [sym_parenthesized_expression] = STATE(129),
    [sym_subscript_expression] = STATE(129),
    [sym_field_expression] = STATE(129),
    [sym_call_expression] = STATE(129),
    [sym_comma_expression] = STATE(129),
    [sym_assignment_expression] = STATE(129),
    [sym_conditional_expression] = STATE(129),
    [sym__expression] = STATE(129),
    [sym__constant_expression] = STATE(129),
    [sym__assignment_left_expression] = STATE(129),
    [sym_number_literal] = STATE(129),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(398),
    [anon_sym_false] = ACTIONS(398),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [94] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(131),
    [sym_unary_expression] = STATE(131),
    [sym_update_expression] = STATE(131),
    [sym_parenthesized_expression] = STATE(131),
    [sym_subscript_expression] = STATE(131),
    [sym_field_expression] = STATE(131),
    [sym_call_expression] = STATE(131),
    [sym_comma_expression] = STATE(131),
    [sym_assignment_expression] = STATE(131),
    [sym_conditional_expression] = STATE(131),
    [sym__expression] = STATE(131),
    [sym__constant_expression] = STATE(131),
    [sym__assignment_left_expression] = STATE(131),
    [sym_number_literal] = STATE(131),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(400),
    [anon_sym_false] = ACTIONS(400),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [95] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(147),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(147),
    [sym_assignment_expression] = STATE(147),
    [sym_conditional_expression] = STATE(147),
    [sym__expression] = STATE(147),
    [sym__constant_expression] = STATE(147),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [96] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(153),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(153),
    [sym_assignment_expression] = STATE(153),
    [sym_conditional_expression] = STATE(153),
    [sym__expression] = STATE(153),
    [sym__constant_expression] = STATE(153),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [97] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(179),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(181),
    [sym_assignment_expression] = STATE(181),
    [sym_conditional_expression] = STATE(179),
    [sym__expression] = STATE(181),
    [sym__constant_expression] = STATE(179),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [98] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(177),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(177),
    [sym_assignment_expression] = STATE(177),
    [sym_conditional_expression] = STATE(177),
    [sym__expression] = STATE(177),
    [sym__constant_expression] = STATE(177),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [99] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(180),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(181),
    [sym_assignment_expression] = STATE(181),
    [sym_conditional_expression] = STATE(180),
    [sym__expression] = STATE(181),
    [sym__constant_expression] = STATE(180),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [100] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(166),
    [sym_unary_expression] = STATE(146),
    [sym_update_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_comma_expression] = STATE(166),
    [sym_assignment_expression] = STATE(166),
    [sym_conditional_expression] = STATE(166),
    [sym__expression] = STATE(166),
    [sym__constant_expression] = STATE(166),
    [sym__assignment_left_expression] = STATE(146),
    [sym_number_literal] = STATE(146),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [101] = {
    [sym_type_specifier] = STATE(267),
    [sym_primitive_type] = STATE(190),
    [sym_binary_expression] = STATE(132),
    [sym_unary_expression] = STATE(132),
    [sym_update_expression] = STATE(132),
    [sym_parenthesized_expression] = STATE(132),
    [sym_subscript_expression] = STATE(132),
    [sym_field_expression] = STATE(132),
    [sym_call_expression] = STATE(132),
    [sym_comma_expression] = STATE(132),
    [sym_assignment_expression] = STATE(132),
    [sym_conditional_expression] = STATE(132),
    [sym__expression] = STATE(132),
    [sym__constant_expression] = STATE(132),
    [sym__assignment_left_expression] = STATE(132),
    [sym_number_literal] = STATE(132),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_PLUS] = ACTIONS(59),
    [anon_sym_DASH_DASH] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(402),
    [anon_sym_false] = ACTIONS(402),
    [aux_sym_number_literal_token1] = ACTIONS(63),
    [aux_sym_number_literal_token2] = ACTIONS(63),
    [aux_sym_number_literal_token3] = ACTIONS(65),
    [aux_sym_number_literal_token4] = ACTIONS(65),
    [aux_sym_number_literal_token5] = ACTIONS(63),
    [aux_sym_number_literal_token6] = ACTIONS(65),
    [sym_comment] = ACTIONS(25),
  },
  [102] = {
    [sym_identifier] = ACTIONS(404),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_struct] = ACTIONS(404),
    [anon_sym_void] = ACTIONS(404),
    [anon_sym_float] = ACTIONS(404),
    [anon_sym_double] = ACTIONS(404),
    [anon_sym_int] = ACTIONS(404),
    [anon_sym_uint] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_vec2] = ACTIONS(404),
    [anon_sym_vec3] = ACTIONS(404),
    [anon_sym_vec4] = ACTIONS(404),
    [anon_sym_dvec2] = ACTIONS(404),
    [anon_sym_dvec3] = ACTIONS(404),
    [anon_sym_dvec4] = ACTIONS(404),
    [anon_sym_bvec2] = ACTIONS(404),
    [anon_sym_bvec3] = ACTIONS(404),
    [anon_sym_bvec4] = ACTIONS(404),
    [anon_sym_ivec2] = ACTIONS(404),
    [anon_sym_ivec3] = ACTIONS(404),
    [anon_sym_ivec4] = ACTIONS(404),
    [anon_sym_uvec2] = ACTIONS(404),
    [anon_sym_uvec3] = ACTIONS(404),
    [anon_sym_uvec4] = ACTIONS(404),
    [anon_sym_mat2] = ACTIONS(404),
    [anon_sym_mat3] = ACTIONS(404),
    [anon_sym_mat4] = ACTIONS(404),
    [anon_sym_mat2x2] = ACTIONS(404),
    [anon_sym_mat2x3] = ACTIONS(404),
    [anon_sym_mat2x4] = ACTIONS(404),
    [anon_sym_mat3x2] = ACTIONS(404),
    [anon_sym_mat3x3] = ACTIONS(404),
    [anon_sym_mat3x4] = ACTIONS(404),
    [anon_sym_mat4x2] = ACTIONS(404),
    [anon_sym_mat4x3] = ACTIONS(404),
    [anon_sym_mat4x4] = ACTIONS(404),
    [anon_sym_dmat2] = ACTIONS(404),
    [anon_sym_dmat3] = ACTIONS(404),
    [anon_sym_dmat4] = ACTIONS(404),
    [anon_sym_dmat2x2] = ACTIONS(404),
    [anon_sym_dmat2x3] = ACTIONS(404),
    [anon_sym_dmat2x4] = ACTIONS(404),
    [anon_sym_dmat3x2] = ACTIONS(404),
    [anon_sym_dmat3x3] = ACTIONS(404),
    [anon_sym_dmat3x4] = ACTIONS(404),
    [anon_sym_dmat4x2] = ACTIONS(404),
    [anon_sym_dmat4x3] = ACTIONS(404),
    [anon_sym_dmat4x4] = ACTIONS(404),
    [anon_sym_atomic_uint] = ACTIONS(404),
    [anon_sym_sampler1d] = ACTIONS(404),
    [anon_sym_sampler2d] = ACTIONS(404),
    [anon_sym_sampler3d] = ACTIONS(404),
    [anon_sym_samplercube] = ACTIONS(404),
    [anon_sym_sampler1DShadow] = ACTIONS(404),
    [anon_sym_sampler2DShadow] = ACTIONS(404),
    [anon_sym_samplerCubeShadow] = ACTIONS(404),
    [anon_sym_sampler1DArray] = ACTIONS(404),
    [anon_sym_sampler2DArray] = ACTIONS(404),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(404),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(404),
    [anon_sym_samplerCubeArray] = ACTIONS(404),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(404),
    [anon_sym_isampler1D] = ACTIONS(404),
    [anon_sym_isampler2D] = ACTIONS(404),
    [anon_sym_isampler3D] = ACTIONS(404),
    [anon_sym_isamplerCube] = ACTIONS(404),
    [anon_sym_isampler1DArray] = ACTIONS(404),
    [anon_sym_isampler2DArray] = ACTIONS(404),
    [anon_sym_isamplerCubeArray] = ACTIONS(404),
    [anon_sym_usampler1D] = ACTIONS(404),
    [anon_sym_usampler2D] = ACTIONS(404),
    [anon_sym_usampler3D] = ACTIONS(404),
    [anon_sym_usamplerCube] = ACTIONS(404),
    [anon_sym_usampler1DArray] = ACTIONS(404),
    [anon_sym_usampler2DArray] = ACTIONS(404),
    [anon_sym_usamplerCubeArray] = ACTIONS(404),
    [anon_sym_sampler2DRect] = ACTIONS(404),
    [anon_sym_sampler2DRectshadow] = ACTIONS(404),
    [anon_sym_isampler2DRect] = ACTIONS(404),
    [anon_sym_usampler2DRect] = ACTIONS(404),
    [anon_sym_samplerBuffer] = ACTIONS(404),
    [anon_sym_isamplerBuffer] = ACTIONS(404),
    [anon_sym_usamplerBuffer] = ACTIONS(404),
    [anon_sym_sampler2DMS] = ACTIONS(404),
    [anon_sym_isampler2DMS] = ACTIONS(404),
    [anon_sym_usampler2DMS] = ACTIONS(404),
    [anon_sym_sampler2DMSArray] = ACTIONS(404),
    [anon_sym_isampler2DMSArray] = ACTIONS(404),
    [anon_sym_usampler2DMSArray] = ACTIONS(404),
    [anon_sym_image1D] = ACTIONS(404),
    [anon_sym_iimage1D] = ACTIONS(404),
    [anon_sym_uimage1D] = ACTIONS(404),
    [anon_sym_image2D] = ACTIONS(404),
    [anon_sym_iimage2D] = ACTIONS(404),
    [anon_sym_uimage2D] = ACTIONS(404),
    [anon_sym_image3D] = ACTIONS(404),
    [anon_sym_iimage3D] = ACTIONS(404),
    [anon_sym_uimage3D] = ACTIONS(404),
    [anon_sym_image2DRect] = ACTIONS(404),
    [anon_sym_iimage2DRect] = ACTIONS(404),
    [anon_sym_uimage2DRect] = ACTIONS(404),
    [anon_sym_imageCube] = ACTIONS(404),
    [anon_sym_iimageCube] = ACTIONS(404),
    [anon_sym_uimageCube] = ACTIONS(404),
    [anon_sym_imageBuffer] = ACTIONS(404),
    [anon_sym_iimageBuffer] = ACTIONS(404),
    [anon_sym_uimageBuffer] = ACTIONS(404),
    [anon_sym_image1DArray] = ACTIONS(404),
    [anon_sym_iimage1DArray] = ACTIONS(404),
    [anon_sym_uimage1DArray] = ACTIONS(404),
    [anon_sym_image2DArray] = ACTIONS(404),
    [anon_sym_iimage2DArray] = ACTIONS(404),
    [anon_sym_uimage2DArray] = ACTIONS(404),
    [anon_sym_imageCubeArray] = ACTIONS(404),
    [anon_sym_iimageCubeArray] = ACTIONS(404),
    [anon_sym_uimageCubeArray] = ACTIONS(404),
    [anon_sym_image2DMS] = ACTIONS(404),
    [anon_sym_iimage2DMS] = ACTIONS(404),
    [anon_sym_uimage2DMS] = ACTIONS(404),
    [anon_sym_image2DMSArray] = ACTIONS(404),
    [anon_sym_iimage2DMSArray] = ACTIONS(404),
    [anon_sym_uimage2DMSArray] = ACTIONS(404),
    [anon_sym_const] = ACTIONS(404),
    [anon_sym_inout] = ACTIONS(404),
    [anon_sym_in] = ACTIONS(404),
    [anon_sym_out] = ACTIONS(404),
    [anon_sym_centroid] = ACTIONS(404),
    [anon_sym_patch] = ACTIONS(404),
    [anon_sym_sample] = ACTIONS(404),
    [anon_sym_uniform] = ACTIONS(404),
    [anon_sym_buffer] = ACTIONS(404),
    [anon_sym_shared] = ACTIONS(404),
    [anon_sym_coherent] = ACTIONS(404),
    [anon_sym_volatile] = ACTIONS(404),
    [anon_sym_restrict] = ACTIONS(404),
    [anon_sym_readonly] = ACTIONS(404),
    [anon_sym_writeonly] = ACTIONS(404),
    [anon_sym_subroutine] = ACTIONS(404),
    [anon_sym_varying] = ACTIONS(404),
    [anon_sym_attribute] = ACTIONS(404),
    [anon_sym_layout] = ACTIONS(404),
    [anon_sym_highp] = ACTIONS(404),
    [anon_sym_mediump] = ACTIONS(404),
    [anon_sym_lowp] = ACTIONS(404),
    [anon_sym_smooth] = ACTIONS(404),
    [anon_sym_flat] = ACTIONS(404),
    [anon_sym_noperspective] = ACTIONS(404),
    [sym_invariant_qualifier] = ACTIONS(404),
    [sym_precise_qualifier] = ACTIONS(404),
    [sym_comment] = ACTIONS(25),
  },
  [103] = {
    [ts_builtin_sym_end] = ACTIONS(410),
    [sym_identifier] = ACTIONS(412),
    [anon_sym_precision] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(412),
    [anon_sym_void] = ACTIONS(412),
    [anon_sym_float] = ACTIONS(412),
    [anon_sym_double] = ACTIONS(412),
    [anon_sym_int] = ACTIONS(412),
    [anon_sym_uint] = ACTIONS(412),
    [anon_sym_bool] = ACTIONS(412),
    [anon_sym_vec2] = ACTIONS(412),
    [anon_sym_vec3] = ACTIONS(412),
    [anon_sym_vec4] = ACTIONS(412),
    [anon_sym_dvec2] = ACTIONS(412),
    [anon_sym_dvec3] = ACTIONS(412),
    [anon_sym_dvec4] = ACTIONS(412),
    [anon_sym_bvec2] = ACTIONS(412),
    [anon_sym_bvec3] = ACTIONS(412),
    [anon_sym_bvec4] = ACTIONS(412),
    [anon_sym_ivec2] = ACTIONS(412),
    [anon_sym_ivec3] = ACTIONS(412),
    [anon_sym_ivec4] = ACTIONS(412),
    [anon_sym_uvec2] = ACTIONS(412),
    [anon_sym_uvec3] = ACTIONS(412),
    [anon_sym_uvec4] = ACTIONS(412),
    [anon_sym_mat2] = ACTIONS(412),
    [anon_sym_mat3] = ACTIONS(412),
    [anon_sym_mat4] = ACTIONS(412),
    [anon_sym_mat2x2] = ACTIONS(412),
    [anon_sym_mat2x3] = ACTIONS(412),
    [anon_sym_mat2x4] = ACTIONS(412),
    [anon_sym_mat3x2] = ACTIONS(412),
    [anon_sym_mat3x3] = ACTIONS(412),
    [anon_sym_mat3x4] = ACTIONS(412),
    [anon_sym_mat4x2] = ACTIONS(412),
    [anon_sym_mat4x3] = ACTIONS(412),
    [anon_sym_mat4x4] = ACTIONS(412),
    [anon_sym_dmat2] = ACTIONS(412),
    [anon_sym_dmat3] = ACTIONS(412),
    [anon_sym_dmat4] = ACTIONS(412),
    [anon_sym_dmat2x2] = ACTIONS(412),
    [anon_sym_dmat2x3] = ACTIONS(412),
    [anon_sym_dmat2x4] = ACTIONS(412),
    [anon_sym_dmat3x2] = ACTIONS(412),
    [anon_sym_dmat3x3] = ACTIONS(412),
    [anon_sym_dmat3x4] = ACTIONS(412),
    [anon_sym_dmat4x2] = ACTIONS(412),
    [anon_sym_dmat4x3] = ACTIONS(412),
    [anon_sym_dmat4x4] = ACTIONS(412),
    [anon_sym_atomic_uint] = ACTIONS(412),
    [anon_sym_sampler1d] = ACTIONS(412),
    [anon_sym_sampler2d] = ACTIONS(412),
    [anon_sym_sampler3d] = ACTIONS(412),
    [anon_sym_samplercube] = ACTIONS(412),
    [anon_sym_sampler1DShadow] = ACTIONS(412),
    [anon_sym_sampler2DShadow] = ACTIONS(412),
    [anon_sym_samplerCubeShadow] = ACTIONS(412),
    [anon_sym_sampler1DArray] = ACTIONS(412),
    [anon_sym_sampler2DArray] = ACTIONS(412),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(412),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(412),
    [anon_sym_samplerCubeArray] = ACTIONS(412),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(412),
    [anon_sym_isampler1D] = ACTIONS(412),
    [anon_sym_isampler2D] = ACTIONS(412),
    [anon_sym_isampler3D] = ACTIONS(412),
    [anon_sym_isamplerCube] = ACTIONS(412),
    [anon_sym_isampler1DArray] = ACTIONS(412),
    [anon_sym_isampler2DArray] = ACTIONS(412),
    [anon_sym_isamplerCubeArray] = ACTIONS(412),
    [anon_sym_usampler1D] = ACTIONS(412),
    [anon_sym_usampler2D] = ACTIONS(412),
    [anon_sym_usampler3D] = ACTIONS(412),
    [anon_sym_usamplerCube] = ACTIONS(412),
    [anon_sym_usampler1DArray] = ACTIONS(412),
    [anon_sym_usampler2DArray] = ACTIONS(412),
    [anon_sym_usamplerCubeArray] = ACTIONS(412),
    [anon_sym_sampler2DRect] = ACTIONS(412),
    [anon_sym_sampler2DRectshadow] = ACTIONS(412),
    [anon_sym_isampler2DRect] = ACTIONS(412),
    [anon_sym_usampler2DRect] = ACTIONS(412),
    [anon_sym_samplerBuffer] = ACTIONS(412),
    [anon_sym_isamplerBuffer] = ACTIONS(412),
    [anon_sym_usamplerBuffer] = ACTIONS(412),
    [anon_sym_sampler2DMS] = ACTIONS(412),
    [anon_sym_isampler2DMS] = ACTIONS(412),
    [anon_sym_usampler2DMS] = ACTIONS(412),
    [anon_sym_sampler2DMSArray] = ACTIONS(412),
    [anon_sym_isampler2DMSArray] = ACTIONS(412),
    [anon_sym_usampler2DMSArray] = ACTIONS(412),
    [anon_sym_image1D] = ACTIONS(412),
    [anon_sym_iimage1D] = ACTIONS(412),
    [anon_sym_uimage1D] = ACTIONS(412),
    [anon_sym_image2D] = ACTIONS(412),
    [anon_sym_iimage2D] = ACTIONS(412),
    [anon_sym_uimage2D] = ACTIONS(412),
    [anon_sym_image3D] = ACTIONS(412),
    [anon_sym_iimage3D] = ACTIONS(412),
    [anon_sym_uimage3D] = ACTIONS(412),
    [anon_sym_image2DRect] = ACTIONS(412),
    [anon_sym_iimage2DRect] = ACTIONS(412),
    [anon_sym_uimage2DRect] = ACTIONS(412),
    [anon_sym_imageCube] = ACTIONS(412),
    [anon_sym_iimageCube] = ACTIONS(412),
    [anon_sym_uimageCube] = ACTIONS(412),
    [anon_sym_imageBuffer] = ACTIONS(412),
    [anon_sym_iimageBuffer] = ACTIONS(412),
    [anon_sym_uimageBuffer] = ACTIONS(412),
    [anon_sym_image1DArray] = ACTIONS(412),
    [anon_sym_iimage1DArray] = ACTIONS(412),
    [anon_sym_uimage1DArray] = ACTIONS(412),
    [anon_sym_image2DArray] = ACTIONS(412),
    [anon_sym_iimage2DArray] = ACTIONS(412),
    [anon_sym_uimage2DArray] = ACTIONS(412),
    [anon_sym_imageCubeArray] = ACTIONS(412),
    [anon_sym_iimageCubeArray] = ACTIONS(412),
    [anon_sym_uimageCubeArray] = ACTIONS(412),
    [anon_sym_image2DMS] = ACTIONS(412),
    [anon_sym_iimage2DMS] = ACTIONS(412),
    [anon_sym_uimage2DMS] = ACTIONS(412),
    [anon_sym_image2DMSArray] = ACTIONS(412),
    [anon_sym_iimage2DMSArray] = ACTIONS(412),
    [anon_sym_uimage2DMSArray] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(412),
    [anon_sym_inout] = ACTIONS(412),
    [anon_sym_in] = ACTIONS(412),
    [anon_sym_out] = ACTIONS(412),
    [anon_sym_centroid] = ACTIONS(412),
    [anon_sym_patch] = ACTIONS(412),
    [anon_sym_sample] = ACTIONS(412),
    [anon_sym_uniform] = ACTIONS(412),
    [anon_sym_buffer] = ACTIONS(412),
    [anon_sym_shared] = ACTIONS(412),
    [anon_sym_coherent] = ACTIONS(412),
    [anon_sym_volatile] = ACTIONS(412),
    [anon_sym_restrict] = ACTIONS(412),
    [anon_sym_readonly] = ACTIONS(412),
    [anon_sym_writeonly] = ACTIONS(412),
    [anon_sym_subroutine] = ACTIONS(412),
    [anon_sym_varying] = ACTIONS(412),
    [anon_sym_attribute] = ACTIONS(412),
    [anon_sym_layout] = ACTIONS(412),
    [anon_sym_highp] = ACTIONS(412),
    [anon_sym_mediump] = ACTIONS(412),
    [anon_sym_lowp] = ACTIONS(412),
    [anon_sym_smooth] = ACTIONS(412),
    [anon_sym_flat] = ACTIONS(412),
    [anon_sym_noperspective] = ACTIONS(412),
    [sym_invariant_qualifier] = ACTIONS(412),
    [sym_precise_qualifier] = ACTIONS(412),
    [sym_comment] = ACTIONS(25),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(414),
    [sym_identifier] = ACTIONS(416),
    [anon_sym_precision] = ACTIONS(416),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_void] = ACTIONS(416),
    [anon_sym_float] = ACTIONS(416),
    [anon_sym_double] = ACTIONS(416),
    [anon_sym_int] = ACTIONS(416),
    [anon_sym_uint] = ACTIONS(416),
    [anon_sym_bool] = ACTIONS(416),
    [anon_sym_vec2] = ACTIONS(416),
    [anon_sym_vec3] = ACTIONS(416),
    [anon_sym_vec4] = ACTIONS(416),
    [anon_sym_dvec2] = ACTIONS(416),
    [anon_sym_dvec3] = ACTIONS(416),
    [anon_sym_dvec4] = ACTIONS(416),
    [anon_sym_bvec2] = ACTIONS(416),
    [anon_sym_bvec3] = ACTIONS(416),
    [anon_sym_bvec4] = ACTIONS(416),
    [anon_sym_ivec2] = ACTIONS(416),
    [anon_sym_ivec3] = ACTIONS(416),
    [anon_sym_ivec4] = ACTIONS(416),
    [anon_sym_uvec2] = ACTIONS(416),
    [anon_sym_uvec3] = ACTIONS(416),
    [anon_sym_uvec4] = ACTIONS(416),
    [anon_sym_mat2] = ACTIONS(416),
    [anon_sym_mat3] = ACTIONS(416),
    [anon_sym_mat4] = ACTIONS(416),
    [anon_sym_mat2x2] = ACTIONS(416),
    [anon_sym_mat2x3] = ACTIONS(416),
    [anon_sym_mat2x4] = ACTIONS(416),
    [anon_sym_mat3x2] = ACTIONS(416),
    [anon_sym_mat3x3] = ACTIONS(416),
    [anon_sym_mat3x4] = ACTIONS(416),
    [anon_sym_mat4x2] = ACTIONS(416),
    [anon_sym_mat4x3] = ACTIONS(416),
    [anon_sym_mat4x4] = ACTIONS(416),
    [anon_sym_dmat2] = ACTIONS(416),
    [anon_sym_dmat3] = ACTIONS(416),
    [anon_sym_dmat4] = ACTIONS(416),
    [anon_sym_dmat2x2] = ACTIONS(416),
    [anon_sym_dmat2x3] = ACTIONS(416),
    [anon_sym_dmat2x4] = ACTIONS(416),
    [anon_sym_dmat3x2] = ACTIONS(416),
    [anon_sym_dmat3x3] = ACTIONS(416),
    [anon_sym_dmat3x4] = ACTIONS(416),
    [anon_sym_dmat4x2] = ACTIONS(416),
    [anon_sym_dmat4x3] = ACTIONS(416),
    [anon_sym_dmat4x4] = ACTIONS(416),
    [anon_sym_atomic_uint] = ACTIONS(416),
    [anon_sym_sampler1d] = ACTIONS(416),
    [anon_sym_sampler2d] = ACTIONS(416),
    [anon_sym_sampler3d] = ACTIONS(416),
    [anon_sym_samplercube] = ACTIONS(416),
    [anon_sym_sampler1DShadow] = ACTIONS(416),
    [anon_sym_sampler2DShadow] = ACTIONS(416),
    [anon_sym_samplerCubeShadow] = ACTIONS(416),
    [anon_sym_sampler1DArray] = ACTIONS(416),
    [anon_sym_sampler2DArray] = ACTIONS(416),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(416),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(416),
    [anon_sym_samplerCubeArray] = ACTIONS(416),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(416),
    [anon_sym_isampler1D] = ACTIONS(416),
    [anon_sym_isampler2D] = ACTIONS(416),
    [anon_sym_isampler3D] = ACTIONS(416),
    [anon_sym_isamplerCube] = ACTIONS(416),
    [anon_sym_isampler1DArray] = ACTIONS(416),
    [anon_sym_isampler2DArray] = ACTIONS(416),
    [anon_sym_isamplerCubeArray] = ACTIONS(416),
    [anon_sym_usampler1D] = ACTIONS(416),
    [anon_sym_usampler2D] = ACTIONS(416),
    [anon_sym_usampler3D] = ACTIONS(416),
    [anon_sym_usamplerCube] = ACTIONS(416),
    [anon_sym_usampler1DArray] = ACTIONS(416),
    [anon_sym_usampler2DArray] = ACTIONS(416),
    [anon_sym_usamplerCubeArray] = ACTIONS(416),
    [anon_sym_sampler2DRect] = ACTIONS(416),
    [anon_sym_sampler2DRectshadow] = ACTIONS(416),
    [anon_sym_isampler2DRect] = ACTIONS(416),
    [anon_sym_usampler2DRect] = ACTIONS(416),
    [anon_sym_samplerBuffer] = ACTIONS(416),
    [anon_sym_isamplerBuffer] = ACTIONS(416),
    [anon_sym_usamplerBuffer] = ACTIONS(416),
    [anon_sym_sampler2DMS] = ACTIONS(416),
    [anon_sym_isampler2DMS] = ACTIONS(416),
    [anon_sym_usampler2DMS] = ACTIONS(416),
    [anon_sym_sampler2DMSArray] = ACTIONS(416),
    [anon_sym_isampler2DMSArray] = ACTIONS(416),
    [anon_sym_usampler2DMSArray] = ACTIONS(416),
    [anon_sym_image1D] = ACTIONS(416),
    [anon_sym_iimage1D] = ACTIONS(416),
    [anon_sym_uimage1D] = ACTIONS(416),
    [anon_sym_image2D] = ACTIONS(416),
    [anon_sym_iimage2D] = ACTIONS(416),
    [anon_sym_uimage2D] = ACTIONS(416),
    [anon_sym_image3D] = ACTIONS(416),
    [anon_sym_iimage3D] = ACTIONS(416),
    [anon_sym_uimage3D] = ACTIONS(416),
    [anon_sym_image2DRect] = ACTIONS(416),
    [anon_sym_iimage2DRect] = ACTIONS(416),
    [anon_sym_uimage2DRect] = ACTIONS(416),
    [anon_sym_imageCube] = ACTIONS(416),
    [anon_sym_iimageCube] = ACTIONS(416),
    [anon_sym_uimageCube] = ACTIONS(416),
    [anon_sym_imageBuffer] = ACTIONS(416),
    [anon_sym_iimageBuffer] = ACTIONS(416),
    [anon_sym_uimageBuffer] = ACTIONS(416),
    [anon_sym_image1DArray] = ACTIONS(416),
    [anon_sym_iimage1DArray] = ACTIONS(416),
    [anon_sym_uimage1DArray] = ACTIONS(416),
    [anon_sym_image2DArray] = ACTIONS(416),
    [anon_sym_iimage2DArray] = ACTIONS(416),
    [anon_sym_uimage2DArray] = ACTIONS(416),
    [anon_sym_imageCubeArray] = ACTIONS(416),
    [anon_sym_iimageCubeArray] = ACTIONS(416),
    [anon_sym_uimageCubeArray] = ACTIONS(416),
    [anon_sym_image2DMS] = ACTIONS(416),
    [anon_sym_iimage2DMS] = ACTIONS(416),
    [anon_sym_uimage2DMS] = ACTIONS(416),
    [anon_sym_image2DMSArray] = ACTIONS(416),
    [anon_sym_iimage2DMSArray] = ACTIONS(416),
    [anon_sym_uimage2DMSArray] = ACTIONS(416),
    [anon_sym_const] = ACTIONS(416),
    [anon_sym_inout] = ACTIONS(416),
    [anon_sym_in] = ACTIONS(416),
    [anon_sym_out] = ACTIONS(416),
    [anon_sym_centroid] = ACTIONS(416),
    [anon_sym_patch] = ACTIONS(416),
    [anon_sym_sample] = ACTIONS(416),
    [anon_sym_uniform] = ACTIONS(416),
    [anon_sym_buffer] = ACTIONS(416),
    [anon_sym_shared] = ACTIONS(416),
    [anon_sym_coherent] = ACTIONS(416),
    [anon_sym_volatile] = ACTIONS(416),
    [anon_sym_restrict] = ACTIONS(416),
    [anon_sym_readonly] = ACTIONS(416),
    [anon_sym_writeonly] = ACTIONS(416),
    [anon_sym_subroutine] = ACTIONS(416),
    [anon_sym_varying] = ACTIONS(416),
    [anon_sym_attribute] = ACTIONS(416),
    [anon_sym_layout] = ACTIONS(416),
    [anon_sym_highp] = ACTIONS(416),
    [anon_sym_mediump] = ACTIONS(416),
    [anon_sym_lowp] = ACTIONS(416),
    [anon_sym_smooth] = ACTIONS(416),
    [anon_sym_flat] = ACTIONS(416),
    [anon_sym_noperspective] = ACTIONS(416),
    [sym_invariant_qualifier] = ACTIONS(416),
    [sym_precise_qualifier] = ACTIONS(416),
    [sym_comment] = ACTIONS(25),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(418),
    [sym_identifier] = ACTIONS(420),
    [anon_sym_precision] = ACTIONS(420),
    [anon_sym_struct] = ACTIONS(420),
    [anon_sym_void] = ACTIONS(420),
    [anon_sym_float] = ACTIONS(420),
    [anon_sym_double] = ACTIONS(420),
    [anon_sym_int] = ACTIONS(420),
    [anon_sym_uint] = ACTIONS(420),
    [anon_sym_bool] = ACTIONS(420),
    [anon_sym_vec2] = ACTIONS(420),
    [anon_sym_vec3] = ACTIONS(420),
    [anon_sym_vec4] = ACTIONS(420),
    [anon_sym_dvec2] = ACTIONS(420),
    [anon_sym_dvec3] = ACTIONS(420),
    [anon_sym_dvec4] = ACTIONS(420),
    [anon_sym_bvec2] = ACTIONS(420),
    [anon_sym_bvec3] = ACTIONS(420),
    [anon_sym_bvec4] = ACTIONS(420),
    [anon_sym_ivec2] = ACTIONS(420),
    [anon_sym_ivec3] = ACTIONS(420),
    [anon_sym_ivec4] = ACTIONS(420),
    [anon_sym_uvec2] = ACTIONS(420),
    [anon_sym_uvec3] = ACTIONS(420),
    [anon_sym_uvec4] = ACTIONS(420),
    [anon_sym_mat2] = ACTIONS(420),
    [anon_sym_mat3] = ACTIONS(420),
    [anon_sym_mat4] = ACTIONS(420),
    [anon_sym_mat2x2] = ACTIONS(420),
    [anon_sym_mat2x3] = ACTIONS(420),
    [anon_sym_mat2x4] = ACTIONS(420),
    [anon_sym_mat3x2] = ACTIONS(420),
    [anon_sym_mat3x3] = ACTIONS(420),
    [anon_sym_mat3x4] = ACTIONS(420),
    [anon_sym_mat4x2] = ACTIONS(420),
    [anon_sym_mat4x3] = ACTIONS(420),
    [anon_sym_mat4x4] = ACTIONS(420),
    [anon_sym_dmat2] = ACTIONS(420),
    [anon_sym_dmat3] = ACTIONS(420),
    [anon_sym_dmat4] = ACTIONS(420),
    [anon_sym_dmat2x2] = ACTIONS(420),
    [anon_sym_dmat2x3] = ACTIONS(420),
    [anon_sym_dmat2x4] = ACTIONS(420),
    [anon_sym_dmat3x2] = ACTIONS(420),
    [anon_sym_dmat3x3] = ACTIONS(420),
    [anon_sym_dmat3x4] = ACTIONS(420),
    [anon_sym_dmat4x2] = ACTIONS(420),
    [anon_sym_dmat4x3] = ACTIONS(420),
    [anon_sym_dmat4x4] = ACTIONS(420),
    [anon_sym_atomic_uint] = ACTIONS(420),
    [anon_sym_sampler1d] = ACTIONS(420),
    [anon_sym_sampler2d] = ACTIONS(420),
    [anon_sym_sampler3d] = ACTIONS(420),
    [anon_sym_samplercube] = ACTIONS(420),
    [anon_sym_sampler1DShadow] = ACTIONS(420),
    [anon_sym_sampler2DShadow] = ACTIONS(420),
    [anon_sym_samplerCubeShadow] = ACTIONS(420),
    [anon_sym_sampler1DArray] = ACTIONS(420),
    [anon_sym_sampler2DArray] = ACTIONS(420),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(420),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(420),
    [anon_sym_samplerCubeArray] = ACTIONS(420),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(420),
    [anon_sym_isampler1D] = ACTIONS(420),
    [anon_sym_isampler2D] = ACTIONS(420),
    [anon_sym_isampler3D] = ACTIONS(420),
    [anon_sym_isamplerCube] = ACTIONS(420),
    [anon_sym_isampler1DArray] = ACTIONS(420),
    [anon_sym_isampler2DArray] = ACTIONS(420),
    [anon_sym_isamplerCubeArray] = ACTIONS(420),
    [anon_sym_usampler1D] = ACTIONS(420),
    [anon_sym_usampler2D] = ACTIONS(420),
    [anon_sym_usampler3D] = ACTIONS(420),
    [anon_sym_usamplerCube] = ACTIONS(420),
    [anon_sym_usampler1DArray] = ACTIONS(420),
    [anon_sym_usampler2DArray] = ACTIONS(420),
    [anon_sym_usamplerCubeArray] = ACTIONS(420),
    [anon_sym_sampler2DRect] = ACTIONS(420),
    [anon_sym_sampler2DRectshadow] = ACTIONS(420),
    [anon_sym_isampler2DRect] = ACTIONS(420),
    [anon_sym_usampler2DRect] = ACTIONS(420),
    [anon_sym_samplerBuffer] = ACTIONS(420),
    [anon_sym_isamplerBuffer] = ACTIONS(420),
    [anon_sym_usamplerBuffer] = ACTIONS(420),
    [anon_sym_sampler2DMS] = ACTIONS(420),
    [anon_sym_isampler2DMS] = ACTIONS(420),
    [anon_sym_usampler2DMS] = ACTIONS(420),
    [anon_sym_sampler2DMSArray] = ACTIONS(420),
    [anon_sym_isampler2DMSArray] = ACTIONS(420),
    [anon_sym_usampler2DMSArray] = ACTIONS(420),
    [anon_sym_image1D] = ACTIONS(420),
    [anon_sym_iimage1D] = ACTIONS(420),
    [anon_sym_uimage1D] = ACTIONS(420),
    [anon_sym_image2D] = ACTIONS(420),
    [anon_sym_iimage2D] = ACTIONS(420),
    [anon_sym_uimage2D] = ACTIONS(420),
    [anon_sym_image3D] = ACTIONS(420),
    [anon_sym_iimage3D] = ACTIONS(420),
    [anon_sym_uimage3D] = ACTIONS(420),
    [anon_sym_image2DRect] = ACTIONS(420),
    [anon_sym_iimage2DRect] = ACTIONS(420),
    [anon_sym_uimage2DRect] = ACTIONS(420),
    [anon_sym_imageCube] = ACTIONS(420),
    [anon_sym_iimageCube] = ACTIONS(420),
    [anon_sym_uimageCube] = ACTIONS(420),
    [anon_sym_imageBuffer] = ACTIONS(420),
    [anon_sym_iimageBuffer] = ACTIONS(420),
    [anon_sym_uimageBuffer] = ACTIONS(420),
    [anon_sym_image1DArray] = ACTIONS(420),
    [anon_sym_iimage1DArray] = ACTIONS(420),
    [anon_sym_uimage1DArray] = ACTIONS(420),
    [anon_sym_image2DArray] = ACTIONS(420),
    [anon_sym_iimage2DArray] = ACTIONS(420),
    [anon_sym_uimage2DArray] = ACTIONS(420),
    [anon_sym_imageCubeArray] = ACTIONS(420),
    [anon_sym_iimageCubeArray] = ACTIONS(420),
    [anon_sym_uimageCubeArray] = ACTIONS(420),
    [anon_sym_image2DMS] = ACTIONS(420),
    [anon_sym_iimage2DMS] = ACTIONS(420),
    [anon_sym_uimage2DMS] = ACTIONS(420),
    [anon_sym_image2DMSArray] = ACTIONS(420),
    [anon_sym_iimage2DMSArray] = ACTIONS(420),
    [anon_sym_uimage2DMSArray] = ACTIONS(420),
    [anon_sym_const] = ACTIONS(420),
    [anon_sym_inout] = ACTIONS(420),
    [anon_sym_in] = ACTIONS(420),
    [anon_sym_out] = ACTIONS(420),
    [anon_sym_centroid] = ACTIONS(420),
    [anon_sym_patch] = ACTIONS(420),
    [anon_sym_sample] = ACTIONS(420),
    [anon_sym_uniform] = ACTIONS(420),
    [anon_sym_buffer] = ACTIONS(420),
    [anon_sym_shared] = ACTIONS(420),
    [anon_sym_coherent] = ACTIONS(420),
    [anon_sym_volatile] = ACTIONS(420),
    [anon_sym_restrict] = ACTIONS(420),
    [anon_sym_readonly] = ACTIONS(420),
    [anon_sym_writeonly] = ACTIONS(420),
    [anon_sym_subroutine] = ACTIONS(420),
    [anon_sym_varying] = ACTIONS(420),
    [anon_sym_attribute] = ACTIONS(420),
    [anon_sym_layout] = ACTIONS(420),
    [anon_sym_highp] = ACTIONS(420),
    [anon_sym_mediump] = ACTIONS(420),
    [anon_sym_lowp] = ACTIONS(420),
    [anon_sym_smooth] = ACTIONS(420),
    [anon_sym_flat] = ACTIONS(420),
    [anon_sym_noperspective] = ACTIONS(420),
    [sym_invariant_qualifier] = ACTIONS(420),
    [sym_precise_qualifier] = ACTIONS(420),
    [sym_comment] = ACTIONS(25),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(422),
    [sym_identifier] = ACTIONS(424),
    [anon_sym_precision] = ACTIONS(424),
    [anon_sym_struct] = ACTIONS(424),
    [anon_sym_void] = ACTIONS(424),
    [anon_sym_float] = ACTIONS(424),
    [anon_sym_double] = ACTIONS(424),
    [anon_sym_int] = ACTIONS(424),
    [anon_sym_uint] = ACTIONS(424),
    [anon_sym_bool] = ACTIONS(424),
    [anon_sym_vec2] = ACTIONS(424),
    [anon_sym_vec3] = ACTIONS(424),
    [anon_sym_vec4] = ACTIONS(424),
    [anon_sym_dvec2] = ACTIONS(424),
    [anon_sym_dvec3] = ACTIONS(424),
    [anon_sym_dvec4] = ACTIONS(424),
    [anon_sym_bvec2] = ACTIONS(424),
    [anon_sym_bvec3] = ACTIONS(424),
    [anon_sym_bvec4] = ACTIONS(424),
    [anon_sym_ivec2] = ACTIONS(424),
    [anon_sym_ivec3] = ACTIONS(424),
    [anon_sym_ivec4] = ACTIONS(424),
    [anon_sym_uvec2] = ACTIONS(424),
    [anon_sym_uvec3] = ACTIONS(424),
    [anon_sym_uvec4] = ACTIONS(424),
    [anon_sym_mat2] = ACTIONS(424),
    [anon_sym_mat3] = ACTIONS(424),
    [anon_sym_mat4] = ACTIONS(424),
    [anon_sym_mat2x2] = ACTIONS(424),
    [anon_sym_mat2x3] = ACTIONS(424),
    [anon_sym_mat2x4] = ACTIONS(424),
    [anon_sym_mat3x2] = ACTIONS(424),
    [anon_sym_mat3x3] = ACTIONS(424),
    [anon_sym_mat3x4] = ACTIONS(424),
    [anon_sym_mat4x2] = ACTIONS(424),
    [anon_sym_mat4x3] = ACTIONS(424),
    [anon_sym_mat4x4] = ACTIONS(424),
    [anon_sym_dmat2] = ACTIONS(424),
    [anon_sym_dmat3] = ACTIONS(424),
    [anon_sym_dmat4] = ACTIONS(424),
    [anon_sym_dmat2x2] = ACTIONS(424),
    [anon_sym_dmat2x3] = ACTIONS(424),
    [anon_sym_dmat2x4] = ACTIONS(424),
    [anon_sym_dmat3x2] = ACTIONS(424),
    [anon_sym_dmat3x3] = ACTIONS(424),
    [anon_sym_dmat3x4] = ACTIONS(424),
    [anon_sym_dmat4x2] = ACTIONS(424),
    [anon_sym_dmat4x3] = ACTIONS(424),
    [anon_sym_dmat4x4] = ACTIONS(424),
    [anon_sym_atomic_uint] = ACTIONS(424),
    [anon_sym_sampler1d] = ACTIONS(424),
    [anon_sym_sampler2d] = ACTIONS(424),
    [anon_sym_sampler3d] = ACTIONS(424),
    [anon_sym_samplercube] = ACTIONS(424),
    [anon_sym_sampler1DShadow] = ACTIONS(424),
    [anon_sym_sampler2DShadow] = ACTIONS(424),
    [anon_sym_samplerCubeShadow] = ACTIONS(424),
    [anon_sym_sampler1DArray] = ACTIONS(424),
    [anon_sym_sampler2DArray] = ACTIONS(424),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(424),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(424),
    [anon_sym_samplerCubeArray] = ACTIONS(424),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(424),
    [anon_sym_isampler1D] = ACTIONS(424),
    [anon_sym_isampler2D] = ACTIONS(424),
    [anon_sym_isampler3D] = ACTIONS(424),
    [anon_sym_isamplerCube] = ACTIONS(424),
    [anon_sym_isampler1DArray] = ACTIONS(424),
    [anon_sym_isampler2DArray] = ACTIONS(424),
    [anon_sym_isamplerCubeArray] = ACTIONS(424),
    [anon_sym_usampler1D] = ACTIONS(424),
    [anon_sym_usampler2D] = ACTIONS(424),
    [anon_sym_usampler3D] = ACTIONS(424),
    [anon_sym_usamplerCube] = ACTIONS(424),
    [anon_sym_usampler1DArray] = ACTIONS(424),
    [anon_sym_usampler2DArray] = ACTIONS(424),
    [anon_sym_usamplerCubeArray] = ACTIONS(424),
    [anon_sym_sampler2DRect] = ACTIONS(424),
    [anon_sym_sampler2DRectshadow] = ACTIONS(424),
    [anon_sym_isampler2DRect] = ACTIONS(424),
    [anon_sym_usampler2DRect] = ACTIONS(424),
    [anon_sym_samplerBuffer] = ACTIONS(424),
    [anon_sym_isamplerBuffer] = ACTIONS(424),
    [anon_sym_usamplerBuffer] = ACTIONS(424),
    [anon_sym_sampler2DMS] = ACTIONS(424),
    [anon_sym_isampler2DMS] = ACTIONS(424),
    [anon_sym_usampler2DMS] = ACTIONS(424),
    [anon_sym_sampler2DMSArray] = ACTIONS(424),
    [anon_sym_isampler2DMSArray] = ACTIONS(424),
    [anon_sym_usampler2DMSArray] = ACTIONS(424),
    [anon_sym_image1D] = ACTIONS(424),
    [anon_sym_iimage1D] = ACTIONS(424),
    [anon_sym_uimage1D] = ACTIONS(424),
    [anon_sym_image2D] = ACTIONS(424),
    [anon_sym_iimage2D] = ACTIONS(424),
    [anon_sym_uimage2D] = ACTIONS(424),
    [anon_sym_image3D] = ACTIONS(424),
    [anon_sym_iimage3D] = ACTIONS(424),
    [anon_sym_uimage3D] = ACTIONS(424),
    [anon_sym_image2DRect] = ACTIONS(424),
    [anon_sym_iimage2DRect] = ACTIONS(424),
    [anon_sym_uimage2DRect] = ACTIONS(424),
    [anon_sym_imageCube] = ACTIONS(424),
    [anon_sym_iimageCube] = ACTIONS(424),
    [anon_sym_uimageCube] = ACTIONS(424),
    [anon_sym_imageBuffer] = ACTIONS(424),
    [anon_sym_iimageBuffer] = ACTIONS(424),
    [anon_sym_uimageBuffer] = ACTIONS(424),
    [anon_sym_image1DArray] = ACTIONS(424),
    [anon_sym_iimage1DArray] = ACTIONS(424),
    [anon_sym_uimage1DArray] = ACTIONS(424),
    [anon_sym_image2DArray] = ACTIONS(424),
    [anon_sym_iimage2DArray] = ACTIONS(424),
    [anon_sym_uimage2DArray] = ACTIONS(424),
    [anon_sym_imageCubeArray] = ACTIONS(424),
    [anon_sym_iimageCubeArray] = ACTIONS(424),
    [anon_sym_uimageCubeArray] = ACTIONS(424),
    [anon_sym_image2DMS] = ACTIONS(424),
    [anon_sym_iimage2DMS] = ACTIONS(424),
    [anon_sym_uimage2DMS] = ACTIONS(424),
    [anon_sym_image2DMSArray] = ACTIONS(424),
    [anon_sym_iimage2DMSArray] = ACTIONS(424),
    [anon_sym_uimage2DMSArray] = ACTIONS(424),
    [anon_sym_const] = ACTIONS(424),
    [anon_sym_inout] = ACTIONS(424),
    [anon_sym_in] = ACTIONS(424),
    [anon_sym_out] = ACTIONS(424),
    [anon_sym_centroid] = ACTIONS(424),
    [anon_sym_patch] = ACTIONS(424),
    [anon_sym_sample] = ACTIONS(424),
    [anon_sym_uniform] = ACTIONS(424),
    [anon_sym_buffer] = ACTIONS(424),
    [anon_sym_shared] = ACTIONS(424),
    [anon_sym_coherent] = ACTIONS(424),
    [anon_sym_volatile] = ACTIONS(424),
    [anon_sym_restrict] = ACTIONS(424),
    [anon_sym_readonly] = ACTIONS(424),
    [anon_sym_writeonly] = ACTIONS(424),
    [anon_sym_subroutine] = ACTIONS(424),
    [anon_sym_varying] = ACTIONS(424),
    [anon_sym_attribute] = ACTIONS(424),
    [anon_sym_layout] = ACTIONS(424),
    [anon_sym_highp] = ACTIONS(424),
    [anon_sym_mediump] = ACTIONS(424),
    [anon_sym_lowp] = ACTIONS(424),
    [anon_sym_smooth] = ACTIONS(424),
    [anon_sym_flat] = ACTIONS(424),
    [anon_sym_noperspective] = ACTIONS(424),
    [sym_invariant_qualifier] = ACTIONS(424),
    [sym_precise_qualifier] = ACTIONS(424),
    [sym_comment] = ACTIONS(25),
  },
  [107] = {
    [sym_identifier] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(428),
    [anon_sym_struct] = ACTIONS(426),
    [anon_sym_void] = ACTIONS(426),
    [anon_sym_float] = ACTIONS(426),
    [anon_sym_double] = ACTIONS(426),
    [anon_sym_int] = ACTIONS(426),
    [anon_sym_uint] = ACTIONS(426),
    [anon_sym_bool] = ACTIONS(426),
    [anon_sym_vec2] = ACTIONS(426),
    [anon_sym_vec3] = ACTIONS(426),
    [anon_sym_vec4] = ACTIONS(426),
    [anon_sym_dvec2] = ACTIONS(426),
    [anon_sym_dvec3] = ACTIONS(426),
    [anon_sym_dvec4] = ACTIONS(426),
    [anon_sym_bvec2] = ACTIONS(426),
    [anon_sym_bvec3] = ACTIONS(426),
    [anon_sym_bvec4] = ACTIONS(426),
    [anon_sym_ivec2] = ACTIONS(426),
    [anon_sym_ivec3] = ACTIONS(426),
    [anon_sym_ivec4] = ACTIONS(426),
    [anon_sym_uvec2] = ACTIONS(426),
    [anon_sym_uvec3] = ACTIONS(426),
    [anon_sym_uvec4] = ACTIONS(426),
    [anon_sym_mat2] = ACTIONS(426),
    [anon_sym_mat3] = ACTIONS(426),
    [anon_sym_mat4] = ACTIONS(426),
    [anon_sym_mat2x2] = ACTIONS(426),
    [anon_sym_mat2x3] = ACTIONS(426),
    [anon_sym_mat2x4] = ACTIONS(426),
    [anon_sym_mat3x2] = ACTIONS(426),
    [anon_sym_mat3x3] = ACTIONS(426),
    [anon_sym_mat3x4] = ACTIONS(426),
    [anon_sym_mat4x2] = ACTIONS(426),
    [anon_sym_mat4x3] = ACTIONS(426),
    [anon_sym_mat4x4] = ACTIONS(426),
    [anon_sym_dmat2] = ACTIONS(426),
    [anon_sym_dmat3] = ACTIONS(426),
    [anon_sym_dmat4] = ACTIONS(426),
    [anon_sym_dmat2x2] = ACTIONS(426),
    [anon_sym_dmat2x3] = ACTIONS(426),
    [anon_sym_dmat2x4] = ACTIONS(426),
    [anon_sym_dmat3x2] = ACTIONS(426),
    [anon_sym_dmat3x3] = ACTIONS(426),
    [anon_sym_dmat3x4] = ACTIONS(426),
    [anon_sym_dmat4x2] = ACTIONS(426),
    [anon_sym_dmat4x3] = ACTIONS(426),
    [anon_sym_dmat4x4] = ACTIONS(426),
    [anon_sym_atomic_uint] = ACTIONS(426),
    [anon_sym_sampler1d] = ACTIONS(426),
    [anon_sym_sampler2d] = ACTIONS(426),
    [anon_sym_sampler3d] = ACTIONS(426),
    [anon_sym_samplercube] = ACTIONS(426),
    [anon_sym_sampler1DShadow] = ACTIONS(426),
    [anon_sym_sampler2DShadow] = ACTIONS(426),
    [anon_sym_samplerCubeShadow] = ACTIONS(426),
    [anon_sym_sampler1DArray] = ACTIONS(426),
    [anon_sym_sampler2DArray] = ACTIONS(426),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(426),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(426),
    [anon_sym_samplerCubeArray] = ACTIONS(426),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(426),
    [anon_sym_isampler1D] = ACTIONS(426),
    [anon_sym_isampler2D] = ACTIONS(426),
    [anon_sym_isampler3D] = ACTIONS(426),
    [anon_sym_isamplerCube] = ACTIONS(426),
    [anon_sym_isampler1DArray] = ACTIONS(426),
    [anon_sym_isampler2DArray] = ACTIONS(426),
    [anon_sym_isamplerCubeArray] = ACTIONS(426),
    [anon_sym_usampler1D] = ACTIONS(426),
    [anon_sym_usampler2D] = ACTIONS(426),
    [anon_sym_usampler3D] = ACTIONS(426),
    [anon_sym_usamplerCube] = ACTIONS(426),
    [anon_sym_usampler1DArray] = ACTIONS(426),
    [anon_sym_usampler2DArray] = ACTIONS(426),
    [anon_sym_usamplerCubeArray] = ACTIONS(426),
    [anon_sym_sampler2DRect] = ACTIONS(426),
    [anon_sym_sampler2DRectshadow] = ACTIONS(426),
    [anon_sym_isampler2DRect] = ACTIONS(426),
    [anon_sym_usampler2DRect] = ACTIONS(426),
    [anon_sym_samplerBuffer] = ACTIONS(426),
    [anon_sym_isamplerBuffer] = ACTIONS(426),
    [anon_sym_usamplerBuffer] = ACTIONS(426),
    [anon_sym_sampler2DMS] = ACTIONS(426),
    [anon_sym_isampler2DMS] = ACTIONS(426),
    [anon_sym_usampler2DMS] = ACTIONS(426),
    [anon_sym_sampler2DMSArray] = ACTIONS(426),
    [anon_sym_isampler2DMSArray] = ACTIONS(426),
    [anon_sym_usampler2DMSArray] = ACTIONS(426),
    [anon_sym_image1D] = ACTIONS(426),
    [anon_sym_iimage1D] = ACTIONS(426),
    [anon_sym_uimage1D] = ACTIONS(426),
    [anon_sym_image2D] = ACTIONS(426),
    [anon_sym_iimage2D] = ACTIONS(426),
    [anon_sym_uimage2D] = ACTIONS(426),
    [anon_sym_image3D] = ACTIONS(426),
    [anon_sym_iimage3D] = ACTIONS(426),
    [anon_sym_uimage3D] = ACTIONS(426),
    [anon_sym_image2DRect] = ACTIONS(426),
    [anon_sym_iimage2DRect] = ACTIONS(426),
    [anon_sym_uimage2DRect] = ACTIONS(426),
    [anon_sym_imageCube] = ACTIONS(426),
    [anon_sym_iimageCube] = ACTIONS(426),
    [anon_sym_uimageCube] = ACTIONS(426),
    [anon_sym_imageBuffer] = ACTIONS(426),
    [anon_sym_iimageBuffer] = ACTIONS(426),
    [anon_sym_uimageBuffer] = ACTIONS(426),
    [anon_sym_image1DArray] = ACTIONS(426),
    [anon_sym_iimage1DArray] = ACTIONS(426),
    [anon_sym_uimage1DArray] = ACTIONS(426),
    [anon_sym_image2DArray] = ACTIONS(426),
    [anon_sym_iimage2DArray] = ACTIONS(426),
    [anon_sym_uimage2DArray] = ACTIONS(426),
    [anon_sym_imageCubeArray] = ACTIONS(426),
    [anon_sym_iimageCubeArray] = ACTIONS(426),
    [anon_sym_uimageCubeArray] = ACTIONS(426),
    [anon_sym_image2DMS] = ACTIONS(426),
    [anon_sym_iimage2DMS] = ACTIONS(426),
    [anon_sym_uimage2DMS] = ACTIONS(426),
    [anon_sym_image2DMSArray] = ACTIONS(426),
    [anon_sym_iimage2DMSArray] = ACTIONS(426),
    [anon_sym_uimage2DMSArray] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(426),
    [anon_sym_inout] = ACTIONS(426),
    [anon_sym_in] = ACTIONS(426),
    [anon_sym_out] = ACTIONS(426),
    [anon_sym_centroid] = ACTIONS(426),
    [anon_sym_patch] = ACTIONS(426),
    [anon_sym_sample] = ACTIONS(426),
    [anon_sym_uniform] = ACTIONS(426),
    [anon_sym_buffer] = ACTIONS(426),
    [anon_sym_shared] = ACTIONS(426),
    [anon_sym_coherent] = ACTIONS(426),
    [anon_sym_volatile] = ACTIONS(426),
    [anon_sym_restrict] = ACTIONS(426),
    [anon_sym_readonly] = ACTIONS(426),
    [anon_sym_writeonly] = ACTIONS(426),
    [anon_sym_subroutine] = ACTIONS(426),
    [anon_sym_varying] = ACTIONS(426),
    [anon_sym_attribute] = ACTIONS(426),
    [anon_sym_layout] = ACTIONS(426),
    [anon_sym_highp] = ACTIONS(426),
    [anon_sym_mediump] = ACTIONS(426),
    [anon_sym_lowp] = ACTIONS(426),
    [anon_sym_smooth] = ACTIONS(426),
    [anon_sym_flat] = ACTIONS(426),
    [anon_sym_noperspective] = ACTIONS(426),
    [sym_invariant_qualifier] = ACTIONS(426),
    [sym_precise_qualifier] = ACTIONS(426),
    [sym_comment] = ACTIONS(25),
  },
  [108] = {
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_struct] = ACTIONS(430),
    [anon_sym_void] = ACTIONS(430),
    [anon_sym_float] = ACTIONS(430),
    [anon_sym_double] = ACTIONS(430),
    [anon_sym_int] = ACTIONS(430),
    [anon_sym_uint] = ACTIONS(430),
    [anon_sym_bool] = ACTIONS(430),
    [anon_sym_vec2] = ACTIONS(430),
    [anon_sym_vec3] = ACTIONS(430),
    [anon_sym_vec4] = ACTIONS(430),
    [anon_sym_dvec2] = ACTIONS(430),
    [anon_sym_dvec3] = ACTIONS(430),
    [anon_sym_dvec4] = ACTIONS(430),
    [anon_sym_bvec2] = ACTIONS(430),
    [anon_sym_bvec3] = ACTIONS(430),
    [anon_sym_bvec4] = ACTIONS(430),
    [anon_sym_ivec2] = ACTIONS(430),
    [anon_sym_ivec3] = ACTIONS(430),
    [anon_sym_ivec4] = ACTIONS(430),
    [anon_sym_uvec2] = ACTIONS(430),
    [anon_sym_uvec3] = ACTIONS(430),
    [anon_sym_uvec4] = ACTIONS(430),
    [anon_sym_mat2] = ACTIONS(430),
    [anon_sym_mat3] = ACTIONS(430),
    [anon_sym_mat4] = ACTIONS(430),
    [anon_sym_mat2x2] = ACTIONS(430),
    [anon_sym_mat2x3] = ACTIONS(430),
    [anon_sym_mat2x4] = ACTIONS(430),
    [anon_sym_mat3x2] = ACTIONS(430),
    [anon_sym_mat3x3] = ACTIONS(430),
    [anon_sym_mat3x4] = ACTIONS(430),
    [anon_sym_mat4x2] = ACTIONS(430),
    [anon_sym_mat4x3] = ACTIONS(430),
    [anon_sym_mat4x4] = ACTIONS(430),
    [anon_sym_dmat2] = ACTIONS(430),
    [anon_sym_dmat3] = ACTIONS(430),
    [anon_sym_dmat4] = ACTIONS(430),
    [anon_sym_dmat2x2] = ACTIONS(430),
    [anon_sym_dmat2x3] = ACTIONS(430),
    [anon_sym_dmat2x4] = ACTIONS(430),
    [anon_sym_dmat3x2] = ACTIONS(430),
    [anon_sym_dmat3x3] = ACTIONS(430),
    [anon_sym_dmat3x4] = ACTIONS(430),
    [anon_sym_dmat4x2] = ACTIONS(430),
    [anon_sym_dmat4x3] = ACTIONS(430),
    [anon_sym_dmat4x4] = ACTIONS(430),
    [anon_sym_atomic_uint] = ACTIONS(430),
    [anon_sym_sampler1d] = ACTIONS(430),
    [anon_sym_sampler2d] = ACTIONS(430),
    [anon_sym_sampler3d] = ACTIONS(430),
    [anon_sym_samplercube] = ACTIONS(430),
    [anon_sym_sampler1DShadow] = ACTIONS(430),
    [anon_sym_sampler2DShadow] = ACTIONS(430),
    [anon_sym_samplerCubeShadow] = ACTIONS(430),
    [anon_sym_sampler1DArray] = ACTIONS(430),
    [anon_sym_sampler2DArray] = ACTIONS(430),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(430),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(430),
    [anon_sym_samplerCubeArray] = ACTIONS(430),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(430),
    [anon_sym_isampler1D] = ACTIONS(430),
    [anon_sym_isampler2D] = ACTIONS(430),
    [anon_sym_isampler3D] = ACTIONS(430),
    [anon_sym_isamplerCube] = ACTIONS(430),
    [anon_sym_isampler1DArray] = ACTIONS(430),
    [anon_sym_isampler2DArray] = ACTIONS(430),
    [anon_sym_isamplerCubeArray] = ACTIONS(430),
    [anon_sym_usampler1D] = ACTIONS(430),
    [anon_sym_usampler2D] = ACTIONS(430),
    [anon_sym_usampler3D] = ACTIONS(430),
    [anon_sym_usamplerCube] = ACTIONS(430),
    [anon_sym_usampler1DArray] = ACTIONS(430),
    [anon_sym_usampler2DArray] = ACTIONS(430),
    [anon_sym_usamplerCubeArray] = ACTIONS(430),
    [anon_sym_sampler2DRect] = ACTIONS(430),
    [anon_sym_sampler2DRectshadow] = ACTIONS(430),
    [anon_sym_isampler2DRect] = ACTIONS(430),
    [anon_sym_usampler2DRect] = ACTIONS(430),
    [anon_sym_samplerBuffer] = ACTIONS(430),
    [anon_sym_isamplerBuffer] = ACTIONS(430),
    [anon_sym_usamplerBuffer] = ACTIONS(430),
    [anon_sym_sampler2DMS] = ACTIONS(430),
    [anon_sym_isampler2DMS] = ACTIONS(430),
    [anon_sym_usampler2DMS] = ACTIONS(430),
    [anon_sym_sampler2DMSArray] = ACTIONS(430),
    [anon_sym_isampler2DMSArray] = ACTIONS(430),
    [anon_sym_usampler2DMSArray] = ACTIONS(430),
    [anon_sym_image1D] = ACTIONS(430),
    [anon_sym_iimage1D] = ACTIONS(430),
    [anon_sym_uimage1D] = ACTIONS(430),
    [anon_sym_image2D] = ACTIONS(430),
    [anon_sym_iimage2D] = ACTIONS(430),
    [anon_sym_uimage2D] = ACTIONS(430),
    [anon_sym_image3D] = ACTIONS(430),
    [anon_sym_iimage3D] = ACTIONS(430),
    [anon_sym_uimage3D] = ACTIONS(430),
    [anon_sym_image2DRect] = ACTIONS(430),
    [anon_sym_iimage2DRect] = ACTIONS(430),
    [anon_sym_uimage2DRect] = ACTIONS(430),
    [anon_sym_imageCube] = ACTIONS(430),
    [anon_sym_iimageCube] = ACTIONS(430),
    [anon_sym_uimageCube] = ACTIONS(430),
    [anon_sym_imageBuffer] = ACTIONS(430),
    [anon_sym_iimageBuffer] = ACTIONS(430),
    [anon_sym_uimageBuffer] = ACTIONS(430),
    [anon_sym_image1DArray] = ACTIONS(430),
    [anon_sym_iimage1DArray] = ACTIONS(430),
    [anon_sym_uimage1DArray] = ACTIONS(430),
    [anon_sym_image2DArray] = ACTIONS(430),
    [anon_sym_iimage2DArray] = ACTIONS(430),
    [anon_sym_uimage2DArray] = ACTIONS(430),
    [anon_sym_imageCubeArray] = ACTIONS(430),
    [anon_sym_iimageCubeArray] = ACTIONS(430),
    [anon_sym_uimageCubeArray] = ACTIONS(430),
    [anon_sym_image2DMS] = ACTIONS(430),
    [anon_sym_iimage2DMS] = ACTIONS(430),
    [anon_sym_uimage2DMS] = ACTIONS(430),
    [anon_sym_image2DMSArray] = ACTIONS(430),
    [anon_sym_iimage2DMSArray] = ACTIONS(430),
    [anon_sym_uimage2DMSArray] = ACTIONS(430),
    [anon_sym_const] = ACTIONS(430),
    [anon_sym_inout] = ACTIONS(430),
    [anon_sym_in] = ACTIONS(430),
    [anon_sym_out] = ACTIONS(430),
    [anon_sym_centroid] = ACTIONS(430),
    [anon_sym_patch] = ACTIONS(430),
    [anon_sym_sample] = ACTIONS(430),
    [anon_sym_uniform] = ACTIONS(430),
    [anon_sym_buffer] = ACTIONS(430),
    [anon_sym_shared] = ACTIONS(430),
    [anon_sym_coherent] = ACTIONS(430),
    [anon_sym_volatile] = ACTIONS(430),
    [anon_sym_restrict] = ACTIONS(430),
    [anon_sym_readonly] = ACTIONS(430),
    [anon_sym_writeonly] = ACTIONS(430),
    [anon_sym_subroutine] = ACTIONS(430),
    [anon_sym_varying] = ACTIONS(430),
    [anon_sym_attribute] = ACTIONS(430),
    [anon_sym_layout] = ACTIONS(430),
    [anon_sym_highp] = ACTIONS(430),
    [anon_sym_mediump] = ACTIONS(430),
    [anon_sym_lowp] = ACTIONS(430),
    [anon_sym_smooth] = ACTIONS(430),
    [anon_sym_flat] = ACTIONS(430),
    [anon_sym_noperspective] = ACTIONS(430),
    [sym_invariant_qualifier] = ACTIONS(430),
    [sym_precise_qualifier] = ACTIONS(430),
    [sym_comment] = ACTIONS(25),
  },
  [109] = {
    [sym_identifier] = ACTIONS(404),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_struct] = ACTIONS(404),
    [anon_sym_void] = ACTIONS(404),
    [anon_sym_float] = ACTIONS(404),
    [anon_sym_double] = ACTIONS(404),
    [anon_sym_int] = ACTIONS(404),
    [anon_sym_uint] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_vec2] = ACTIONS(404),
    [anon_sym_vec3] = ACTIONS(404),
    [anon_sym_vec4] = ACTIONS(404),
    [anon_sym_dvec2] = ACTIONS(404),
    [anon_sym_dvec3] = ACTIONS(404),
    [anon_sym_dvec4] = ACTIONS(404),
    [anon_sym_bvec2] = ACTIONS(404),
    [anon_sym_bvec3] = ACTIONS(404),
    [anon_sym_bvec4] = ACTIONS(404),
    [anon_sym_ivec2] = ACTIONS(404),
    [anon_sym_ivec3] = ACTIONS(404),
    [anon_sym_ivec4] = ACTIONS(404),
    [anon_sym_uvec2] = ACTIONS(404),
    [anon_sym_uvec3] = ACTIONS(404),
    [anon_sym_uvec4] = ACTIONS(404),
    [anon_sym_mat2] = ACTIONS(404),
    [anon_sym_mat3] = ACTIONS(404),
    [anon_sym_mat4] = ACTIONS(404),
    [anon_sym_mat2x2] = ACTIONS(404),
    [anon_sym_mat2x3] = ACTIONS(404),
    [anon_sym_mat2x4] = ACTIONS(404),
    [anon_sym_mat3x2] = ACTIONS(404),
    [anon_sym_mat3x3] = ACTIONS(404),
    [anon_sym_mat3x4] = ACTIONS(404),
    [anon_sym_mat4x2] = ACTIONS(404),
    [anon_sym_mat4x3] = ACTIONS(404),
    [anon_sym_mat4x4] = ACTIONS(404),
    [anon_sym_dmat2] = ACTIONS(404),
    [anon_sym_dmat3] = ACTIONS(404),
    [anon_sym_dmat4] = ACTIONS(404),
    [anon_sym_dmat2x2] = ACTIONS(404),
    [anon_sym_dmat2x3] = ACTIONS(404),
    [anon_sym_dmat2x4] = ACTIONS(404),
    [anon_sym_dmat3x2] = ACTIONS(404),
    [anon_sym_dmat3x3] = ACTIONS(404),
    [anon_sym_dmat3x4] = ACTIONS(404),
    [anon_sym_dmat4x2] = ACTIONS(404),
    [anon_sym_dmat4x3] = ACTIONS(404),
    [anon_sym_dmat4x4] = ACTIONS(404),
    [anon_sym_atomic_uint] = ACTIONS(404),
    [anon_sym_sampler1d] = ACTIONS(404),
    [anon_sym_sampler2d] = ACTIONS(404),
    [anon_sym_sampler3d] = ACTIONS(404),
    [anon_sym_samplercube] = ACTIONS(404),
    [anon_sym_sampler1DShadow] = ACTIONS(404),
    [anon_sym_sampler2DShadow] = ACTIONS(404),
    [anon_sym_samplerCubeShadow] = ACTIONS(404),
    [anon_sym_sampler1DArray] = ACTIONS(404),
    [anon_sym_sampler2DArray] = ACTIONS(404),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(404),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(404),
    [anon_sym_samplerCubeArray] = ACTIONS(404),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(404),
    [anon_sym_isampler1D] = ACTIONS(404),
    [anon_sym_isampler2D] = ACTIONS(404),
    [anon_sym_isampler3D] = ACTIONS(404),
    [anon_sym_isamplerCube] = ACTIONS(404),
    [anon_sym_isampler1DArray] = ACTIONS(404),
    [anon_sym_isampler2DArray] = ACTIONS(404),
    [anon_sym_isamplerCubeArray] = ACTIONS(404),
    [anon_sym_usampler1D] = ACTIONS(404),
    [anon_sym_usampler2D] = ACTIONS(404),
    [anon_sym_usampler3D] = ACTIONS(404),
    [anon_sym_usamplerCube] = ACTIONS(404),
    [anon_sym_usampler1DArray] = ACTIONS(404),
    [anon_sym_usampler2DArray] = ACTIONS(404),
    [anon_sym_usamplerCubeArray] = ACTIONS(404),
    [anon_sym_sampler2DRect] = ACTIONS(404),
    [anon_sym_sampler2DRectshadow] = ACTIONS(404),
    [anon_sym_isampler2DRect] = ACTIONS(404),
    [anon_sym_usampler2DRect] = ACTIONS(404),
    [anon_sym_samplerBuffer] = ACTIONS(404),
    [anon_sym_isamplerBuffer] = ACTIONS(404),
    [anon_sym_usamplerBuffer] = ACTIONS(404),
    [anon_sym_sampler2DMS] = ACTIONS(404),
    [anon_sym_isampler2DMS] = ACTIONS(404),
    [anon_sym_usampler2DMS] = ACTIONS(404),
    [anon_sym_sampler2DMSArray] = ACTIONS(404),
    [anon_sym_isampler2DMSArray] = ACTIONS(404),
    [anon_sym_usampler2DMSArray] = ACTIONS(404),
    [anon_sym_image1D] = ACTIONS(404),
    [anon_sym_iimage1D] = ACTIONS(404),
    [anon_sym_uimage1D] = ACTIONS(404),
    [anon_sym_image2D] = ACTIONS(404),
    [anon_sym_iimage2D] = ACTIONS(404),
    [anon_sym_uimage2D] = ACTIONS(404),
    [anon_sym_image3D] = ACTIONS(404),
    [anon_sym_iimage3D] = ACTIONS(404),
    [anon_sym_uimage3D] = ACTIONS(404),
    [anon_sym_image2DRect] = ACTIONS(404),
    [anon_sym_iimage2DRect] = ACTIONS(404),
    [anon_sym_uimage2DRect] = ACTIONS(404),
    [anon_sym_imageCube] = ACTIONS(404),
    [anon_sym_iimageCube] = ACTIONS(404),
    [anon_sym_uimageCube] = ACTIONS(404),
    [anon_sym_imageBuffer] = ACTIONS(404),
    [anon_sym_iimageBuffer] = ACTIONS(404),
    [anon_sym_uimageBuffer] = ACTIONS(404),
    [anon_sym_image1DArray] = ACTIONS(404),
    [anon_sym_iimage1DArray] = ACTIONS(404),
    [anon_sym_uimage1DArray] = ACTIONS(404),
    [anon_sym_image2DArray] = ACTIONS(404),
    [anon_sym_iimage2DArray] = ACTIONS(404),
    [anon_sym_uimage2DArray] = ACTIONS(404),
    [anon_sym_imageCubeArray] = ACTIONS(404),
    [anon_sym_iimageCubeArray] = ACTIONS(404),
    [anon_sym_uimageCubeArray] = ACTIONS(404),
    [anon_sym_image2DMS] = ACTIONS(404),
    [anon_sym_iimage2DMS] = ACTIONS(404),
    [anon_sym_uimage2DMS] = ACTIONS(404),
    [anon_sym_image2DMSArray] = ACTIONS(404),
    [anon_sym_iimage2DMSArray] = ACTIONS(404),
    [anon_sym_uimage2DMSArray] = ACTIONS(404),
    [anon_sym_const] = ACTIONS(404),
    [anon_sym_inout] = ACTIONS(404),
    [anon_sym_in] = ACTIONS(404),
    [anon_sym_out] = ACTIONS(404),
    [anon_sym_centroid] = ACTIONS(404),
    [anon_sym_patch] = ACTIONS(404),
    [anon_sym_sample] = ACTIONS(404),
    [anon_sym_uniform] = ACTIONS(404),
    [anon_sym_buffer] = ACTIONS(404),
    [anon_sym_shared] = ACTIONS(404),
    [anon_sym_coherent] = ACTIONS(404),
    [anon_sym_volatile] = ACTIONS(404),
    [anon_sym_restrict] = ACTIONS(404),
    [anon_sym_readonly] = ACTIONS(404),
    [anon_sym_writeonly] = ACTIONS(404),
    [anon_sym_subroutine] = ACTIONS(404),
    [anon_sym_varying] = ACTIONS(404),
    [anon_sym_attribute] = ACTIONS(404),
    [anon_sym_layout] = ACTIONS(404),
    [anon_sym_highp] = ACTIONS(404),
    [anon_sym_mediump] = ACTIONS(404),
    [anon_sym_lowp] = ACTIONS(404),
    [anon_sym_smooth] = ACTIONS(404),
    [anon_sym_flat] = ACTIONS(404),
    [anon_sym_noperspective] = ACTIONS(404),
    [sym_invariant_qualifier] = ACTIONS(404),
    [sym_precise_qualifier] = ACTIONS(404),
    [sym_comment] = ACTIONS(25),
  },
  [110] = {
    [sym_identifier] = ACTIONS(434),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_struct] = ACTIONS(434),
    [anon_sym_void] = ACTIONS(434),
    [anon_sym_float] = ACTIONS(434),
    [anon_sym_double] = ACTIONS(434),
    [anon_sym_int] = ACTIONS(434),
    [anon_sym_uint] = ACTIONS(434),
    [anon_sym_bool] = ACTIONS(434),
    [anon_sym_vec2] = ACTIONS(434),
    [anon_sym_vec3] = ACTIONS(434),
    [anon_sym_vec4] = ACTIONS(434),
    [anon_sym_dvec2] = ACTIONS(434),
    [anon_sym_dvec3] = ACTIONS(434),
    [anon_sym_dvec4] = ACTIONS(434),
    [anon_sym_bvec2] = ACTIONS(434),
    [anon_sym_bvec3] = ACTIONS(434),
    [anon_sym_bvec4] = ACTIONS(434),
    [anon_sym_ivec2] = ACTIONS(434),
    [anon_sym_ivec3] = ACTIONS(434),
    [anon_sym_ivec4] = ACTIONS(434),
    [anon_sym_uvec2] = ACTIONS(434),
    [anon_sym_uvec3] = ACTIONS(434),
    [anon_sym_uvec4] = ACTIONS(434),
    [anon_sym_mat2] = ACTIONS(434),
    [anon_sym_mat3] = ACTIONS(434),
    [anon_sym_mat4] = ACTIONS(434),
    [anon_sym_mat2x2] = ACTIONS(434),
    [anon_sym_mat2x3] = ACTIONS(434),
    [anon_sym_mat2x4] = ACTIONS(434),
    [anon_sym_mat3x2] = ACTIONS(434),
    [anon_sym_mat3x3] = ACTIONS(434),
    [anon_sym_mat3x4] = ACTIONS(434),
    [anon_sym_mat4x2] = ACTIONS(434),
    [anon_sym_mat4x3] = ACTIONS(434),
    [anon_sym_mat4x4] = ACTIONS(434),
    [anon_sym_dmat2] = ACTIONS(434),
    [anon_sym_dmat3] = ACTIONS(434),
    [anon_sym_dmat4] = ACTIONS(434),
    [anon_sym_dmat2x2] = ACTIONS(434),
    [anon_sym_dmat2x3] = ACTIONS(434),
    [anon_sym_dmat2x4] = ACTIONS(434),
    [anon_sym_dmat3x2] = ACTIONS(434),
    [anon_sym_dmat3x3] = ACTIONS(434),
    [anon_sym_dmat3x4] = ACTIONS(434),
    [anon_sym_dmat4x2] = ACTIONS(434),
    [anon_sym_dmat4x3] = ACTIONS(434),
    [anon_sym_dmat4x4] = ACTIONS(434),
    [anon_sym_atomic_uint] = ACTIONS(434),
    [anon_sym_sampler1d] = ACTIONS(434),
    [anon_sym_sampler2d] = ACTIONS(434),
    [anon_sym_sampler3d] = ACTIONS(434),
    [anon_sym_samplercube] = ACTIONS(434),
    [anon_sym_sampler1DShadow] = ACTIONS(434),
    [anon_sym_sampler2DShadow] = ACTIONS(434),
    [anon_sym_samplerCubeShadow] = ACTIONS(434),
    [anon_sym_sampler1DArray] = ACTIONS(434),
    [anon_sym_sampler2DArray] = ACTIONS(434),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(434),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(434),
    [anon_sym_samplerCubeArray] = ACTIONS(434),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(434),
    [anon_sym_isampler1D] = ACTIONS(434),
    [anon_sym_isampler2D] = ACTIONS(434),
    [anon_sym_isampler3D] = ACTIONS(434),
    [anon_sym_isamplerCube] = ACTIONS(434),
    [anon_sym_isampler1DArray] = ACTIONS(434),
    [anon_sym_isampler2DArray] = ACTIONS(434),
    [anon_sym_isamplerCubeArray] = ACTIONS(434),
    [anon_sym_usampler1D] = ACTIONS(434),
    [anon_sym_usampler2D] = ACTIONS(434),
    [anon_sym_usampler3D] = ACTIONS(434),
    [anon_sym_usamplerCube] = ACTIONS(434),
    [anon_sym_usampler1DArray] = ACTIONS(434),
    [anon_sym_usampler2DArray] = ACTIONS(434),
    [anon_sym_usamplerCubeArray] = ACTIONS(434),
    [anon_sym_sampler2DRect] = ACTIONS(434),
    [anon_sym_sampler2DRectshadow] = ACTIONS(434),
    [anon_sym_isampler2DRect] = ACTIONS(434),
    [anon_sym_usampler2DRect] = ACTIONS(434),
    [anon_sym_samplerBuffer] = ACTIONS(434),
    [anon_sym_isamplerBuffer] = ACTIONS(434),
    [anon_sym_usamplerBuffer] = ACTIONS(434),
    [anon_sym_sampler2DMS] = ACTIONS(434),
    [anon_sym_isampler2DMS] = ACTIONS(434),
    [anon_sym_usampler2DMS] = ACTIONS(434),
    [anon_sym_sampler2DMSArray] = ACTIONS(434),
    [anon_sym_isampler2DMSArray] = ACTIONS(434),
    [anon_sym_usampler2DMSArray] = ACTIONS(434),
    [anon_sym_image1D] = ACTIONS(434),
    [anon_sym_iimage1D] = ACTIONS(434),
    [anon_sym_uimage1D] = ACTIONS(434),
    [anon_sym_image2D] = ACTIONS(434),
    [anon_sym_iimage2D] = ACTIONS(434),
    [anon_sym_uimage2D] = ACTIONS(434),
    [anon_sym_image3D] = ACTIONS(434),
    [anon_sym_iimage3D] = ACTIONS(434),
    [anon_sym_uimage3D] = ACTIONS(434),
    [anon_sym_image2DRect] = ACTIONS(434),
    [anon_sym_iimage2DRect] = ACTIONS(434),
    [anon_sym_uimage2DRect] = ACTIONS(434),
    [anon_sym_imageCube] = ACTIONS(434),
    [anon_sym_iimageCube] = ACTIONS(434),
    [anon_sym_uimageCube] = ACTIONS(434),
    [anon_sym_imageBuffer] = ACTIONS(434),
    [anon_sym_iimageBuffer] = ACTIONS(434),
    [anon_sym_uimageBuffer] = ACTIONS(434),
    [anon_sym_image1DArray] = ACTIONS(434),
    [anon_sym_iimage1DArray] = ACTIONS(434),
    [anon_sym_uimage1DArray] = ACTIONS(434),
    [anon_sym_image2DArray] = ACTIONS(434),
    [anon_sym_iimage2DArray] = ACTIONS(434),
    [anon_sym_uimage2DArray] = ACTIONS(434),
    [anon_sym_imageCubeArray] = ACTIONS(434),
    [anon_sym_iimageCubeArray] = ACTIONS(434),
    [anon_sym_uimageCubeArray] = ACTIONS(434),
    [anon_sym_image2DMS] = ACTIONS(434),
    [anon_sym_iimage2DMS] = ACTIONS(434),
    [anon_sym_uimage2DMS] = ACTIONS(434),
    [anon_sym_image2DMSArray] = ACTIONS(434),
    [anon_sym_iimage2DMSArray] = ACTIONS(434),
    [anon_sym_uimage2DMSArray] = ACTIONS(434),
    [anon_sym_const] = ACTIONS(434),
    [anon_sym_inout] = ACTIONS(434),
    [anon_sym_in] = ACTIONS(434),
    [anon_sym_out] = ACTIONS(434),
    [anon_sym_centroid] = ACTIONS(434),
    [anon_sym_patch] = ACTIONS(434),
    [anon_sym_sample] = ACTIONS(434),
    [anon_sym_uniform] = ACTIONS(434),
    [anon_sym_buffer] = ACTIONS(434),
    [anon_sym_shared] = ACTIONS(434),
    [anon_sym_coherent] = ACTIONS(434),
    [anon_sym_volatile] = ACTIONS(434),
    [anon_sym_restrict] = ACTIONS(434),
    [anon_sym_readonly] = ACTIONS(434),
    [anon_sym_writeonly] = ACTIONS(434),
    [anon_sym_subroutine] = ACTIONS(434),
    [anon_sym_varying] = ACTIONS(434),
    [anon_sym_attribute] = ACTIONS(434),
    [anon_sym_layout] = ACTIONS(434),
    [anon_sym_highp] = ACTIONS(434),
    [anon_sym_mediump] = ACTIONS(434),
    [anon_sym_lowp] = ACTIONS(434),
    [anon_sym_smooth] = ACTIONS(434),
    [anon_sym_flat] = ACTIONS(434),
    [anon_sym_noperspective] = ACTIONS(434),
    [sym_invariant_qualifier] = ACTIONS(434),
    [sym_precise_qualifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(25),
  },
  [111] = {
    [sym_identifier] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(440),
    [anon_sym_struct] = ACTIONS(438),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_int] = ACTIONS(438),
    [anon_sym_uint] = ACTIONS(438),
    [anon_sym_bool] = ACTIONS(438),
    [anon_sym_vec2] = ACTIONS(438),
    [anon_sym_vec3] = ACTIONS(438),
    [anon_sym_vec4] = ACTIONS(438),
    [anon_sym_dvec2] = ACTIONS(438),
    [anon_sym_dvec3] = ACTIONS(438),
    [anon_sym_dvec4] = ACTIONS(438),
    [anon_sym_bvec2] = ACTIONS(438),
    [anon_sym_bvec3] = ACTIONS(438),
    [anon_sym_bvec4] = ACTIONS(438),
    [anon_sym_ivec2] = ACTIONS(438),
    [anon_sym_ivec3] = ACTIONS(438),
    [anon_sym_ivec4] = ACTIONS(438),
    [anon_sym_uvec2] = ACTIONS(438),
    [anon_sym_uvec3] = ACTIONS(438),
    [anon_sym_uvec4] = ACTIONS(438),
    [anon_sym_mat2] = ACTIONS(438),
    [anon_sym_mat3] = ACTIONS(438),
    [anon_sym_mat4] = ACTIONS(438),
    [anon_sym_mat2x2] = ACTIONS(438),
    [anon_sym_mat2x3] = ACTIONS(438),
    [anon_sym_mat2x4] = ACTIONS(438),
    [anon_sym_mat3x2] = ACTIONS(438),
    [anon_sym_mat3x3] = ACTIONS(438),
    [anon_sym_mat3x4] = ACTIONS(438),
    [anon_sym_mat4x2] = ACTIONS(438),
    [anon_sym_mat4x3] = ACTIONS(438),
    [anon_sym_mat4x4] = ACTIONS(438),
    [anon_sym_dmat2] = ACTIONS(438),
    [anon_sym_dmat3] = ACTIONS(438),
    [anon_sym_dmat4] = ACTIONS(438),
    [anon_sym_dmat2x2] = ACTIONS(438),
    [anon_sym_dmat2x3] = ACTIONS(438),
    [anon_sym_dmat2x4] = ACTIONS(438),
    [anon_sym_dmat3x2] = ACTIONS(438),
    [anon_sym_dmat3x3] = ACTIONS(438),
    [anon_sym_dmat3x4] = ACTIONS(438),
    [anon_sym_dmat4x2] = ACTIONS(438),
    [anon_sym_dmat4x3] = ACTIONS(438),
    [anon_sym_dmat4x4] = ACTIONS(438),
    [anon_sym_atomic_uint] = ACTIONS(438),
    [anon_sym_sampler1d] = ACTIONS(438),
    [anon_sym_sampler2d] = ACTIONS(438),
    [anon_sym_sampler3d] = ACTIONS(438),
    [anon_sym_samplercube] = ACTIONS(438),
    [anon_sym_sampler1DShadow] = ACTIONS(438),
    [anon_sym_sampler2DShadow] = ACTIONS(438),
    [anon_sym_samplerCubeShadow] = ACTIONS(438),
    [anon_sym_sampler1DArray] = ACTIONS(438),
    [anon_sym_sampler2DArray] = ACTIONS(438),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(438),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(438),
    [anon_sym_samplerCubeArray] = ACTIONS(438),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(438),
    [anon_sym_isampler1D] = ACTIONS(438),
    [anon_sym_isampler2D] = ACTIONS(438),
    [anon_sym_isampler3D] = ACTIONS(438),
    [anon_sym_isamplerCube] = ACTIONS(438),
    [anon_sym_isampler1DArray] = ACTIONS(438),
    [anon_sym_isampler2DArray] = ACTIONS(438),
    [anon_sym_isamplerCubeArray] = ACTIONS(438),
    [anon_sym_usampler1D] = ACTIONS(438),
    [anon_sym_usampler2D] = ACTIONS(438),
    [anon_sym_usampler3D] = ACTIONS(438),
    [anon_sym_usamplerCube] = ACTIONS(438),
    [anon_sym_usampler1DArray] = ACTIONS(438),
    [anon_sym_usampler2DArray] = ACTIONS(438),
    [anon_sym_usamplerCubeArray] = ACTIONS(438),
    [anon_sym_sampler2DRect] = ACTIONS(438),
    [anon_sym_sampler2DRectshadow] = ACTIONS(438),
    [anon_sym_isampler2DRect] = ACTIONS(438),
    [anon_sym_usampler2DRect] = ACTIONS(438),
    [anon_sym_samplerBuffer] = ACTIONS(438),
    [anon_sym_isamplerBuffer] = ACTIONS(438),
    [anon_sym_usamplerBuffer] = ACTIONS(438),
    [anon_sym_sampler2DMS] = ACTIONS(438),
    [anon_sym_isampler2DMS] = ACTIONS(438),
    [anon_sym_usampler2DMS] = ACTIONS(438),
    [anon_sym_sampler2DMSArray] = ACTIONS(438),
    [anon_sym_isampler2DMSArray] = ACTIONS(438),
    [anon_sym_usampler2DMSArray] = ACTIONS(438),
    [anon_sym_image1D] = ACTIONS(438),
    [anon_sym_iimage1D] = ACTIONS(438),
    [anon_sym_uimage1D] = ACTIONS(438),
    [anon_sym_image2D] = ACTIONS(438),
    [anon_sym_iimage2D] = ACTIONS(438),
    [anon_sym_uimage2D] = ACTIONS(438),
    [anon_sym_image3D] = ACTIONS(438),
    [anon_sym_iimage3D] = ACTIONS(438),
    [anon_sym_uimage3D] = ACTIONS(438),
    [anon_sym_image2DRect] = ACTIONS(438),
    [anon_sym_iimage2DRect] = ACTIONS(438),
    [anon_sym_uimage2DRect] = ACTIONS(438),
    [anon_sym_imageCube] = ACTIONS(438),
    [anon_sym_iimageCube] = ACTIONS(438),
    [anon_sym_uimageCube] = ACTIONS(438),
    [anon_sym_imageBuffer] = ACTIONS(438),
    [anon_sym_iimageBuffer] = ACTIONS(438),
    [anon_sym_uimageBuffer] = ACTIONS(438),
    [anon_sym_image1DArray] = ACTIONS(438),
    [anon_sym_iimage1DArray] = ACTIONS(438),
    [anon_sym_uimage1DArray] = ACTIONS(438),
    [anon_sym_image2DArray] = ACTIONS(438),
    [anon_sym_iimage2DArray] = ACTIONS(438),
    [anon_sym_uimage2DArray] = ACTIONS(438),
    [anon_sym_imageCubeArray] = ACTIONS(438),
    [anon_sym_iimageCubeArray] = ACTIONS(438),
    [anon_sym_uimageCubeArray] = ACTIONS(438),
    [anon_sym_image2DMS] = ACTIONS(438),
    [anon_sym_iimage2DMS] = ACTIONS(438),
    [anon_sym_uimage2DMS] = ACTIONS(438),
    [anon_sym_image2DMSArray] = ACTIONS(438),
    [anon_sym_iimage2DMSArray] = ACTIONS(438),
    [anon_sym_uimage2DMSArray] = ACTIONS(438),
    [anon_sym_const] = ACTIONS(438),
    [anon_sym_inout] = ACTIONS(438),
    [anon_sym_in] = ACTIONS(438),
    [anon_sym_out] = ACTIONS(438),
    [anon_sym_centroid] = ACTIONS(438),
    [anon_sym_patch] = ACTIONS(438),
    [anon_sym_sample] = ACTIONS(438),
    [anon_sym_uniform] = ACTIONS(438),
    [anon_sym_buffer] = ACTIONS(438),
    [anon_sym_shared] = ACTIONS(438),
    [anon_sym_coherent] = ACTIONS(438),
    [anon_sym_volatile] = ACTIONS(438),
    [anon_sym_restrict] = ACTIONS(438),
    [anon_sym_readonly] = ACTIONS(438),
    [anon_sym_writeonly] = ACTIONS(438),
    [anon_sym_subroutine] = ACTIONS(438),
    [anon_sym_varying] = ACTIONS(438),
    [anon_sym_attribute] = ACTIONS(438),
    [anon_sym_layout] = ACTIONS(438),
    [anon_sym_highp] = ACTIONS(438),
    [anon_sym_mediump] = ACTIONS(438),
    [anon_sym_lowp] = ACTIONS(438),
    [anon_sym_smooth] = ACTIONS(438),
    [anon_sym_flat] = ACTIONS(438),
    [anon_sym_noperspective] = ACTIONS(438),
    [sym_invariant_qualifier] = ACTIONS(438),
    [sym_precise_qualifier] = ACTIONS(438),
    [sym_comment] = ACTIONS(25),
  },
  [112] = {
    [sym_identifier] = ACTIONS(442),
    [anon_sym_SEMI] = ACTIONS(444),
    [anon_sym_struct] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(442),
    [anon_sym_float] = ACTIONS(442),
    [anon_sym_double] = ACTIONS(442),
    [anon_sym_int] = ACTIONS(442),
    [anon_sym_uint] = ACTIONS(442),
    [anon_sym_bool] = ACTIONS(442),
    [anon_sym_vec2] = ACTIONS(442),
    [anon_sym_vec3] = ACTIONS(442),
    [anon_sym_vec4] = ACTIONS(442),
    [anon_sym_dvec2] = ACTIONS(442),
    [anon_sym_dvec3] = ACTIONS(442),
    [anon_sym_dvec4] = ACTIONS(442),
    [anon_sym_bvec2] = ACTIONS(442),
    [anon_sym_bvec3] = ACTIONS(442),
    [anon_sym_bvec4] = ACTIONS(442),
    [anon_sym_ivec2] = ACTIONS(442),
    [anon_sym_ivec3] = ACTIONS(442),
    [anon_sym_ivec4] = ACTIONS(442),
    [anon_sym_uvec2] = ACTIONS(442),
    [anon_sym_uvec3] = ACTIONS(442),
    [anon_sym_uvec4] = ACTIONS(442),
    [anon_sym_mat2] = ACTIONS(442),
    [anon_sym_mat3] = ACTIONS(442),
    [anon_sym_mat4] = ACTIONS(442),
    [anon_sym_mat2x2] = ACTIONS(442),
    [anon_sym_mat2x3] = ACTIONS(442),
    [anon_sym_mat2x4] = ACTIONS(442),
    [anon_sym_mat3x2] = ACTIONS(442),
    [anon_sym_mat3x3] = ACTIONS(442),
    [anon_sym_mat3x4] = ACTIONS(442),
    [anon_sym_mat4x2] = ACTIONS(442),
    [anon_sym_mat4x3] = ACTIONS(442),
    [anon_sym_mat4x4] = ACTIONS(442),
    [anon_sym_dmat2] = ACTIONS(442),
    [anon_sym_dmat3] = ACTIONS(442),
    [anon_sym_dmat4] = ACTIONS(442),
    [anon_sym_dmat2x2] = ACTIONS(442),
    [anon_sym_dmat2x3] = ACTIONS(442),
    [anon_sym_dmat2x4] = ACTIONS(442),
    [anon_sym_dmat3x2] = ACTIONS(442),
    [anon_sym_dmat3x3] = ACTIONS(442),
    [anon_sym_dmat3x4] = ACTIONS(442),
    [anon_sym_dmat4x2] = ACTIONS(442),
    [anon_sym_dmat4x3] = ACTIONS(442),
    [anon_sym_dmat4x4] = ACTIONS(442),
    [anon_sym_atomic_uint] = ACTIONS(442),
    [anon_sym_sampler1d] = ACTIONS(442),
    [anon_sym_sampler2d] = ACTIONS(442),
    [anon_sym_sampler3d] = ACTIONS(442),
    [anon_sym_samplercube] = ACTIONS(442),
    [anon_sym_sampler1DShadow] = ACTIONS(442),
    [anon_sym_sampler2DShadow] = ACTIONS(442),
    [anon_sym_samplerCubeShadow] = ACTIONS(442),
    [anon_sym_sampler1DArray] = ACTIONS(442),
    [anon_sym_sampler2DArray] = ACTIONS(442),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(442),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(442),
    [anon_sym_samplerCubeArray] = ACTIONS(442),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(442),
    [anon_sym_isampler1D] = ACTIONS(442),
    [anon_sym_isampler2D] = ACTIONS(442),
    [anon_sym_isampler3D] = ACTIONS(442),
    [anon_sym_isamplerCube] = ACTIONS(442),
    [anon_sym_isampler1DArray] = ACTIONS(442),
    [anon_sym_isampler2DArray] = ACTIONS(442),
    [anon_sym_isamplerCubeArray] = ACTIONS(442),
    [anon_sym_usampler1D] = ACTIONS(442),
    [anon_sym_usampler2D] = ACTIONS(442),
    [anon_sym_usampler3D] = ACTIONS(442),
    [anon_sym_usamplerCube] = ACTIONS(442),
    [anon_sym_usampler1DArray] = ACTIONS(442),
    [anon_sym_usampler2DArray] = ACTIONS(442),
    [anon_sym_usamplerCubeArray] = ACTIONS(442),
    [anon_sym_sampler2DRect] = ACTIONS(442),
    [anon_sym_sampler2DRectshadow] = ACTIONS(442),
    [anon_sym_isampler2DRect] = ACTIONS(442),
    [anon_sym_usampler2DRect] = ACTIONS(442),
    [anon_sym_samplerBuffer] = ACTIONS(442),
    [anon_sym_isamplerBuffer] = ACTIONS(442),
    [anon_sym_usamplerBuffer] = ACTIONS(442),
    [anon_sym_sampler2DMS] = ACTIONS(442),
    [anon_sym_isampler2DMS] = ACTIONS(442),
    [anon_sym_usampler2DMS] = ACTIONS(442),
    [anon_sym_sampler2DMSArray] = ACTIONS(442),
    [anon_sym_isampler2DMSArray] = ACTIONS(442),
    [anon_sym_usampler2DMSArray] = ACTIONS(442),
    [anon_sym_image1D] = ACTIONS(442),
    [anon_sym_iimage1D] = ACTIONS(442),
    [anon_sym_uimage1D] = ACTIONS(442),
    [anon_sym_image2D] = ACTIONS(442),
    [anon_sym_iimage2D] = ACTIONS(442),
    [anon_sym_uimage2D] = ACTIONS(442),
    [anon_sym_image3D] = ACTIONS(442),
    [anon_sym_iimage3D] = ACTIONS(442),
    [anon_sym_uimage3D] = ACTIONS(442),
    [anon_sym_image2DRect] = ACTIONS(442),
    [anon_sym_iimage2DRect] = ACTIONS(442),
    [anon_sym_uimage2DRect] = ACTIONS(442),
    [anon_sym_imageCube] = ACTIONS(442),
    [anon_sym_iimageCube] = ACTIONS(442),
    [anon_sym_uimageCube] = ACTIONS(442),
    [anon_sym_imageBuffer] = ACTIONS(442),
    [anon_sym_iimageBuffer] = ACTIONS(442),
    [anon_sym_uimageBuffer] = ACTIONS(442),
    [anon_sym_image1DArray] = ACTIONS(442),
    [anon_sym_iimage1DArray] = ACTIONS(442),
    [anon_sym_uimage1DArray] = ACTIONS(442),
    [anon_sym_image2DArray] = ACTIONS(442),
    [anon_sym_iimage2DArray] = ACTIONS(442),
    [anon_sym_uimage2DArray] = ACTIONS(442),
    [anon_sym_imageCubeArray] = ACTIONS(442),
    [anon_sym_iimageCubeArray] = ACTIONS(442),
    [anon_sym_uimageCubeArray] = ACTIONS(442),
    [anon_sym_image2DMS] = ACTIONS(442),
    [anon_sym_iimage2DMS] = ACTIONS(442),
    [anon_sym_uimage2DMS] = ACTIONS(442),
    [anon_sym_image2DMSArray] = ACTIONS(442),
    [anon_sym_iimage2DMSArray] = ACTIONS(442),
    [anon_sym_uimage2DMSArray] = ACTIONS(442),
    [anon_sym_const] = ACTIONS(442),
    [anon_sym_inout] = ACTIONS(442),
    [anon_sym_in] = ACTIONS(442),
    [anon_sym_out] = ACTIONS(442),
    [anon_sym_centroid] = ACTIONS(442),
    [anon_sym_patch] = ACTIONS(442),
    [anon_sym_sample] = ACTIONS(442),
    [anon_sym_uniform] = ACTIONS(442),
    [anon_sym_buffer] = ACTIONS(442),
    [anon_sym_shared] = ACTIONS(442),
    [anon_sym_coherent] = ACTIONS(442),
    [anon_sym_volatile] = ACTIONS(442),
    [anon_sym_restrict] = ACTIONS(442),
    [anon_sym_readonly] = ACTIONS(442),
    [anon_sym_writeonly] = ACTIONS(442),
    [anon_sym_subroutine] = ACTIONS(442),
    [anon_sym_varying] = ACTIONS(442),
    [anon_sym_attribute] = ACTIONS(442),
    [anon_sym_layout] = ACTIONS(442),
    [anon_sym_highp] = ACTIONS(442),
    [anon_sym_mediump] = ACTIONS(442),
    [anon_sym_lowp] = ACTIONS(442),
    [anon_sym_smooth] = ACTIONS(442),
    [anon_sym_flat] = ACTIONS(442),
    [anon_sym_noperspective] = ACTIONS(442),
    [sym_invariant_qualifier] = ACTIONS(442),
    [sym_precise_qualifier] = ACTIONS(442),
    [sym_comment] = ACTIONS(25),
  },
  [113] = {
    [sym_identifier] = ACTIONS(446),
    [anon_sym_RBRACE] = ACTIONS(448),
    [anon_sym_struct] = ACTIONS(446),
    [anon_sym_void] = ACTIONS(446),
    [anon_sym_float] = ACTIONS(446),
    [anon_sym_double] = ACTIONS(446),
    [anon_sym_int] = ACTIONS(446),
    [anon_sym_uint] = ACTIONS(446),
    [anon_sym_bool] = ACTIONS(446),
    [anon_sym_vec2] = ACTIONS(446),
    [anon_sym_vec3] = ACTIONS(446),
    [anon_sym_vec4] = ACTIONS(446),
    [anon_sym_dvec2] = ACTIONS(446),
    [anon_sym_dvec3] = ACTIONS(446),
    [anon_sym_dvec4] = ACTIONS(446),
    [anon_sym_bvec2] = ACTIONS(446),
    [anon_sym_bvec3] = ACTIONS(446),
    [anon_sym_bvec4] = ACTIONS(446),
    [anon_sym_ivec2] = ACTIONS(446),
    [anon_sym_ivec3] = ACTIONS(446),
    [anon_sym_ivec4] = ACTIONS(446),
    [anon_sym_uvec2] = ACTIONS(446),
    [anon_sym_uvec3] = ACTIONS(446),
    [anon_sym_uvec4] = ACTIONS(446),
    [anon_sym_mat2] = ACTIONS(446),
    [anon_sym_mat3] = ACTIONS(446),
    [anon_sym_mat4] = ACTIONS(446),
    [anon_sym_mat2x2] = ACTIONS(446),
    [anon_sym_mat2x3] = ACTIONS(446),
    [anon_sym_mat2x4] = ACTIONS(446),
    [anon_sym_mat3x2] = ACTIONS(446),
    [anon_sym_mat3x3] = ACTIONS(446),
    [anon_sym_mat3x4] = ACTIONS(446),
    [anon_sym_mat4x2] = ACTIONS(446),
    [anon_sym_mat4x3] = ACTIONS(446),
    [anon_sym_mat4x4] = ACTIONS(446),
    [anon_sym_dmat2] = ACTIONS(446),
    [anon_sym_dmat3] = ACTIONS(446),
    [anon_sym_dmat4] = ACTIONS(446),
    [anon_sym_dmat2x2] = ACTIONS(446),
    [anon_sym_dmat2x3] = ACTIONS(446),
    [anon_sym_dmat2x4] = ACTIONS(446),
    [anon_sym_dmat3x2] = ACTIONS(446),
    [anon_sym_dmat3x3] = ACTIONS(446),
    [anon_sym_dmat3x4] = ACTIONS(446),
    [anon_sym_dmat4x2] = ACTIONS(446),
    [anon_sym_dmat4x3] = ACTIONS(446),
    [anon_sym_dmat4x4] = ACTIONS(446),
    [anon_sym_atomic_uint] = ACTIONS(446),
    [anon_sym_sampler1d] = ACTIONS(446),
    [anon_sym_sampler2d] = ACTIONS(446),
    [anon_sym_sampler3d] = ACTIONS(446),
    [anon_sym_samplercube] = ACTIONS(446),
    [anon_sym_sampler1DShadow] = ACTIONS(446),
    [anon_sym_sampler2DShadow] = ACTIONS(446),
    [anon_sym_samplerCubeShadow] = ACTIONS(446),
    [anon_sym_sampler1DArray] = ACTIONS(446),
    [anon_sym_sampler2DArray] = ACTIONS(446),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(446),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(446),
    [anon_sym_samplerCubeArray] = ACTIONS(446),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(446),
    [anon_sym_isampler1D] = ACTIONS(446),
    [anon_sym_isampler2D] = ACTIONS(446),
    [anon_sym_isampler3D] = ACTIONS(446),
    [anon_sym_isamplerCube] = ACTIONS(446),
    [anon_sym_isampler1DArray] = ACTIONS(446),
    [anon_sym_isampler2DArray] = ACTIONS(446),
    [anon_sym_isamplerCubeArray] = ACTIONS(446),
    [anon_sym_usampler1D] = ACTIONS(446),
    [anon_sym_usampler2D] = ACTIONS(446),
    [anon_sym_usampler3D] = ACTIONS(446),
    [anon_sym_usamplerCube] = ACTIONS(446),
    [anon_sym_usampler1DArray] = ACTIONS(446),
    [anon_sym_usampler2DArray] = ACTIONS(446),
    [anon_sym_usamplerCubeArray] = ACTIONS(446),
    [anon_sym_sampler2DRect] = ACTIONS(446),
    [anon_sym_sampler2DRectshadow] = ACTIONS(446),
    [anon_sym_isampler2DRect] = ACTIONS(446),
    [anon_sym_usampler2DRect] = ACTIONS(446),
    [anon_sym_samplerBuffer] = ACTIONS(446),
    [anon_sym_isamplerBuffer] = ACTIONS(446),
    [anon_sym_usamplerBuffer] = ACTIONS(446),
    [anon_sym_sampler2DMS] = ACTIONS(446),
    [anon_sym_isampler2DMS] = ACTIONS(446),
    [anon_sym_usampler2DMS] = ACTIONS(446),
    [anon_sym_sampler2DMSArray] = ACTIONS(446),
    [anon_sym_isampler2DMSArray] = ACTIONS(446),
    [anon_sym_usampler2DMSArray] = ACTIONS(446),
    [anon_sym_image1D] = ACTIONS(446),
    [anon_sym_iimage1D] = ACTIONS(446),
    [anon_sym_uimage1D] = ACTIONS(446),
    [anon_sym_image2D] = ACTIONS(446),
    [anon_sym_iimage2D] = ACTIONS(446),
    [anon_sym_uimage2D] = ACTIONS(446),
    [anon_sym_image3D] = ACTIONS(446),
    [anon_sym_iimage3D] = ACTIONS(446),
    [anon_sym_uimage3D] = ACTIONS(446),
    [anon_sym_image2DRect] = ACTIONS(446),
    [anon_sym_iimage2DRect] = ACTIONS(446),
    [anon_sym_uimage2DRect] = ACTIONS(446),
    [anon_sym_imageCube] = ACTIONS(446),
    [anon_sym_iimageCube] = ACTIONS(446),
    [anon_sym_uimageCube] = ACTIONS(446),
    [anon_sym_imageBuffer] = ACTIONS(446),
    [anon_sym_iimageBuffer] = ACTIONS(446),
    [anon_sym_uimageBuffer] = ACTIONS(446),
    [anon_sym_image1DArray] = ACTIONS(446),
    [anon_sym_iimage1DArray] = ACTIONS(446),
    [anon_sym_uimage1DArray] = ACTIONS(446),
    [anon_sym_image2DArray] = ACTIONS(446),
    [anon_sym_iimage2DArray] = ACTIONS(446),
    [anon_sym_uimage2DArray] = ACTIONS(446),
    [anon_sym_imageCubeArray] = ACTIONS(446),
    [anon_sym_iimageCubeArray] = ACTIONS(446),
    [anon_sym_uimageCubeArray] = ACTIONS(446),
    [anon_sym_image2DMS] = ACTIONS(446),
    [anon_sym_iimage2DMS] = ACTIONS(446),
    [anon_sym_uimage2DMS] = ACTIONS(446),
    [anon_sym_image2DMSArray] = ACTIONS(446),
    [anon_sym_iimage2DMSArray] = ACTIONS(446),
    [anon_sym_uimage2DMSArray] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(446),
    [anon_sym_inout] = ACTIONS(446),
    [anon_sym_in] = ACTIONS(446),
    [anon_sym_out] = ACTIONS(446),
    [anon_sym_centroid] = ACTIONS(446),
    [anon_sym_patch] = ACTIONS(446),
    [anon_sym_sample] = ACTIONS(446),
    [anon_sym_uniform] = ACTIONS(446),
    [anon_sym_buffer] = ACTIONS(446),
    [anon_sym_shared] = ACTIONS(446),
    [anon_sym_coherent] = ACTIONS(446),
    [anon_sym_volatile] = ACTIONS(446),
    [anon_sym_restrict] = ACTIONS(446),
    [anon_sym_readonly] = ACTIONS(446),
    [anon_sym_writeonly] = ACTIONS(446),
    [anon_sym_subroutine] = ACTIONS(446),
    [anon_sym_varying] = ACTIONS(446),
    [anon_sym_attribute] = ACTIONS(446),
    [anon_sym_layout] = ACTIONS(446),
    [anon_sym_highp] = ACTIONS(446),
    [anon_sym_mediump] = ACTIONS(446),
    [anon_sym_lowp] = ACTIONS(446),
    [anon_sym_smooth] = ACTIONS(446),
    [anon_sym_flat] = ACTIONS(446),
    [anon_sym_noperspective] = ACTIONS(446),
    [sym_invariant_qualifier] = ACTIONS(446),
    [sym_precise_qualifier] = ACTIONS(446),
    [sym_comment] = ACTIONS(25),
  },
  [114] = {
    [sym_identifier] = ACTIONS(450),
    [anon_sym_SEMI] = ACTIONS(452),
    [anon_sym_struct] = ACTIONS(450),
    [anon_sym_void] = ACTIONS(450),
    [anon_sym_float] = ACTIONS(450),
    [anon_sym_double] = ACTIONS(450),
    [anon_sym_int] = ACTIONS(450),
    [anon_sym_uint] = ACTIONS(450),
    [anon_sym_bool] = ACTIONS(450),
    [anon_sym_vec2] = ACTIONS(450),
    [anon_sym_vec3] = ACTIONS(450),
    [anon_sym_vec4] = ACTIONS(450),
    [anon_sym_dvec2] = ACTIONS(450),
    [anon_sym_dvec3] = ACTIONS(450),
    [anon_sym_dvec4] = ACTIONS(450),
    [anon_sym_bvec2] = ACTIONS(450),
    [anon_sym_bvec3] = ACTIONS(450),
    [anon_sym_bvec4] = ACTIONS(450),
    [anon_sym_ivec2] = ACTIONS(450),
    [anon_sym_ivec3] = ACTIONS(450),
    [anon_sym_ivec4] = ACTIONS(450),
    [anon_sym_uvec2] = ACTIONS(450),
    [anon_sym_uvec3] = ACTIONS(450),
    [anon_sym_uvec4] = ACTIONS(450),
    [anon_sym_mat2] = ACTIONS(450),
    [anon_sym_mat3] = ACTIONS(450),
    [anon_sym_mat4] = ACTIONS(450),
    [anon_sym_mat2x2] = ACTIONS(450),
    [anon_sym_mat2x3] = ACTIONS(450),
    [anon_sym_mat2x4] = ACTIONS(450),
    [anon_sym_mat3x2] = ACTIONS(450),
    [anon_sym_mat3x3] = ACTIONS(450),
    [anon_sym_mat3x4] = ACTIONS(450),
    [anon_sym_mat4x2] = ACTIONS(450),
    [anon_sym_mat4x3] = ACTIONS(450),
    [anon_sym_mat4x4] = ACTIONS(450),
    [anon_sym_dmat2] = ACTIONS(450),
    [anon_sym_dmat3] = ACTIONS(450),
    [anon_sym_dmat4] = ACTIONS(450),
    [anon_sym_dmat2x2] = ACTIONS(450),
    [anon_sym_dmat2x3] = ACTIONS(450),
    [anon_sym_dmat2x4] = ACTIONS(450),
    [anon_sym_dmat3x2] = ACTIONS(450),
    [anon_sym_dmat3x3] = ACTIONS(450),
    [anon_sym_dmat3x4] = ACTIONS(450),
    [anon_sym_dmat4x2] = ACTIONS(450),
    [anon_sym_dmat4x3] = ACTIONS(450),
    [anon_sym_dmat4x4] = ACTIONS(450),
    [anon_sym_atomic_uint] = ACTIONS(450),
    [anon_sym_sampler1d] = ACTIONS(450),
    [anon_sym_sampler2d] = ACTIONS(450),
    [anon_sym_sampler3d] = ACTIONS(450),
    [anon_sym_samplercube] = ACTIONS(450),
    [anon_sym_sampler1DShadow] = ACTIONS(450),
    [anon_sym_sampler2DShadow] = ACTIONS(450),
    [anon_sym_samplerCubeShadow] = ACTIONS(450),
    [anon_sym_sampler1DArray] = ACTIONS(450),
    [anon_sym_sampler2DArray] = ACTIONS(450),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(450),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(450),
    [anon_sym_samplerCubeArray] = ACTIONS(450),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(450),
    [anon_sym_isampler1D] = ACTIONS(450),
    [anon_sym_isampler2D] = ACTIONS(450),
    [anon_sym_isampler3D] = ACTIONS(450),
    [anon_sym_isamplerCube] = ACTIONS(450),
    [anon_sym_isampler1DArray] = ACTIONS(450),
    [anon_sym_isampler2DArray] = ACTIONS(450),
    [anon_sym_isamplerCubeArray] = ACTIONS(450),
    [anon_sym_usampler1D] = ACTIONS(450),
    [anon_sym_usampler2D] = ACTIONS(450),
    [anon_sym_usampler3D] = ACTIONS(450),
    [anon_sym_usamplerCube] = ACTIONS(450),
    [anon_sym_usampler1DArray] = ACTIONS(450),
    [anon_sym_usampler2DArray] = ACTIONS(450),
    [anon_sym_usamplerCubeArray] = ACTIONS(450),
    [anon_sym_sampler2DRect] = ACTIONS(450),
    [anon_sym_sampler2DRectshadow] = ACTIONS(450),
    [anon_sym_isampler2DRect] = ACTIONS(450),
    [anon_sym_usampler2DRect] = ACTIONS(450),
    [anon_sym_samplerBuffer] = ACTIONS(450),
    [anon_sym_isamplerBuffer] = ACTIONS(450),
    [anon_sym_usamplerBuffer] = ACTIONS(450),
    [anon_sym_sampler2DMS] = ACTIONS(450),
    [anon_sym_isampler2DMS] = ACTIONS(450),
    [anon_sym_usampler2DMS] = ACTIONS(450),
    [anon_sym_sampler2DMSArray] = ACTIONS(450),
    [anon_sym_isampler2DMSArray] = ACTIONS(450),
    [anon_sym_usampler2DMSArray] = ACTIONS(450),
    [anon_sym_image1D] = ACTIONS(450),
    [anon_sym_iimage1D] = ACTIONS(450),
    [anon_sym_uimage1D] = ACTIONS(450),
    [anon_sym_image2D] = ACTIONS(450),
    [anon_sym_iimage2D] = ACTIONS(450),
    [anon_sym_uimage2D] = ACTIONS(450),
    [anon_sym_image3D] = ACTIONS(450),
    [anon_sym_iimage3D] = ACTIONS(450),
    [anon_sym_uimage3D] = ACTIONS(450),
    [anon_sym_image2DRect] = ACTIONS(450),
    [anon_sym_iimage2DRect] = ACTIONS(450),
    [anon_sym_uimage2DRect] = ACTIONS(450),
    [anon_sym_imageCube] = ACTIONS(450),
    [anon_sym_iimageCube] = ACTIONS(450),
    [anon_sym_uimageCube] = ACTIONS(450),
    [anon_sym_imageBuffer] = ACTIONS(450),
    [anon_sym_iimageBuffer] = ACTIONS(450),
    [anon_sym_uimageBuffer] = ACTIONS(450),
    [anon_sym_image1DArray] = ACTIONS(450),
    [anon_sym_iimage1DArray] = ACTIONS(450),
    [anon_sym_uimage1DArray] = ACTIONS(450),
    [anon_sym_image2DArray] = ACTIONS(450),
    [anon_sym_iimage2DArray] = ACTIONS(450),
    [anon_sym_uimage2DArray] = ACTIONS(450),
    [anon_sym_imageCubeArray] = ACTIONS(450),
    [anon_sym_iimageCubeArray] = ACTIONS(450),
    [anon_sym_uimageCubeArray] = ACTIONS(450),
    [anon_sym_image2DMS] = ACTIONS(450),
    [anon_sym_iimage2DMS] = ACTIONS(450),
    [anon_sym_uimage2DMS] = ACTIONS(450),
    [anon_sym_image2DMSArray] = ACTIONS(450),
    [anon_sym_iimage2DMSArray] = ACTIONS(450),
    [anon_sym_uimage2DMSArray] = ACTIONS(450),
    [anon_sym_const] = ACTIONS(450),
    [anon_sym_inout] = ACTIONS(450),
    [anon_sym_in] = ACTIONS(450),
    [anon_sym_out] = ACTIONS(450),
    [anon_sym_centroid] = ACTIONS(450),
    [anon_sym_patch] = ACTIONS(450),
    [anon_sym_sample] = ACTIONS(450),
    [anon_sym_uniform] = ACTIONS(450),
    [anon_sym_buffer] = ACTIONS(450),
    [anon_sym_shared] = ACTIONS(450),
    [anon_sym_coherent] = ACTIONS(450),
    [anon_sym_volatile] = ACTIONS(450),
    [anon_sym_restrict] = ACTIONS(450),
    [anon_sym_readonly] = ACTIONS(450),
    [anon_sym_writeonly] = ACTIONS(450),
    [anon_sym_subroutine] = ACTIONS(450),
    [anon_sym_varying] = ACTIONS(450),
    [anon_sym_attribute] = ACTIONS(450),
    [anon_sym_layout] = ACTIONS(450),
    [anon_sym_highp] = ACTIONS(450),
    [anon_sym_mediump] = ACTIONS(450),
    [anon_sym_lowp] = ACTIONS(450),
    [anon_sym_smooth] = ACTIONS(450),
    [anon_sym_flat] = ACTIONS(450),
    [anon_sym_noperspective] = ACTIONS(450),
    [sym_invariant_qualifier] = ACTIONS(450),
    [sym_precise_qualifier] = ACTIONS(450),
    [sym_comment] = ACTIONS(25),
  },
  [115] = {
    [sym_identifier] = ACTIONS(454),
    [anon_sym_RBRACE] = ACTIONS(456),
    [anon_sym_struct] = ACTIONS(454),
    [anon_sym_void] = ACTIONS(454),
    [anon_sym_float] = ACTIONS(454),
    [anon_sym_double] = ACTIONS(454),
    [anon_sym_int] = ACTIONS(454),
    [anon_sym_uint] = ACTIONS(454),
    [anon_sym_bool] = ACTIONS(454),
    [anon_sym_vec2] = ACTIONS(454),
    [anon_sym_vec3] = ACTIONS(454),
    [anon_sym_vec4] = ACTIONS(454),
    [anon_sym_dvec2] = ACTIONS(454),
    [anon_sym_dvec3] = ACTIONS(454),
    [anon_sym_dvec4] = ACTIONS(454),
    [anon_sym_bvec2] = ACTIONS(454),
    [anon_sym_bvec3] = ACTIONS(454),
    [anon_sym_bvec4] = ACTIONS(454),
    [anon_sym_ivec2] = ACTIONS(454),
    [anon_sym_ivec3] = ACTIONS(454),
    [anon_sym_ivec4] = ACTIONS(454),
    [anon_sym_uvec2] = ACTIONS(454),
    [anon_sym_uvec3] = ACTIONS(454),
    [anon_sym_uvec4] = ACTIONS(454),
    [anon_sym_mat2] = ACTIONS(454),
    [anon_sym_mat3] = ACTIONS(454),
    [anon_sym_mat4] = ACTIONS(454),
    [anon_sym_mat2x2] = ACTIONS(454),
    [anon_sym_mat2x3] = ACTIONS(454),
    [anon_sym_mat2x4] = ACTIONS(454),
    [anon_sym_mat3x2] = ACTIONS(454),
    [anon_sym_mat3x3] = ACTIONS(454),
    [anon_sym_mat3x4] = ACTIONS(454),
    [anon_sym_mat4x2] = ACTIONS(454),
    [anon_sym_mat4x3] = ACTIONS(454),
    [anon_sym_mat4x4] = ACTIONS(454),
    [anon_sym_dmat2] = ACTIONS(454),
    [anon_sym_dmat3] = ACTIONS(454),
    [anon_sym_dmat4] = ACTIONS(454),
    [anon_sym_dmat2x2] = ACTIONS(454),
    [anon_sym_dmat2x3] = ACTIONS(454),
    [anon_sym_dmat2x4] = ACTIONS(454),
    [anon_sym_dmat3x2] = ACTIONS(454),
    [anon_sym_dmat3x3] = ACTIONS(454),
    [anon_sym_dmat3x4] = ACTIONS(454),
    [anon_sym_dmat4x2] = ACTIONS(454),
    [anon_sym_dmat4x3] = ACTIONS(454),
    [anon_sym_dmat4x4] = ACTIONS(454),
    [anon_sym_atomic_uint] = ACTIONS(454),
    [anon_sym_sampler1d] = ACTIONS(454),
    [anon_sym_sampler2d] = ACTIONS(454),
    [anon_sym_sampler3d] = ACTIONS(454),
    [anon_sym_samplercube] = ACTIONS(454),
    [anon_sym_sampler1DShadow] = ACTIONS(454),
    [anon_sym_sampler2DShadow] = ACTIONS(454),
    [anon_sym_samplerCubeShadow] = ACTIONS(454),
    [anon_sym_sampler1DArray] = ACTIONS(454),
    [anon_sym_sampler2DArray] = ACTIONS(454),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(454),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(454),
    [anon_sym_samplerCubeArray] = ACTIONS(454),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(454),
    [anon_sym_isampler1D] = ACTIONS(454),
    [anon_sym_isampler2D] = ACTIONS(454),
    [anon_sym_isampler3D] = ACTIONS(454),
    [anon_sym_isamplerCube] = ACTIONS(454),
    [anon_sym_isampler1DArray] = ACTIONS(454),
    [anon_sym_isampler2DArray] = ACTIONS(454),
    [anon_sym_isamplerCubeArray] = ACTIONS(454),
    [anon_sym_usampler1D] = ACTIONS(454),
    [anon_sym_usampler2D] = ACTIONS(454),
    [anon_sym_usampler3D] = ACTIONS(454),
    [anon_sym_usamplerCube] = ACTIONS(454),
    [anon_sym_usampler1DArray] = ACTIONS(454),
    [anon_sym_usampler2DArray] = ACTIONS(454),
    [anon_sym_usamplerCubeArray] = ACTIONS(454),
    [anon_sym_sampler2DRect] = ACTIONS(454),
    [anon_sym_sampler2DRectshadow] = ACTIONS(454),
    [anon_sym_isampler2DRect] = ACTIONS(454),
    [anon_sym_usampler2DRect] = ACTIONS(454),
    [anon_sym_samplerBuffer] = ACTIONS(454),
    [anon_sym_isamplerBuffer] = ACTIONS(454),
    [anon_sym_usamplerBuffer] = ACTIONS(454),
    [anon_sym_sampler2DMS] = ACTIONS(454),
    [anon_sym_isampler2DMS] = ACTIONS(454),
    [anon_sym_usampler2DMS] = ACTIONS(454),
    [anon_sym_sampler2DMSArray] = ACTIONS(454),
    [anon_sym_isampler2DMSArray] = ACTIONS(454),
    [anon_sym_usampler2DMSArray] = ACTIONS(454),
    [anon_sym_image1D] = ACTIONS(454),
    [anon_sym_iimage1D] = ACTIONS(454),
    [anon_sym_uimage1D] = ACTIONS(454),
    [anon_sym_image2D] = ACTIONS(454),
    [anon_sym_iimage2D] = ACTIONS(454),
    [anon_sym_uimage2D] = ACTIONS(454),
    [anon_sym_image3D] = ACTIONS(454),
    [anon_sym_iimage3D] = ACTIONS(454),
    [anon_sym_uimage3D] = ACTIONS(454),
    [anon_sym_image2DRect] = ACTIONS(454),
    [anon_sym_iimage2DRect] = ACTIONS(454),
    [anon_sym_uimage2DRect] = ACTIONS(454),
    [anon_sym_imageCube] = ACTIONS(454),
    [anon_sym_iimageCube] = ACTIONS(454),
    [anon_sym_uimageCube] = ACTIONS(454),
    [anon_sym_imageBuffer] = ACTIONS(454),
    [anon_sym_iimageBuffer] = ACTIONS(454),
    [anon_sym_uimageBuffer] = ACTIONS(454),
    [anon_sym_image1DArray] = ACTIONS(454),
    [anon_sym_iimage1DArray] = ACTIONS(454),
    [anon_sym_uimage1DArray] = ACTIONS(454),
    [anon_sym_image2DArray] = ACTIONS(454),
    [anon_sym_iimage2DArray] = ACTIONS(454),
    [anon_sym_uimage2DArray] = ACTIONS(454),
    [anon_sym_imageCubeArray] = ACTIONS(454),
    [anon_sym_iimageCubeArray] = ACTIONS(454),
    [anon_sym_uimageCubeArray] = ACTIONS(454),
    [anon_sym_image2DMS] = ACTIONS(454),
    [anon_sym_iimage2DMS] = ACTIONS(454),
    [anon_sym_uimage2DMS] = ACTIONS(454),
    [anon_sym_image2DMSArray] = ACTIONS(454),
    [anon_sym_iimage2DMSArray] = ACTIONS(454),
    [anon_sym_uimage2DMSArray] = ACTIONS(454),
    [anon_sym_const] = ACTIONS(454),
    [anon_sym_inout] = ACTIONS(454),
    [anon_sym_in] = ACTIONS(454),
    [anon_sym_out] = ACTIONS(454),
    [anon_sym_centroid] = ACTIONS(454),
    [anon_sym_patch] = ACTIONS(454),
    [anon_sym_sample] = ACTIONS(454),
    [anon_sym_uniform] = ACTIONS(454),
    [anon_sym_buffer] = ACTIONS(454),
    [anon_sym_shared] = ACTIONS(454),
    [anon_sym_coherent] = ACTIONS(454),
    [anon_sym_volatile] = ACTIONS(454),
    [anon_sym_restrict] = ACTIONS(454),
    [anon_sym_readonly] = ACTIONS(454),
    [anon_sym_writeonly] = ACTIONS(454),
    [anon_sym_subroutine] = ACTIONS(454),
    [anon_sym_varying] = ACTIONS(454),
    [anon_sym_attribute] = ACTIONS(454),
    [anon_sym_layout] = ACTIONS(454),
    [anon_sym_highp] = ACTIONS(454),
    [anon_sym_mediump] = ACTIONS(454),
    [anon_sym_lowp] = ACTIONS(454),
    [anon_sym_smooth] = ACTIONS(454),
    [anon_sym_flat] = ACTIONS(454),
    [anon_sym_noperspective] = ACTIONS(454),
    [sym_invariant_qualifier] = ACTIONS(454),
    [sym_precise_qualifier] = ACTIONS(454),
    [sym_comment] = ACTIONS(25),
  },
  [116] = {
    [sym_parameter_declarator] = STATE(235),
    [sym_type_specifier] = STATE(199),
    [sym_primitive_type] = STATE(190),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [sym_comment] = ACTIONS(25),
  },
  [117] = {
    [sym_type_specifier] = STATE(215),
    [sym_primitive_type] = STATE(190),
    [sym_identifier] = ACTIONS(458),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [sym_comment] = ACTIONS(25),
  },
  [118] = {
    [sym_type_specifier] = STATE(252),
    [sym_primitive_type] = STATE(190),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [sym_comment] = ACTIONS(25),
  },
  [119] = {
    [sym_type_specifier] = STATE(195),
    [sym_primitive_type] = STATE(190),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [sym_comment] = ACTIONS(25),
  },
  [120] = {
    [sym_type_specifier] = STATE(215),
    [sym_primitive_type] = STATE(190),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_struct] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(11),
    [anon_sym_float] = ACTIONS(11),
    [anon_sym_double] = ACTIONS(11),
    [anon_sym_int] = ACTIONS(11),
    [anon_sym_uint] = ACTIONS(11),
    [anon_sym_bool] = ACTIONS(11),
    [anon_sym_vec2] = ACTIONS(11),
    [anon_sym_vec3] = ACTIONS(11),
    [anon_sym_vec4] = ACTIONS(11),
    [anon_sym_dvec2] = ACTIONS(11),
    [anon_sym_dvec3] = ACTIONS(11),
    [anon_sym_dvec4] = ACTIONS(11),
    [anon_sym_bvec2] = ACTIONS(11),
    [anon_sym_bvec3] = ACTIONS(11),
    [anon_sym_bvec4] = ACTIONS(11),
    [anon_sym_ivec2] = ACTIONS(11),
    [anon_sym_ivec3] = ACTIONS(11),
    [anon_sym_ivec4] = ACTIONS(11),
    [anon_sym_uvec2] = ACTIONS(11),
    [anon_sym_uvec3] = ACTIONS(11),
    [anon_sym_uvec4] = ACTIONS(11),
    [anon_sym_mat2] = ACTIONS(11),
    [anon_sym_mat3] = ACTIONS(11),
    [anon_sym_mat4] = ACTIONS(11),
    [anon_sym_mat2x2] = ACTIONS(11),
    [anon_sym_mat2x3] = ACTIONS(11),
    [anon_sym_mat2x4] = ACTIONS(11),
    [anon_sym_mat3x2] = ACTIONS(11),
    [anon_sym_mat3x3] = ACTIONS(11),
    [anon_sym_mat3x4] = ACTIONS(11),
    [anon_sym_mat4x2] = ACTIONS(11),
    [anon_sym_mat4x3] = ACTIONS(11),
    [anon_sym_mat4x4] = ACTIONS(11),
    [anon_sym_dmat2] = ACTIONS(11),
    [anon_sym_dmat3] = ACTIONS(11),
    [anon_sym_dmat4] = ACTIONS(11),
    [anon_sym_dmat2x2] = ACTIONS(11),
    [anon_sym_dmat2x3] = ACTIONS(11),
    [anon_sym_dmat2x4] = ACTIONS(11),
    [anon_sym_dmat3x2] = ACTIONS(11),
    [anon_sym_dmat3x3] = ACTIONS(11),
    [anon_sym_dmat3x4] = ACTIONS(11),
    [anon_sym_dmat4x2] = ACTIONS(11),
    [anon_sym_dmat4x3] = ACTIONS(11),
    [anon_sym_dmat4x4] = ACTIONS(11),
    [anon_sym_atomic_uint] = ACTIONS(11),
    [anon_sym_sampler1d] = ACTIONS(11),
    [anon_sym_sampler2d] = ACTIONS(11),
    [anon_sym_sampler3d] = ACTIONS(11),
    [anon_sym_samplercube] = ACTIONS(11),
    [anon_sym_sampler1DShadow] = ACTIONS(11),
    [anon_sym_sampler2DShadow] = ACTIONS(11),
    [anon_sym_samplerCubeShadow] = ACTIONS(11),
    [anon_sym_sampler1DArray] = ACTIONS(11),
    [anon_sym_sampler2DArray] = ACTIONS(11),
    [anon_sym_sampler1DArrayShadow] = ACTIONS(11),
    [anon_sym_sampler2DArrayShadow] = ACTIONS(11),
    [anon_sym_samplerCubeArray] = ACTIONS(11),
    [anon_sym_samplerCubeArrayShadow] = ACTIONS(11),
    [anon_sym_isampler1D] = ACTIONS(11),
    [anon_sym_isampler2D] = ACTIONS(11),
    [anon_sym_isampler3D] = ACTIONS(11),
    [anon_sym_isamplerCube] = ACTIONS(11),
    [anon_sym_isampler1DArray] = ACTIONS(11),
    [anon_sym_isampler2DArray] = ACTIONS(11),
    [anon_sym_isamplerCubeArray] = ACTIONS(11),
    [anon_sym_usampler1D] = ACTIONS(11),
    [anon_sym_usampler2D] = ACTIONS(11),
    [anon_sym_usampler3D] = ACTIONS(11),
    [anon_sym_usamplerCube] = ACTIONS(11),
    [anon_sym_usampler1DArray] = ACTIONS(11),
    [anon_sym_usampler2DArray] = ACTIONS(11),
    [anon_sym_usamplerCubeArray] = ACTIONS(11),
    [anon_sym_sampler2DRect] = ACTIONS(11),
    [anon_sym_sampler2DRectshadow] = ACTIONS(11),
    [anon_sym_isampler2DRect] = ACTIONS(11),
    [anon_sym_usampler2DRect] = ACTIONS(11),
    [anon_sym_samplerBuffer] = ACTIONS(11),
    [anon_sym_isamplerBuffer] = ACTIONS(11),
    [anon_sym_usamplerBuffer] = ACTIONS(11),
    [anon_sym_sampler2DMS] = ACTIONS(11),
    [anon_sym_isampler2DMS] = ACTIONS(11),
    [anon_sym_usampler2DMS] = ACTIONS(11),
    [anon_sym_sampler2DMSArray] = ACTIONS(11),
    [anon_sym_isampler2DMSArray] = ACTIONS(11),
    [anon_sym_usampler2DMSArray] = ACTIONS(11),
    [anon_sym_image1D] = ACTIONS(11),
    [anon_sym_iimage1D] = ACTIONS(11),
    [anon_sym_uimage1D] = ACTIONS(11),
    [anon_sym_image2D] = ACTIONS(11),
    [anon_sym_iimage2D] = ACTIONS(11),
    [anon_sym_uimage2D] = ACTIONS(11),
    [anon_sym_image3D] = ACTIONS(11),
    [anon_sym_iimage3D] = ACTIONS(11),
    [anon_sym_uimage3D] = ACTIONS(11),
    [anon_sym_image2DRect] = ACTIONS(11),
    [anon_sym_iimage2DRect] = ACTIONS(11),
    [anon_sym_uimage2DRect] = ACTIONS(11),
    [anon_sym_imageCube] = ACTIONS(11),
    [anon_sym_iimageCube] = ACTIONS(11),
    [anon_sym_uimageCube] = ACTIONS(11),
    [anon_sym_imageBuffer] = ACTIONS(11),
    [anon_sym_iimageBuffer] = ACTIONS(11),
    [anon_sym_uimageBuffer] = ACTIONS(11),
    [anon_sym_image1DArray] = ACTIONS(11),
    [anon_sym_iimage1DArray] = ACTIONS(11),
    [anon_sym_uimage1DArray] = ACTIONS(11),
    [anon_sym_image2DArray] = ACTIONS(11),
    [anon_sym_iimage2DArray] = ACTIONS(11),
    [anon_sym_uimage2DArray] = ACTIONS(11),
    [anon_sym_imageCubeArray] = ACTIONS(11),
    [anon_sym_iimageCubeArray] = ACTIONS(11),
    [anon_sym_uimageCubeArray] = ACTIONS(11),
    [anon_sym_image2DMS] = ACTIONS(11),
    [anon_sym_iimage2DMS] = ACTIONS(11),
    [anon_sym_uimage2DMS] = ACTIONS(11),
    [anon_sym_image2DMSArray] = ACTIONS(11),
    [anon_sym_iimage2DMSArray] = ACTIONS(11),
    [anon_sym_uimage2DMSArray] = ACTIONS(11),
    [sym_comment] = ACTIONS(25),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(466), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(188), 1,
      aux_sym__array_specifier_list,
    ACTIONS(464), 14,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(462), 27,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [58] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 10,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(468), 23,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [120] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(490), 1,
      anon_sym_AMP,
    ACTIONS(492), 1,
      anon_sym_CARET,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(470), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(486), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 19,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_COMMA,
    STATE(128), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(500), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(496), 27,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [250] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(504), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(502), 23,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(508), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(506), 23,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [370] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(490), 1,
      anon_sym_AMP,
    ACTIONS(492), 1,
      anon_sym_CARET,
    ACTIONS(512), 1,
      anon_sym_EQ,
    ACTIONS(514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(518), 1,
      anon_sym_PIPE,
    ACTIONS(520), 1,
      anon_sym_QMARK,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(486), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(510), 16,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_COLON,
  [454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(524), 1,
      anon_sym_COMMA,
    STATE(128), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(527), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(522), 27,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [508] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 8,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(468), 23,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [572] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(490), 1,
      anon_sym_AMP,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(486), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(470), 3,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 19,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [646] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(490), 1,
      anon_sym_AMP,
    ACTIONS(492), 1,
      anon_sym_CARET,
    ACTIONS(514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(518), 1,
      anon_sym_PIPE,
    ACTIONS(527), 1,
      anon_sym_EQ,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(486), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(522), 17,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [728] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 6,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(468), 23,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [794] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 4,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(468), 21,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [864] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(470), 1,
      anon_sym_EQ,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(490), 1,
      anon_sym_AMP,
    ACTIONS(492), 1,
      anon_sym_CARET,
    ACTIONS(518), 1,
      anon_sym_PIPE,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(486), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 19,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [942] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(490), 1,
      anon_sym_AMP,
    ACTIONS(492), 1,
      anon_sym_CARET,
    ACTIONS(514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(518), 1,
      anon_sym_PIPE,
    ACTIONS(520), 1,
      anon_sym_QMARK,
    ACTIONS(531), 1,
      anon_sym_EQ,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(486), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(529), 16,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_COLON,
  [1026] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(486), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 4,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(468), 19,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1098] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(470), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(468), 23,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1158] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(470), 1,
      anon_sym_EQ,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(490), 1,
      anon_sym_AMP,
    ACTIONS(492), 1,
      anon_sym_CARET,
    ACTIONS(514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(518), 1,
      anon_sym_PIPE,
    STATE(124), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(482), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(484), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(486), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(494), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(476), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 18,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(535), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(533), 28,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(539), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(537), 28,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(541), 28,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(545), 28,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(551), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(549), 28,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(555), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(553), 28,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(508), 13,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(506), 28,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(559), 1,
      anon_sym_EQ,
    ACTIONS(563), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(561), 12,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(557), 18,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1634] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 10,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1697] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(470), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 12,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    STATE(152), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(500), 6,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(496), 23,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1799] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(510), 6,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [1870] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(529), 6,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [1941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(591), 1,
      anon_sym_COMMA,
    STATE(152), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(527), 6,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(522), 23,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_COLON,
  [1984] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 4,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(468), 16,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2037] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(587), 1,
      anon_sym_CARET,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 9,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2102] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(470), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 10,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2163] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(470), 6,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(468), 19,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2212] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 6,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(468), 16,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2263] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 8,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2330] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(468), 9,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2395] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(470), 4,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(468), 14,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2450] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(522), 7,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
  [2519] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(594), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2589] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(596), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2659] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(596), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [2727] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(598), 1,
      anon_sym_COLON,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2796] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(600), 1,
      anon_sym_RPAREN,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(602), 1,
      anon_sym_RPAREN,
    STATE(152), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(500), 6,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(496), 18,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_QMARK,
  [2906] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(604), 1,
      anon_sym_RPAREN,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2975] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(606), 1,
      anon_sym_RPAREN,
    STATE(167), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3044] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(608), 1,
      anon_sym_RBRACK,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3113] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(610), 1,
      anon_sym_RPAREN,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3182] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(612), 1,
      anon_sym_RPAREN,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3251] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(614), 1,
      anon_sym_SEMI,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3320] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(616), 1,
      anon_sym_RPAREN,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3389] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(618), 1,
      anon_sym_SEMI,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3458] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(620), 1,
      anon_sym_COLON,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3527] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(622), 1,
      anon_sym_RPAREN,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3596] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_SEMI,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_RBRACK,
    ACTIONS(630), 6,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(626), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_QMARK,
  [3701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(632), 1,
      anon_sym_RPAREN,
    ACTIONS(630), 6,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(626), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT,
      anon_sym_QMARK,
  [3737] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_LBRACK,
    ACTIONS(480), 1,
      anon_sym_DOT,
    ACTIONS(575), 1,
      anon_sym_AMP,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    ACTIONS(581), 1,
      anon_sym_AMP_AMP,
    ACTIONS(583), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPE,
    ACTIONS(587), 1,
      anon_sym_CARET,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    STATE(149), 1,
      aux_sym_comma_expression_repeat1,
    ACTIONS(478), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(565), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(567), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(569), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(571), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(573), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3803] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(636), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(639), 1,
      anon_sym_LBRACK,
    STATE(182), 1,
      aux_sym__array_specifier_list,
    ACTIONS(634), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_identifier,
  [3824] = 8,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(642), 1,
      anon_sym_LBRACE,
    ACTIONS(644), 1,
      anon_sym_COMMA,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(188), 1,
      aux_sym__array_specifier_list,
    STATE(223), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(460), 2,
      anon_sym_SEMI,
      sym_identifier,
  [3850] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(650), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(182), 1,
      aux_sym__array_specifier_list,
    ACTIONS(648), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_identifier,
  [3870] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(654), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(184), 1,
      aux_sym__array_specifier_list,
    ACTIONS(652), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_identifier,
  [3890] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(658), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(189), 1,
      aux_sym__array_specifier_list,
    ACTIONS(656), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_identifier,
  [3910] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(660), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
  [3926] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(650), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(182), 1,
      aux_sym__array_specifier_list,
    ACTIONS(664), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_identifier,
  [3946] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(650), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(182), 1,
      aux_sym__array_specifier_list,
    ACTIONS(666), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_identifier,
  [3966] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(188), 1,
      aux_sym__array_specifier_list,
    ACTIONS(460), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_identifier,
  [3986] = 6,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(670), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(192), 1,
      aux_sym__array_specifier_list,
    ACTIONS(668), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
  [4007] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(650), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(182), 1,
      aux_sym__array_specifier_list,
    ACTIONS(674), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [4026] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(192), 1,
      aux_sym__array_specifier_list,
    ACTIONS(668), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [4045] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(678), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
  [4060] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym_identifier,
    STATE(212), 1,
      sym_struct_declarator,
    STATE(258), 1,
      sym_struct_declarator_list,
    STATE(248), 2,
      sym__field_declarator,
      sym_array_declarator,
  [4077] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(682), 1,
      sym_identifier,
    ACTIONS(684), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(213), 2,
      sym__field_declarator,
      sym_array_declarator,
  [4092] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(686), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(247), 2,
      sym__field_declarator,
      sym_array_declarator,
  [4107] = 5,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym_identifier,
    STATE(212), 1,
      sym_struct_declarator,
    STATE(276), 1,
      sym_struct_declarator_list,
    STATE(248), 2,
      sym__field_declarator,
      sym_array_declarator,
  [4124] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(688), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(247), 2,
      sym__field_declarator,
      sym_array_declarator,
  [4139] = 3,
    ACTIONS(25), 1,
      sym_comment,
    STATE(118), 1,
      sym_precision_qualifier,
    ACTIONS(690), 3,
      anon_sym_highp,
      anon_sym_mediump,
      anon_sym_lowp,
  [4151] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym_identifier,
  [4163] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(694), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4173] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(678), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_RPAREN,
    ACTIONS(676), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
  [4187] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(698), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4197] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(700), 1,
      anon_sym_SEMI,
    STATE(250), 2,
      sym__field_declarator,
      sym_array_declarator,
  [4211] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym_identifier,
    STATE(243), 1,
      sym_struct_declarator,
    STATE(248), 2,
      sym__field_declarator,
      sym_array_declarator,
  [4225] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(702), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4235] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(704), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_COMMA,
    STATE(228), 1,
      aux_sym_struct_declarator_list_repeat1,
  [4248] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(692), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym_identifier,
  [4257] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(708), 1,
      sym_identifier,
    ACTIONS(710), 1,
      anon_sym_shared,
    STATE(249), 1,
      sym_layout_qualifier_id,
  [4270] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(712), 1,
      anon_sym_COMMA,
    ACTIONS(714), 1,
      anon_sym_RPAREN,
    STATE(217), 1,
      aux_sym_layout_qualifier_repeat1,
  [4283] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(706), 1,
      anon_sym_COMMA,
    ACTIONS(716), 1,
      anon_sym_SEMI,
    STATE(208), 1,
      aux_sym_struct_declarator_list_repeat1,
  [4296] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(720), 1,
      anon_sym_EQ,
    ACTIONS(718), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [4307] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(724), 1,
      anon_sym_EQ,
    ACTIONS(722), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [4318] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(726), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym_identifier,
  [4327] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(728), 1,
      anon_sym_COMMA,
    ACTIONS(730), 1,
      anon_sym_RPAREN,
    STATE(219), 1,
      aux_sym_function_parameter_list_repeat1,
  [4340] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(732), 1,
      anon_sym_COMMA,
    ACTIONS(735), 1,
      anon_sym_RPAREN,
    STATE(217), 1,
      aux_sym_layout_qualifier_repeat1,
  [4353] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(740), 1,
      anon_sym_RPAREN,
    STATE(218), 1,
      aux_sym_function_parameter_list_repeat1,
  [4366] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(728), 1,
      anon_sym_COMMA,
    ACTIONS(742), 1,
      anon_sym_RPAREN,
    STATE(218), 1,
      aux_sym_function_parameter_list_repeat1,
  [4379] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_RBRACE,
    ACTIONS(744), 1,
      anon_sym_COMMA,
    STATE(229), 1,
      aux_sym__initializer_repeat1,
  [4392] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_COMMA,
    ACTIONS(748), 1,
      anon_sym_RPAREN,
    STATE(222), 1,
      aux_sym_type_name_list_repeat1,
  [4405] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_COMMA,
    ACTIONS(753), 1,
      anon_sym_RPAREN,
    STATE(222), 1,
      aux_sym_type_name_list_repeat1,
  [4418] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_COMMA,
    ACTIONS(755), 1,
      anon_sym_SEMI,
    STATE(226), 1,
      aux_sym_declaration_repeat1,
  [4431] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(708), 1,
      sym_identifier,
    ACTIONS(710), 1,
      anon_sym_shared,
    STATE(231), 1,
      sym_layout_qualifier_id,
  [4444] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_COMMA,
    ACTIONS(757), 1,
      anon_sym_RPAREN,
    STATE(221), 1,
      aux_sym_type_name_list_repeat1,
  [4457] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(759), 1,
      anon_sym_SEMI,
    ACTIONS(761), 1,
      anon_sym_COMMA,
    STATE(226), 1,
      aux_sym_declaration_repeat1,
  [4470] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym_identifier,
    STATE(214), 2,
      sym__field_declarator,
      sym_array_declarator,
  [4481] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_SEMI,
    ACTIONS(766), 1,
      anon_sym_COMMA,
    STATE(228), 1,
      aux_sym_struct_declarator_list_repeat1,
  [4494] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(769), 1,
      anon_sym_RBRACE,
    ACTIONS(771), 1,
      anon_sym_COMMA,
    STATE(229), 1,
      aux_sym__initializer_repeat1,
  [4507] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(776), 1,
      anon_sym_EQ,
    ACTIONS(774), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4518] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(712), 1,
      anon_sym_COMMA,
    ACTIONS(778), 1,
      anon_sym_RPAREN,
    STATE(211), 1,
      aux_sym_layout_qualifier_repeat1,
  [4531] = 4,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(780), 1,
      anon_sym_RBRACE,
    ACTIONS(782), 1,
      anon_sym_COMMA,
    STATE(220), 1,
      aux_sym__initializer_repeat1,
  [4544] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(769), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [4552] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(784), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [4560] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(688), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4568] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(786), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4576] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(788), 1,
      anon_sym_SEMI,
    ACTIONS(790), 1,
      anon_sym_COMMA,
  [4586] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(759), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [4594] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(792), 1,
      sym_identifier,
    STATE(260), 1,
      sym_type_name_list,
  [4604] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(794), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [4612] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(753), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4620] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(796), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [4628] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(764), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [4636] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(686), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4644] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(740), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4652] = 3,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(798), 1,
      sym_identifier,
    ACTIONS(800), 1,
      anon_sym_LBRACE,
  [4662] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(802), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4670] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(804), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [4678] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(735), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4686] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_SEMI,
  [4693] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(808), 1,
      anon_sym_RBRACE,
  [4700] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_SEMI,
  [4707] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(812), 1,
      anon_sym_LPAREN,
  [4714] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_RBRACE,
  [4721] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_RPAREN,
  [4728] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_SEMI,
  [4735] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(818), 1,
      anon_sym_LBRACE,
  [4742] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(820), 1,
      anon_sym_SEMI,
  [4749] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(822), 1,
      anon_sym_RBRACE,
  [4756] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(824), 1,
      anon_sym_RPAREN,
  [4763] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_RPAREN,
  [4770] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(828), 1,
      anon_sym_RPAREN,
  [4777] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(830), 1,
      sym_identifier,
  [4784] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(832), 1,
      ts_builtin_sym_end,
  [4791] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(834), 1,
      anon_sym_LPAREN,
  [4798] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(836), 1,
      anon_sym_LPAREN,
  [4805] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
  [4812] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(838), 1,
      anon_sym_RBRACE,
  [4819] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(368), 1,
      anon_sym_SEMI,
  [4826] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(840), 1,
      sym_identifier,
  [4833] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(842), 1,
      anon_sym_RBRACE,
  [4840] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_SEMI,
  [4847] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_SEMI,
  [4854] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_RPAREN,
  [4861] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_SEMI,
  [4868] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(850), 1,
      anon_sym_SEMI,
  [4875] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_EQ,
  [4882] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
  [4889] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_while,
  [4896] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(858), 1,
      sym_identifier,
  [4903] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_LBRACE,
  [4910] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
  [4917] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_LPAREN,
  [4924] = 2,
    ACTIONS(25), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(121)] = 0,
  [SMALL_STATE(122)] = 58,
  [SMALL_STATE(123)] = 120,
  [SMALL_STATE(124)] = 196,
  [SMALL_STATE(125)] = 250,
  [SMALL_STATE(126)] = 310,
  [SMALL_STATE(127)] = 370,
  [SMALL_STATE(128)] = 454,
  [SMALL_STATE(129)] = 508,
  [SMALL_STATE(130)] = 572,
  [SMALL_STATE(131)] = 646,
  [SMALL_STATE(132)] = 728,
  [SMALL_STATE(133)] = 794,
  [SMALL_STATE(134)] = 864,
  [SMALL_STATE(135)] = 942,
  [SMALL_STATE(136)] = 1026,
  [SMALL_STATE(137)] = 1098,
  [SMALL_STATE(138)] = 1158,
  [SMALL_STATE(139)] = 1238,
  [SMALL_STATE(140)] = 1287,
  [SMALL_STATE(141)] = 1336,
  [SMALL_STATE(142)] = 1385,
  [SMALL_STATE(143)] = 1434,
  [SMALL_STATE(144)] = 1483,
  [SMALL_STATE(145)] = 1532,
  [SMALL_STATE(146)] = 1581,
  [SMALL_STATE(147)] = 1634,
  [SMALL_STATE(148)] = 1697,
  [SMALL_STATE(149)] = 1756,
  [SMALL_STATE(150)] = 1799,
  [SMALL_STATE(151)] = 1870,
  [SMALL_STATE(152)] = 1941,
  [SMALL_STATE(153)] = 1984,
  [SMALL_STATE(154)] = 2037,
  [SMALL_STATE(155)] = 2102,
  [SMALL_STATE(156)] = 2163,
  [SMALL_STATE(157)] = 2212,
  [SMALL_STATE(158)] = 2263,
  [SMALL_STATE(159)] = 2330,
  [SMALL_STATE(160)] = 2395,
  [SMALL_STATE(161)] = 2450,
  [SMALL_STATE(162)] = 2519,
  [SMALL_STATE(163)] = 2589,
  [SMALL_STATE(164)] = 2659,
  [SMALL_STATE(165)] = 2727,
  [SMALL_STATE(166)] = 2796,
  [SMALL_STATE(167)] = 2865,
  [SMALL_STATE(168)] = 2906,
  [SMALL_STATE(169)] = 2975,
  [SMALL_STATE(170)] = 3044,
  [SMALL_STATE(171)] = 3113,
  [SMALL_STATE(172)] = 3182,
  [SMALL_STATE(173)] = 3251,
  [SMALL_STATE(174)] = 3320,
  [SMALL_STATE(175)] = 3389,
  [SMALL_STATE(176)] = 3458,
  [SMALL_STATE(177)] = 3527,
  [SMALL_STATE(178)] = 3596,
  [SMALL_STATE(179)] = 3665,
  [SMALL_STATE(180)] = 3701,
  [SMALL_STATE(181)] = 3737,
  [SMALL_STATE(182)] = 3803,
  [SMALL_STATE(183)] = 3824,
  [SMALL_STATE(184)] = 3850,
  [SMALL_STATE(185)] = 3870,
  [SMALL_STATE(186)] = 3890,
  [SMALL_STATE(187)] = 3910,
  [SMALL_STATE(188)] = 3926,
  [SMALL_STATE(189)] = 3946,
  [SMALL_STATE(190)] = 3966,
  [SMALL_STATE(191)] = 3986,
  [SMALL_STATE(192)] = 4007,
  [SMALL_STATE(193)] = 4026,
  [SMALL_STATE(194)] = 4045,
  [SMALL_STATE(195)] = 4060,
  [SMALL_STATE(196)] = 4077,
  [SMALL_STATE(197)] = 4092,
  [SMALL_STATE(198)] = 4107,
  [SMALL_STATE(199)] = 4124,
  [SMALL_STATE(200)] = 4139,
  [SMALL_STATE(201)] = 4151,
  [SMALL_STATE(202)] = 4163,
  [SMALL_STATE(203)] = 4173,
  [SMALL_STATE(204)] = 4187,
  [SMALL_STATE(205)] = 4197,
  [SMALL_STATE(206)] = 4211,
  [SMALL_STATE(207)] = 4225,
  [SMALL_STATE(208)] = 4235,
  [SMALL_STATE(209)] = 4248,
  [SMALL_STATE(210)] = 4257,
  [SMALL_STATE(211)] = 4270,
  [SMALL_STATE(212)] = 4283,
  [SMALL_STATE(213)] = 4296,
  [SMALL_STATE(214)] = 4307,
  [SMALL_STATE(215)] = 4318,
  [SMALL_STATE(216)] = 4327,
  [SMALL_STATE(217)] = 4340,
  [SMALL_STATE(218)] = 4353,
  [SMALL_STATE(219)] = 4366,
  [SMALL_STATE(220)] = 4379,
  [SMALL_STATE(221)] = 4392,
  [SMALL_STATE(222)] = 4405,
  [SMALL_STATE(223)] = 4418,
  [SMALL_STATE(224)] = 4431,
  [SMALL_STATE(225)] = 4444,
  [SMALL_STATE(226)] = 4457,
  [SMALL_STATE(227)] = 4470,
  [SMALL_STATE(228)] = 4481,
  [SMALL_STATE(229)] = 4494,
  [SMALL_STATE(230)] = 4507,
  [SMALL_STATE(231)] = 4518,
  [SMALL_STATE(232)] = 4531,
  [SMALL_STATE(233)] = 4544,
  [SMALL_STATE(234)] = 4552,
  [SMALL_STATE(235)] = 4560,
  [SMALL_STATE(236)] = 4568,
  [SMALL_STATE(237)] = 4576,
  [SMALL_STATE(238)] = 4586,
  [SMALL_STATE(239)] = 4594,
  [SMALL_STATE(240)] = 4604,
  [SMALL_STATE(241)] = 4612,
  [SMALL_STATE(242)] = 4620,
  [SMALL_STATE(243)] = 4628,
  [SMALL_STATE(244)] = 4636,
  [SMALL_STATE(245)] = 4644,
  [SMALL_STATE(246)] = 4652,
  [SMALL_STATE(247)] = 4662,
  [SMALL_STATE(248)] = 4670,
  [SMALL_STATE(249)] = 4678,
  [SMALL_STATE(250)] = 4686,
  [SMALL_STATE(251)] = 4693,
  [SMALL_STATE(252)] = 4700,
  [SMALL_STATE(253)] = 4707,
  [SMALL_STATE(254)] = 4714,
  [SMALL_STATE(255)] = 4721,
  [SMALL_STATE(256)] = 4728,
  [SMALL_STATE(257)] = 4735,
  [SMALL_STATE(258)] = 4742,
  [SMALL_STATE(259)] = 4749,
  [SMALL_STATE(260)] = 4756,
  [SMALL_STATE(261)] = 4763,
  [SMALL_STATE(262)] = 4770,
  [SMALL_STATE(263)] = 4777,
  [SMALL_STATE(264)] = 4784,
  [SMALL_STATE(265)] = 4791,
  [SMALL_STATE(266)] = 4798,
  [SMALL_STATE(267)] = 4805,
  [SMALL_STATE(268)] = 4812,
  [SMALL_STATE(269)] = 4819,
  [SMALL_STATE(270)] = 4826,
  [SMALL_STATE(271)] = 4833,
  [SMALL_STATE(272)] = 4840,
  [SMALL_STATE(273)] = 4847,
  [SMALL_STATE(274)] = 4854,
  [SMALL_STATE(275)] = 4861,
  [SMALL_STATE(276)] = 4868,
  [SMALL_STATE(277)] = 4875,
  [SMALL_STATE(278)] = 4882,
  [SMALL_STATE(279)] = 4889,
  [SMALL_STATE(280)] = 4896,
  [SMALL_STATE(281)] = 4903,
  [SMALL_STATE(282)] = 4910,
  [SMALL_STATE(283)] = 4917,
  [SMALL_STATE(284)] = 4924,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [69] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(121),
  [72] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(31),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(200),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(2),
  [81] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2),
  [83] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(278),
  [86] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(84),
  [89] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(282),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(283),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(6),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(253),
  [101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(273),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(61),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(75),
  [110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(272),
  [113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(246),
  [116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(194),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(109),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(102),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(266),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(110),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(111),
  [134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(112),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(83),
  [140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(83),
  [143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(82),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(146),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(144),
  [152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(144),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_list, 1),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4),
  [165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 2),
  [169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 2),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, .production_id = 14),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, .production_id = 14),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, .production_id = 24),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, .production_id = 24),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 2, .production_id = 4),
  [185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 2, .production_id = 4),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 7, .production_id = 27),
  [189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 7, .production_id = 27),
  [191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 7, .production_id = 30),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iteration_statement, 7, .production_id = 30),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jump_statement, 2),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jump_statement, 2),
  [199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_label, 2),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_label, 2),
  [203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jump_statement, 3),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jump_statement, 3),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_label, 3),
  [213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_label, 3),
  [215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1),
  [217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 26),
  [221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 26),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 5),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iteration_statement, 5),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 6, .production_id = 28),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 6, .production_id = 28),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 8, .production_id = 34),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iteration_statement, 8, .production_id = 34),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 6, .production_id = 30),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iteration_statement, 6, .production_id = 30),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 31),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 31),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 7, .production_id = 33),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iteration_statement, 7, .production_id = 33),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 7, .production_id = 32),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 7, .production_id = 32),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 7),
  [255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iteration_statement, 7),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(190),
  [262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(200),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(246),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(194),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(109),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(102),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(266),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(110),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(111),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, .production_id = 7), SHIFT_REPEAT(112),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, .production_id = 1),
  [291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, .production_id = 9),
  [293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(190),
  [296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(246),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(194),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(109),
  [307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(102),
  [310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(266),
  [313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(110),
  [316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(111),
  [319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_declaration_list_repeat1, 2), SHIFT_REPEAT(112),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration_list, 1),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_qualifier_list_repeat1, 2),
  [330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_qualifier_list_repeat1, 2),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_qualifier_list_repeat1, 2), SHIFT_REPEAT(109),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_qualifier_list_repeat1, 2), SHIFT_REPEAT(102),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_qualifier_list_repeat1, 2), SHIFT_REPEAT(266),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_qualifier_list_repeat1, 2), SHIFT_REPEAT(110),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_qualifier_list_repeat1, 2), SHIFT_REPEAT(111),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_qualifier_list_repeat1, 2), SHIFT_REPEAT(112),
  [350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier_list, 1),
  [352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier_list, 1),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 1, .production_id = 3),
  [366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 1, .production_id = 3),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_prototype, 2),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_prototype, 2),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_qualifier, 1),
  [406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_qualifier, 1),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, .production_id = 5),
  [412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, .production_id = 5),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 1, .production_id = 1),
  [416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 1, .production_id = 1),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__external_declaration, 1, .production_id = 2),
  [420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external_declaration, 1, .production_id = 2),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__external_declaration, 1, .production_id = 3),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external_declaration, 1, .production_id = 3),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_layout_qualifier, 4),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_layout_qualifier, 4),
  [430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_qualifier, 4),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_qualifier, 4),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_precision_qualifier, 1),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_precision_qualifier, 1),
  [438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation_qualifier, 1),
  [440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_qualifier, 1),
  [442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1),
  [444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 3, .production_id = 15),
  [448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 3, .production_id = 15),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_layout_qualifier, 5),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_layout_qualifier, 5),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, .production_id = 14),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, .production_id = 14),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1),
  [462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_left_expression, 1),
  [464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment_left_expression, 1),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 19),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 19),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 2),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comma_expression, 2),
  [502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 11),
  [504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 11),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2),
  [508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2),
  [510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 25),
  [512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 25),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comma_expression_repeat1, 2),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comma_expression_repeat1, 2), SHIFT_REPEAT(94),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comma_expression_repeat1, 2),
  [529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 19),
  [531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 19),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 23),
  [535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 23),
  [537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 18),
  [539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 18),
  [541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 18),
  [547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 18),
  [549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 20),
  [551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 20),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1),
  [555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_expression, 1),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_expression, 1),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comma_expression_repeat1, 2), SHIFT_REPEAT(81),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition, 1, .production_id = 22),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 1),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_parameter_list, 2),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_parameter_list, 1),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_layout_qualifier_id, 3, .production_id = 17),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_specifier_list, 2),
  [636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_specifier_list, 2), SHIFT_REPEAT(182),
  [639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__array_specifier_list, 2), SHIFT_REPEAT(97),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 5, .production_id = 10),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 4, .production_id = 10),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 5, .production_id = 16),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_specifier_list, 3),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__array_specifier_list, 3),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 2),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 6, .production_id = 16),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 2, .production_id = 3),
  [676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1),
  [678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator_list, 1),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 3),
  [688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 15),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fully_specified_type, 1),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 5),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 4),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 3),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declarator_list, 2),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declarator_list, 1),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator_list, 2, .production_id = 6),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator_list, 3, .production_id = 8),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fully_specified_type, 2),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_list, 1),
  [732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_layout_qualifier_repeat1, 2), SHIFT_REPEAT(210),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_layout_qualifier_repeat1, 2),
  [737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_parameter_list_repeat1, 2), SHIFT_REPEAT(49),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameter_list_repeat1, 2),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_list, 2),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name_list, 2),
  [750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_name_list_repeat1, 2), SHIFT_REPEAT(284),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_name_list_repeat1, 2),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name_list, 1),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2),
  [761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2), SHIFT_REPEAT(270),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_declarator_list_repeat1, 2),
  [766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_declarator_list_repeat1, 2), SHIFT_REPEAT(206),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__initializer_repeat1, 2),
  [771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__initializer_repeat1, 2), SHIFT_REPEAT(58),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_layout_qualifier_id, 1, .production_id = 3),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator_list, 5, .production_id = 21),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_layout_qualifier_id, 1),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition, 4, .production_id = 29),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator_list, 4, .production_id = 13),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declarator, 2, .production_id = 15),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declarator, 1),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [832] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 12),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_glsl(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
